class AppList extends React.Component {
	constructor(props) {
		super(props);
        console.log("AppList.constructor");
        this.handleClick=this.handleClick.bind(this);
        this.state={pageList:[], menuList:[], titleMsg:"Title", url:""};
	}
	
	componentDidMount() {
        
	}
    
//                    setTime={this.state.setTime}
    handleClick(_url) {
//        console.log("handleClick("+_url+")");
        window.location.href=_url+"?local=true&cache=false";
    }
    
    
  render() {
      console.log("AppList.render()")
      var self=this;
      for(var x in this.props) {
          this.state[x]=this.props[x];
      }
      var _titleMsg=<div className="appList_title">{this.state.titleMsg}</div>;
      var showMenu=this.state.menuList.map(function(x, i){
          var _url="files/"+getLocaleStr(x.picFile);
		  var _msgList=getLocaleStr(x.description.msg).map(function(y, j) {
			  return(<p className="msgItem" key={j}>{y}</p>)
		  });
          return (<div className="menuContainer" key={i}>
				  <div className="picContainer">
					  <img className="menuPic" src={_url}/>
					  <div className="subTitle">{getLocaleStr(x.subTitle)}</div>
				  </div>
				  <div className="msgTop" style={{backgroundColor:x.color}}>
				  	<div className="msgContainer">
						<h2>{getLocaleStr(x.description.title)}</h2>
				  		<div className="msgPack">
						 {_msgList}
				 		</div>
				  	</div>
				  </div>
				  <div className="menuDivider"></div>
          </div>)
      });
      var showApp=this.state.pageList.map(function(x, i){
          var _url="url(files/"+x.picFile+")";
          return (<div className="p3DevType" key={i}>
              <div className="devIcon" onClick={() => self.handleClick(x.url)} style={{backgroundImage: _url}}></div>
              <div className="devMsg">{x.msg}</div>
          </div>)
      });
      return (<div className="app_top">
		<div className="menuTop">{showMenu}</div>
		<div className="appList_top">
         {_titleMsg}
         {showApp}
		</div>
      </div>);
//          var _testObj={x:{a:3, b:4}, y:{a:8, b:9}, z:{a:77, b:88}};
//          var xxxx=[];
//          for(var i in _testObj) {
//              console.log("i="+i);
////              xxxx.push(<div key={_testObj[i].a}>
//              xxxx.push(<div key={_testObj[i].a}>
//                      <div className="inner">{_testObj[i].b}</div>
//                      </div>);
//          }
//      return (<div>
//         {showApp}
//         {xxxx}
//      </div>);
  }
}

window.AppList=AppList;
