const {AppList}=window;
//00-Hello-OHA.png                         07-oMassMiniApp2.0.png
//01-Set-Timer-in-UI.png                   09-oMassMiniApp4.0.png
//02-Device-PlugInOut_index.png            10-oMassMiniApp4.1.png
//03-Set-Timer-DevicePlugInOut.png         acup_icon.png
//04-Variable-Voltage-In-2-Patterns.png    eav24_icon.png
//05-Variable-Frequency-In-8-Patterns.png  eav40_icon.png
//06-Full-oMass-Demo.png                   ryo_chart.png

ReactDOM.render(
    <AppList
        titleMsg="Mini-App List"
		menuList={[
		{
			picFile: {
				"en-US":"oha-2.jpg",
				"default": "oha-2.jpg"
			}, 
			color: "#ff0000", 
			subTitle: {
				"en-US":"",
				"default": ""
			}, 
			description:{
				title: {
					"en-US":"oLaser LLLT", 
					"default": "oLaser for LLLT"
				}, 
				msg: {
					"en-US":["iOS and Android", 
						"Lightning (iOS), USB OTG(Android), BlueTooth 4.0", 
						"1 minute per acupoint for healthcare daily"], 
					
					"default":["iOS and Android", 
						"Lightning (iOS), USB OTG(Android), BlueTooth 4.0", 
						"1 minute per acupoint acupoint for healthcare daily"]
				}
			}
		}, 
		{
			picFile: {
				"en-US":"oha-3.jpg" ,
				"default": "oha-3.jpg"
			}, 
			color: "#1fa4de", 
			subTitle: {
				"en-US":"", 
				"zh-CN": "",
				"zh": "", 
				"default": ""
			}, 
			description:{
				title: {
					"en-US":"oCupping Device",
					"default": "oCupping Device"
				}, 
				msg: {
					"en-US":
					[
					"iOS and Android", 
					"Lightning (iOS), USB OTG(Android), BlueTooth 4.0", 
					"3 minutes per acupoint for healthcare daily"
					],
					"default":[
						"iOS and Android", 
						"Lightning (iOS), USB OTG(Android), BlueTooth 4.0", 
						"3 minute per acupoint for healthcare daily"
					]
				}
			}
		}
		]}
        pageList={[
                {picFile: "00-Hello-OHA-oPower.png", msg: "Hello OHA opower demo.", url:"http://www.ohacorp.com/opower/ex/00-Hello-OHA-oPower/index.html"},
                {picFile: "01-PWM-power-control.png", msg: "PWM power control demo.", url:"http://www.ohacorp.com/opower/ex/01-PWM-power-control/index.html"},
                {picFile: "02-Power-control-by-timer.png", msg: "Power control with timer", url:"http://www.ohacorp.com/opower/ex/02-Power-control-by-timer/index.html"}
        ]}
    />
    , document.getElementById("page1")
);