class BottomArea extends React.Component {
	constructor(props) {
		super(props);
//		window.selfBttomArea=this;
		this.handleLikeClick=this.handleLikeClick.bind(this);
		this.handleDialogClick=this.handleDialogClick.bind(this);
		this.handleShareClick=this.handleShareClick.bind(this);
		this.likeIcon=this.likeIcon.bind(this);
		this.dialogIcon=this.dialogIcon.bind(this);
		this.shareIcon=this.shareIcon.bind(this);
		this.handleIconArea=this.handleIconArea.bind(this);
		this.state=({id:-1, pageData:{}, sid: -1, isLikePressed: false, isPlugged: false, numLike:0, likeFuncExists:false, shareFuncExists:false, likeUrl:"", likeIsDoneUrl:"", likeCancelUrl:"", likeGetCountlUrl:"", guestbookUrl:"", guestbookExists: false, shareUrl:""});
	}
    
	handleLikeClick(){
//		console.log("BootomArea.handleLikeClick, this.state.isPlugged="+this.state.isPlugged);
		if(!this.state.isPlugged || $(".LikeIcon").hasClass("isPressing")) {
			return;
		}
		var id=this.state.id;
		if(this.state.likeFuncExists) {
			var xhttp = new XMLHttpRequest();
			xhttp.self=this;
			var _model=this.state.pageData.model.split(":");
			var _modelEnc=encodeURIComponent(_model[0]);
			var _sidEnc=encodeURIComponent(this.state.sid);
//			console.log("BootomArea.handleLikeClick, this.state.isLikePressed="+this.state.isLikePressed);
			$(".LikeIcon").addClass("isPressing");
			if(this.state.isLikePressed) {
				xhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						console.log("Vote Cancel="+this.responseText+", id="+id);
						$("#id"+id+" .LikeIcon").attr("src", "pic/like_icon.png");
	//					$("#id"+id+" .LikeIcon").click(new function(event){selfBttomArea.handleLikeClick(id, false)});
						var _num=parseInt($("#id"+id+" .LikeNum").text());
						$("#id"+id+" .LikeNum").text(_num-1);
//						selfBttomArea.state.isLikePressed=false;
						this.self.state.isLikePressed=false;
						$(".LikeIcon").removeClass("isPressing");
					}
				};
				var _cmd=this.state.likeCancelUrl.replace("$model", _modelEnc);
				var _cmd=_cmd.replace("$id", _sidEnc);
	//			xhttp.open("GET", "http://www.ohacorp.com/vote/vote.php?model="+_modelEnc+"&id="+_sidEnc+"&cancel=1", true);
				xhttp.open("GET", _cmd, true);
			}
			else {
				xhttp.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						console.log("Vote="+this.responseText+", id="+id);
						$("#id"+id+" .LikeIcon").attr("src", "pic/like_ok_icon.png");
	//					$("#id"+id+" .LikeIcon").click(new function(event){selfBttomArea.handleLikeClick(id, true)});
						var _num=parseInt($("#id"+id+" .LikeNum").text());
						$("#id"+id+" .LikeNum").text(_num+1);
//						selfBttomArea.state.isLikePressed=true;
						this.self.state.isLikePressed=true;
						$(".LikeIcon").removeClass("isPressing");
					}
				};
				var _cmd=this.state.likeUrl.replace("$model", _modelEnc);
				var _cmd=_cmd.replace("$id", _sidEnc);
	//			xhttp.open("GET", "http://www.ohacorp.com/vote/vote.php?model="+_modelEnc+"&id="+_sidEnc, true);
				xhttp.open("GET", _cmd, true);
			}
			xhttp.send();
		}
	}
	
	handleDialogClick() {
		if(this.state.guestbookUrl.length>0) {
			var _cmd="ohadm://guestbook_"+encodeURIComponent(this.state.guestbookUrl);
			oha_api.runOhaCmd(_cmd);
		}
	}
	
	handleShareClick() {
		if(this.state.shareUrl.length>0) {
			var _cmd="ohadm://share_"+encodeURIComponent(this.state.shareUrl);
			oha_api.runOhaCmd(_cmd);
		}
	}
	
	deleteIcon() {
		var _pic="pic/delete.png";
        return <div id="delIcon" className="IconDiv"><img className="IconImage clickable" src={_pic} onClick={this.props.runDelete}></img>
        </div>
	}
	
	likeIcon() {
		var _pic="pic/like_icon.png";
		if(this.state.isLikePressed) {
			_pic="pic/like_ok_icon.png";
		}
//		console.log("BottomArea.likeIcon, _pic="+_pic+", id="+this.state.id+", this.state.isLikePressed="+this.state.isLikePressed);
		if(!this.state.likeFuncExists) {
			return null;
		}
		if(this.state.isPlugged) {
			return <div id="likeIcon" className="IconDiv"><img className="LikeIcon IconImage clickable" src={_pic} onClick={this.handleLikeClick}></img>
			<h3>&nbsp;&nbsp;&nbsp;<span className="LikeNum">---</span></h3></div>
		}
		else {
			return <div id="likeIcon" className="IconDiv unclickable">
				<img className="LikeIcon IconImage" src={_pic}></img>
				<h3>&nbsp;&nbsp;&nbsp;<span className="LikeNum">---</span></h3>
			</div>
//				<h3>&nbsp;&nbsp;&nbsp;<span className="LikeNum">---</span>&nbsp;&nbsp;&nbsp;</h3>
		}
	}
	
	dialogIcon() {
		if(!this.state.guestbookExists) {
			return null;
		}
		if(this.state.isPlugged) {
			return <div id="dialogIcon" className="IconDiv">
				<img className="MessageIcon IconImage clickable" src="pic/message_icon.png" onClick={this.handleDialogClick}></img>
				<h3>&nbsp;&nbsp;&nbsp;<span>---</span></h3>
			</div>
		}
		else {
			return <div id="dialogIcon" className="IconDiv unclickable">
				<img className="MessageIcon IconImage" src="pic/message_icon.png" onClick={this.handleDialogClick}></img>
				<h3>&nbsp;&nbsp;&nbsp;<span>---</span></h3>
			</div>
		}
	}
	
	shareIcon() {
		if(!this.state.shareFuncExists) {
			return null;
		}
		if(this.state.isPlugged) {
			return <div id="shareIcon" className="IconDiv">
				<img className="ShareIcon IconImage clickable" src="pic/share_icon.png" onClick={this.handleShareClick}></img>
			</div>
		}
		else {
			return <div id="shareIcon" className="IconDiv unclickable">
				<img className="ShareIcon IconImage" src="pic/share_icon.png" onClick={this.handleShareClick}></img>
			</div>
		}
	}
        
    urlIcon() {
        return <div className="urlIcon IconDiv unclickable">
            <img className="ShareIcon IconImage" src="pic/WWW.svg" onClick={this.props.runWWW}></img>
            </div>
    }
	
	handleIconArea() {
		return <div className="IconArea">
				{this.deleteIcon()}
				{this.likeIcon()}
				{this.dialogIcon()}
				{this.urlIcon()}
				{this.shareIcon()}
			</div>
	}
	
	render() {
		const {id, idx, sid, pageData, isPlugged, locale}=this.props;
		console.log("BootomArea.render(), id="+id+",idx="+idx+", model="+pageData.model+", isPlugged="+isPlugged)
		var _model=pageData.model.split(":");
		switch(_model[0]) {
			case "&oMass":
				this.state.likeUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id";
				this.state.likeIsDoneUrl="http://www.ohacorp.com/vote/get_count.php?model=$model&id=$id";
				this.state.likeCancelUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id&cancel=1";
				this.state.likeGetCountlUrl="http://www.ohacorp.com/vote/get_count.php?model=$model";
				this.state.shareUrl="http://www.ohacorp.com";
				this.state.guestbookUrl="https://www.ohacorp.com/WP/wordpress/?p=62&locale="+locale;
				this.state.likeFuncExists=true;
				this.state.guestbookExists=true;
				this.state.shareFuncExists=true;
				break;
			case "&oPower":
				this.state.likeUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id";
				this.state.likeIsDoneUrl="http://www.ohacorp.com/vote/get_count.php?model=$model&id=$id";
				this.state.likeCancelUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id&cancel=1";
				this.state.likeGetCountlUrl="http://www.ohacorp.com/vote/get_count.php?model=$model";
				this.state.shareUrl="http://www.ohacorp.com";
				this.state.guestbookUrl="https://www.ohacorp.com/WP/wordpress/?p=69&locale="+locale;
				this.state.likeFuncExists=true;
				this.state.guestbookExists=true;
				this.state.shareFuncExists=true;
				break;
			case "&oUART":
				this.state.likeUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id";
				this.state.likeIsDoneUrl="http://www.ohacorp.com/vote/get_count.php?model=$model&id=$id";
				this.state.likeCancelUrl="http://www.ohacorp.com/vote/vote.php?model=$model&id=$id&cancel=1";
				this.state.likeGetCountlUrl="http://www.ohacorp.com/vote/get_count.php?model=$model";
				this.state.shareUrl="http://www.ohacorp.com";
				this.state.guestbookUrl="https://www.ohacorp.com/WP/wordpress/?p=71&locale="+locale;
				this.state.likeFuncExists=true;
				this.state.guestbookExists=true;
				this.state.shareFuncExists=true;
				break;
			default:
				
		}
//		for(var _x in this.props) {
//			this.state[_x]=this.props[_x];
//		}
		this.state.id=id;
		this.state.sid=sid;
		this.state.pageData=pageData;
		this.state.isPlugged=isPlugged;
		if(!isPlugged) {
			this.state.isLikePressed=false;
			$("#id"+this.state.id+" .LikeIcon.IconImage").attr({"src":"pic/like_icon.png"});
		}
		if(this.state.likeFuncExists) {
			var xhttp = new XMLHttpRequest();
			var _modelEnc=encodeURIComponent(_model);
			var _sidEnc=encodeURIComponent(sid);
			xhttp.onreadystatechange = function() {
				if (this.readyState == 4 && this.status == 200) {
					$("#id"+id+" .LikeNum").text(this.responseText);
					console.log("Get data="+this.responseText);
				}
			};
			var _cmd=this.state.likeGetCountlUrl.replace("$model", _modelEnc);
	//		xhttp.open("GET", "http://www.ohacorp.com/vote/get_count.php?model="+_modelEnc, true);
			xhttp.open("GET", _cmd, true);
			xhttp.send();
		}
		if(sid!=="" && isPlugged) {
			console.log("BottomArea.render, (sid!==\"\")="+(sid!=="")+", isPlugged="+isPlugged);
			if(this.state.likeFuncExists) {
				var xhttp1 = new XMLHttpRequest();
				xhttp1.self=this;
				xhttp1.onreadystatechange = function() {
					if (this.readyState == 4 && this.status == 200) {
						console.log("LikeOK="+this.responseText);
						switch(this.responseText) {
							case "0":
								console.log("LikeOK is not checked");
								$("#id"+id+" .LikeIcon").attr("src", "pic/like_icon.png");
								this.self.state.isLikePressed=false;
		//						$("#id"+id+" .LikeIcon").on("click", function(event){selfBttomArea.handleLikeClick(id, false)});
								break;
							case "1":
								console.log("LikeOK is checked");
								$("#id"+id+" .LikeIcon").attr("src", "pic/like_ok_icon.png");
								this.self.state.isLikePressed=true;
		//						$("#id"+id+" .LikeIcon").on("click", function(event){selfBttomArea.handleLikeClick(id, true)});
								break;
							default:
								console.log("LikeOK is default");
								$("#id"+id+" .LikeIcon").attr("src", "pic/like_icon.png");
								this.self.state.isLikePressed=false;
						}
					}
				};
				var _cmd=this.state.likeIsDoneUrl.replace("$model", _modelEnc);
				var _cmd=_cmd.replace("$id", _sidEnc);
	//			xhttp1.open("GET", "http://www.ohacorp.com/vote/get_count.php?model="+_modelEnc+"&id="+_sidEnc, true);
				xhttp1.open("GET", _cmd, true);
				xhttp1.send();
			}
		}
		return <div className="BottomArea">
			{this.handleIconArea()}
		</div>
	}
}
window.App.BottomArea=BottomArea;