//免責聲明image style
rule_ImageTW={
 "title":"免責聲明",
 "image":"images/rules.jpg",
 "onclick" : "oha_api.runOhaCmd(\'oha://home_TermOfUsage_使用條款\')",
}

rule_ImageCN={
 "title":"免责声明",
 "image":"images/rules_cn.jpg",
 "onclick" : "oha_api.runOhaCmd(\'oha://home_TermOfUsage_使用条款\')",
}

rule_ImageUS={
 "title":"Terms of Use",
 "image":"images/rules_en.jpg",
 "onclick" :"oha_api.runOhaCmd(\'oha://home_TermOfUsage_Terms of Use\')",
}
rule_ImageJP={
 "title":"Terms of Use",
 "image":"images/rules_en.jpg",
 "onclick" :"oha_api.runOhaCmd(\'oha://home_TermOfUsage_使用条項\')",
}
rule_ImageKR={
 "title":"이용 약관",
 "image":"images/rules_en.jpg",
 "onclick" :"oha_api.runOhaCmd(\'oha://home_TermOfUsage_이용 약관\')",
}
rule_Image={
 "default":rule_ImageUS,
 "zh-TW":rule_ImageTW,
 "zh-CN":rule_ImageCN,
 "en-US":rule_ImageUS,
 "ko-KR":rule_ImageKR,
 "ja-JP":rule_ImageJP,
}

// 免責聲明 ------------------------------------------------------------------------------------

rule_datasTW={
	"title":"免責聲明",
	"rules":[
		{
		"title": "非醫療行業",
		"des":"在OHA app或官方網站(以下簡稱OHA)中，您瀏覽與取得的醫療相關訊息，僅供參考之用，本公司不負擔保責任。OHA是一個軟硬體整合平台，協助廠商開發、生產、應用手機週邊硬體。OHA或其衍生的公司並不是醫療器材廠商，並不生產、也不銷售醫療器材產品。以OHA平台生產、製造、銷售之醫療器材，應由所生產之醫療器材廠商提供符合當地政府的法規的產品，並提供產品的保固、維修、教育訓練等等，並負責所有當地的法律責任。"
		},
		{
		"title": "擔保限制",
		"des":"任何瀏覽OHA 的人士所取得的所有醫療相關訊息，須自行承擔風險，本網站不會作出任何明示或默示的擔保。在不違背上述的一般性原則之下，本網站不負以下擔保責任：OHA 隨時不經通知逕行變更、更新或刪除任何資訊，OHA 資訊的完整性、正確性、精準性、時效性以及可靠性。"
		},
		{
		"title": "專業協助",
		"des":"OHA 所提供的訊息並不能取代您諮詢醫生或其他專業保健人員的建議。因此您如果有特殊醫療相關的需求，仍建議您尋求醫生以及專業保健人員協助。若您有緊急的救護需求，也請您儘早聯絡相關醫護人員。切勿因為OHA 的任何工具、資訊而耽擱、忽視或中斷尋求醫療專業資源。"
		},
		{
		"title": "權利義務",
		"des":"在本醫療免責當中，沒有任何權益受損或不適用於法律的條款，或者排除任何法律規定下任何我們應有的權利。"
		}
	]

}


rule_datas={
			"default":rule_datasTW,
			"zh-TW":rule_datasTW,
			"zh-CN":rule_datasTW,
			};
