// JavaScript Document
var oha_config={
	debug_mode:false,			// Debug mode, must be set as "false" before release
	sw_ver:0.940,
	model:"&oMass",				// Model Name, must be the same as Config.html
	page_name:"Official",				// Page Name, different page must be different page name
    plateForm:"iOS", 
    default_language:"tw", 
    api_path:"oha_api/",
    html_config:{
		en:"default_us.html", 		// English
		tw:"default_tw.html", 		// Traditional Chinese
		cn:"default_cn.html", 		// Simplify Chinese
		kr:"default_kr.html"		// Korean
    },
    isReadOnly:false,
    pwrSaveMsg:"Power saving mode", 
	timer:{					// Timer Setting
		time_option:[60,120,300,600,1200,1800,2400,3000],
		default_value:60
	},
}

var title_conf={
	title: {
//		en:"oMass(V"+oha_config.sw_ver.toFixed(3)+")", 	// English
//		tw:"oMass(V"+oha_config.sw_ver.toFixed(3)+")", 		// Traditional Chinese
//		cn:"oMass(V"+oha_config.sw_ver.toFixed(3)+")", 		// Simplify Chinese
//		kr:"oMass(V"+oha_config.sw_ver.toFixed(3)+")",		// Korean
		en:"oMass", 	// English
		tw:"oMass", 		// Traditional Chinese
		cn:"oMass", 		// Simplify Chinese
		kr:"oMass",		// Korean
	}, 
	subtitle: {
		en:"Healthy, Convient and Funny",  	// English
		tw:"Healthy, Convient and Funny", 		// Traditional Chinese
		cn:"Healthy, Convient and Funny", 		// Simplify Chinese
		kr:"Healthy, Convient and Funny"		// Korean
	}, 
}

var msg_conf={
    pwrSaveMsg:{
       en: "Power Saving Mode", 
       tw: "螢幕省電模式", 
       cn: "萤幕省电模式", 
       kr: "Power Saving Mode", 
    }, 
}

oha_config.title=title_conf.title;
oha_config.subtitle=title_conf.subtitle;

oha_api.init(oha_config);  