const {DevList, PageHeader}=window.App
const menuTypeOptions={
	editDelete: 0, 
	deleteConfirm: 1, 
	edit:2
};
//var a;
class Top extends React.Component {
	constructor(props) {
		super(props)
		this.launchMenu=this.launchMenu.bind(this);
		this.showMenu=this.showMenu.bind(this);
		this.runEdit=this.runEdit.bind(this);
		this.runDelete=this.runDelete.bind(this);
		this.closeMenu=this.closeMenu.bind(this);
		this.runUpdateMap=this.runUpdateMap.bind(this);
		const {action, pages, page, mapping, devInfo}=this.props;
		this.state={pages: pages, page:page, mapping:mapping, devInfo:devInfo, action:action, showMenu:false, curPage:0, plugPage:-1, interChange:false, otgState:"NC", bleState:"NC", sid:""};
//		this.test=this.test.bind(this);
//		console.log("Top.conductor, action="+this.state.action+", pages="+this.state.pages+", devInfo="+this.state.devInfo);
	}
//	test() {
////		a=this.props.pages;
//		console.log("test, state="+this.state);
//	}
//	componentDidMount() {
//		console.log("Top.componentDidMount");
//	}
	
	runEdit(_id, _title, _subtitle) {
		this.pagesTmp=this.state.pages;
		this.pageTmp=this.pagesTmp[_id];
		this.pageTmp.title=_title;
		this.pageTmp.subtitle=_subtitle;
		this.pagesTmp[_id]=this.pageTmp;
		this.setState({showMenu: false, pages: this.pagesTmp, interChange:true, action:"updatePage"});
		const sChar=String.fromCharCode(0x03);
		var _cmd="ohadm://updateTitle_"+_id+sChar+_title+sChar+_subtitle;
		oha_api.runOhaCmd(_cmd);
	}
	
	runDelete(_id) {
		this.index=this.state.mapping.indexOf(_id);
		this.state.mapping.splice(this.index, 1);
		this.mappingNew=this.state.mapping.map((_no, _idx)=>(_no>_id?parseInt(_no-1):parseInt(_no)));
		this.pagesTmp=this.state.pages;
		this.pagesTmp.splice(_id, 1);
		var _cmd="ohadm://delete_"+_id;
		oha_api.runOhaCmd(_cmd);
		this.setState({showMenu: false, pages:this.pagesTmp, mapping:this.mappingNew, interChange:true, action:"updatePage"});
//		this.runUpdateMap();
//		console.log("this.mappingNew="+this.mappingNew);
//		console.log("runDelete, _id="+_id+", this.state.pages="+this.state.pages);
	}
	
	closeMenu() {
//		this.setState({showMenu: false, interChange:true, action:"launchMenu"});
		ReactDOM.render(
			<SettingMenu
			pageNo={-1}
			/>,
		  document.getElementById('setting-menu')
		);
	}
	
	launchMenu(_id) {
//		console.log("launchMenu("+_id+")")
//		this.setState({showMenu: true, curPage:_id, interChange:true, action:"launchMenu"});
//		this.setState({showMenu: true, interChange:true, action:"launchMenu"});
//		this.setState({showMenu: true, interChange:true});
//		console.log("launchMenu cp1 ("+this.state.curPage+")")
//		ReactDOM.render(
//			<SettingMenu
//			title="Device Manager"
//			closeMenu={this.closeMenu}
//			runEdit={this.runEdit}
//			runDelete={this.runDelete}
//			pages={this.state.pages}
//			pageNo={this.state.curPage}
//			/>,
//		  document.getElementById('setting-menu')
//		);
		ReactDOM.render(
			<SettingMenu
			title="Device Manager"
			closeMenu={this.closeMenu}
			runEdit={this.runEdit}
			runDelete={this.runDelete}
			pages={this.state.pages}
			pageNo={_id}
			/>,
		  document.getElementById('setting-menu')
		);
	}
	
	showMenu() {
//		console.log("showMenu("+this.state.curPage+")");
		if(this.state.showMenu) {
			return (<SettingMenu
					title="Device Manager"
					closeMenu={this.closeMenu}
					runEdit={this.runEdit}
					runDelete={this.runDelete}
					pages={this.state.pages}
					pageNo={this.state.curPage}
					/>
				   );
		}
		else {
			return null;
		}
	}
	
	runUpdateMap() {
		var _cmd="ohadm://updateMap_";
//		console.log("App.runUpdateMap(), this.state.mapping="+this.state.mapping)
		this.mapping=this.state.mapping;
		for(this.i=0;this.i<this.mapping.length;this.i++) {
			var item=this.mapping[this.i];
			if(this.i>0) {
				_cmd+=":";
			}
			_cmd+=this.mapping[this.i];
		}
//		console.log("DevList.runUpdateMap, _cmd="+_cmd+", mapping="+this.mapping);
		oha_api.runOhaCmd(_cmd);
	}
	
//	runUpdatePage() {
//		var _cmd="ohadm://updatePage_";
//		this.mapping=this.state.mapping;
//		for(this.i=0;this.i<this.mapping.length;this.i++) {
//			var item=this.mapping[this.i];
//			if(this.i>0) {
//				_cmd+=":";
//			}
//			_cmd+=this.mapping[this.i];
//		}
//		console.log("DevList.runUpdateMap, _cmd="+_cmd+", mapping="+this.mapping);
//		oha_api.runOhaCmd(_cmd);
//	}
	
	render() {
		const {page, action, sid}=this.props;
//		console.log("Top.render(), this.props.action="+this.props.action+", this.state.interChange="+this.state.interChange)
		if(!this.state.interChange) {
			switch(this.props.action) {
				case "initial":
	//				console.log("initial");
					this.state.pages=this.props.pages;
					this.state.mapping=this.props.mapping;
					this.state.action="initial";
					this.state.curPage=this.state.mapping[0];
	//				console.log("Top.render(), devInfo.devModel="+devInfo.devModel);
					break;
				case "plugIn":
	//				this.state.pages=pages;
					this.state.plugPage=this.props.plugPage;
					this.state.curPage=this.props.plugPage;
					this.state.sid=sid;
					this.state.action="plugEvent";
					break;
				case "plugOut":
//					this.state.devInfo=undefined;
					this.state.action="plugEvent";
					this.state.plugPage=-1;
					this.state.sid="";
					break;
				case "addPage":
					this.pageLength=this.state.pages.length;
					this.state.pages.splice(this.pageLength,0,page)
					this.state.mapping.splice(0,0,this.pageLength);
					this.state.curPage=this.pageLength;
//					console.log("App.render, action=addPage, this.state.mapping="+this.state.mapping);
					this.state.action="updatePage";
					scrollTo(0,0);
					break;
				case "phoneInfo":
					this.state.devInfo=this.props.devInfo;
					this.state.action="updateDev";
					break;
				case "updatePage":
					this.state.pages.splice(this.props.curPage, 1, this.props.page);
					this.state.action="updatePage";
					break;
				case "updateOTG":
					this.state.otgState=this.props.otgState;
					this.state.action="updateDev";
				case "updateBLE":
					this.state.bleState=this.props.bleState;
					this.state.action="updateDev";
				default:
					this.state.action="updatePage";
					console.log("this.state.action="+this.state.action);
			}
		}
		else {
//			this.state.action="updatePage"
			console.log("Internal Change!!");
			this.state.interChange=false;
		}
		console.log("Top.render, action="+this.state.action+", this.state.mapping="+this.state.mapping);
//		this.test();
		return (
			<div id="AppTop">
				<DevList
					action={this.state.action}
					devInfo={this.state.devInfo}
					pages={this.state.pages}
					mapping={this.state.mapping}
					launchMenu={this.launchMenu}
					runUpdateMap={this.runUpdateMap}
					curPage={this.state.curPage}
					plugPage={this.state.plugPage}
					sid={this.state.sid}
					otgState={this.state.otgState}
					bleState={this.state.bleState}
				/>
				<div id="setting-menu" className="menu-container"></div>
			</div>
//				{this.showMenu()}
			);
	}
}

class SettingMenu extends React.Component {
	constructor(props) {
		super(props);
		this.handleClickEdit=this.handleClickEdit.bind(this);
		this.handleClickDelete=this.handleClickDelete.bind(this);
		this.handleClickDeleteOK=this.handleClickDeleteOK.bind(this);
		this.handleClickEditOK=this.handleClickEditOK.bind(this);
		this.handleClickCancel=this.handleClickCancel.bind(this);
		this.handleTitleChange=this.handleTitleChange.bind(this);
		this.handleSubTitleChange=this.handleSubTitleChange.bind(this);
		this.genBody=this.genBody.bind(this);
		this.genEnd=this.genEnd.bind(this);
		this.state={menuType:menuTypeOptions.editDelete, pages:this.props.pages};
	}
	
	handleClickEdit() {
		console.log("SettingMenu.handleClickEdit("+this.props.pageNo+")");
		this.setState({menuType:menuTypeOptions.edit});
	}
	
	handleClickDelete(_id) {
		console.log("SettingMenu.handleClickDelete("+_id+")");
//		this.props.runDelete(_id);
		this.setState({menuType:menuTypeOptions.deleteConfirm});
	}
	
	handleClickDeleteOK() {
		console.log("SettingMenu.handleClickDeleteOK("+this.props.pageNo+")");
		this.props.runDelete(this.props.pageNo);
		this.setState({menuType:menuTypeOptions.editDelete});
		this.props.closeMenu();
	}
	
	handleClickEditOK() {
		console.log("SettingMenu.handleClickEditOK("+this.props.pageNo+")");
		this.props.runEdit(this.props.pageNo, this.state.title, this.state.subtitle);
		this.setState({menuType:menuTypeOptions.editDelete});
		this.props.closeMenu();
	}
	
	handleClickCancel() {
		console.log("SettingMenu.handleClickCancel");
		this.props.closeMenu();
//		this.setState({menuType:menuTypeOptions.editDelete});
	}
	
	handleTitleChange(e) {
		console.log("SettingMenu.handleTitleChange");
		this.setState({title:e.target.value});
	}
	
	handleSubTitleChange(e) {
		console.log("SettingMenu.handleSubTitleChange");
		this.setState({subtitle:e.target.value});
	}

	
	genBody() {
		switch(this.state.menuType) {
			case menuTypeOptions.editDelete:
				return (
					<div className="menu_body">
						<SettingItem message="Edit" pageNo={this.props.pageNo} handleClick={this.handleClickEdit}/>
						<SettingItem message="Delete" pageNo={this.props.pageNo} handleClick={this.handleClickDelete}/>
					</div>
					   );
				break;
			case menuTypeOptions.deleteConfirm:
				return (
					<div className="menu_body">
						Delete item, are you sure?
					</div>
					   );
				break;
			case menuTypeOptions.edit:
				this.pageTmp=this.props.pages[this.props.pageNo];
				return(
					<div className="menu_body">
						<form>
							Title&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; : <input type="text" defaultValue={this.pageTmp.title} onChange={this.handleTitleChange}/><br/>
							SubTitle : <input type="text" defaultValue={this.pageTmp.subtitle} onChange={this.handleSubTitleChange}/>
						</form>
					</div>
					);
				break;
		}
	}
	
	genEnd() {
		switch(this.state.menuType) {
			case menuTypeOptions.editDelete:
				return (
					<div className="menu_end" onClick={this.handleClickCancel}>
						CANCEL
					</div>
					   );
				break;
			case menuTypeOptions.deleteConfirm:
				return (
					<div className="menu_end item_two">
						<div className="menu_end_item" onClick={this.handleClickDeleteOK}>
							OK
						</div>
						<div className="menu_end_item" onClick={this.handleClickCancel}>
							CANCEL
						</div>
					</div>

					   );
				break;
			case menuTypeOptions.edit:
				return (
					<div className="menu_end item_two">
						<div className="menu_end_item" onClick={this.handleClickEditOK}>
							OK
						</div>
						<div className="menu_end_item" onClick={this.handleClickCancel}>
							CANCEL
						</div>
					</div>

					   );
				break;
		}
		
	}
	
	render() {
		if(this.props.pageNo<0) {
			return null;
		}
		return (
			<div className="mask_bg">
				<div className="menu_container">
					<div className="menu_title">
						{this.props.title}
					</div>
						{this.genBody()}
						{this.genEnd()}
				</div>
			</div>
		)
	}
}

class SettingItem extends React.Component {
	constructor(props) {
		super(props);
		this.handleClick=this.handleClick.bind(this);
//		console.log("SettingItem.constructor, pageNo="+this.props.pageNo);
	}
	
	handleClick() {
		this.props.handleClick(this.props.pageNo);
	}
	
	render() {
		return (
			<div className="menu_item" onClick={this.handleClick}>
				<div className="menu_item_txt">{this.props.message}</div>
			</div>
		)
	}
}
			
window.App.Top = Top;
//const {Top} = window.App;
//	var devInfoX=window.getDevInfo();
//	console.log("devInfo="+devInfoX);

oha_api.ready(function(){
	var pagesArray=window.getPageTable();
	var pagesMapTable=window.getPageMapTable();
	ReactDOM.render(
	  <Top
			action="initial"
			pages={pagesArray}
			mapping={pagesMapTable}
		/>,
	  document.getElementById('app')
	);

})

window.phoneInfo=function(devModel, available, devUsedTimes){
	ReactDOM.render(
	  <Top
		action="phoneInfo"
		devInfo={{devModel:devModel, available:available, devUsedTimes:devUsedTimes}}
		/>,
	  document.getElementById('app')
	);
}

window.plugIn=function(pageIdx, sid){
	ReactDOM.render(
	  <Top
		action="plugIn"
		plugPage={pageIdx}
		sid={sid}
		/>,
	  document.getElementById('app')
	);
}
	  
window.plugOut=function(){
	ReactDOM.render(
	  <Top
		action="plugOut"
		plugPage={-1}
		sid={""}
	  />,
	  document.getElementById('app')
	);
}
	  
window.addPage=function(_model, _url, _title, _subtitle, _version, _snapUrl, _date){
	if(typeof(_snapUrl)=="undefined") {
		_snapUrl="./SnapShot/OHA.jpg";
	}
	var _pat=/^[0-9]{12}$/;
	if(!_pat.test(_date)) {
		_date=new Date().getOhaFormat();
	}
	ReactDOM.render(
	  <Top
		action="addPage"
		page={
			{
				model: _model, 
				url: _url, 
				title:_title, 
				subtitle: _subtitle, 
				version: _version, 
				date: _date,
				snap_url: _snapUrl
			}
		}
		/>,
	  document.getElementById('app')
	);
}
	  
window.updatePage=function(_pageId, _model, _url, _title, _subtitle, _version, _snapUrl, _date){
	if(typeof(_snapUrl)=="undefined") {
		_snapUrl="./SnapShot/OHA.jpg";
	}
	var _pat=/^[0-9]{12}$/;
	if(!_pat.test(_date)) {
		_date=new Date().getOhaFormat();
	}
	ReactDOM.render(
	  <Top
		action="updatePage"
		curPage={_pageId}
		page={
			{
				model:_model, 
				url: _url, 
				title:_title, 
				subtitle: _subtitle, 
				version: _version, 
				date: _date,
				snap_url: _snapUrl
			}
		}
		/>,
	  document.getElementById('app')
	);
}

window.updateOTG=function(_state) {
	var _st="NC";
	switch(_state) {
		case "NA":
			_st="NA";
			break;
		case "OK":
			_st="OK";
			break;
		default:
			_st="NC";
	}
	
	ReactDOM.render(
	  <Top
		action="updateOTG"
		otgState={_st}
	  />,
	  document.getElementById('app')
	);
}
	  
window.updateBLE=function(_state) {
	var _st="NC";
	switch(_state) {
		case "OK":
			_st="OK";
			break;
		default:
			_st="NC";
	}
	
	ReactDOM.render(
	  <Top
		action="updateBLE"
		bleState={_st}
	  />,
	  document.getElementById('app')
	);
}
	  
