var __urlCmdQ=[];
var __toastQ=[];
var __isUrlCmdActive=false;
var _isToastQNotEmpty=false;
var __urlCmdInterval;
var __toastCode='<div id="toastViewDiv">\
        <div id="toastView">\
            <text></text>\
        </div>\
    </div>';
$('head').append('<link rel="stylesheet" href="oha.files/oha_api_style.css" type="text/css" />');
$(window).load(function() {
    $("html").append(__toastCode); 
    
});

function runOhaCmd(_cmdStr) {
//    console.log('runOhaCmd('+_cmdStr+');')
    if(oha_config.plateForm=="Android" && oha_config.appVer >= 184) {
//        console.log('OhaJsInterface.CMD('+_cmdStr+');')
//        OhaJsInterface.CMD(_cmdStr);
        var _a=OhaJsInterface.CMD(_cmdStr);
        console.log('runOhaCmd('+_cmdStr+")="+_a);
        return _a;
    }
    else if(oha_config.plateForm=="iOS" && oha_config.appVer >459) {
//        alert("window.OHANativeApis.JSCommand("+"_cmdStr"+")");
        return window.OHANativeApis.JSCommand(_cmdStr);
    }
    else {
        if(__isUrlCmdActive) {
            __urlCmdQ.push(_cmdStr);
        }
        else {
            __isUrlCmdActive=true;
            window.location.href=_cmdStr;
//            console.log('Url command('+_cmdStr+');')
            setTimeout('__runUrlCmd()', 200);
            return null;
        }
    }
}

function showToast(_msg) {
    __toastQ.push(_msg);
    if(__toastQ.length>1) {
        return;
    }
    __showToast();
}

function setUiAlpha(_alpha) {
    if(typeof(_alpha)=="number") {
        if(_alpha <=1 && _alpha >=0) {
            runOhaCmd("oha://alpha_"+_alpha)
        }
        else {
            showToast("Alpha value is not correct("+_alpha+")");
        }
    }
    else {
        showToast("Alpha value is not a number("+_alpha+")");
    }
}

function cookieWrite(_key, _data) {
    if(__cookieCmdOk()) {
        runOhaCmd('oha://cookie_write_'+_key+"_"+_data);
    }
    else {
        $.cookie(_key, _data, {expires:365});
    }
}

function cookieRead(_key, _default) {
    if(__cookieCmdOk()) {
        return runOhaCmd('oha://cookie_read_'+_key+"_"+_default);
    }
    else {
        var _c=$.cookie(_key);
        if(_c==null) {
            _c=_default;
        }
        return _c;
    }
}

function cookieRemove(_key) {
    if(__cookieCmdOk()) {
        runOhaCmd('oha://cookie_remove_'+_key);
    }
    else {
        $.removeCookie(_key);
    }
}

function cookieRemoveAll(_key) {
    if(__cookieCmdOk()) {
        runOhaCmd('oha://cookie_removeAll');
    }
    else {
        for(var _x in $.cookie()) {
            $.removeCookie(_x);
        }
    }
}

function __showToast() {
    if(__toastQ.length==0) {
        return;
    }
    var _msg=__toastQ[0]
    $("#toastViewDiv").stop();
    $("#toastView").text(_msg);
    $("#toastViewDiv").fadeIn(500);
    setTimeout(function() {
//        $("#toastViewDiv").fadeOut(1000, function(){
//            __toastQ.splice(0,1);
//            __showToast();
//        });
        $("#toastViewDiv").fadeOut(1000);
        __toastQ.splice(0,1);
        __showToast();
    }, 2000);
}

function __initSize() {
    var _w=$(window).width();
    $("#toastViewDiv").css({"font-size":0.04*_w+"px"});
    $("#toastView").css({"border-radius":0.02*_w+"px"});
}

function __runUrlCmd() {
    if(__urlCmdQ.length==0) {
        __isUrlCmdActive=false;
    }
    else {
        var _cmd=__urlCmdQ[0];
        __urlCmdQ.splice(0,1);
        window.location.href=_cmd;
//        console.log('Url command('+_cmd+');')
        setTimeout('__runUrlCmd()', 200);
    }
}

function __cookieCmdOk() {
    return ((oha_config.plateForm=="Android") && (oha_config.appVer > 189));
}