/* document.getElementById("oha_iframe").setAttribute("src", oha_config.url);*/


var _lightNo=90;
var isReadOnly=false;
const isAllowUiOrientation=false;
const isSupportSlowClick=true;
const isSupportNewPwm=true;
var slowTimer;
var _activeEnable=false;
var isOcupAutoInitPeriod=false;
var winHeight=0, winWidth=0;

var autoModeStusOption ={
    notStart:"off", 
    initial:"init",
    active:"active",
    idle:"idle",
}
var uiModeDef={
        normal: 'normalUi', 
        oCup: 'oCuppingUi', 
        oPowerPWM: 'pwm',
        oPowerPWMX: 'pwmx', 
		oHeating: "heating"
    };

const olaserFreqTable=[0, 0.5, 1, 2, 3, 4, 5, 6, 8, 10, 15, 25, 33, 50, 75, 128];
var curLaserFidx=0;

const cookieConfig={
    uiType: {       // Bottom view or normal view
        key: 'uiType', 
        default: 'normal', 
        options: {
            bottom: 'bottom', 
            normal: 'normal', 
        }
    },
//    uiModeOptions: {
//        normal: 'normalUi', 
//        oPower: 'opower', 
//        oCup: 'oCuppingUi', 
//        oPowerPWM: 'pwm'
//    },
    uiModeSet: {        // The UI Mode that is set by json/model name
        key: 'uiModeX',
        default: "normalUi", 
    },
    uiModePrev: {        // The previous UI Mode
        key: 'uiMode',
        default: uiModeDef.normal, 
    }, 
    pwmTimer: {
        key: 'pwmDefaultTime', 
        default: 600 
    }, 
    localeType: {
        key: 'localeType', 
    }, 
	laserFreqIdx: {
		key:'laserFidx', 
		default: 0
	}, 
	ifShowUiDesc: {
		key:'ifShowUiDesc', 
		default: "true"
	}
}

var ui_default={
    uiMode: uiModeDef.normal,
    driveMode:"low2high",
    interval:1, 
}
var ui_config={
        isDevPlugIn:false, 
        uiMode:ui_default.uiMode, 
        driveMode:ui_default.driveMode,
        interval:ui_default.interval,
		isLandscape: false, 
		width:-1,
		height:-1, 
    };
var model_config={
    uiMode:ui_default.uiMode,
    driveMode:"undefined", 
}

var oha_timer=null;

$(window).ready(function(){

//var _js = document.createElement('script');
//_js.src = 'oha.files/tempCtrl.js';
//document.head.appendChild(_js);
    
$.fn.olaser()
$("#preloadDiv").append("<img src='"+oha_config.tag_icon+"'/>");
if(oha_config.debug_mode) {
	OHA_DevReady(0, oha_config.model);
	$("body").prepend('<div id="dbg_title" style="position: absolute;font-size:5vw;width:100%;text-align:center;background-color:gray;color:red;opacity:0.5"></div>');
	$("#dbg_title").append('<h1 id="dbg_msg">Debug Mode</h1>');
}
	$(".oha_scroff").css({"background-color":"rgba(0,0,0,0.5)"});
    oha_timer=$("#timer text,#xTimer text").oha_timer({
        maxTime:99, 
        timeup: function() {
            console.log("updated timeup")
            _timeup();
        }, 
    })
//    oha_api.readLocalJson(function(_data) {
//        console.log("Read Json OK, power_ctrl_mode: "+_data.opower_options.power_ctrl_mode);
//        if(_data.hasOwnProperty("opower_options")) {
//            var _powerOpt=_data.opower_options;
//            if(_powerOpt.hasOwnProperty("power_ctrl_mode")) {
//                switch(_powerOpt.power_ctrl_mode) {
//                    case "pwm":
//                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
//                        break;
//                    case "opower":
//                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPower);
//                        break;
//                    case "ocup":
//                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);
//                        break;
//                    default:
//                        
//                                                }
//            }
//        }
//        cookieInit();
//    }, 
//                       function(_msg) {     // fail function();
//        console.log("Read Json fail, msg="+_msg);
//        cookieInit();
//    }
//                      )
//	cookieInit();
    oha_api.readJson(function(_data){
        if(_data.hasOwnProperty("opower_options")) {
            console.log("oha_api.readJson done!!, power_ctrl_mode: "+_data.opower_options.power_ctrl_mode);
            var _powerOpt=_data.opower_options;
            if(_powerOpt.hasOwnProperty("power_ctrl_mode")) {
                switch(_powerOpt.power_ctrl_mode) {
                    case "pwm":
                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
                        break;
                    case "opower":
                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPower);
                        break;
                    case "ocup":
                        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);
                        break;
                    default:
                        
                }
            }
            if(_powerOpt.hasOwnProperty("pwmSettings")) {
                pwmSettings(_powerOpt.pwmSettings);
            }
        }
		if(_data.hasOwnProperty("OHA_UI")) {
			_jOhaUi=_data.OHA_UI;
			if(_jOhaUi.hasOwnProperty("title")) {
//				$("#oha_title").text(_data.OHA_UI.title)
				$("#oha_title").text(getLocaleStr(_data.OHA_UI.title))
			}
		}
        cookieInit();        
    })
	if(isAllowUiOrientation) {
		oha_api.runOhaCmd("oha://orientation_true");
	}
	else {
		oha_api.runOhaCmd("oha://orientation_false");
	}
})

$(window).on("load", function(){
    cookieInit();
    setsize();
})

function pwmSettings(_jdata) {
    if(_jdata.hasOwnProperty("test_mode")) {
        if((typeof _jdata.test_mode=="boolean") && _jdata.test_mode) {
            pwmFunc.setTestMode();
        }
    }
    if(_jdata.hasOwnProperty("low")) {
        var _period=_jdata.low;
        pwmFunc.outputMode.low=_period.split("/");
        console.log("pwmSettings: low ="+pwmFunc.outputMode.low);
    }
    if(_jdata.hasOwnProperty("medium")) {
        var _period=_jdata.medium;
        pwmFunc.outputMode.medium=_period.split("/");
        console.log("pwmSettings: medium ="+pwmFunc.outputMode.medium);
    }
    if(_jdata.hasOwnProperty("high")) {
        var _period=_jdata.high;
        pwmFunc.outputMode.high=_period.split("/");
        console.log("pwmSettings: high ="+pwmFunc.outputMode.high);
    }
    if(_jdata.hasOwnProperty("timer_default")) {
        var _pwmTimer=oha_api.cookieRead(cookieConfig.pwmTimer.key, cookieConfig.pwmTimer.default);
        if(_pwmTimer==cookieConfig.pwmTimer.default) {
            pwmFunc.timer_set=parseInt(_jdata.timer_default);
            oha_api.cookieWrite(cookieConfig.pwmTimer.key, pwmFunc.timer_set);
        }
    }
}

$(window).ready(function() {
	console.log("window load cp0")
//    $("#refresh").hide();
//    console.log("isReadOnly="+oha_config.isReadOnly);
//    if(model_config.isReadOnly) {
//        $("#refresh").hide();
//    }
    winHeight=$(window).height();
    winWidth=$(window).width();
    refreshEnable(false);
//    $("#ohaMinView").show();
//    $("div.oha_ctrl").hide();
//    var _uiType=oha_api.cookieRead(cookieConfig.uiType.key, cookieConfig.uiType.default);
//    if(_uiType==cookieConfig.uiType.options.normal) {
//        if(oha_api.getPlateForm()=="iOS") {
//            setTimeout('OHA_UI()',1000);
//        }
//        else {
//            OHA_UI();
//        }
//    }
//    else {
//        if(oha_api.getPlateForm()=="iOS") {
//            setTimeout('show_tag()',1000);
//        }
//        else {
//            show_tag();
//        }
//    }
    setsize();
	if((oha_api.getPlateForm()=='Android') && (oha_api.getAppVer()>=345)) {
		$("#xBtnSettings").hide();
		$("#xBtnMin").show();
	}
	else {
		$("#xBtnSettings").show();
		$("#xBtnMin").hide();
	}
//    cookieInit();
    console.log("PlateForm("+oha_api.getPlateForm()+")")
    if(oha_api.getPlateForm()=="Android") {
        $("#earPhone").hide();
        $("#usbOtg").show();
        if(oha_api.getAppVer()<=187) {
            $("#itemUiAlpha").hide();
        }
    }
    if(oha_config.isReadOnly) {
        $("#refresh").hide();
    }
//    if(oha_config.plateForm=="iOS") {
//        $("html").css({"opacity":"0.8"})
//    }
    document.documentElement.style.webkitUserSelect='none';
    if(oha_api.ohaConfig.plateForm=="iOS" && oha_api.getAppVer() <= 460) {
        setTimeout(function() {
            oha_api.runOhaCmd("oha://lightness_90");
        }, 1000);
    }
	if(isAllowUiOrientation) {
		oha_api.runOhaCmd("oha://orientation_true");
	}
	else {
		oha_api.runOhaCmd("oha://orientation_false");
	}

});

$(window).resize(function() {
	setsize();
//    $("#setMenuTitleText").css({'font-size':sf*0.05+'px', 'line-height':$("#oha_ui").height()*0.16+'px'});
});

//const uiRateV=414/581;
const uiRateV=3/5;
const uiRateH=3/2;
function setsize() {
//    var _h=window.innerHeight;
//    var _w=window.innerWidth;
    var _h=$(window).height();
    var _w=$(window).width();
	console.log("setsize("+_w+", "+_h+")");
//	var sf=_h/1.5;
//	if(sf>_w) {
//		sf=_w;
//	}
	var _width=_w*0.8;
	var _height=_h*0.8;
	var _isLandscape=false;
	ui_config.isLandscape=false;
//	if(isAllowUiOrientation) {
		if(_h*uiRateV>_w) {
			_height=_width/uiRateV;	
			setOrientation(false);
	//		if(typeof helpManager !="undefined") {
	//			helpManager.setOrientation(false);
	//		}
		}
		else if(_h>_w){
			_width=_height*uiRateV;
			setOrientation(false);
	//		if(typeof helpManager !="undefined") {
	//			helpManager.setOrientation(false);
	//		}
		}
		else if(_h >_w/uiRateH) {
			_height=_width/uiRateH;
			setOrientation(true);
	//		if(typeof helpManager !="undefined") {
	//			helpManager.setOrientation(true);
	//		}
			_isLandscape=true;
			ui_config.isLandscape=true;
		}
		else {
			_width=_height*uiRateH;
			setOrientation(true);
	//		if(typeof helpManager !="undefined") {
	//			helpManager.setOrientation(true);
	//		}
			_isLandscape=true;
			ui_config.isLandscape=true;
		}
//	}
//	else {
//		_isLandscape=false;
//		ui_config.isLandscape=false;
//		_width=_height*uiRateV;
//		setOrientation(false);
//	}
//	if(_isLandscape) {
//		$("#uiOptDesc").css({left: _width*0.1+"px", top: _h*0.1+_height*0.1+"px", width:_width*0.8+"px", height: _height*0.8+"px"});
//		$("#uiOptDesc").css({left: (_w*0.4-0.5*_width)+"px", top: _h*0.4-0.5*_height, width:_width*1+"px", height: _height*1+"px"});
//	}
//	else {
//		$("#uiOptDesc").css({left: 0.1*_w+_width*0.1+"px", top: _height*0.1+"px", width:_width*0.8+"px", height: _height*0.8+"px"});
//		$("#uiOptDesc").css({left: (_w*0.4-0.5*_width)+"px", top: _h*0.4-0.5*_height, width:_width*1+"px", height: _height*1+"px"});
//	}
	$("#uiOptDesc").css({left: 0.5*(_w-_width*0.8)+"px", top: 0.5*(_h-_height*0.8)+"px", width:_width*0.8+"px", height: _height*0.8+"px"});
	if(_isLandscape) {
		var _uiRate=860/1200;
		var _uiFontFactor=0.02;
		var _uiDescTop=0.29;
		var _hRate=100/860;
		$("#uiOptDesc .topArea").css({"font-size": _width*0.035+"px"});
		$("#uiOptDesc").css({"font-size": _width*0.03+"px"});
		$("#uiOptDesc #uiDescCheckDiv").css({"font-size": _width*0.03+"px"});
		$("#uiMenuDiv .menuBottom").css({"font-size": _width*0.03+"px"});
		$("#uiOptHelpChk, #uiDescCheck").css({width: _width*0.03+"px", height: _width*0.03+"px"});
	}
	else {
		var _uiRate=864/480;
		var _uiFontFactor=0.04;
		var _uiDescTop=0.33;
		var _hRate=64/864;
		$("#uiOptDesc .topArea").css({"font-size": _height*0.035+"px"});
		$("#uiOptDesc").css({"font-size": _height*0.03+"px"});
		$("#uiOptDesc #uiDescCheckDiv").css({"font-size": _height*0.03+"px"});
		$("#uiMenuDiv .menuBottom").css({"font-size": _height*0.025+"px"});
		$("#uiOptHelpChk, #uiDescCheck").css({width: _height*0.03+"px", height: _height*0.03+"px"});
	}
	if(_h>_uiRate*_w) {
		console.log("case1, isLandScape="+_isLandscape+", _uiDescTop="+_uiDescTop);
//		$("#ui_desc_div").css({left: "2%", top: 0.4*(_h-_w*_uiRate)+0.8*_w*_uiRate*_uiDescTop+"px", width: "96%", height: 3*_w*_uiFontFactor+"px", fontSize:_w*_uiFontFactor+"px"});
		$("#ui_desc_div").css({left: "2%", top: 50+100*_w*_uiRate*(_uiDescTop-0.5)/_h+"%", width: "96%", height: 3*_w*_uiFontFactor+"px", fontSize:_w*_uiFontFactor+"px"});
		$("#new_ui").css({top: 0.4*(_h-_w*_uiRate)+"px", right:"0px", height:_w*_uiRate*0.8*_hRate, width:_w*_uiRate*0.8/0.85*_hRate});
	}
	else {
		console.log("case2, isLandScape="+_isLandscape+", _uiDescTop="+_uiDescTop);
//		$("#ui_desc_div").css({left: 0.4*(_w-0.96*_h/_uiRate)+"px", top: (0.1*_h+0.8*_h*_uiDescTop)+"px", width: _h*0.96*0.8/_uiRate+"px", height: 2*_h*_uiFontFactor/_uiRate+"px", fontSize:_h*_uiFontFactor/_uiRate+"px"});
		$("#ui_desc_div").css({left: 0.4*(_w-0.96*_h/_uiRate)+"px", top: (100*_uiDescTop)+"%", width: _h*0.96*0.8/_uiRate+"px", height: 2*_h*_uiFontFactor/_uiRate+"px", fontSize:_h*_uiFontFactor/_uiRate+"px"});
		$("#new_ui").css({top: "0px", right:0.4*(_w-_h/_uiRate)+"px", height:_h*0.8*_hRate, width:_h*0.8/0.85*_hRate});
	}
	var _menuH=_h*0.6;
	var _menuW=_w*0.4;
	if(_menuH/_menuW>34/30) {
		var _menuWx=_menuW;
		var _menuHx=(_menuW*34)/30;
	}
	else {
		var _menuWx=(_menuH*30)/34;
		var _menuHx=_menuH;
	}
	$("#uiMenuDiv .menuBottom").css({"bottom": 0.5*(_menuH-0.96*_menuHx)+"px", right: 0.5*(_menuW-0.8*_menuWx)+"px"});
	ui_config.width=_width;
	ui_config.height=_height;
	if(typeof helpManager !="undefined") {
		helpManager.resize(_width, _height);
	}
	var _left=(_w-_width)/2;
	var _top=(_h-_height)/2
//	$("div.oha_ctrl").css({"width":_width, "height":_height, "left":_left, "top":_top});
	var _menuW=_width*0.96;
	var _menuBorderW=_height*0.003;
	var _menuLeft=(_w-_menuW-_menuBorderW)*0.5;
	var _titleBorderRadius=_height*0.02;
	if(_isLandscape) {
		var _menuTitleFontSize=_height*0.05;
		var _menuMsgFontSize=_height*0.05;
		var _menuH=_height*0.9;
	}
	else {
		var _menuTitleFontSize=_height*0.035;
		var _menuMsgFontSize=_height*0.03;
		var _menuH=_height*0.6;
	}
	var _menuTop=(_h-_menuH-_menuBorderW)/2;
	$("#setMenuDiv").css({'width': _menuW, 'height': _menuH, 'top': _menuTop, 'left': _menuLeft, 'border-radius':_titleBorderRadius, 'border-width':_menuBorderW});
	$("#setMenuTitle").css({'border-top-left-radius':_titleBorderRadius, 'border-top-right-radius':_titleBorderRadius});
	$("#setMenuTitleText").css({'font-size':_menuTitleFontSize+'px', 'line-height':_menuTitleFontSize+'px'});
	$(".setMenuMsgText").css({'font-size':_menuMsgFontSize+'px'});
	$("#backBtn").css({'font-size':_menuMsgFontSize+'px'});
	$("#setMenuEnd").css({'border-bottom-left-radius':_titleBorderRadius, 'border-bottom-right-radius':_titleBorderRadius, 'border-width':_titleBorderRadius+'px'});
	$(".setMenuContent").css({'border-width':_menuBorderW+'px'});
	if(_isLandscape) {
	    $("#powerSaveMsg").css({'font-size':_width*0.08+'px','line-height':_width*0.08+'px'});
//		$("#new_ui").css({top: 0.5*(0.8*_h-_height)+"px", right:0.5*(0.8*_w-_width)+"px", height:_height*0.125, width:_height*0.15});
	}
	else {
		$("#powerSaveMsg").css({'font-size':_height*0.08+'px','line-height':_h*0.08+'px'});
//		$("#new_ui").css({top: 0.5*(0.8*_h-_height)+"px", right:0.5*(0.8*_w-_width)+"px", height:_height*0.074, width:_height*0.1});
	}
	var _locale=oha_api.getLocale().localeCode;
	if(_locale.indexOf("zh")==0) {
		$("#xBtnPower text").attr({"font-size":21});
	}
	else {
		$("#xBtnPower text").attr({"font-size":28});
	}
//    $("#bottomBar").css({'height':_height*0.2});
//    $("#ohaMinView").css({'height':_w*0.2+'px'});
//	console.log("set ohaMinView height, _w="+_w+", height="+$("#ohaMinView").css("height")+", width="+$("#ohaMinView").css("width"));
//	$("#ohaMinBg").css({"height":_h*0.625});
//	$("#new_ui").css({top:_height*0.09});
}

function cookieInit() {
    // =========== Check for previous version =============
//    var _prevUiVer=$.cookie('uiVer');
    localeSel=Number(oha_api.cookieRead(cookieConfig.localeType.key, localeOptions.SystemSelected));
    var _prevUiVer=oha_api.cookieRead('uiVer', oha_config.sw_ver);
    if(_prevUiVer==oha_config.sw_ver) {
        oha_api.cookieWrite('uiVer', _prevUiVer);
    }
    var _pVer=parseFloat(_prevUiVer);
    if(_pVer !== oha_api.getAppVer()) {
//        $.cookie('uiVer', _pVer, {expires:365});
        oha_api.cookieWrite('uiVer', _pVer);
    }
    if(_pVer<2.46) {
        $.removeCookie('driveMode');
    }
    if(_pVer<2.458) {
        $.removeCookie('driveMode1');
    }
    // ====================================================
    var _uiType=oha_api.cookieRead(cookieConfig.uiType.key, cookieConfig.uiType.default);
    if(_uiType==cookieConfig.uiType.options.normal) {
        if(oha_api.getPlateForm()=="iOS") {
            setTimeout('OHA_UI()',1000);
        }
        else {
            OHA_UI();
        }
    }
    else {
        if(oha_api.getPlateForm()=="iOS") {
            setTimeout('show_tag()',1000);
        }
        else {
            show_tag();
        }
    }
    var _cookieTime=''
//    if(ui_config.uiMode=="normalUi") {
//        _cookieTime=$.cookie('timeSet');
//    }
//    else {
//        _cookieTime=$.cookie('timeSetOcup');
//    }
//    _cookieTime=$.cookie('timeSet');
	if(oha_api.getPlateForm()==oha_api.PlateFormOpt.Apple) {
		_cookieTime=oha_api.cookieRead('timeSet', 120);
	}
	else {
		_cookieTime=oha_api.cookieRead('timeSet', 60);
	}
    oha_timer.setTime(parseInt(_cookieTime));
    var _uiMode='';
//    _uiMode=oha_api.cookieRead('uiMode', 'normalUi');
    _uiMode=oha_api.cookieRead(cookieConfig.uiModePrev.key, uiModeDef.normal);
//    var _uiModeX=oha_api.cookieRead('uiModeX', 'normalUi');
    var _uiModeX=oha_api.cookieRead(cookieConfig.uiModeSet.key, uiModeDef.normal);

     if(_uiModeX==uiModeDef.normal) {
        ui_config.uiMode=_uiMode;
        switch(_uiMode) {
            case uiModeDef.oCup:
                oCupUI();
                break;
            case uiModeDef.oPowerPWM:
                oPowerPwmUi();
                break;
			case uiModeDef.oHeating:
				oHeatingUi();
				break;
            default:
                normalUI();
                break;
                      }
    }
    else {
        ui_config.uiMode=_uiModeX;
//        $("#uiSelMenu").hide();
        switch(_uiModeX) {
            case uiModeDef.oCup:
                oCupUI();
                break;
            case uiModeDef.oPowerPWM:
                oPowerPwmUi();
                break;
			case uiModeDef.oHeating:
				oHeatingUi();
				break;
            default:
                normalUI();
                break;
                      }
    }
//    if(_uiModeX==uiModeDef.oCup) {
//        oCupUI();
//    }
//    else if(_uiMode==uiModeDef.oCup) {
//        ui_config.uiMode=_uiMode;
//        oCupUI();
//    }
//    else {
//        normalUI();
//    }
    var _powerMode='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _powerMode=$.cookie('powerMode');
        _powerMode=oha_api.cookieRead('powerMode', '1');
    }
    else {
//        _powerMode=$.cookie('powerModeOcup');
        _powerMode=oha_api.cookieRead('powerModeOcup', '1');
    }

//    console.log("Read power mode("+_powerMode+")");
    if(_powerMode=='0') {
//            $("#powerSaveEnable").hide();
//            $("#powerSaveDisable").show();
        $("#itemPowerMode").find(".setItemIcon").css("background-image", "url('oha.files/light_on.png')");
//        $("#itemPowerMode").find(".setItemMsg h3").text("Power saving mode off");
        $("#itemPowerMode").find(".setItemMsg h3").text(getLocaleStr(MsgString.PowerSaveMenu.Off));
        _isPowerMode=false;
    }
//    var _cookieTime=$.cookie('timeSet');
    var _cookieSound='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _cookieSound=$.cookie('soundMode');
        _cookieSound=oha_api.cookieRead('soundMode', '1');
   }
    else {
//        _cookieSound=$.cookie('soundModeOcup');
        _cookieSound=oha_api.cookieRead('soundModeOcup', '1');
    }

    if(_cookieSound=='0') {
        $("#button_sound").find("line").show();
        oha_api.runOhaCmd("oha://loudness_-1");
//        window.location.href="oha://loudness_-1";
    }
    var _oCupInitTime='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _oCupInitTime=$.cookie('oCupAutoInitTime');
        _oCupInitTime=parseInt(oha_api.cookieRead('oCupAutoInitTime', '20'));
    }
    else {
//        _oCupInitTime=$.cookie('oCupAutoInitTimeOcup');
        _oCupInitTime=parseInt(oha_api.cookieRead('oCupAutoInitTimeOcup', '20'));
    }

    $("#initTimeSet text").text(_oCupInitTime);
    var _oCupIdleTime='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _oCupIdleTime=$.cookie('oCupAutoIdleTime');
        _oCupIdleTime=parseInt(oha_api.cookieRead('oCupAutoIdleTime', '10'));
    }
    else {
//        _oCupIdleTime=$.cookie('oCupAutoIdleTimeOcup');
        _oCupIdleTime=parseInt(oha_api.cookieRead('oCupAutoIdleTimeOcup', '10'));
    }
    if(_oCupIdleTime>0) {
        $("#activeSetting").css({"opacity": 1.0});
        _activeEnable=true;
    }
    $("#idleTime text").text(_oCupIdleTime);
    var _oCupActiveTime='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _oCupActiveTime=$.cookie('oCupAutoActiveTime');
        _oCupActiveTime=parseInt(oha_api.cookieRead('oCupAutoActiveTime', '2'));
    }
    else {
//        _oCupActiveTime=$.cookie('oCupAutoActiveTimeOcup');
        _oCupActiveTime=parseInt(oha_api.cookieRead('oCupAutoActiveTimeOcup', '2'));
    }
    $("#activeTime text").text(_oCupActiveTime);
    var _oCupAutoMode='';
    if(ui_config.uiMode==uiModeDef.normal) {
//        _oCupAutoMode=$.cookie('oCupAutoMode');
        _oCupAutoMode=oha_api.cookieRead('oCupAutoMode', '0');
    }
    else {
//        _oCupAutoMode=$.cookie('oCupAutoModeOcup');
        _oCupAutoMode=oha_api.cookieRead('oCupAutoModeOcup', '0');
    }
    if(_oCupAutoMode=='1') {
        $("#modeAuto").show();
        $("#modeManual").hide()
        $("#oCupAutoTimer").show();
        _itSetTime=parseInt($("#initTimeSet").find("text").text());
        $("#oCupAutoInitTimer text").text(setInitTimerFormat(_itSetTime));
        var _idleS=parseInt($("#idleTime").find("text").text());
        $("#oCupAutoIdleTimer text").text(setInitTimerFormat(_idleS));
        var _actS=parseInt($("#activeTime").find("text").text());
        $("#oCupAutoActiveTimer text").text(setInitTimerFormat(_actS));
//        $.cookie('oCupAutoMode', '1', {expires:365});
        if(ui_config.uiMode==uiModeDef.normal) {
//            $.cookie('oCupAutoMode', '1', {expires:365});
            oha_api.cookieWrite('oCupAutoMode', '1');
        }
        else {
//            $.cookie('oCupAutoModeOcup', '1', {expires:365});
            oha_api.cookieWrite('oCupAutoModeOcup', '1');
        }

//        $("#opBtn").css("opacity", 0.5);
    }
//    var _intv=$.cookie('drvIntvSet');
    var _intv=oha_api.cookieRead('drvIntvSet', ui_config.interval);
    $("#intvSetValue").text(_intv);
    $("#itemDrvIntv .setItemMsg .setMenuMsgText").text("Power interval: "+_intv+"s")
    ui_config.interval=_intv;
    var _drvMode='';
    _drvMode=oha_api.cookieRead('driveMode', ui_default.driveMode);
//    if(ui_config.uiMode==uiModeDef.normal) {
////        _drvMode=$.cookie('driveMode');
//        _drvMode=oha_api.cookieRead('driveMode', ui_default.driveMode);
//    }
//    else {
////        _drvMode=$.cookie('driveModeOcup');
//        _drvMode=oha_api.cookieRead('driveModeOcup', ui_default.driveMode);
//    }

//    ui_config.driveMode=_drvMode;
    console.log('_drvMode='+_drvMode)
    if(/^high[X]?$/.test(_drvMode)) {
//        drvHigh();
//        $("#itemDrvMode .setMenuMsgText").text("High power")
        $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode0));
    }
    else if(/^low[X]?$/.test(_drvMode)) {
//        drvLow();
//        $("#itemDrvMode .setMenuMsgText").text("Low power")
        $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode1))
    }
    else if(/^low2high[X]?$/.test(_drvMode)) {
//        drvLow2High();
//        $("#itemDrvMode .setMenuMsgText").text("Low to High power (intv:"+_intv+"s)")
        $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode2)+" ("+getLocaleStr(MsgString.Driving.mode3)+":"+_intv+"s)")
    }
     else if(/^high2low[X]?$/.test(_drvMode)){
//        drvHigh2Low();
        $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode3)+" ("+getLocaleStr(MsgString.Driving.intv)+":"+_intv+"s)")
    }
    if(_drvMode[_drvMode.length-1]=="X") {
        $("#itemDrvMode").hide();
    }

    var _isReadOnlyX=false;
    if(ui_config.uiMode==uiModeDef.normal) {
//        _isReadOnly=$.cookie('readOnly');
        _isReadOnlyX=oha_api.cookieRead('readOnly', 'false');
    }
    else {
//        _isReadOnly=$.cookie('readOnlyOcup');
        _isReadOnlyX=oha_api.cookieRead('readOnlyOcup', 'false');
    }
    var _isReadOnly=false;
    if(_isReadOnlyX=='true') {
        _isReadOnly=false;
    }
    console.log("_isReadOnly="+_isReadOnly)
    if(_isReadOnly=='true') {
        $("#refresh").hide();
    }
//    var _alpha=$.cookie('alphaSet');
    var _alpha=parseInt(oha_api.cookieRead('alphaSet', '20'));
    if(oha_api.getPlateForm()=="Android") {
        oha_api.setUiAlpha((100-_alpha)/100);
    }
    else {  // iOS
//        $("html").css({"opacity":(100-_x)/100})
        $("html").css({"opacity":(100-_alpha)/100})
    }
    $("#alphaSetValue").text(_alpha);
//    $("#itemUiAlpha .setItemMsg .setMenuMsgText").text("Transparency: "+_alpha+"%")
    $("#itemUiAlpha .setItemMsg .setMenuMsgText").text(getLocaleStr(MsgString.Transparency)+": "+_alpha+"%")
	setLocale();
	
	curLaserFidx=parseInt(oha_api.cookieRead(cookieConfig.laserFreqIdx.key, cookieConfig.laserFreqIdx.default));
	$("#freqTxt").text(olaserFreqTable[curLaserFidx]+" Hz");
}

function drvHigh() {
    $("#drvMenuSvg").hide();
    $("#setMenuDiv").css({"z-index":1000})
//    $("#itemDrvMode .setMenuMsgText").text("High power")
    $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode0));
    ui_config.driveMode='high';
    oha_api.cookieWrite('driveMode', 'high');
//    if(ui_config.uiMode==uiModeDef.normal) {
////        $.cookie('driveMode', 'high', {expires:365});
//        oha_api.cookieWrite('driveMode', 'high');
//    }
//    else {
////        $.cookie('driveModeOcup', 'high', {expires:365});
//         oha_api.cookieWrite('driveModeOcup', 'high');
//   }

}

function drvLow() {
    $("#drvMenuSvg").hide();
    $("#setMenuDiv").css({"z-index":1000})
//    $("#itemDrvMode .setMenuMsgText").text("Low power")
    $("#itemDrvMode .setMenuMsgText").text(getLocaleStr(MsgString.Driving.mode1))
    ui_config.driveMode='low';
    oha_api.cookieWrite('driveMode', 'low');
//    if(ui_config.uiMode==uiModeDef.normal) {
////        $.cookie('driveMode', 'low', {expires:365});
//         oha_api.cookieWrite('driveMode', 'low');
//    }
//    else {
////        $.cookie('driveModeOcup', 'low', {expires:365});
//         oha_api.cookieWrite('driveModeOcup', 'low');
//    }
}

function drvLow2High() {
    $("#drvMenuSvg").hide();
    $("#intvMenuSvg").show();
//    $("#intvMenuSvg").addClass("L2H");
    $("#intvMenuBackBtn").attr({"class":"L2H"})
//    $("#itemDrvMode .setMenuMsgText").text("Low to High power")
    ui_config.driveMode='low2high';
    oha_api.cookieWrite('driveMode', 'low2high');
//    if(ui_config.uiMode==uiModeDef.normal) {
////        $.cookie('driveMode', 'low2high', {expires:365});
//        oha_api.cookieWrite('driveMode', 'low2high');
//    }
//    else {
////        $.cookie('driveModeOcup', 'low2high', {expires:365});
//        oha_api.cookieWrite('driveModeOcup', 'low2high');
//    }
}

function drvHigh2Low() {
    $("#drvMenuSvg").hide();
    $("#intvMenuSvg").show();
//    $("#intvMenuSvg").addClass("H2L");
    $("#intvMenuBackBtn").attr({"class":"H2L"})
//    $("#setMenuDiv").css({"z-index":1000})
//    $("#itemDrvMode .setMenuMsgText").text("High to Low power")
    ui_config.driveMode='high2low';
    oha_api.cookieWrite('driveMode', 'high2low');
//    if(ui_config.uiMode==uiModeDef.normal) {
////        $.cookie('driveMode', 'high2low', {expires:365});
//        oha_api.cookieWrite('driveMode', 'high2low');
//    }
//    else {
////        $.cookie('driveModeOcup', 'high2low', {expires:365});
//        oha_api.cookieWrite('driveModeOcup', 'high2low');
//    }
}

function OHA_TEST(i) {
    console.log("OHA_TEST("+i+")");
}

function isOcupping() {
        return (ui_config.uiMode==uiModeDef.oCup);
}

function isSlowUp() {
        return (ui_config.driveMode=="low2high");
}

var DeviceId=-1;
oha_api.UiNew=function(_ver) {
    $("#new_ui").show();
}

oha_api.DevPlugIn=function() {
    DeviceId=oha_api.DeviceId;
    ohaCheckModel(arguments[0]);
    oha_power="off";
    ui_config.isDevPlugIn=true;
//        oha_api.setToastPos();
    $("#oha_menu").hide();
//        OHA_UI();
//            if(!isReadOnly) {
////                $("#refresh").show();
//                refreshEnable(true);
//            }
    refreshEnable(true);
    $("#powerUnconnected,#xBtnPowerUnconnected").hide();
//    switch(ui_config.uiMode) {
//        case uiModeDef.normal:
//            normalUI();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.normal);
//            break;
//        case uiModeDef.oCup:
//            oCupUI();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);
//            break;
//        case uiModeDef.oPowerPWM:
//            oPowerPwmUi();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
//            break;
//        default:
//            normalUI();
//            oha_api.cookieRemove(cookieConfig.uiModeSet.key);
//            break;
//                           }
    switch(ui_config.uiMode) {
        case uiModeDef.normal:
            normalUI();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.normal);
            break;
        case uiModeDef.oCup:
            oCupUI();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);
            break;
        case uiModeDef.oPowerPWM:
            oPowerPwmUi();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
            break;
        case uiModeDef.oHeating:
			oHeatingUi();
//            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
            break;
        default:
            normalUI();
//            oha_api.cookieRemove(cookieConfig.uiModeSet.key);
            break;
                           }
	$("#powerStusMsg").text(getLocaleStr(MsgString.PowerStusMsg.Off));
//    if(model_config.uiMode==uiModeDef.oCup) {
//        oCupUI();
//        $("#uiSelMenu").hide();
//    }       // Normal UI
//    else {
//        $("#uiSelMenu").show();
//        if(ui_config.uiMode==uiModeDef.normal) {
//            normalUI();
//        }
//        else {
//            oCupUI();
//        }
//    }
    if(model_config.driveMode!=="undefined") {
        if(ui_config.driveMode=="high") {
            drvHigh();
        }
        else if(ui_config.driveMode=="low") {
            drvLow();
        }
        else if(ui_config.driveMode=="low2high") {
            drvLow2High();
        }
         else {
            drvHigh2Low();
        }
        $("#itemDrvMode").hide();
    }
    else {
        $("#itemDrvMode").show();
    }
//    else {
//        drvDirect();
//    }

//			$("#uiMask").hide();
//			alert("Hello");
//    DeviceId=_id;
//			loadingover();
    _init();
    _poweroffx();
    _sendCurLightness();
//        counting_time=set_time;
//			console.log("timer_create.counting_time="+count_time);
    if(oha_api.ohaConfig.plateForm=="iOS" && oha_api.getAppVer() <= 460) {
        oha_api.runOhaCmd("oha://lightness_90");
    }
//	pwmFunc.setTestMode(true);
	if(pwmFunc.isRunning()) {
		pwmFunc.stopPwm();
	}
    if($("#helpIcon").hasClass("isShow")) {
		helpManager.showHelp(true, 1);
	}
}

oha_api.DevPlugOut=function(){
    oha_api.showToast("Device unconnected");
    initUI();
    ui_config.isDevPlugIn=false;
    DeviceId=-1;
//			turn_off();
    poweroff();
    _lightOn();
    time_stop();
//			plugout();
//			$("#timer").text(settimeform(set_time));
//			$("#uiMask").show();
    $("#powerUnconnected,#xBtnPowerUnconnected").show();
    $("#powerBtnNormal,#xBtnPowerNormal").hide();
    $("#powerBtnPWM,#xBtnPowerPWM").hide();
    $("#powerBtnOcup,#xBtnPowerOcup").hide();
	$("#powerStusMsg").text(getLocaleStr(MsgString.PowerStusMsg.Unconnected));
//            $("#refresh").hide();
//        $("#uiSelMenu").show();
//        $("#itemDrvMode").show();
    refreshEnable(false);
//            if(ui_config.isOcupping()) {
//                $("#opBtn").hide();
//                $("#modeBtn").hide();
//                $("#opBtn").css("opacity", 1.0);
//            }
//        console.log("lightness-2 cp2");
    oha_api.runOhaCmd("oha://lightness_-2")
	if(pwmFunc.isRunning()) {
		pwmFunc.stopPwm();
	}
    if($("#helpIcon").hasClass("isShow")) {
		helpManager.showHelp(true, 0);
	}
}

function _init() {
	if(!oha_config.debug_mode) {
        oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:00:H,00:H,05:H,00:H,00:H,AA:H,AA");
//		window.location.href="oha://cw_"+DeviceId+"_G:02:00:H,00:H,05:H,00:H,00:H,AA:H,AA";
	}
}

function initUiConfig() {
    ui_config={
        isDevPlugIn:false, 
        uiMode:ui_default.uiMode, 
        driveMode:ui_default.driveMode, 
    };
    model_config={
        uiMode: uiModeDef.normal,
        driveMode:"undefined", 
		isBlueTooth:false
    };
}

function ohaCheckModel(_model) {
//    initUiConfig();
    var _modelArray=_model.split(":");
    var _isReadOnly=false;
//	oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.normal);
	model_config.uiMode=uiModeDef.normal;
//	ui_config.uiMode=uiModeDef.normal;
	ui_config.uiMode=oha_api.cookieRead(cookieConfig.uiModePrev.key, uiModeDef.normal);
//	oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.normal);
    for(var i=1; i<_modelArray.length;i++) {
        var _p=_modelArray[i];
        console.log("_p="+_p);
        if(_p=='RO') {
//            $("#refresh").hide();
            _isReadOnly=true;
        }
        else if(_p=='CUP') {
            model_config.uiMode=uiModeDef.oCup;
            ui_config.uiMode=uiModeDef.oCup;
            oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);

//            $.cookie('uiMode', 'oCuppingUi', {expires:365});
        }
        else if((_p=='PWM') || (_p=='PWMX')) {
            model_config.uiMode=uiModeDef.oPowerPWM;
            ui_config.uiMode=uiModeDef.oPowerPWM;
			oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oPowerPWM);
//            $.cookie('uiMode', 'oCuppingUi', {expires:365});
			if(_p=='PWMX') {
				pwmFunc.timeFactor=200;
			}
        }
		else if(_p=='BT') {
			model_config.isBlueTooth=true;
		}
        else if(_p=='HEAT') {
            model_config.uiMode=uiModeDef.oHeating;
            ui_config.uiMode=uiModeDef.oHeating;
			oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oHeating);
//            $.cookie('uiMode', 'oCuppingUi', {expires:365});
        }
        else if(/^DRV[0-3]$/.test(_p)) {     // oPump slow up mode
            var _i=parseInt(_p.substring(3));
            switch(_i) {
                case 0:
                    ui_config.driveMode="high";
                    model_config.driveMode="high";
                    break;
                case 1:
                    ui_config.driveMode="low";
                    model_config.driveMode="low";
                    break;
                case 2:
                    ui_config.driveMode="low2high";
                    model_config.driveMode="low2high";
                    break;
                case 3:
                    ui_config.driveMode="high2low";
                    model_config.driveMode="high2low";
                    break;
            }
//            ui_config.driveMode="2-Steps";
//            $.cookie('driveMode', '2-Steps', {expires:365});
        }
    }
	if((model_config.uiMode==uiModeDef.oHeating)&&model_config.isBlueTooth) {
		tempCtrl.setBT(true);
	}
    if(_isReadOnly || (oha_config.isReadOnly)) {
        $("#refresh").hide();
    }
    else {
        $("#refresh").show();
    }
//    $.cookie('readOnly', _isReadOnly?'true':'false', {expires:365});
    oha_api.cookieWrite('readOnly', _isReadOnly?'true':'false');
//    if(model_config.uiMode==uiModeDef.normal) {
////        $.cookie('uiModeX', 'normalUi', {expires:365});
////        oha_api.cookieWrite('uiModeX', 'normalUi');
//        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.normal);
////        var _uiMode=$.cookie('uiMode');
//        var _uiMode=oha_api.cookieRead(cookieConfig.uiModePrev, cookieConfig.uiModePrev.default);
//        if(/^oCuppingUi[X]?$/.test(_uiMode)) {
////            console.log('ui_config.uiMode="oCuppingUi"')
//            ui_config.uiMode=uiModeDef.oCup;
////            $.cookie('uiMode', "oCuppingUi", {expires:365});
//        }
//        else {
////            console.log('ui_config.uiMode="normalUi"')
//            ui_config.uiMode=uiModeDef.normal;
////            $.cookie('uiMode', "normalUi", {expires:365});
//        }
//        if(model_config.driveMode!=="undefined") {
//            ui_config.driveMode=model_config.driveMode;
//            $("#itemDrvMode").hide();
////            $.cookie('driveMode', model_config.driveMode+"X", {expires:365});
////            oha_api.cookieWrite('driveMode', model_config.driveMode+"X");
//        }
//    }
//    else {
////        $.cookie('uiModeX', 'oCuppingUi', {expires:365});
////        oha_api.cookieWrite('uiModeX', 'oCuppingUi');
//        oha_api.cookieWrite(cookieConfig.uiModeSet.key, uiModeDef.oCup);
////        $.cookie('readOnlyOcup', _isReadOnly?'true':'false', {expires:365});
//        oha_api.cookieWrite('readOnlyOcup', _isReadOnly?'true':'false');
//        if(model_config.driveMode!=="undefined") {
//            ui_config.driveMode=model_config.driveMode;
//            $("#itemDrvMode").hide();
////            $.cookie('driveModeOcup', model_config.driveMode+"X", {expires:365});
////            oha_api.cookieWrite('driveModeOcup', model_config.driveMode+"X");
//        }
//   }
//    oha_api.cookieWrite('driveMode', model_config.driveMode+"X");
}

function OHA_UI() {
    oha_api.runOhaCmd("oha://bodySize_full");
    $("#oha_menu").hide();
    $("div.oha_ctrl").fadeIn(1000);
//	$(".oha_tag").hide();
//    $("#ohaMinViewSvg").hide();
//	console.log("#ohaMinView.hide() cp0")
    $("#ohaMinView").hide();
    oha_api.cookieWrite(cookieConfig.uiType.key, cookieConfig.uiType.options.normal);
    setsize();
}

function isOlaserPwm() {
//	console.log("isOlaserPwm, fwVer="+oha_api.getFwVer());
	return ((oha_api.getFwVer()>=2.0) && 
			(oha_api.cookieRead(cookieConfig.uiModePrev.key, uiModeDef.normal)==uiModeDef.normal) 
			&& (curLaserFidx!=0));
}

function _poweron(isDirect){
    if(typeof isDirect=="undefined") {
        isDirect=false;
    }
	if(!oha_config.debug_mode) {
//        if(isOcupping() && ($("#modeAuto").css("display")!=="none")){
////            initTimerStart();
//            if(!isOcupAutoInitPeriod) {
//                playAutoMode();
//                return;
//            }
////            else {
////                initTimerStart();
////            }
//        }
		var _isOlaserPwm=isOlaserPwm();
		if(_isOlaserPwm) {
			var _period=Math.round((125/olaserFreqTable[curLaserFidx])).toString(16);
		}
		if(isDirect) {
			if(_isOlaserPwm) {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,05:H,00:H,00:H,"+_period+":H,"+_period);
			}
			else {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,AA")
			}
			return;
		}
		if(ui_config.driveMode=="low") {
			if(_isOlaserPwm) {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,01:H,00:H,00:H,"+_period+":H,"+_period);
			}
			else {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,01:H,00:H,00:H,AA")
			}
		}
		else if(ui_config.driveMode=="low2high") {
			if(_isOlaserPwm) {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,01:H,00:H,00:H,"+_period+":H,"+_period);
			}
			else {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,01:H,00:H,00:H,AA")
			}
			slowTimer=setTimeout(function(){slowUp()}, (ui_config.interval)*1000);
		}
		else if(ui_config.driveMode=="high2low") {
			if(_isOlaserPwm) {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,05:H,00:H,00:H,"+_period+":H,"+_period);
			}
			else {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,AA")
			}
			slowTimer=setTimeout(function(){slowDown()}, (ui_config.interval)*1000);
		}
		else{
			if(_isOlaserPwm) {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,04:H,00:H,00:H,"+_period+":H,"+_period);
			}
			else {
				oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,04:H,00:H,00:H,AA")
			}
		}
	}
}

function slowUp() {
//    oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,05:H,00:H,00:H,55');
	var _isOlaserPwm=isOlaserPwm();
	if(_isOlaserPwm) {
		var _period=Math.round((125/olaserFreqTable[curLaserFidx])).toString(16);
		oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,05:H,00:H,00:H,"+_period+":H,"+_period);
	}
	else {
		oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,05:H,00:H,00:H,AA');
	}
}

function slowDown() {
	var _isOlaserPwm=isOlaserPwm();
	if(_isOlaserPwm) {
		var _period=Math.round((125/olaserFreqTable[curLaserFidx])).toString(16);
		oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:03:H,00:H,04:H,00:H,00:H,"+_period+":H,"+_period);
	}
	else {
		oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,04:H,00:H,00:H,55');
	}
//    oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,01:H,00:H,00:H,AA');
//    oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,04:H,00:H,00:H,55');
}

function _poweroff(){	
//    console.log("_poweroff()");
	if(!oha_config.debug_mode) {
//        if(isOcupping() && ($("#modeAuto").css("display")!=="none")){
//            stopAutoMode((oha_power=="off"));
//        }
        if(/^(high|low)[2](high|low)$/.test(ui_config.driveMode)) {
            clearTimeout(slowTimer);
        }
//            console.log("_poweroff()")
            oha_api.runOhaCmd("oha://cw_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,55")
//        window.location.href="oha://cw_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,55";
	}
//	else {
//		console.log('oha poweroff command');
//	}
}


function _poweroffx(){			// Cmd for excuting when app onDestroy
	if(!oha_config.debug_mode) {
        oha_api.runOhaCmd("oha://cx_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,55")
//	 	window.location.href="oha://cx_"+DeviceId+"_G:02:01:H,00:H,05:H,00:H,00:H,55";
	}
}

function _sendCurLightness() {
	if(oha_config.debug_mode) {
		console.log("Send current lightness:"+_lightNo);
	}
    oha_api.runOhaCmd("oha://lightness_"+_lightNo);
//	window.location.href="oha://lightness_"+_lightNo;
}

function _loadurl(_url) {
//	alert("hello("+_url+")");
	$("#oha_iframe").attr("src", _url);
}

function _timeup() {
//    console.log("_timeup")
//    var _uiMode=oha_api.cookieRead(cookieConfig.uiModeSet.key, cookieConfig.uiModeSet.default);
	if((oha_api.getPlateForm()=='Android') && (oha_api.getAppVer()>=345)) {
		oha_api.runOhaCmd("oha://countdown_-1");
	}
	if($("#powerBtnPWM").css("display")!="none") {
		poweroffPwm();
	}
	else {
		poweroff();
	}
//    if(_uiMode==uiModeDef.oPowerPWM){
////        console.log("_timeup._uiMode==oPowerPWM")
////        $("#powerOnPWM,#xPowerOnPWM").hide();
////        $("#powerOffPWM,#xPowerOffPWM").show();
//        poweroffPwm();
//    }
//    else {
//        poweroff();
//    }
    $(".oha_scroff").hide();
	oha_api.runOhaCmd('oha://cw_'+DeviceId+'_G:02:01:H,00:H,05:H,00:H,00:H,55');
	oha_api.runOhaCmd('oha://sound')
	oha_api.runOhaCmd('oha://lightness_-2');
	if($("#ohaMinView").css("display")!=="none"){
		setBarLayout();
	}
//	checkDOM();
}

function checkDOM() {
	var _uiMode=oha_api.cookieRead(cookieConfig.uiModePrev.key, uiModeDef.normal);
    if(_uiMode==uiModeDef.oPowerPWM){
        if($("#powerOffPWM").css("display")=="none") {
			console.log("Warning!! #powerOffPWM is not displayed.");
			redoDOM();
			setTimeout(function(){checkDOM()}, 1000);
		}
		else {
			console.log("Pass!! #powerOffPWM is displayed.");
		}
    }
    else {
        if(ui_config.uiMode=="oCuppingUi") {
            if($("#powerOnOcup").css("display")!="none") {
				console.log("Warning!! #powerOnOcup is displayed.")
				redoDOM();
				setTimeout(function(){checkDOM()}, 1000);
			}
			else {
				console.log("Pass!! #powerOnOcup is not displayed");
			}
        }
        else {
            if($("#powerOnNormal").css("display")!="none") {
				console.log("Warning!! #powerOnNormal is displayed.");
				redoDOM();
				setTimeout(function(){checkDOM()}, 1000);
			}
			else {
				console.log("Pass!! #powerOnNormal is not displayed.");
			}
        }
    }
}

function redoDOM() {
    var _uiMode=oha_api.cookieRead(cookieConfig.uiModeSet.key, cookieConfig.uiModeSet.default);
    if(_uiMode==uiModeDef.oPowerPWM){
		$("#powerOnPWM,#xPowerOnPWM").hide();
		$("#powerOffPWM,#xPowerOffPWM").show();
    }
    else {
        poweroffDOM();
		oha_power="off"
		time_stop()
        if(ui_config.uiMode=="oCuppingUi") {
            $("#powerOnOcup,#xPowerOnOcup").hide();
            $("#powerOffOcup,#xPowerOffOcup").show();
            $("#uiSelMenu").css({"opacity":1.0});
        }
        else {
            $("#powerOnNormal,#xPowerOnNormal").hide();
            $("#powerOffNormal,#xPowerOffNormal").show();
            $("#uiSelMenu").css({"opacity":1.0});
        }

		$(".now_time").hide();
		$("#clock_icon").show();
		$("#setMenu").hide();
		$("#btn_brightness").show();
		refreshEnable(true);
        $("#modeBtn").css({"opacity":1.0})
        $("#opPause").show();
        $("#opResume").hide();
    }
    $(".oha_scroff").hide();
}

function _sendSound() {
	if(oha_config.debug_mode) {
		console.log('send sound');
	}
    oha_api.runOhaCmd('oha://sound');
//	window.location.href='oha://sound';
}

function _lightOn() {
	if(oha_config.debug_mode) {
		console.log('lightOn');
	}
	if($(".oha_scroff").css("display")!="none") {
		$(".oha_scroff").hide();
//		$("#button_light").find("line").hide();
        oha_api.runOhaCmd("oha://lightness_-2");
//		window.location.href="oha://lightness_-2";
	}
}

var _itStartTime;
var _itLastTime=-1;
var _itSetTime;
var _initTimer;
function initTimerStart() {
    isOcupAutoInitPeriod=true;
    _autoModeStatus=autoModeStusOption.initial;
    _itStartTime=new Date().getTime();
    _itLastTime=-1;
    _itSetTime=parseInt($("#initTimeSet").find("text").text());
    $("#oCupAutoInitTimer text").text(setInitTimerFormat(_itSetTime));
    $("#oCupAutoInitTimer text").attr({"fill":"#ff0000"});
    _poweron();
//    console.log("initTimerStart("+_itSetTime+")");
    _initTimer=setInterval(function() {
        var _curTime=new Date().getTime();
        var _period=Math.floor((_curTime-_itStartTime)/1000);
        var _lastTime=parseInt(_itSetTime-_period);
//        console.log("initTimerStart.setTimeout("+_lastTime+","+_itLastTime+")");
        if(_lastTime!==_itLastTime) {
//            console.log("update, _lastTime="+_lastTime)
            $("#oCupAutoInitTimer text").text(setInitTimerFormat(_lastTime));
            _itLastTime=_lastTime;
        }
        if(_lastTime<=0) {
//            $("#initTimerSvg").hide();
//            $("#oCupAutoInitTimer text").text(setInitTimerFormat(_itSetTime));
            $("#menuBg").hide();
            clearInterval(_initTimer);
            isOcupAutoInitPeriod=false;
            _autoModeStatus=autoModeStusOption.idle;
            initTimerUp();
        }
    }, 250);
}

function initTimerStop() {
    isOcupAutoInitPeriod=false;
    $("#powerOnBtn").hide();
    $("#powerOffBtn").show();
    _itSetTime=parseInt($("#initTimeSet").find("text").text());
    $("#oCupAutoInitTimer text").text(setInitTimerFormat(_itSetTime));
    $("#oCupAutoInitTimer text").attr({"fill":"#ffffff"});
    $("#oCupAutoIdleTimer text").text(setInitTimerFormat($("#idleTime text").text()));
    $("#oCupAutoActiveTimer text").text(setInitTimerFormat($("#activeTime text").text()));
    _poweroff();
    clearInterval(_initTimer);
}

function setInitTimerFormat(secs){
	if(typeof secs=="undefined"){
	  secs=0;
	}
	var themins=Math.floor(secs/60)
	if(themins>=10){	  
      showmin=themins.toString()      
	  }else{	 
      showmin="0"+themins.toString()      
	  }
	  
	var thesec=secs % 60;
	if(thesec >= 10){
	  showsec=thesec.toString()   		
	  }else{
	  showsec="0"+thesec.toString()   		  	
	  }   
	
	return  showmin+":"+ showsec
	  
}

function initTimerUp() {
//    console.log("initTimerIsUp");
    $("#oCupAutoInitTimer text").text(setInitTimerFormat(_itSetTime));
    $("#oCupAutoInitTimer text").attr({"fill":"#ffffff"});
//    poweron();
    playAutoMode();
}

//function _pause(){
//	 window.location.href="oha://cw_"+DeviceId+"_G:02:01:H,00:H,04:H,00:H,00:H,55";
//}

//function simPlugProblem() {
//	for(var i=0;i<5;i++) {
//		console.log("sim time "+i);
//		oha_api.DevPlugOut();
//		oha_api.DevPlugIn(oha_config.model);
//	}
//}
