var htmlStr='\
<div class="_custNameDiv">\
    <span class="_custName">Name</span>\
</div>\
<div class="_custValueUnitDiv">\
    <div class="_custValueDiv _custArea">\
        <span class="_custValue">Value</span>\
    </div>\
    <div class="_custUnitDiv _custArea">\
        <span class="_custUnit">unit</span>\
    </div>\
</div>\
<div class="_custDescDiv">\
    <span class="_custDesc">The XXXX sensor is made by OHA group</span>\
</div>\
';

var cssStr='\
<style>\
.odd ._jsContainer {\
    background-color:blue;\
}\
.even ._jsContainer {\
    background-color:red;\
}\
._jsContainer {\
    font-family:graynormal, Arial,"微軟正黑體",sans-serif;\
    font-size:3vw;\
}\
._jsContainer ._custValueUnitDiv::before {\
    content:"";\
    position:relative;\
    display:inline-block;\
    width:0;\
    height:100%;\
    vertical-align:middle;\
}\
._jsContainer ._custValueUnitDiv {\
    position:absolute;\
    text-align:center;\
    top:20%;\
    left:0;\
    width:100%;\
    height: 60%;\
}\
._jsContainer ._custArea {\
    position:relative;\
    display:inline-block;\
    color:white;\
    vertical-align:middle;\
}\
._jsContainer ._custValueDiv {\
    font-size:16vw;\
/*    background-color:green;*/\
}\
._jsContainer ._custUnitDiv {\
    font-size:4vw;\
/*    background-color:red;*/\
}\
._jsContainer ._custNameDiv {\
    position:absolute;\
    top:2%;\
    left:2%;\
    width:98%;\
    height:20%;\
    text-align:left;\
    font-size:6vw;\
}\
._jsContainer ._custDescDiv {\
    position: absolute;\
    bottom: 2%;\
    left: 0;\
    width: 100%;\
}\
<\style>';

var _face1Config=new Object();
function oha_sensor_js(_selector) {
//    $(_selector).find(".nameSection").text("Hello OHA oSensor!!");
    console.log("oha_sensor_js("+_selector+")")
    _face1Config.selector=_selector;
    $("head").append(cssStr);
    $(_selector).addClass("_jsContainer");
    $(_selector).html(htmlStr);
}

function oha_sensor_call (_sname, _value, _raw, _unit, _desc) {
//    var _newValue=parseFloat(_value)+parseFloat(_raw);
//    console.log("oha_sensor_call()");
    console.log("oha_sensor_call("+_sname+","+_value+","+_raw+","+_unit+","+_desc+")");
    var _newValue=_value;
    var _p=/^\d+(?:[.]\d*)*(?:[:]\d+(?:[.]\d*)*)*$/
    if(_p.test(_raw)) {
        var _plist=_raw.split(":");
        var _pvlist=[];
        for(var i=0;i<_plist.length;i++) {
            _pvlist[i]=parseFloat(_plist[i]);
        }
        _newValue=bmp085GetPressure(parseFloat(_value), _pvlist);
    }
    $("._jsContainer ._custNameDiv ._custName").text(_sname);
    $("._jsContainer ._custValueDiv ._custValue").text(_newValue);
    $("._jsContainer ._custUnitDiv ._custUnit").text(_unit);
    $("._jsContainer ._custDescDiv ._custDesc").text(_desc);
}

// This function only get the sum of _value and all the parameter, you can
// use it the calculate more complicate function
function bmp085GetPressure(_value, _plist) {
    var _ret=_value;
    for(var i=0;i<_plist.length;i++) {
        _ret+=_plist[i];
    }
    return Math.floor(_ret);
}

//function bmp085GetPressure(ac2, b2, b5, up){
//  var x1, x2, x3, b3, b6, p;
//  var b4, b7;
//
//  b6 = (b5 - 4000);
//
//  // Calculate B3
//  x1 = (b2 * (b6 * b6)>>12)>>11;
//  x2 = (ac2 * b6)>>11;
//  x3 = x1 + x2;
//  b3 = (((((long)ac1)*4 + x3)<<OSS) + 2)>>2;
//
//  // Calculate B4
//  x1 = (ac3 * b6)>>13;
//  x2 = (b1 * ((b6 * b6)>>12))>>16;
//  x3 = ((x1 + x2) + 2)>>2;
//  b4 = (ac4 * (unsigned long)(x3 + 32768))>>15;
////  x1 = (ac3 * (b5 - 4000))>>13;
////  x2 = (b1 * (((b5 - 4000) * (b5 - 4000))>>12))>>16;
////  x3 = (((ac3 * (b5 - 4000))>>13 + (b1 * (((b5 - 4000) * (b5 - 4000))>>12))>>16) + 2)>>2;
////  b4 = (ac4 * (unsigned long)((((ac3 * (b5 - 4000))>>13 + (b1 * (((b5 - 4000) * (b5 - 4000))>>12))>>16) + 2)>>2 + 32768))>>15;
//
//  b7 = ((unsigned long)(up - b3) * (50000>>OSS));
//
//  if (b7 < 0x80000000)
//    p = (b7<<1)/b4;
//  else
//    p = (b7/b4)<<1;
//
//  x1 = (p>>8) * (p>>8);
//  x1 = (x1 * 3038)>>16;
//  x2 = (-7357 * p)>>16;
//  p += (x1 + x2 + 3791)>>4;
//
//  long temp = p;
//  return temp;
//}

//function oha_sensor_value(_selector, _sensorValue) {
//    
//}
//test("hello");