(function(_jq){
    var calibrate_config_Html='\
				<select class="CaliProfile">\
				</select>\
				<button class="Login">Login</button>\
				<button class="InputData">Input</button>\
				<button class="ListData">List</button>\
				<button class="Calculate">Graph</button>\
				<button class="DeleteSelData">Delete Sel Data</button>\
                <div  class="listviewPanel"></div>\
				<div class="regressionPanel">\
                <canvas  class="regressionCanvas"></canvas>\
				</div>\
				<div class="loginPanel container">\
					<div class="eav eavSection1" style="top:0%;height:100%">\
						<div class="oha_value_section">\
							<span>User name:</span><input class="Username" type="text" value=0></input><br/>\
							<span>Password:</span><input class="Password" type="text" value=0></input><br/>\
							<button class="DoLogin">Connect</button>\
						</div>\
					</div>\
				</div>\
				<div class="inputviewPanel container">\
					<div class="eav eavSection2" style="top:0%;height:50%">\
						<div class="nameSection">\
							OAQ <span class="mini_nameSection">Original / Calibrated</span>\
						</div>\
						<div class="oha_value_section">\
							<div class="valueSection">\
								<span class="caliValueSection">64</span><span class="unitSection">&nbsp;uA(Max)</span>\
							</div>\
						</div>\
						<button class="ToggleDataInput">Click to lock UI.</button>\
						<div class="detailSection">\
							\
						</div>\
					</div>\
					<div class="eav eavSection1" style="top:50%;height:50%">\
						<div class="nameSection">\
							New Calibrated Value\
						</div>\
						<div class="oha_value_section">\
							<input class="TargetValue" type="text" value=0></input>\
							<button class="InsertData">Insert Data</button>\
						</div>\
					</div>\
				</div>\
    ';
    
    var _css="<style>\
		.oha_calibrate_config .caliValueSection{\
			display:inline-block;\
			font-size:8vh;\
		}\
        .oha_calibrate_config .CaliProfile {\
            position:absolute;\
			  top: 0;\
			  left: 0px;\
			  width: 100%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .InsertData {\
            position:absolute;\
			  top: 20%;\
			  left: 50%;\
			  width: 40%;\
			  height:50%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .ToggleDataInput {\
            position:absolute;\
			  top: 80%;\
			  left: 20%;\
			  width: 60%;\
			  height:20%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .Login {\
            position:absolute;\
			  top: 8%;\
			  left: 0%;\
			  width: 25%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .InputData {\
            position:absolute;\
			  top: 8%;\
			  left: 25%;\
			  width: 25%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .ListData {\
            position:absolute;\
			  top: 8%;\
			  left: 50%;\
			  width: 25%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .Calculate {\
            position:absolute;\
			  top: 8%;\
			  left: 75%;\
			  width: 25%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_calibrate_config .TargetValue {\
			position:absolute;\
			font-size:3vh;\
			text-align:center;\
			top:20%;\
			height:50%;\
			left:5%;\
			width:40%;\
		}\
        .oha_calibrate_config .DeleteSelData {\
            position:absolute;\
			  top: 16%;\
			  left: 0%;\
			  width: 24%;\
			  height:7%;\
			  outline: 0;\
			  font-size:2vh;\
			  border-width:0.2vh;\
			  border-style:solid;\
			  border-radius:1vh;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
		.oha_calibrate_config .listviewPanel {\
		  background: gray;\
		  position: absolute;\
		  top: 24%;\
		  left: 0;\
		  right: 0;\
		  bottom: 0;\
		  outline: 0;\
		  border: 1px solid white;\
		}\
		.oha_calibrate_config .inputviewPanel {\
		  background: gray;\
		  position: absolute;\
		  top: 16%;\
		  left: 0;\
		  right: 0;\
		  height:84%;\
		  outline: 0;\
		  border: 1px solid white;\
		}\
		.oha_calibrate_config .loginPanel {\
		  background: gray;\
		  position: absolute;\
		  top: 16%;\
		  left: 0;\
		  right: 0;\
		  height:84%;\
		  outline: 0;\
		  border: 1px solid white;\
		}\
		.oha_calibrate_config .slick-header.ui-state-default, .oha_calibrate_config .slick-headerrow.ui-state-default {\
		  width: 100%;\
		  overflow: hidden;\
		  border-left: 0px;\
		}\
		\
		.oha_calibrate_config .slick-header-columns, .oha_calibrate_config.slick-headerrow-columns {\
		  position: relative;\
		  white-space: nowrap;\
		  cursor: default;\
		  overflow: hidden;\
		}\
		\
		.oha_calibrate_config .slick-header-column.ui-state-default {\
		  position: relative;\
		  display: inline-block;\
		  overflow: hidden;\
		  -o-text-overflow: ellipsis;\
		  text-overflow: ellipsis;\
		  height: 16px;\
		  line-height: 16px;\
		  margin: 0;\
		  padding: 4px;\
		  border-right: 1px solid silver;\
		  border-left: 0px;\
		  border-top: 0px;\
		  border-bottom: 0px;\
		  float: left;\
		}\
		\
		.oha_calibrate_config .slick-headerrow-column.ui-state-default {\
		  padding: 4px;\
		}\
		\
		.oha_calibrate_config .slick-header-column-sorted {\
		  font-style: italic;\
		}\
		\
		.oha_calibrate_config .slick-sort-indicator {\
		  display: inline-block;\
		  width: 8px;\
		  height: 5px;\
		  margin-left: 4px;\
		  margin-top: 6px;\
		  float: left;\
		}\
		\
		.oha_calibrate_config .slick-sort-indicator-desc {\
		  background: url(images/sort-desc.gif);\
		}\
		\
		.oha_calibrate_config .slick-sort-indicator-asc {\
		  background: url(images/sort-asc.gif);\
		}\
		\
		.oha_calibrate_config .slick-resizable-handle {\
		  position: absolute;\
		  font-size: 0.1px;\
		  display: block;\
		  cursor: col-resize;\
		  width: 4px;\
		  right: 0px;\
		  top: 0;\
		  height: 100%;\
		}\
		\
		.oha_calibrate_config .slick-sortable-placeholder {\
		  background: silver;\
		}\
		\
		.oha_calibrate_config .grid-canvas {\
		  position: relative;\
		  outline: 0;\
		}\
		\
		.oha_calibrate_config .slick-row.ui-widget-content, .oha_calibrate_config.slick-row.ui-state-active {\
		  position: absolute;\
		  border: 0px;\
		  width: 100%;\
		}\
		\
		.oha_calibrate_config .slick-cell, .oha_calibrate_config .slick-headerrow-column {\
		  position: absolute;\
		  border: 1px solid transparent;\
		  border-right: 1px dotted silver;\
		  border-bottom-color: silver;\
		  overflow: hidden;\
		  -o-text-overflow: ellipsis;\
		  text-overflow: ellipsis;\
		  vertical-align: middle;\
		  z-index: 1;\
		  padding: 1px 2px 2px 1px;\
		  margin: 0;\
		  white-space: nowrap;\
		  cursor: default;\
		}\
		\
		.oha_calibrate_config .slick-group {\
		}\
		\
		.oha_calibrate_config .slick-group-toggle {\
		  display: inline-block;\
		}\
		\
		.oha_calibrate_config .slick-cell.highlighted {\
		  background: lightskyblue;\
		  background: rgba(0, 0, 255, 0.2);\
		  -webkit-transition: all 0.5s;\
		  -moz-transition: all 0.5s;\
		  -o-transition: all 0.5s;\
		  transition: all 0.5s;\
		}\
		\
		.oha_calibrate_config .slick-cell.flashing {\
		  border: 1px solid red !important;\
		}\
		\
		.oha_calibrate_config .slick-cell.editable {\
		  z-index: 11;\
		  overflow: visible;\
		  background: white;\
		  border-color: black;\
		  border-style: solid;\
		}\
		\
		.oha_calibrate_config .slick-cell:focus {\
		  outline: none;\
		}\
		\
		.oha_calibrate_config .slick-reorder-proxy {\
		  display: inline-block;\
		  background: blue;\
		  opacity: 0.15;\
		  filter: alpha(opacity = 15);\
		  cursor: move;\
		}\
		\
		.oha_calibrate_config .slick-reorder-guide {\
		  display: inline-block;\
		  height: 2px;\
		  background: blue;\
		  opacity: 0.7;\
		  filter: alpha(opacity = 70);\
		}\
		\
		.oha_calibrate_config .slick-selection {\
		  z-index: 10;\
		  position: absolute;\
		  border: 2px dashed black;\
		}\
        .oha_calibrate_config .regressionCanvas{\
		  background: gray;\
		  position: absolute;\
		  top: 0;\
		  left: 0;\
		  width: 80%;\
		  height: 80%;\
		  outline: 0;\
		  border: 1px solid white;\
        }\
        .oha_calibrate_config .regressionPanel{\
		  background: gray;\
		  position: absolute;\
		  top: 16%;\
		  left: 0;\
		  right: 0;\
		  bottom: 0;\
		  outline: 0;\
		  overflow: hidden;\
        }\
		.slick-cell-checkboxsel {\
			background: #f0f0f0;\
			border-right-color: silver;\
			border-right-style: solid;\
		}\
    </style>";
	function parseTime(seconds)
	{
		var h;
		var m;
		var s;
		
		s = Math.floor(seconds % 60);
		m = Math.floor((seconds / 60)) %60;
		h = Math.floor(seconds / 3600);
		
		if (h > 0)
			return parseInt(h)+":"+parseInt(m)+"'"+parseInt(s)+"''";
		else if (m>0)
			return parseInt(m)+"'"+parseInt(s)+"''";
		else
			return parseInt(s)+"''";
	}

    _jq.fn.oha_calibrate_config=function(_opt) {
        var self = this;
		var count=0;
		var source_index = 	[22, 33];
		var target_index = 	[44, 66];
		var predict_line = [];
		var awPredict = 1.0;
		var baPredict = 0.0;

        $(this).addClass("oha_calibrate_config");
        $('head').append(_css);
        var _default={
			profile_id: 1,
			aw: 1.0,
			ba: 0.0,
			server_url:"http://54.183.18.76/tmp/chartjs/",
			callback : null
        };
		var login_result = {"login":0};

        _jq.extend(_default, _opt);
		awPredict = _default.aw;
		baPredict = _default.ba;
		
		var callback = _default.callback;
		_default.callback = undefined;
		
		// list data
		var grid=null;
		var list_data = [];
		var profile_array = [];
		var display_title = "";
		var display_source= "";
		var display_target = "";
		var isProfileOwner = 0;
		var profileOwnerName = "";
		
		
        $(this).append(calibrate_config_Html);
		var ctx = _jq(self).find(".waveviewPanel")[0];
		
		var CaliProfile = _jq(self).find(".CaliProfile")[0];
		CaliProfile.addEventListener("change", function(event) { CaliProfileChange(event);});
		var InsertData = _jq(self).find(".InsertData")[0];
		InsertData.addEventListener("click", function(event) { InsertDataClick(event);});
		var DeleteSelData = _jq(self).find(".DeleteSelData")[0];
		DeleteSelData.addEventListener("click", function(event) { DeleteSelectDataClick(event);});
		
		var Login = _jq(self).find(".Login")[0];
		Login.addEventListener("click", function(event) { LoginClick(event);});
		var InputData = _jq(self).find(".InputData")[0];
		InputData.addEventListener("click", function(event) { InputDataClick(event);});
		var ListData = _jq(self).find(".ListData")[0];
		ListData.addEventListener("click", function(event) { ListDataClick(event);});

		var Calculate = _jq(self).find(".Calculate")[0];
		Calculate.addEventListener("click", function(event) { CalculateClick(event);});
		var DoLogin = _jq(self).find(".DoLogin")[0];
		DoLogin.addEventListener("click", function(event) {DoLoginClick(event);});

		var TargetValue = _jq(self).find(".TargetValue")[0];
		var listviewPanel = _jq(self).find(".listviewPanel")[0];
		var regressionPanel = _jq(self).find(".regressionPanel")[0];
		var regressionCanvas = _jq(self).find(".regressionCanvas")[0];
		var loginPanel = _jq(self).find(".loginPanel")[0];
		
		var oRegressionGraph = null;
		var inputViewPanel = _jq(self).find(".inputviewPanel")[0];
		var sourceValue = 0;
		
		var ToggleDataInput = _jq(self).find(".ToggleDataInput")[0];
		ToggleDataInput.addEventListener("click", function(event) {ToggleDataClick(event);});
		var isAllowSetValue = true;

		this.GetLock=function()
		{
			return !isAllowSetValue;
		}
		this.SetLock=function(isLock)
		{
			isAllowSetValue = !isLock;
			if (isAllowSetValue)
			{
				_jq(self).find(".ToggleDataInput").text("Click to lock UI");
			}
			else
			{
				_jq(self).find(".ToggleDataInput").text("Locked. Click to Unlock.");
			}
		}
		this.SetValue=function(value)
		{
			if (isAllowSetValue)
			{
				if ( (typeof value) !="number")
					sourceValue = parseFloat(value);
				else sourceValue = value;
				_jq(self).find(".caliValueSection").text(sourceValue+"/"+this.Calibrate(sourceValue).toFixed(1));
			}
		} 
		this.SwitchTo = function(index)
		{
			if (index ==0)
				LoginClick();
			else if (index == 2)
				ListDataClick();
			else if (index==3)
				CalculateClick();
			else
				InputDataClick();
		}
		this.Calibrate = function(source_value)
		{
			return parseFloat(source_value)*awPredict+baPredict;
		}
		
		function ToggleDataClick(event)
		{
			if (isAllowSetValue)
			{
				isAllowSetValue = false;
				_jq(self).find(".ToggleDataInput").text("Locked. Click to Unlock.");
			}
			else
			{
				isAllowSetValue = true;
				_jq(self).find(".ToggleDataInput").text("Click to lock UI.");
			}
		}

		function UpdateCalibrationData(cali_data)
		{
			console.log("cali_data="+cali_data);
			list_data.length = 0;
			source_index.length = 0;
			target_index.length = 0;
			predict_line=[];
			if (typeof cali_data != 'undefined' && typeof cali_data[0] != 'undefined' && typeof cali_data[0].aw != 'undefined')
			{
				awPredict = cali_data[0].aw;
				baPredict = cali_data[0].ba;
				predict_line = [
					[0, parseFloat(0 * awPredict) + parseFloat(baPredict)],
					[160, parseFloat(160 * awPredict) + parseFloat(baPredict)]
				];
			}
			else
			{
				awPredict = 1.0;
				baPredict = 0.0;
			}
			for (var i = 0; i < cali_data.length; i++)
			{
				if (typeof cali_data[i].aw == 'undefined')
				{
					list_data.push(cali_data[i]);
					source_index.push(cali_data[i].source);
					target_index.push(cali_data[i].target);
				}
			}

			CalculateRegression();
		}
		function CaliProfileChange(event)
		{
			var profileIndex = CaliProfile.options[CaliProfile.selectedIndex].value;
			
			//default set to disable Calibration.
			if (profileIndex == -1)
			{
				_default.profile_id = profileIndex;
			}
			else
			for (var i = 0; i < profile_array.length; i++)
			{
				if (profile_array[i].id == profileIndex)
				{
					console.log("name="+profile_array[i].name+",source="+profile_array[i].source+",target="+profile_array[i].target);
					display_title = profile_array[i].name;
					display_source = profile_array[i].source;
					display_target = profile_array[i].target;
					_default.profile_id = profileIndex;
					break;
				}
			}
			console.log("CaliProfile.selectedIndex="+CaliProfile.selectedIndex);
			console.log("profileIndex="+profileIndex);
			console.log("default profile id="+_default.profile_id);
			if (_default.profile_id==-1) // disable
			{
				//LoginClick();
				InputDataClick();
				_jq(self).find(".InsertData").attr('disabled', true);
				awPredict = 1.0;
				baPredict = 0.0;
				$(".Login").attr('disabled', true);
				$(".InputData").attr('disabled', true);
				$(".ListData").attr('disabled', true);
				$(".Calculate").attr('disabled', true);
				return;
			}
			else
			{
				$(".Login").attr('disabled', false);
				$(".InputData").attr('disabled', false);
				$(".ListData").attr('disabled', false);
				$(".Calculate").attr('disabled', false);
				
			}
			check_profile_owner();
			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
					console.log(xmlhttp.responseText);
					var cali_data = eval(xmlhttp.responseText);
					//_jq(self).find(".InsertData").attr('disabled', false);
					UpdateCalibrationData(cali_data);
					UpdateListViewPanel();
					UpdateRegressionChart();
				}
			}
			
			var url = _default.server_url+"get_cali_data.php?id="+profileIndex+"&type=raw";
			console.log("query url="+url);
			xmlhttp.open("GET",url,true);
			xmlhttp.send();

		}
		function LoginClick(event)
		{
			loginPanel.style.display = 'block';
			InsertData.style.display = 'none';
			DeleteSelData.style.display = 'none';
			TargetValue.style.display = 'none';
			listviewPanel.style.display = 'none';
			$(".inputviewPanel").hide();
			regressionPanel.style.display = 'none';
			UpdateListViewPanel();
		}
		
		function InputDataClick(event)
		{
			console.log("input click");
			//_jq(self).find(".InsertData").attr('disabled', false);
			loginPanel.style.display = 'none';
			InsertData.style.display = 'block';
			DeleteSelData.style.display = 'none';
			TargetValue.style.display = 'block';
			listviewPanel.style.display = 'none';
			//inputViewPanel.style.display='block';
			//inputViewPanel.show();
			$(".inputviewPanel").show();
			regressionPanel.style.display = 'none';
			//StartCalculate.style.display = 'none';
			UpdateListViewPanel();
		}
		function ListDataClick(event)
		{
			loginPanel.style.display = 'none';
			InsertData.style.display = 'none';
			DeleteSelData.style.display = 'block';
			TargetValue.style.display = 'none';
			listviewPanel.style.display = 'block';
			//inputViewPanel.style.display='none';
			//inputViewPanel.hide();
			$(".inputviewPanel").hide();
			regressionPanel.style.display = 'none';
			//StartCalculate.style.display = 'none';
			UpdateListViewPanel();
		}
		
		function CalculateClick(event)
		{
			loginPanel.style.display = 'none';
			InsertData.style.display = 'none';
			DeleteSelData.style.display = 'none';
			TargetValue.style.display = 'none';
			listviewPanel.style.display = 'none';
			//inputViewPanel.style.display='none';
			$(".inputviewPanel").hide();
			regressionPanel.style.display = 'block';
			//StartCalculate.style.display = 'block';
			UpdateRegressionChart();
		}
		
		function check_profile_owner()
		{
			isProfileOwner = 0;
			profileOwnerName = '';
			login_id = -1;
			
			if (typeof (login_result["login"]) == 'undefined' || login_result["login"]==0 || typeof login_result["id"] == 'undefined') 
			{
				login_id = -1;
			
			}
			else 
			{
				login_id = login_result["id"];
			}

			var profileIndex = CaliProfile.options[CaliProfile.selectedIndex].value;
			for (var i = 0; i < profile_array.length; i++)
			{
				if (profile_array[i].id == profileIndex)
				{
					if (profile_array[i].owner_id == login_id )
					{
						isProfileOwner = 1;
					}
					profileOwnerName = profile_array[i].owner_name;
					console.log(profile_array);
					break;
				}
			}

			console.log("isProfileOnwer="+isProfileOwner);
			if (isProfileOwner) 
			{
				$(".inputviewPanel .eavSection1 .oha_value_section .InsertData ").attr('disabled', false);
				$(".inputviewPanel .eavSection1 .oha_value_section .TargetValue ").attr('disabled', false);
				$(".DeleteSelData").attr('disabled', false);
				$(".inputviewPanel .eavSection1 .nameSection").html("New Calibrated Value");
			}
			else
			{
				$(".inputviewPanel .eavSection1 .oha_value_section .InsertData ").attr('disabled', true);
				$(".inputviewPanel .eavSection1 .oha_value_section .TargetValue ").attr('disabled', true);
				$(".inputviewPanel .eavSection1 .nameSection").html("Login as "+profileOwnerName+" to input data");
				$(".DeleteSelData").attr('disabled', true);
			}
			
		}
		function DoLoginClick(event)
		{
			var username = _jq(self).find(".Username")[0].value;
			var passwd = _jq(self).find(".Password")[0].value;

			var url = _default.server_url+"login.php?u="+username+"&p="+passwd;
			console.log(url);
			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
					console.log(xmlhttp.responseText);
					login_result = eval(xmlhttp.responseText);
					check_profile_owner();
				}
			}
			xmlhttp.open("GET",url,true);
			xmlhttp.send();
		}
		function DeleteSelectDataClick(event)
		{
			var profileIndex = CaliProfile.options[CaliProfile.selectedIndex].value;
			var rows = grid.getSelectedRows();
			//console.log(rows);
			var url = _default.server_url+"delete_cali_data.php?dataset_id="+profileIndex;
			var append = '';
			rows.forEach(
				function(row_id)
				{
					console.log(list_data[row_id]);
					if (append.length==0)
						append = list_data[row_id].id;
					else
						append = append + "_" + list_data[row_id].id;
				}
			);
			url = url + "&id=" + append;
			if (login_result['login']==1)
			{
				url = url + "&uid="+login_result["id"];
			}
			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
					var cali_data = eval(xmlhttp.responseText);
					UpdateCalibrationData(cali_data);
					UpdateListViewPanel();
					UpdateRegressionChart();
				}
			}
			xmlhttp.open("GET",url,true);
			xmlhttp.send();
		}
		function InsertDataClick(event)
		{
			var profileIndex = CaliProfile.options[CaliProfile.selectedIndex].value;
			var src = sourceValue;
			var target = _jq(self).find(".TargetValue")[0].value;
			
			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
					var cali_data = eval(xmlhttp.responseText);
					UpdateCalibrationData(cali_data);
					UpdateListViewPanel();
					UpdateRegressionChart();
				}
			}
			
			var url = _default.server_url+"insert_cali_data.php?id="+profileIndex+"&source="+src+"&target="+target;
			if (login_result['login']==1)
			{
				url = url + "&uid="+login_result["id"];
			}
			console.log("query url="+url);
			xmlhttp.open("GET",url,true);
			xmlhttp.send();
		}
		
		function linearRegression(y,x){
			var lr = {};
			var n = y.length;
			var sum_x = 0;
			var sum_y = 0;
			var sum_xy = 0;
			var sum_xx = 0;
			var sum_yy = 0;

			for (var i = 0; i < y.length; i++) {

				sum_x += x[i];
				sum_y += y[i];
				sum_xy += (x[i]*y[i]);
				sum_xx += (x[i]*x[i]);
				sum_yy += (y[i]*y[i]);
			} 

			lr['slope'] = (n * sum_xy - sum_x * sum_y) / (n*sum_xx - sum_x * sum_x);
			lr['intercept'] = (sum_y - lr.slope * sum_x)/n;
			lr['r2'] = Math.pow((n*sum_xy - sum_x*sum_y)/Math.sqrt((n*sum_xx-sum_x*sum_x)*(n*sum_yy-sum_y*sum_y)),2);

			return lr;
		}
		
		function CalculateRegression(event)
		{
			var lr = linearRegression(target_index, source_index);
			console.log("slope="+lr['slope']+",intercept="+lr['intercept']+",r2="+lr['r2']);
			awPredict = lr['slope'];
			baPredict = lr['intercept'];
			//return;
//			var max_source = Math.max(...source_index)*1.1;
			var max_source = Math.max.apply(null, source_index)*1.1;
			if (max_source > 255.0) max_source = 255.0;

			predict_line = [
				[0, parseFloat(0 * awPredict) + parseFloat(baPredict)],
				[max_source, parseFloat(max_source * awPredict) + parseFloat(baPredict)]
			];
			
			_default.aw = awPredict;
			_default.ba = baPredict;
			if (callback != null)
				callback(_default);
			
			UpdateRegressionChart();
			
			//
			var profileIndex = CaliProfile.options[CaliProfile.selectedIndex].value;

			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				}
			}
			var url = _default.server_url+"update_cali_coefficient.php?id="+profileIndex+"&aw="+awPredict+"&ba="+baPredict;
			xmlhttp.open("GET",url,true);
			console.log("query url="+url)
			xmlhttp.send();

		}
		
		function init() {
			var xmlhttp=new XMLHttpRequest();
			xmlhttp.onreadystatechange=function() {
				if (xmlhttp.readyState==4 && xmlhttp.status==200) {
					console.log(xmlhttp.responseText);
					profile_array = eval(xmlhttp.responseText);
					var selecter = _jq(self).find(".CaliProfile")[0];
					var i;
					for(i = selecter.options.length - 1 ; i >= 0 ; i--)
					{
						selecter.remove(i);
					}
					for (i = 0; i < profile_array.length; i++)
					{
						var opt = document.createElement('option');
						opt.value = profile_array[i].id;
						opt.innerHTML = profile_array[i].name + "("+profile_array[i].owner_name+")";
						selecter.appendChild(opt);
						console.log("name="+profile_array[i].name+", source="+profile_array[i].source+", target="+profile_array[i].target);
					}
					// 20190703, insert disable calibration.
					var opt = document.createElement('option');
					opt.value = -1;
					opt.innerHTML = "Disable Calibration";
					
					selecter.insertBefore(opt, selecter.childNodes[0]);
					
					for (i = 0; i < CaliProfile.options.length; i++)
					{
						if (CaliProfile.options[i].value == _default.profile_id)
						{
							CaliProfile.selectedIndex = i;
						}
					}
					if (profile_array.length > 0)
					{
						CaliProfileChange();
					}
					
				}
			}

			var url = _default.server_url+"get_cali_data.php?type=options";
			xmlhttp.open("GET",url,true);
			console.log("query url="+url)
			xmlhttp.send();
			
		}
		function UpdateListViewPanel()
		{
			var list = _jq(self).find(".listviewPanel")[0];
			if (!list) {
				return;
			}
			var w = list.parentNode.clientWidth;
			var h = list.parentNode.clientHeight;

			var columns = [];
			var checkboxSelector = new Slick.CheckboxSelectColumn({
				cssClass: "slick-cell-checkboxsel"
			});
			columns.push(checkboxSelector.getColumnDefinition());
			columns.push({id: "Source", name: display_source, field: "source", width:w/2});
			columns.push({id: "Target", name: display_target, field: "target", width:w/2});
			
			var options = {
				enableCellNavigation: true,
				enableColumnReorder: false
			};
			//if (grid == null)
				grid = new Slick.Grid(list, list_data, columns, options);
			grid.setSelectionModel(new Slick.RowSelectionModel({selectActiveRow: false}));
			grid.registerPlugin(checkboxSelector);
			var canvas = _jq(self).find(".slick-viewport")[0];
			if (canvas)
			{
				canvas.scrollTop = canvas.scrollHeight;
			}
			grid.resizeCanvas();

			grid.updateRowCount();
			grid.invalidateAllRows();
			grid.render();
		}

		function UpdateRegressionChart()
		{
			var chart_data = 
			{
				datasets: 
				[
					{
						label: 'predict line',
						data: [],
						fill: false,
						backgroundColor: 
							'rgba(255, 99, 132, 1)'
						,
						
						borderColor: 
							'rgba(255,99,132,1)'
						,
						info:[0,0],
						borderWidth: 1,
						pointRadius: 3
					},
					{
						label: 'datasets',
						data: [],
						backgroundColor: 
							'rgba(99, 255, 132, 1)'
						,
						borderColor: 
							'rgba(99,255,132,1)'
						,
						info:[],
						showLine: false,
						pointRadius: 3,
						pointHoverRadius: 3
					}
				]
			};
			var chart_options = {
					responsive: true,
					scales: {
						yAxes: [ {
							scaleLabel: {
								labelString: display_target,
								display: true,
							}
						}],
						xAxes: [{
							scaleLabel: {
								labelString: display_source,
								display: true,
							}
						}]
					},
					
					title: { display: true, text:display_title}//,
				};
			//console.log("UpdateRegressionChart:");
			//console.log(chart_options);
			for (var i=0; i<source_index.length; i++) {
				chart_data.datasets[1].data.push({
					x: source_index[i],
					y: target_index[i]
				});
			}
			chart_data.datasets[0].data.push({x:predict_line[0][0],y:predict_line[0][1]});
			chart_data.datasets[0].data.push({x:predict_line[1][0],y:predict_line[1][1]});
			
			if (oRegressionGraph == null )
			{
				oRegressionGraph = new Chart(regressionCanvas, {
					type: 'scatter',
					data: chart_data,
					options: chart_options
				});
				//console.log("================================================");
				//console.log(oRegressionGraph);
			}
			else
			{
				//console.log(oRegressionGraph);
				oRegressionGraph.config.data = chart_data;
				oRegressionGraph.config.options = chart_options;
				oRegressionGraph.chart.config.options = chart_options;
				oRegressionGraph.update();
				//console.log("after update");
				//console.log(oRegressionGraph);
				
			}
		}
		init();
        return self;
    };
    
})(jQuery);

		