const {AppList}=window;
//00-Hello-OHA.png                         07-oMassMiniApp2.0.png
//01-Set-Timer-in-UI.png                   09-oMassMiniApp4.0.png
//02-Device-PlugInOut_index.png            10-oMassMiniApp4.1.png
//03-Set-Timer-DevicePlugInOut.png         acup_icon.png
//04-Variable-Voltage-In-2-Patterns.png    eav24_icon.png
//05-Variable-Frequency-In-8-Patterns.png  eav40_icon.png
//06-Full-oMass-Demo.png                   ryo_chart.png
ReactDOM.render(
    <AppList
        titleMsg="Mini-App List"
		menuList={[
		{
			picFile: {
				"en-US":"oha-1.jpg", 
				"default": "oha-1.jpg"
			}, 
			color: "#f8b62c", 
			subTitle: {
				"en-US":"", 
				"default": ""
			}, 
			description:{
				title: {
					"en-US":"oMass Massager", 
					"default": "oMass Massager"
				}, 
				msg: {
					"en-US":["iOS and Android",
			"Lightning or Audio(iOS) USB OTG(Android), Bluetooth wireless",
			"0.5 ~100Hz pulse frequency",
			"10 ~ 100V pulse voltage",
			"50~800us pulse width "], 
					
					
					"default":["iOS and Android",
			"Lightning or Audio(iOS) USB OTG(Android), Bluetooth wireless",
			"0.5 ~100Hz pulse frequency",
			"10 ~ 100V pulse voltage",
			"50~800us pulse width "]
				}
			}
		}
		]}
        pageList={[
                {picFile: "00-Hello-OHA.png", msg: "Hello OHA demo.", url:"http://www.ohacorp.com/omass/ex/00-Hello-OHA/index.html"},
                {picFile: "01-Set-Timer-in-UI.png", msg: "Set Timer in UI.", url:"http://www.ohacorp.com/omass/ex/01-Set-Timer-in-UI/index.html"},
                {picFile: "02-Device-PlugInOut_index.png", msg: "Plug in/out demo", url:"http://www.ohacorp.com/omass/ex/02-Device-PlugInOut/index.html"},
                {picFile: "03-Set-Timer-DevicePlugInOut.png", msg: "Timer & device plug in/out demo", url:"http://www.ohacorp.com/omass/ex/03-Set-Timer-DevicePlugInOut/index.html"},
                {picFile: "04-Variable-Voltage-In-2-Patterns.png", msg: "2 Patterns demo with voltage adjustment", url:"http://www.ohacorp.com/omass/ex/00-Hello-OHA/index.html"},
                {picFile: "05-Variable-Frequency-In-8-Patterns.png", msg: "8 Patterns demo with viriable frequency", url:"http://www.ohacorp.com/omass/ex/05-Variable-Frequency-In-8-Patterns/index.html"},
                {picFile: "06-Full-oMass-Demo.png", msg: "Full oMass demo", url:"http://www.ohacorp.com/omass/ex/06-Full-oMass-Demo/index.html"},
                {picFile: "07-oMassMiniApp2.0.png", msg: "oMass MiniApp 2.0", url:"http://www.ohacorp.com/omass/ex/07-oMassMiniApp2.0/default_us.html"},
                {picFile: "09-oMassMiniApp4.0.png", msg: "oMass MiniApp 4.0", url:"http://www.ohacorp.com/omass/ex/09-oMassMiniApp4.0/index.html"},
                {picFile: "10-oMassMiniApp4.1.png", msg: "oMass MiniApp 4.1", url:"http://www.ohacorp.com/omass/ex/10-oMassMiniApp4.1/index.html"}, 
                {picFile: "12-oMass-professional-mode.png", msg: "oMass MiniApp 4.1", url:"http://www.ohacorp.com/omass/ex/12-oMass-professional-mode/index.html"}, 
                {picFile: "13-Cyber-Orb-gh-pages.png", msg: "Game demo", url:"https://www.ohacorp.com/omass/ex/13-Cyber-Orb-gh-pages/index.html"}, 
                {picFile: "16-PowerSaving.png", msg: "Power saving mode demo", url:"http://www.ohacorp.com/omass/ex/16-PowerSaving/index.html"}
        ]}
    />
    , document.getElementById("page1")
);