var sysConfig={
    Version:1.220, 
	Date: "202008201353",
	isRelease: false,
	debugUserAgent: {
		enable: false,
//		localeStr: "zh-CN", 
		localeStr: "zh-TW", 
//		localeStr: "ja-JP", 
		plateform: "Android",
//		appVer: "257", 		// Android
		appVer: "317", 		// Android
//		localeStr: "TW", 
//		plateform: "iOS",
//		appVer: "473", 		// iOS
	},
}

var oha_api=new function(){
    this.__localeCode="en-US";

    this.langSet="en";
    this.countryCode="";
    this.langCode={
        English:"en", 
        TraditionChinese:"zh-TW", 
        SimpleChinese:"zh-CN", 
        Korean:"ko", 
    }
	this.ohaConfig={
		plateForm:"Android", 
		ohaVer: -1, 
		appVer: -1
	}
};

const localeOptions={
    English: 0, 
    TraditionChinese:1, 
    SimpliedChinese: 2, 
    SystemSelected: 3
};

function getLocaleStr(StrObj) {
	var _locale=oha_api.__localeCode;
	  var _localeX=_locale.split("-");
	  if(StrObj.hasOwnProperty(_locale)) {
		  return StrObj[_locale];
	  }
	  else if(StrObj.hasOwnProperty(_localeX[0])) {
		  return StrObj[_localeX[0]];
	  }
	  else if(StrObj.hasOwnProperty("default")) {
		  return StrObj.default;
	  }
}

	$(window).ready(function(){
        document.documentElement.style.webkitUserSelect='none';
        var uAgent=navigator.userAgent;
		if(sysConfig.debugUserAgent.enable && !sysConfig.isRelease) {
//			console.log("debugUserAgent")
			if(sysConfig.debugUserAgent.plateform=="iOS") {
//				console.log("debugUserAgent, OS=iOS")
				uAgent="UserAgent=Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60;oLang:"+sysConfig.debugUserAgent.localeStr+";oVer:01;oPlateform:iOS;appVer:"+sysConfig.debugUserAgent.appVer;
			}
			else {
//				console.log("debugUserAgent, OS=Android")
				uAgent="userAgent=Mozilla/5.0 (Linux; Android 6.0.1; VirtualBox Build/MOB31E; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/44.0.2403.119 Mobile Safari/537.36;oLangN:"+sysConfig.debugUserAgent.localeStr+";oLang:HK;oVer:01;oPlateform:Android;appVer:"+sysConfig.debugUserAgent.appVer;
			}
		}
//		uAgent="UserAgent=Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60;oLang:TW;oVer:01;oPlateform:iOS;appVer:473";
//		uAgent="UserAgent=Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60;oLang:TW;oVer:01;appVer:473";
//		uAgent="userAgent=Mozilla/5.0 (Linux; Android 6.0.1; VirtualBox Build/MOB31E; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/44.0.2403.119 Mobile Safari/537.36;oLangN:zh-HK;oLang:HK;oVer:01;oPlateform:Android;appVer:257";
    //    MyLog("userAgent="+uAgent)
    //    var _pat="/oPlateform[ ]*[^;]+!([ ]*|$)";
        var _pat=/oPlateform[ ]*:[ ]*[^; ]+(?=[ ]*([;]|$))/g;
        var _plateform=uAgent.match(_pat);
        if(_plateform!=null) {
            var _p=_plateform[_plateform.length-1];
            _p=_p.substring(_p.indexOf(":")+1).trim();
            if(_p.toLowerCase()=="android") {
                oha_api.ohaConfig.plateForm="Android";
        //        $("#titleText").css({"color":"red"});

            }
            else if(_p.toLowerCase()=="ios") {
                oha_api.ohaConfig.plateForm="iOS";
           }
        }
        _pat=/appVer[ ]*:[ ]*[0-9]+(?=[ ]*([;]|$))/g;
        var _appVer=uAgent.match(_pat);
    //    MyLog("App Version="+_appVer);
        if(_appVer!=null) {
            _p=_appVer[_appVer.length-1];
            _p=_p.substring(_p.indexOf(":")+1).trim();
             oha_api.ohaConfig.appVer=parseInt(_p);
        }
        var _vIdx=uAgent.indexOf("oVer:");
        var ohaVer=-1;
        if(_vIdx>=0) {
            ohaVer=parseInt(uAgent.substr(_vIdx+5, 2));
            if(isNaN(ohaVer)) {
                ohaVer=0;
            }
            oha_api.ohaConfig.ohaVer=ohaVer;
        }
        var ual=uAgent.length;
        var _lang="en";
        switch(ohaVer) {
        case 0:
            _lang=uAgent.substr(ual-2,2);
    //		alert("Lang(0)="+_lang);
        break;
        case 1:
            var _pat=/;oLang:([a-zA-Z]{2})/
            if(_pat.test(uAgent)) {
                _lang=RegExp.$1.toLowerCase();
                switch(_lang) {
                    case "us":
                        oha_api.langSet="en";
                        oha_api.countryCode="US";
                        oha_api.__localeCode="en-US";
                        break;
                    case "tw":
//                        oha_api.langSet=oha_api.langCode.TraditionChinese;
                        oha_api.langSet="zh";
                        oha_api.countryCode="TW";
                        oha_api.__localeCode="zh-TW";
                        break;
                    case "cn":
//                        oha_api.langSet=oha_api.langCode.SimpleChinese;
                        oha_api.langSet="zh";
                        oha_api.countryCode="CN";
                        oha_api.__localeCode="zh-CN";
                        break;
                    case "jp":
//                        oha_api.langSet=oha_api.langCode.SimpleChinese;
                        oha_api.langSet="ja";
                        oha_api.countryCode="JP";
                        oha_api.__localeCode="ja-JP";
                        break;
                    case "kr":
                        oha_api.langSet=oha_api.langCode.Korean;
                        oha_api.countryCode="KR";
                        oha_api.__localeCode="ko-KR";
                        break;
                    default:
                        oha_api.langSet=oha_api.langCode.English;
                        oha_api.countryCode="US";
                        oha_api.__localeCode="en-US";
                }
            }
        break;
        }
        var _pat=/;oLangN:(([a-z]{2})(?:-([A-Z]{2}))?)/
        if(_pat.test(uAgent)) {
            oha_api.__localeCode=RegExp.$1;
            oha_api.langSet=RegExp.$2;
            oha_api.countryCode=RegExp.$3;
        }
		
		
    });