class PageHeader extends React.Component {
	constructor(props) {
		super(props);
		this.state={devInfo:null}
		this.handleHwCheck=this.handleHwCheck.bind(this);
		this.handleUrlUpdate=this.handleUrlUpdate.bind(this);
		this.handleOTGInfo=this.handleOTGInfo.bind(this);
		this.handleBLECheck=this.handleBLECheck.bind(this);
		this.handleLoraCheck=this.handleLoraCheck.bind(this);
		this.handlePhoneInfo=this.handlePhoneInfo.bind(this);
		this.handleHomeIcon=this.handleHomeIcon.bind(this);
		this.handleDevMgrIcon=this.handleDevMgrIcon.bind(this);
		this.handleOtgStatus=this.handleOtgStatus.bind(this);
		this.handleBleStatus=this.handleBleStatus.bind(this);
	}
	
	handleHomeIcon(e){
		oha_api.runOhaCmd("ohadm://homePage")
//		console.log("handleHomeIcon");
	}
	
	handleDevMgrIcon(e){
		oha_api.runOhaCmd("ohadm://curPage")
//		console.log("handleDevMgrIcon");
	}
	
	handleHwCheck(e){
		if($(".OtgCheckBtn").hasClass("disabled")){
			return false
		}
		oha_api.runOhaCmd("ohadm://checkHW")
//		console.log("handleHwCheck");
	}
	
	handleUrlUpdate(e){
		if(!$("#urlBtn.HeaderIconX").hasClass("clickable")){
			return false
		}
		oha_api.runOhaCmd("ohadm://updateUrl")
//		console.log("handleUrlUpdate");
	}
	
	handleOTGInfo(e){
		if(!$("#urlBtn.HeaderIconX").hasClass("clickable")){
			return false
		}
		oha_api.runOhaCmd("ohadm://infoOTG")
//		console.log("handleOTGInfo");
	}
	
	handleBLECheck(e){
		if(!$(".HeaderIconX.bleBtn").hasClass("clickable")){
			return false
		}
		oha_api.runOhaCmd("ohadm://infoBLE")
//		console.log("handleBLECheck");
	}
	
	handleLoraCheck(e){
		if(!$(".HeaderIconX.bleBtn").hasClass("clickable")){
			return false
		}
		oha_api.runOhaCmd("ohadm://infoLora")
//		console.log("handleLoraCheck");
	}
	
	handleOtgStatus() {
		var _url="pic/otg.png";
		switch(this.props.otgState) {
			case "OK":
				_url="pic/otg_connect.svg";
				break;
			case "NA":
				_url="pic/otg_warning_red.svg";
				break;
			default:
				_url="pic/otg.svg";
		}
		return <img className="HeaderIconX clickable otgBtn" src={_url} onClick={this.handleOTGInfo}></img>
	}
	
	handleBleStatus() {
		var _url="pic/bluetooth.png";
		switch(this.props.bleState) {
			case "OK":
				_url="pic/bluetooth_enable.svg";
				break;
			default:
				_url="pic/bluetooth.svg";
		}
		return <img className="HeaderIconX clickable bleBtn" src={_url} onClick={this.handleBLECheck}></img>
	}
	
	handlePhoneInfo(_devInfo, _locale) {
//			return <h3>您尚未插入裝置</h3>
		if(_devInfo==undefined) {
//			console.log("PageHeader.handlePhoneInfo, _devInfo==null");
            if(_locale.indexOf("zh")==0) {
                if(_locale=="zh-CN") {
                    return <div className="SupportTxtDiv">
                        <h4 className="SupportTitle">本系统可以使用的硬体周边介面</h4>
                        <h3>&nbsp;</h3>
                        <h3>&nbsp;</h3>
                    </div>
                }
                else {
                    return <div className="SupportTxtDiv">
                        <h4 className="SupportTitle">本系統可以使用的硬體周邊介面</h4>
                        <h3>&nbsp;</h3>
                        <h3>&nbsp;</h3>
                    </div>
                }
            }
            else {
                return <div className="SupportTxtDiv">
                    <h4 className="SupportTitle">The available peripheral devices</h4>
                    <h3>&nbsp;</h3>
                    <h3>&nbsp;</h3>
                </div>
            }
		}
//		console.log("PageHeader.handlePhoneInfo, _devInfo.available="+_devInfo.available);
        if(_locale.indexOf("zh")==0) {
            if(_locale=="zh-CN") {
                return <div className="SupportTxtDiv">
                    <h4 className="SupportTitle">本系统可以使用的硬体周边介面</h4>
                    <h3>已知有{_devInfo.available}款手机可正常使用OHA硬体应用</h3>
                    <h3>您這款手機<span>{_devInfo.devModel}</span>有<span>{_devInfo.devUsedTimes}</span>人使用過</h3>
                </div>			
            }
            else {
                return <div className="SupportTxtDiv">
                    <h4 className="SupportTitle">本系統可以使用的硬體周邊介面</h4>
                    <h3>已知有{_devInfo.available}款手機可正常使用OHA硬體應用</h3>
                    <h3>您這款手機<span>{_devInfo.devModel}</span>有<span>{_devInfo.devUsedTimes}</span>人使用過</h3>
                </div>			
            }
        }
        else {
            return <div className="SupportTxtDiv">
                    <h4 className="SupportTitle">The available peripheral devices</h4>
                    <h3>{_devInfo.available} phone devices are compatible with OHA App</h3>
                    <h3>The phone model: <span>{_devInfo.devModel}</span> is used<span>{_devInfo.devUsedTimes}</span>times.</h3>
                </div>			
        }

	}
	
//	componentDidMount() {
//		var _w=$(window).width();
//		var _h=$(window).height();
//		$("#AppTop .RightBottom>.OtgCheckBtn").css({"right":_w*0.01, "bottom":_w*0.01, "border-width":_w*0.002, "border-radius":_w*0.01});
//		$(".PageHeader th").css({"height":_h*0.2})
//	}
	
	render() {
		const {devInfo, locale}=this.props;
//		$.extend(this.state.devInfo, devInfo);
		console.log("PageHeader.render(), devInfo="+devInfo)
//		var devDescription={this.handlePhoneInfo(devInfo)}
//		var rightBottom=
//			<div className="RightBottom">
//				<div className="OtgCheckBtn VerticalMiddle clickable" onClick={this.handleHwCheck}><h3>&nbsp;硬體相容性檢查&nbsp;</h3></div>
//			</div>
		var rightBottom=
			<div className="RightBottom">
				<div className="OtgCheckBtn VerticalMiddle clickable" onClick={this.handleHwCheck}></div>
			</div>
//		if(devInfo!==undefined) {
////			console.log("devInfo is not null, devInfo="+devInfo);
//			devDescription=
//			<div className="SupportTxtDiv">
//				<h4 className="SupportTitle">本系統可以使用的硬體周邊介面</h4>
//				<h3>已知有{devInfo.available}款手機可正常使用OHA硬體應用</h3>
//				<h3>您這款手機<span>{devInfo.devModel}</span>有<span>{devInfo.devUsedTimes}</span>人使用過</h3>
//			</div>
//			rightBottom=
//			<div className="RightBottom">
//				<div className="OtgCheckBtn VerticalMiddle clickable" onClick={this.handleHwCheck}><h3>&nbsp;硬體相容性檢查&nbsp;</h3></div>
//			</div>
//		}
		const headerContent=
		<div className="HeaderContent">
			<div className="LeftUp VerticalMiddle">
				<img id="IconHome" className="clickable" src="pic/ic_home.png" onClick={this.handleHomeIcon}></img>
				<h2>{this.props.title}</h2>
			</div>
			<div className="RightUp VerticalMiddle">
				<img id="IconDevList" className="HeaderIcon clickable" src="pic/ic_dev_manager.png" onClick={this.handleDevMgrIcon}></img>
				<div className="IconList1">
					<img id="urlBtn" className="HeaderIconX clickable" src="pic/WWW.svg" onClick={this.handleUrlUpdate}></img>
					<img id="loraBtn" className="HeaderIconX clickable" src="pic/lora.png" onClick={this.handleLoraCheck}></img>
					{this.handleOtgStatus()}
					{this.handleBleStatus()}
				</div>
			</div>
			{this.handlePhoneInfo(devInfo, locale)}
			{rightBottom}
		</div>;
			  
		return <tr className="DevListContent PageHeader">
			<th className="itemContainer">{headerContent}</th>
		</tr>
	}
}
window.App.PageHeader=PageHeader;