const {BottomArea} = window.App;
class PageItem extends React.Component {
	constructor(props) {
		super(props);
//		window.selfPageItem=this;
		this.state={id:-1, touchStartT:-1, isPlugged:false, isShowTitleMore: false};
		this.handleClick=this.handleClick.bind(this);
		this.handleUrlBtn=this.handleUrlBtn.bind(this);
		this.handleLongClick=this.handleLongClick.bind(this);
		this.handleDelete=this.handleDelete.bind(this);
		this.handleTouchStart=this.handleTouchStart.bind(this);
		this.handleTouchEnd=this.handleTouchEnd.bind(this);
		this.handleTouchCancel=this.handleTouchCancel.bind(this);
		this.handleTouchMove=this.handleTouchMove.bind(this);
		this.handleShowMore=this.handleShowMore.bind(this);
		this.handleStopMore=this.handleStopMore.bind(this);
	}
	
	handleClick(_evt){
//		console.log("handleClick("+this.state.id+")");
        _evt.stopPropagation();
//		this.props.sendIdx(this.state.id);
		if(!this.state.isShowTitleMore) {
			this.props.sendIdx(this.props.idx);
		}	
	}
	
	handleTouchStart(_evt){
//        _evt.preventDefault();
        console.log("onTouchStart, idx="+this.props.idx)
//        this.state.touchStartT=new Date().getTime();
//        this.longClickH=setTimeout(function(){window.selfPageItem.handleLongClick(this.props.idx, this.state.isPlugged);}.bind(this), 1500);
        this.longClickH=setTimeout(function(){this.handleLongClick(this.props.idx, this.state.isPlugged);}.bind(this), 1500);
	}
	
	handleTouchEnd(){
//        console.log("onTouchEnd, id="+this.state.id)
        clearTimeout(this.longClickH);
	}
	
	handleTouchMove(){
//        console.log("onTouchMove, id="+this.state.id)
        clearTimeout(this.longClickH);
	}
	
	handleTouchCancel(){
//        console.log("onTouchCancel, id="+this.state.id)
        clearTimeout(this.longClickH);
	}
	
	handleLongClick(_idx, _isPlugged) {
		console.log("PageItem.handleLongClick("+_idx+"), this.props.idx="+this.props.idx+", isPlugged="+_isPlugged);
		if(!_isPlugged) {
			this.props.launchMenu(parseInt(_idx));
		}
	}
    
	handleDelete(_evt) {
        console.log("handleDelete, isPlugged="+this.state.isPlugged+", idx="+this.props.idx);
        _evt.stopPropagation();
		if(!this.state.isPlugged) {
			this.props.runDelete(parseInt(this.props.idx));
		}
	}
    
    handleUrlBtn() {
        console.log("handleUrlBtn, id="+this.props.id);
        oha_api.runOhaCmd("ohadm://updateUrl_"+this.props.id)
    }
	
	handleShowMore(_evt){
        console.log("handleShowMore, idx="+this.props.idx)
		this.setState({isShowTitleMore: true});
		this.refs.titleArea.classList.add("showMore");
	}
	
	handleStopMore(_evt){
        console.log("handleStopMore, idx="+this.props.idx)
		setTimeout(function(){
			this.setState({isShowTitleMore: false});
			this.refs.titleArea.classList.remove("showMore");
		}.bind(this), 100)
	}
	
	
	
	componentDidMount() {
		console.log("PageItem.componentDidMount(), id="+this.state.id);
		var _scrollHeight=this.refs.titleArea.scrollHeight;
		var _clientHeight=this.refs.titleArea.clientHeight;
        this.setsize();
		if(_scrollHeight>_clientHeight) {
			console.log("overflow");
			this.refs.moreBtn.classList.remove("hide");
		}
		else {
			this.refs.moreBtn.classList.add("hide");
		}
	}
    
    setsize() {
		var _w=$(window).width();
		var _h=$(window).height();
//		console.log("PageItem.componentDidMount, _w="+_w);
//		$("#app th").css({"border-radius":_w*0.02});
//		$(".PageItem .UpdateTimeArea").css({"border-width":_w*0.003});
//		$(".PageItem .RightMiddleArea").css({"border-bottom-width":_w*0.003});
//		$(".PageItem th").css({"height":_w*0.6});
		$(this).css({"height":_w*0.6});
    }
	
	componentDidUpdate(prevProps, prevState) {
		var _w=$(window).width();
		const {id}=this.props;
//		if(this.state.isPlugged) {
		if(this.props.isPlugged) {
//			console.log("selector="+"#app #id"+id+" th , _w="+_w);
            $("#app #id"+id+" th").addClass("plugIn");
//			$(window).ready(function(){
//				$("#app #id"+id+" th").css({"border-width":""+_w*0.01});
//			})
		}
		else {
            $("#app #id"+id+" th").removeClass("plugIn");
//			$(window).ready(function(){
//				$("#app #id"+id+" th").css({"border-width":_w*0.004});
//			})
			
		}
	}

	render() {
		var {idx, id, pageData, isPlugged, sid, locale}=this.props;
//		console.log("PageItem.render(), id="+id+", isPlugged="+isPlugged+", sid="+sid+", pageData="+pageData.snap_url)
//		var _w=$(window).width();
//		if(isPlugged) {
//			console.log("selector="+"#app #id"+id+" th , _w="+_w);
//			$("#app #id"+id+" th").css({"border-width":""+_w*0.01});
//		}
//		else {
//			$("#app #id"+id+" th").css({"border-width":_w*0.004});
//		}
		this.state.isPlugged=isPlugged;
		if(pageData.hasOwnProperty("date")) {
//			console.log("pageData.date="+pageData.date);
			if(pageData.date.length<12) {
				var _date=new Date();
				pageData.date=_date.getOhaFormat();
			}
		}
		else {
			var _date=new Date();
			pageData.date=_date.getOhaFormat();
		}
//		console.log("Date="+pageData.date);
		const year=pageData.date.substring(0,4);
		const date=pageData.date.substring(4,8);
		const time=pageData.date.substring(8,10)+":"+pageData.date.substring(10,12);
		this.state.id=id;
//		console.log("PageItem "+this.state.id);
		var SnapShotStyle={backgroundImage:"url("+pageData.snap_url+")"};
        this.setsize();
        if(this.state.isPlugged) {
            var plugClass="isPlugged";
        }
        else {
            var plugClass="";            
        }
        var _updateDate="Date:";
        var _version="Ver:";
        if(locale.indexOf("zh")==0) {
            if(locale=="zh-CN") {
                _updateDate="更新日期:";
                _version="版本:";
            }
            else {
                _updateDate="更新日期:";
                _version="版本:";
            }
        }
		var _deleteBtn=(this.state.isPlugged) ? <div id="deleteBtn" onClick={this.handleDelete} className="isPlugged hide"></div>:
		<div id="deleteBtn" onClick={this.handleDelete} className="hide"></div>;
		return (
			<tr id={"id"+id} className="DevListContent PageItem">
                <th className="pageDividerContainer">
                    <div className="pageDivider"></div>
                </th>
				<th className="itemContainer">
					<div className="SnapShot clickable" style={SnapShotStyle} onClick={this.handleClick} 
						onTouchStart={this.handleTouchStart} onTouchEnd={this.handleTouchEnd} onTouchCancel={this.handleTouchCancel}
						onMouseDown={this.handleTouchStart} onMouseUp={this.handleTouchEnd} onMouseOut={this.handleTouchCancel}>
					</div>
					<div className="RightArea">
			<table className="RightTopArea" onClick={this.handleClick}>
				<tbody>
					<tr><td className="TitleArea"><h2 ref="titleArea">{pageData.title}</h2></td>
						<div className="MoreBtn" ref="moreBtn" onTouchStart={this.handleShowMore} onMouseDown={this.handleShowMore}
						onTouchEnd={this.handleStopMore} onMouseUp={this.handleStopMore} onTouchCancel={this.handleStopMore} onMouseOut={this.handleStopMore}><h2>...</h2></div>
						{_deleteBtn}
                    </tr>
					<tr><td className="UpdateTimeArea"><h4><span>{_updateDate}</span>{year}-{date}-{time}&nbsp;<span>{_version}</span><span>{pageData.version}</span></h4></td></tr>
				</tbody>
			</table>
			<div className="RightMiddleArea">
				<div className="DescrptionArea" onClick={this.handleClick}><h3>{pageData.subtitle}</h3></div>
                <div className="urlBtn hide" onClick={this.handleUrlBtn}></div>
			</div>
					</div>
			<BottomArea id={id} idx={idx} pageData={pageData} sid={sid} isPlugged={this.state.isPlugged} runDelete={this.handleDelete} runWWW={this.handleUrlBtn} locale={locale}></BottomArea>
				</th>
			</tr>
		)
	}
}

PageItem.propTypes = {
//  page: PropTypes.object.isRequired,
  id: PropTypes.number.isRequired,
//  name: PropTypes.string.isRequired,
};
window.App.PageItem=PageItem;