window.App={};
const simGetPageData=false;
const sChar0=String.fromCharCode(0x0d);
const sChar1=String.fromCharCode(0x03);
Number.prototype.pad = function(size) {
  var s = String(this);
  while (s.length < (size || 2)) {s = "0" + s;}
  return s;
}

Date.prototype.getOhaFormat=function() {
	return this.getFullYear()+(this.getMonth()+1).pad(2)+this.getDate().pad(2)+this.getHours().pad(2)+this.getMinutes().pad(2);
}

var pagesArray=[
	{
		model:"&oMass", 
		url:"", 
		title:"Device Title 1, Try to process the long text condition.Now we can see what's happened", 
		subtitle:"Device Description for OHA Device 1",
		version:"201805001200",
//		snap_url:"url(file:///data/data/com.othe.oMassage/files/peipei.jpg)",
		snap_url:"./SnapShot/page1.jpg",
		date:"201805011200"
	}, 
	{
		model:"&oPower", 
		url:"http://www.othe.com.tw/OHA",
		title:"Device Title 2", 
		date:"201805021300",
		subtitle:"Device Description for OHA Device 2",
		snap_url:"./SnapShot/page2.jpg", 
		version:"201805011300"
	}, 
	{
		model:"&oUART", 
		title:"Device Title 3", 
		url:"",
		date:"201805031400",
		subtitle:"Device Description for OHA Device 3",
		snap_url:"./SnapShot/page3.jpg", 
		version:"201805021400"
	}
];
var pageMapTable=[1,2,0];
//var pageMapTable=[1,0];
//var pageMapTable=[0];
//var pageMapTable=[];

function genMappingData(_mapArray) {
	_mapStr="";
	for(x in _mapArray) {
		_mapStr+=_mapArray[x]+":";
	}
	if(_mapStr.length>0) {
		_mapStr=_mapStr.substring(0, _mapStr.length-1);
	}
	return _mapStr;
}

function genPageData(_pagesArray) {
	_pageStr="";
	for(x in _pagesArray) {
		var _item=_pagesArray[x];
		var _model="";
		if(_item.hasOwnProperty("model")) {
			_title=_item.model;
		}
		_pageStr+=(_title+sChar0);
		var _url="";
		if(_item.hasOwnProperty("url")) {
			_url=_item.url;
		}
		_pageStr+=(_url+sChar0);
		var _title="";
		if(_item.hasOwnProperty("title")) {
			_title=_item.title;
		}
		_pageStr+=(_title+sChar0);
		var _subtitle="";
		if(_item.hasOwnProperty("subtitle")) {
			_subtitle=_item.subtitle;
		}
		_pageStr+=(_subtitle+sChar0);
		var _version="";
		if(_item.hasOwnProperty("version")) {
			_version=_item.version;
		}
		_pageStr+=(_version+sChar0);
		var _snap="url(./SnapShot/OHA.png)";
		if(_item.hasOwnProperty("snap_url")) {
			_snap=_item.snap_url;
		}
		_pageStr+=(_snap+sChar0);
		var _date="";
		if(_item.hasOwnProperty("date")) {
			_date=_item.date;
		}
		_pageStr+=(_date+sChar0+sChar1);
	}
//	console.log("genPageData="+_pageStr);
//	_pageStr="";
	return _pageStr;
}

//var devInfo={
//	available:"258",
//	devModel:"Samsung J5", 
//	devUsedTimes:"155"
//};

function getPageTable(_mapping) {
    console.log("getPageTable("+_mapping+")")
	var _pageData="";
	var _pageArray=[];
	if(simGetPageData) {
		_pageData=genPageData(pagesArray);
		console.log("getPageTable() _pageData="+_pageData);
	}
	else {
		_pageData=oha_api.runOhaCmd("ohadm://getPagedata");
	}
	var _pageItemArray="";
//	var _pageData=oha_api.runOhaCmd("oha://getPagedata");
	if(_pageData.length>0) {
		_pageItemArray=_pageData.split(sChar1);
	}
	for(var x1 in _mapping) {
        x=parseInt(_mapping[x1]);
//        console.log("x1="+x1+", x="+x);
		_pageItem={};
		if(_pageItemArray[x].length==0) {
			continue;
		}
		var _pageItemCotent=_pageItemArray[x].split(sChar0);
		i=0;
		_pageItem.model=_pageItemCotent[i++];
		_pageItem.url=_pageItemCotent[i++];
		_pageItem.title=_pageItemCotent[i++];
		_pageItem.subtitle=_pageItemCotent[i++];
		_pageItem.version=_pageItemCotent[i++];
		_pageItem.snap_url=_pageItemCotent[i++];
		_pageItem.date=_pageItemCotent[i++];
		_pageArray.push(_pageItem);
	}
	return _pageArray;
}

//function getPageMapTable() {
//	return pageMapTable;
//}

function getPageMapTable() {
	var _mapData="";
	if(simGetPageData) {
		_mapData=genMappingData(pageMapTable);
	}
	else {
		_mapData=oha_api.runOhaCmd("ohadm://getMapdata");
	}
//	console.log("getPageMapTable, _mapData="+_mapData);
//	_mapData="";
	var _mapArray=[];
	if(_mapData.length>0) {
		_mapArray=_mapData.split(":");
	}
	_mapArray.map(function(x, i){
		_mapArray[i]= parseInt(x);
	});
	return _mapArray;
}
//function getDevInfo() {
//	return devInfo;
//}

function saveCookies() {
	console.log("save the cookies")
}
//$(window).ready(function(){
//	var _w=$(window).width();
//	$("#app th").css({"border-width":_w*0.004, "border-radius":_w*0.02});
//})