var oha_lightbox = [];

oha_lightbox["show"] = function(data){
	
	if($(".oha_lightbox-overlay").length > 0){
		return;
	}
	var inner = this.inner(data);
	$("body").append("<div class='oha_lightbox-overlay fadeIn'>"+inner+"</div>");
	var width = $("#grids").width();
	$(".oha_lightbox-overlay-inner").width(width);

}

oha_lightbox["hide"] = function(){
	$(".oha_lightbox-overlay").fadeOut(500,function(){
		$(".oha_lightbox-overlay").remove();
	})
}

oha_lightbox["inner"] = function(data){
	


	if(typeof data == undefined){
		data = {};
	}

	var _default = {
		title:"",
		image:"images/qrcode_googleplay.png",
		url:"#",
		linkTxt:"Hyperlink",
		urllink:"",
		CloseTxt:"<div class='oha_lightbox-overlay-close-default'></div>",
	};

	var settings = $.extend(_default, data);
	var html = "";
	html += "<div class='oha_lightbox-overlay-close'>"+settings.CloseTxt+"</div>";
	html += "<div class='oha_lightbox-overlay-inner'>";
	html += "<img src='"+settings.image+"'>";
	html += "<div class='oha_lightbox-overlay-inner-title'>"+settings.title+"</div>";
	//html += "<a class='oha_lightbox-overlay-inner-link' href='"+settings.url+"'><div >"+settings.linkTxt+"</div></a>";
	html += "<a class='oha_lightbox-overlay-inner-link' href='"+settings.url+"'><div >"+settings.urllink+"</div></a>";
	html += "</div>";

	return html;
}

$(document).click(function(e) 
{
    
	// console.log($(".oha_lightbox-overlay").length);
	if($(".oha_lightbox-overlay").length == 0){
		return;
	}
	var $tgt = $(e.target);
    if ($tgt.closest(".oha_lightbox-overlay-inner,.oha-lightbox").length) {
    	// oha_lightbox.hide();
    }else{
    	oha_lightbox.hide();
    } 

    // var containers = [".oha_lightbox-overlay",".oha_lightbox-overlay-close"];

    // $(containers).each(function(i){
    // 	// console.log(e.target);
    // 	console.log(this);
    // 	var container = $(this);
	   //  if (!container.is(e.target) && container.has(e.target).length === 0) 
	   //  {
	   //     oha_lightbox.hide();
	   //  }


    // })


    
});


$(window).load(function(){
	// oha_lightbox.show();
	
	$("#grids").on("click",".oha-lightbox",function(){
		var _data = $(this).data();
		// console.log(_data);
		oha_lightbox.show(_data);
	})

})
