//alert("scripts");
function GridMakerSearch(data){
	//alert("GRIDMAKER");
	if(typeof(data)!=="object" ){
		return false;
	}

	if(typeof(data.display)!="undefined" &&  data.display==false){
		return "";
	}

	if(typeof(data.color)!="undefined"){
		colorNo=data.color;
		var styleCode="background-color:"+colorNo;
	}else{
		var styleCode="";
	}

	var search_placeholder = SearchLang("Symptom or acupuncture point",GetUserAgentLang(agent));


	var des = data.des;
	var title = data.title;
	var subtitle = data.subtitle;
	// data.image = typeof data.image_lang[GetUserAgentLang(agent)] == "undefined"? data.image:data.image_lang[GetUserAgentLang(agent)];

	if(typeof data.title_lang != "undefined" && typeof data.title_lang[GetUserAgentLang(agent)] != "undefined"){
		title = data.title_lang[GetUserAgentLang(agent)];
	}

	if(typeof data.subtitle_lang != "undefined" && typeof data.subtitle_lang[GetUserAgentLang(agent)] != "undefined"){
		subtitle = data.subtitle_lang[GetUserAgentLang(agent)];
	}

	if(typeof data.des_lang != "undefined" && typeof data.des_lang[GetUserAgentLang(agent)] != "undefined"){
		des = data.des_lang[GetUserAgentLang(agent)];
	}

	/*
	var serchInputs='<div class="search-inputs">'+
						'<div class="flex-center"><div class="oha-logo"></div><input id="oha-acuSearch" type="text" placeholder=" 請輸入病徵或穴位" oninput="SearchChange()"></div>'+
		                '<div><ul class="results" id="search_result" style="display: none;">'+
		                '</ul></div>'+
	            	'</div>'; 
    */

   


	var serchInputs='<div class="search-inputs">'+						
						'<div class="flex-center">'+
						'<label class="oha_search_label">'+
						'<div class="oha-logo"></div><input id="oha-acuSearch" type="text" placeholder="'+
						search_placeholder + '" oninput="SearchChange()" onkeydown="SearchKeyDown(event)">'+
						'</label>'+
						'</div>'+
	            	'</div>'; 

	// comment out 春雨醫生
	//serchInputs=additional_searchBar.chunyuyisheng()+serchInputs;


	var _des=des.join("<br>");
	var id="oha-"+data.id;

	data.title=TitleLang(data.title,GetUserAgentLang(agent));

	var html='\
				<div id="'+id+'" class="oha-section normal-grid">\
		  		<div class="cover">\
		  			'+serchInputs+'\
		  			<img class="cover-image" src="images/cover/'+data.image+'">\
		  			<div class="subtitle">\
		  				<div class="container">\
		  					'+subtitle+'\
		  				</div>\
		  			</div>\
		  		</div>\
		  		<div class="des" style="'+styleCode+'">\
		  			<div class="container">\
		  				<h2>'+title+' </h2>\
		  				<p>\
			  				'+_des+'\
		  				</p>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		  </div>\
	';	

	$(document).on("focus",'#oha-acuSearch',function(e){
		$(".oha_search_label").addClass("focus");
	});
	$(document).on("blur",'#oha-acuSearch',function(){
		$(".oha_search_label").removeClass("focus");
	});

	return html;

}


additional_searchBar={

	chunyuyisheng:function(){
			var search_placeholder=SearchLang("搜医生、医院、疾病、症状、资讯",GetUserAgentLang(agent));
			search_placeholder="";
	    	var serchInputs='<div class="search-inputs">'+
								'<div class="flex-center"><div class="chunyuyisheng-logo"></div><input id="chunyuyisheng-Search" type="text" placeholder="'+
							search_placeholder + '"><div class="submitBtn" onclick="additional_searchBar.chunyuyishengSearch()"></div></div>'+
		            	'</div>';

		    $("head").append('<link rel="stylesheet" type="text/css" href="chunyuyisheng.css" />');        	
		    return  serchInputs;       	
		},
	chunyuyishengSearch:function(){

		var val=$("#chunyuyisheng-Search").val();
		var url="https://m.chunyuyisheng.com/m/search/?query="+val;
		window.location = url;
	
	}	


	


}



function GridMaker(data){
	//alert("GRIDMAKER");
	if(typeof(data)!=="object" ){
		return false;
	}

	if(typeof(data.display)!="undefined" &&  data.display==false){
		return "";
	}

	if(typeof(data.color)!="undefined"){
		colorNo=data.color;
		var styleCode="background-color:"+colorNo;
	}else{
		var styleCode="";
	}



	var id = "oha-"+data.id;
	var des = data.des;
	var title = data.title;
	var subtitle = data.subtitle;
	// data.image = typeof data.image_lang[GetUserAgentLang(agent)] == "undefined"? data.image:data.image_lang[GetUserAgentLang(agent)];

	if(typeof data.title_lang != "undefined" && typeof data.title_lang[GetUserAgentLang(agent)] != "undefined"){
		title = data.title_lang[GetUserAgentLang(agent)];
	}

	if(typeof data.subtitle_lang != "undefined" && typeof data.subtitle_lang[GetUserAgentLang(agent)] != "undefined"){
		subtitle = data.subtitle_lang[GetUserAgentLang(agent)];
	}

	if(typeof data.image_lang != "undefined" && typeof data.image_lang[GetUserAgentLang(agent)] != "undefined"){
		data.image = data.image_lang[GetUserAgentLang(agent)];
	}

	if(typeof data.des_lang != "undefined" && typeof data.des_lang[GetUserAgentLang(agent)] != "undefined"){
		des = data.des_lang[GetUserAgentLang(agent)];
	}



	var _des = des.join("<br>");

	var html='\
				<div id="'+id+'" class="oha-section normal-grid">\
		  		<div class="cover">\
		  			<img class="cover-image lazyload"src="images/cover/'+data.image+'">\
		  			<div class="subtitle">\
		  				<div class="container">\
		  					'+subtitle+'\
		  				</div>\
		  			</div>\
		  		</div>\
		  		<div class="des" style="'+styleCode+'">\
		  			<div class="container">\
		  				<h2>'+title+' </h2>\
		  				<p>\
			  				'+_des+'\
		  				</p>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		  </div>\
	';

	return html;

}

function smallGridMaker(grid){


	if(typeof(grid.id)!== undefined){
		id='id="'+grid.id+'"';
	}else{
		id="";
	}


	if(grid.GetUrl != undefined){
		var Geturl='data-url="'+grid.GetUrl+'"';
	}else{
		var Geturl='';
	}

	if(grid.command == false){
		var DataCommand=' data-command="false" ';
	}else{
		var DataCommand='';
	}



	html='\
			<a href="'+grid.url+'" '+Geturl+DataCommand+'>\
			<div class="grid" '+id+' ">\
				<div class="grid-image" style="background-image:url('+grid.image+')"></div>\
  				<div class="grid-title">'+grid.title+'</div>\
  			</div>\
  			</a>';

  	return html;
}

function datafilter(langdata){

	var output=langdata.filter(function(data){

	  var _display=typeof(data.display) =="undefined" ||  data.display !=false;

	  return _display=true;
	});
	return output;
}

function nineGridMaker(agent,id,data){

	//alert("nine");

	var lang=UserAgentLang(agent,data);

	if(typeof(grid_datas[lang]) !== undefined){
		langdata=grid_datas[lang];
	}else{
		langdata=grid_datas["default"];
	}



	if(langdata == undefined){
		return false;
	}


	langdata =datafilter(langdata);

	//console.log("lang",langdata);

	if(langdata.length == 0){
		return "";
	}

	var grids="";



	for(i=0 ; i<langdata.length; i++){

		thedata=langdata[i];
		grid=smallGridMaker(thedata);
		grids+=grid;
		
	}

	html='\
		<div id="'+id+'" class="oha-section ohasection-9-grid section-grid">\
  			<div class="clearfix" style="height:60%;">\
	  			'+grids+'\
	  		</div>\
	  		<div class="des center">\
	  			<div class="container">\
	  				<h2>More Information Link </h2>\
	  			</div>\
	  		</div>\
	  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
	  	</div>\
	';

	
  	return html;
}


function accGridMaker(agent,id,data,title,color){

	if(typeof(color)!=undefined){
		colorNo=color;
		var styleCode="background-color:"+colorNo;
	}else{
		var styleCode="";
	}
	//alert("nine");

	// var lang = UserAgentLang(agent,data);
	// console.log("acc",lang);
	if(typeof(data[lang]) !== undefined){
		langdata=data[lang];
	}else{
		langdata=data["default"];
	}

	title=TitleLang(title,lang);


	langdata =datafilter(langdata);
	var render=function(id,langdata,k){

		grids="";
		for(m=0 ; m< langdata.length; m++){
			var thedata=langdata[m];			
			var grid=smallGridMaker(thedata);
			grids+=grid;
			
		}

	
		var html="";

		var newclass=id+"-block";
		id=id+'-'+k;

		html='\
			<div id="'+id+'" class="oha-section ohasection-9-grid section-grid section-acc '+newclass+'" >\
	  			<div class="clearfix" style="height:60%;">\
		  			'+grids+'\
		  		</div>\
		  		<div class="des center" style="'+styleCode+'">\
		  			<div class="container">\
		  				<h2>'+title+' </h2>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		';

		return html;

	}

	langdata=langdata.filter(function(a){
		var result=false;		
		if(a.device != undefined){
            if(isNaN(ver)){
				ver = 260;
			}

			//if(!device){
			//	device = "android";
			//}
			//console.log("accGridMaker",a.device);
			if(a.device.indexOf(device) != (-1) && ver >= AndroidAllowVer){
				result=true;
			}

			if(typeof(a["DisplayUnderAndroidVer"]) !="undefined" ){
				
				if(a.DisplayUnderAndroidVer > Number(ver)){
					result=true;
				}else{
					result=false;
				}
				
			}
		}else{
			result=true;
		}
		return result;
	});
	//var grids="";
	var renderArray = [];
	var i,j,temparray,chunk = 6;
	for (i=0,j=langdata.length; i<j; i+=chunk) {

	    temparray = langdata.slice(i,i+chunk);
	    renderArray.push(temparray);
	    // do whatever
	}

	//console.log(renderArray.length);

	var html="";

	for(k=0 ; k < renderArray.length; k++){
		var data=renderArray[k];
		//console.log(data);
		html += render(id,data,k);
		
	}

	
  	return html;
}

function QrcodGridMaker(agent,id,data,title,color){
	
	if(typeof(color)!=undefined){
		colorNo=color;
		var styleCode="background-color:"+colorNo;
	}else{
		var styleCode="";
	}
	//alert("nine");
	 console.log("QrcodGridMaker"+lang);

	// var langdata = data;

	if(typeof(data[lang]) !== undefined){
		langdata=data[lang];
	}else{
		langdata=data["default"];
	}

	title = TitleLang(title,GetUserAgentLang(agent));

	var render=function(id,langdata,k){

		
		var girds="";

		grids="";
		for(m=0 ; m< langdata.length; m++){
			var thedata=langdata[m];			
			var grid = QrcodeSmallGridMaker(thedata);
			grids+=grid;			
		}

	
		var html="";
		var newclass=id+"-block";
		id=id+'-'+k;
		html='\
			<div id="'+id+'" class="oha-section ohasection-9-grid section-grid section-acc '+newclass+'" >\
	  			<div class="clearfix" style="height:60%;">\
		  			'+grids+'\
		  		</div>\
		  		<div class="des center" style="'+styleCode+'">\
		  			<div class="container">\
		  				<h2>'+title+' </h2>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		';

		return html;

	}

		langdata=langdata.filter(function(a){
		var result=false;		
		console.log("QrcodGridMaker a.device="+a.device+";device="+device);
		
		if(!device){
			result=true;
		}else if(a.device != undefined){
            if(isNaN(ver)){
				ver = 260;
			}

			//if(!device){
			//	device = "android";
			//}
			console.log("QrcodGridMaker a.device="+a.device+";device="+device);
			if(a.device.indexOf(device) != (-1) && ver >= AndroidAllowVer){
				result=true;
			}

			if(typeof(a["DisplayUnderAndroidVer"]) !="undefined" ){
				
				if(a.DisplayUnderAndroidVer > Number(ver)){
					result=true;
				}else{
					result=false;
				}
				
			}
			
		}else{
			result=true;
		}
		return result;
	});


	//var grids="";
	var renderArray=[];
	var i,j,temparray,chunk = 6;
	for (i=0,j=langdata.length; i<j; i+=chunk) {

	    temparray = langdata.slice(i,i+chunk);
	    renderArray.push(temparray);
	    // do whatever
	}

	//console.log(renderArray.length);

	var html="";

	for(k=0 ; k < renderArray.length; k++){
		var data=renderArray[k];
		//console.log(data);
		html+=render(id,data,k);
		
	}

	
  	return html;
}

function QrcodeSmallGridMaker(grid){


	if(typeof(grid.id)!== undefined){
		id='id="'+grid.id+'"';
	}else{
		id="";
	}


	if(grid.url != undefined){
		var Geturl='data-url="'+grid.GetUrl+'"';
	}else{
		var Geturl='';
	}

	var DataCommand=' data-command="false" ';
	// if(grid.command == false){
	// 	var DataCommand=' data-command="false" ';
	// }else{
	// 	var DataCommand='';
	// }

	html='<div class="grid grid-qrcode oha-lightbox"  " data-url="'+grid.url+'" data-image="'+grid.image+'" data-title="'+grid.title+'" data-urllink="'+grid.url+'">\
				<div class="grid-image grid-qrcode" style="background-image:url('+grid.image+')"></div>\
  				<div class="grid-title">'+grid.title+'</div>\
  			</div>';

  	return html;
}








function ruleGridMaker(agent,data){

	//alert("nine");

	var lang=UserAgentLang(agent,data);

	if(typeof(rule_datas[lang]) != undefined){
		langdata=rule_datas[lang];
	}else{
		langdata=rule_datas["default"];
	}
	
	var rules;
	var title;
	var rulesHTML="";
	function ruleMaker(rule){
		var rtitle;
		rtilte="<h4>"+rule["title"]+"</h4>";
		des="<p>"+rule.des+"</p>";
		html="<li>"+rtilte+des+"</li>";
		return html;
	}
    

    

	rules=langdata.rules;

	rulesHTML+="<ul>";
	for(i=0;i<rules.length;i++){

		rulesHTML+=ruleMaker(rules[i]);
	}

	rulesHTML+="</ul>";
	title=langdata["title"];
	rules="test";
	
	html='<div id="section-rule" class="oha-section"><div class="cover"><div class="container">'+rulesHTML+'</div></div><div class="center des"><div class="container"><h2>'+title+'</h2></div></div></div>';

	
  	return html;
}


function UserAgentLang(agent,data){
	var gridlangs=Object.keys(data);

	//var langs=["oLang:CN","oLang:TW","oLang:US"];
	
	lang="default";

	for(i=0;i<gridlangs.length;i++){

		var fixedstr="oLang:"+gridlangs[i];
		
		if(agent.indexOf(fixedstr) !== (-1)){
			lang=gridlangs[i];
			break;
		}


	}
console.log("UserAgentLang="+lang);
	return lang;

}


var lang = null;

function setlang(_lang){
	lang = _lang;
	render();
}

function GetUserAgentLang(agent){

	return lang;

	if(lang != null){

	}else{
		return lang;
	}

	if(agent.indexOf("oLangN") == -1){
		return null;
	}


	var agentfix=agent.replace("oLangN:","");
	var agentArr=agentfix.split("oLang:");
	var last=agentArr[agentArr.length-1];
	last=last.split(";")[0];
	console.log("GetUserAgentLang="+last);
	return last;
	return false;
}

function SearchLang(str, lang)
{
	var result = SearchStr.filter(function(search_element){
	  return search_element["en-US"].trim() == str.trim();
	})

	if(result.length==0){
		return str;
	}else{
		if(typeof(result[0][lang])== "undefined" ){
			return str;
		}else{
			return result[0][lang];
		}
		
	}
}

function TitleLang(str,lang){
	var target=str;
	var result=TitleStr.filter(function(str){
	  return str["en-US"].trim() == target.trim();
	})

	if(result.length==0){
		return str;
	}else{
		if(typeof(result[0][lang])== "undefined" ){
			return str;
		}else{
			return result[0][lang];
		}
		
	}
}


function UserAgentDevice(agent){
	
	if(agent.indexOf("oPlateform:iOS") !== (-1)){

		return "ios";

	}

	if(agent.indexOf("oPlateform:Android") !== (-1)){

		return "android";

	}

	return false;

}


function UserAgentVer(agent){
		
	var agentArr=agent.split("appVer:");
	var last=agentArr[agentArr.length-1];
	last=last.split(";")[0];
	last=Number(last);
	return last;
	return false;

}



function ImgRule(data,color){


	// var lang=UserAgentLang(agent,data);

	if(typeof(data[lang]) !== undefined){
		langdata=data[lang];
	}else{
		langdata=data["default"];
	}
	

	if(typeof(color)!=undefined){
		colorNo=color;
		var styleCode="background-color:"+colorNo;
	}else{
		var styleCode="";
	}

	id="section-rules-img-style";
	html='<div id="'+id+'" class="oha-section">\
  		<div class="cover">\
  			<img class="cover-image lazyload" src="'+langdata.image+'">\
  		</div>\
  		<div class="des center" style="'+styleCode+'">\
  			<div class="container">\
  				<h2><a href="javascript:void(0)" onclick="'+langdata.onclick+'">'+langdata.title+'</a> </h2>\
  			</div>\
  		</div>\
  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
  	</div>';

  	return html;
}


sectionCookie={};

sectionCookie.set=function(tag,val){

	if(typeof(val)== "array" || typeof(val)== "object"){
		val= JSON.stringify(val);
	}
	
	oha_api.cookieWrite(tag,val);
}

sectionCookie.getJSON=function(tag){

	var output;
	output=oha_api.cookieRead(tag,"undefined");

	if(output=="undefined"){
		return output;
	}

	return	JSON.parse(output);
}


sectionCookie.getData=function(tag){

	var output;
	output=oha_api.cookieRead(tag,"undefined");
	//alert(output);
	/*
	if(output === undefined){
		output="undefined";
	}
	*/
	return output;

}

function SectionOrder(){

	var order=[];

	$(".oha-section").each(function(i){

		var id=$(this).attr("id");
		order.push(id);
	})

	return order;
}

function MarkAsHome(id){
	cookieOrder.unshift(id);
	//$.unique( cookieOrder );
	cookieOrder=customUnique(cookieOrder);
	order.unshift(id);
	order=customUnique(order);
	SectionReorder(order);
	$(window).scrollTop(0)
	sectionCookie.set("order",cookieOrder);

	$('#search_result').remove();
}



function SectionReorder(arr){

	var html="";

	for(i=0;i<arr.length;i++){

		var id="#"+arr[i];
		if($(id).length >0 ){
			var section= $(id).wrap('<div>').parent().html();
			html+=section;
		}
		
	}
	$("#grids").html(html);
}


 function customUnique(array) {
     return $.grep(array, function(el, index) {
        return index === $.inArray(el, array);
      });
   }
function CookieOrder(){

	order=SectionOrder();

	if(sectionCookie.getJSON("order") != "undefined" ){

		cookieOrder=sectionCookie.getJSON("order");
		order= cookieOrder.concat(order);
		order=customUnique(order);
	//	$.unique( order );
		SectionReorder(order);
	}else{
		cookieOrder=[];
	}

}

function adjustGridTitle(height,originHeight){
	
	var newHeight=height*0.8;
	var i = 0;

	$(".grid-title").each(function(){

		if($(this).height() > originHeight ){
			$(this).css("font-size",newHeight+"px");
			$(this).css("line-height",newHeight*1.4+"px");
			//console.log($(this).text());
			i++;
		}
	})
	if(i > 0){
		adjustGridTitle(newHeight,originHeight);
	}
}

var RunHideBlocks=false;
var PluginUrl="undefined";

function HideBlocksbyCookie(){
	 console.log("START");
	PluginUrl=sectionCookie.getData("PluginUrl");
	
	if(RunHideBlocks == false){
		 console.log("START1");
		if(PluginUrl != "undefined" ){
			 console.log("START2");
			var _url=PluginUrl;
			
			console.log(_url);
			
			HideBlocks(_url);	
			
		}
	}
}

function HideBlocks(_url){

	var arr = HideBlocksUrls.map(function(elem) { return elem.toLowerCase(); });
	//var _url= oha_api.runOhaCmd("oha://getUrl");
	//var _url="http://aaww.nba.com";
	//console.log("toLowerCase");
	_url=_url.toLowerCase();

	//console.log("Result");
	var Result = arr.indexOf(_url);


	if(PluginUrl != "undefined" ){
		console.log("HAVE COOKIE ALREADY");
		var old_url= PluginUrl
		if(old_url !== _url){
			sectionCookie.set("PluginUrl",_url);
			location.reload();
		}
		
	}else{
		console.log("WRIGHT");
		sectionCookie.set("PluginUrl",_url);	
	}

	if(Result != -1 ){
		console.log("HaveResult");
		datas=[];
		grid_datas=[];
		$(".normal-grid").remove();
		$("#section-grid").remove();
		$(".section-grid-block").remove();
	}
	RunHideBlocks=true;
}
function HideAcc(){
	 console.log("HideAcc");
	//$(".section-acc").remove();
   sectionCookie.set("HideAcc","true");	
}
function HideAccbyCookie(){
	 console.log("HideAccbyCookie");
	HideAccCookie=sectionCookie.getData("HideAcc");
	//HideAccCookie = "false";
	if(HideAccCookie == "undefined" ){
		 console.log("HideAccbyCookie cp 1");
		HideAcc();
		 console.log("HideAccbyCookie cp 2");
		 return true;
	}
	if(HideAccCookie == "true" ){
		 console.log("HideAccbyCookie cp 3");
		
		HideAcc();
		 console.log("HideAccbyCookie cp 4");
		 return true;
	}
	 return false;
}

function ShowAcc(){
	 console.log("ShowAcc cp 1");
	
  sectionCookie.set("HideAcc","false");
   console.log("ShowAcc cp 2");
  
}
/*
var hideblock={
	"Cons":function(_url){
		var arr = HideBlocksUrls.map(function(elem) { return elem.toLowerCase(); });
		_url=_url.toLowerCase();
		var Result = arr.indexOf(_url);
		console.log(Result);
	},
	"hide":function(_url){
		this.Cons(_url);
	}
};
*/

