//alert("scripts");


function GridMaker(data){
	//alert("GRIDMAKER");
	if(typeof(data)!=="object" ){
		return false;
	}

	if(typeof(data.display)!="undefined" &&  data.display==false){
		return "";
	}

	var des=data.des.join("<br>");

	var id="oha-"+data.id;

	var html='\
				<div id="'+id+'" class="oha-section normal-grid">\
		  		<div class="cover">\
		  			<img class="cover-image" src="images/cover/'+data.image+'">\
		  			<div class="subtitle">\
		  				<div class="container">\
		  					'+data.subtitle+'\
		  				</div>\
		  			</div>\
		  		</div>\
		  		<div class="des">\
		  			<div class="container">\
		  				<h2>'+data.title+' </h2>\
		  				<p>\
			  				'+des+'\
		  				</p>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		  </div>\
	';

	return html;

}

function smallGridMaker(grid){


	if(typeof(grid.id)!== undefined){
		id='id="'+grid.id+'"';
	}else{
		id="";
	}


	if(grid.GetUrl != undefined){
		var Geturl='data-url="'+grid.GetUrl+'"';
	}else{
		var Geturl='';
	}

	if(grid.command == false){
		var DataCommand=' data-command="false" ';
	}else{
		var DataCommand='';
	}



	html='\
			<a href="'+grid.url+'" '+Geturl+DataCommand+'>\
			<div class="grid" '+id+' ">\
				<div class="grid-image" style="background-image:url('+grid.image+')"></div>\
  				<div class="grid-title">'+grid.title+'</div>\
  			</div>\
  			</a>';

  	return html;
}

function datafilter(langdata){

	var output=langdata.filter(function(data){

	  var _display=typeof(data.display) =="undefined" ||  data.display !=false;

	  return _display=true;
	});
	return output;
}

function nineGridMaker(agent,id,data){

	//alert("nine");

	var lang=UserAgentLang(agent,data);

	if(typeof(grid_datas[lang]) !== undefined){
		langdata=grid_datas[lang];
	}else{
		langdata=grid_datas["default"];
	}



	if(langdata == undefined){
		return false;
	}


	langdata =datafilter(langdata);

	//console.log("lang",langdata);

	if(langdata.length == 0){
		return "";
	}

	var grids="";



	for(i=0 ; i<langdata.length; i++){

		thedata=langdata[i];
		grid=smallGridMaker(thedata);
		grids+=grid;
		
	}

	html='\
		<div id="'+id+'" class="oha-section ohasection-9-grid section-grid">\
  			<div class="clearfix" style="height:60%;">\
	  			'+grids+'\
	  		</div>\
	  		<div class="des center">\
	  			<div class="container">\
	  				<h2>More Information Link </h2>\
	  			</div>\
	  		</div>\
	  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
	  	</div>\
	';

	
  	return html;
}


function accGridMaker(agent,id,data,title){

	//alert("nine");

	var lang=UserAgentLang(agent,data);

	if(typeof(data[lang]) !== undefined){
		langdata=data[lang];
	}else{
		langdata=data["default"];
	}


	langdata =datafilter(langdata);
	var render=function(id,langdata,k){

		
		var girds="";

		grids="";
		for(m=0 ; m< langdata.length; m++){
			var thedata=langdata[m];			
			var grid=smallGridMaker(thedata);
			grids+=grid;
			
		}

	
		var html="";
		id=id+'-'+k;
		html='\
			<div id="'+id+'" class="oha-section ohasection-9-grid section-grid section-acc">\
	  			<div class="clearfix" style="height:60%;">\
		  			'+grids+'\
		  		</div>\
		  		<div class="des center">\
		  			<div class="container">\
		  				<h2>'+title+' </h2>\
		  			</div>\
		  		</div>\
		  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
		  	</div>\
		';

		return html;

	}

	langdata=langdata.filter(function(a){
		var result=false;		
		if(a.device != undefined){

			if(a.device.indexOf(device) != (-1) && ver >= AndroidAllowVer){
				result=true;
			}

			if(typeof(a["DisplayUnderAndroidVer"]) !="undefined" ){
				
				if(a.DisplayUnderAndroidVer > Number(ver)){
					result=true;
				}else{
					result=false;
				}
				
			}
		}else{
			result=true;
		}
		return result;
	});


	//var grids="";
	var renderArray=[];
	var i,j,temparray,chunk = 6;
	for (i=0,j=langdata.length; i<j; i+=chunk) {

	    temparray = langdata.slice(i,i+chunk);
	    renderArray.push(temparray);
	    // do whatever
	}

	//console.log(renderArray.length);

	var html="";

	for(k=0 ; k < renderArray.length; k++){
		var data=renderArray[k];
		//console.log(data);
		html+=render(id,data,k);
		
	}

	
  	return html;
}










function ruleGridMaker(agent,data){

	//alert("nine");

	var lang=UserAgentLang(agent,data);

	if(typeof(rule_datas[lang]) != undefined){
		langdata=rule_datas[lang];
	}else{
		langdata=rule_datas["default"];
	}
	
	var rules;
	var title;
	var rulesHTML="";
	function ruleMaker(rule){
		var rtitle;
		rtilte="<h4>"+rule["title"]+"</h4>";
		des="<p>"+rule.des+"</p>";
		html="<li>"+rtilte+des+"</li>";
		return html;
	}
    

    

	rules=langdata.rules;

	rulesHTML+="<ul>";
	for(i=0;i<rules.length;i++){

		rulesHTML+=ruleMaker(rules[i]);
	}

	rulesHTML+="</ul>";
	title=langdata["title"];
	rules="test";
	
	html='<div id="section-rule" class="oha-section"><div class="cover"><div class="container">'+rulesHTML+'</div></div><div class="center des"><div class="container"><h2>'+title+'</h2></div></div></div>';

	
  	return html;
}


function UserAgentLang(agent,data){
	var gridlangs=Object.keys(data);

	var langs=["oLang:CN","oLang:TW","oLang:US"];
	
	lang="default";

	for(i=0;i<gridlangs.length;i++){

		var fixedstr="oLang:"+gridlangs[i];
		//console.log();
		if(agent.indexOf(fixedstr) !== (-1)){
			lang=gridlangs[i];
			break;
		}


	}

	

	return lang;

}


function UserAgentDevice(agent){
	
	if(agent.indexOf("oPlateform:iOS") !== (-1)){

		return "ios";

	}

	if(agent.indexOf("oPlateform:Android") !== (-1)){

		return "android";

	}

	return false;

}


function UserAgentVer(agent){
		
	var agentArr=agent.split("appVer:");
	var last=agentArr[agentArr.length-1];
	last=last.split(";")[0];
	last=Number(last);
	return last;
	return false;

}




function ImgRule(){

	id="section-rules-img-style";
	html='<div id="'+id+'" class="oha-section">\
  		<div class="cover">\
  			<img class="cover-image" src="images/rules.jpg">\
  		</div>\
  		<div class="des center">\
  			<div class="container">\
  				<h2><a href="javascript:void(0)" onclick="oha_api.runOhaCmd(\'oha://home_TermOfUsage_使用條款\')">?責??</a> </h2>\
  			</div>\
  		</div>\
  		<div class="MarkHome" data-id="'+id+'"><img src="images/home.svg"></div>\
  	</div>';

  	return html;
}


sectionCookie={};

sectionCookie.set=function(tag,val){

	if(typeof(val)== "array" || typeof(val)== "object"){
		val= JSON.stringify(val);
	}
	
	oha_api.cookieWrite(tag,val);
}

sectionCookie.getJSON=function(tag){

	var output;
	output=oha_api.cookieRead(tag,"undefined");

	if(output=="undefined"){
		return output;
	}

	return	JSON.parse(output);
}


sectionCookie.getData=function(tag){

	var output;
	output=oha_api.cookieRead(tag,"undefined");
	//alert(output);
	/*
	if(output === undefined){
		output="undefined";
	}
	*/
	return output;

}

function SectionOrder(){

	var order=[];

	$(".oha-section").each(function(i){

		var id=$(this).attr("id");
		order.push(id);
	})

	return order;
}

function MarkAsHome(id){
	cookieOrder.unshift(id);
	//$.unique( cookieOrder );
	cookieOrder=customUnique(cookieOrder);
	order.unshift(id);
	order=customUnique(order);
	SectionReorder(order);
	$(window).scrollTop(0)
	sectionCookie.set("order",cookieOrder);
}



function SectionReorder(arr){

	var html="";

	for(i=0;i<arr.length;i++){

		var id="#"+arr[i];
		if($(id).length >0 ){
			var section= $(id).wrap('<div>').parent().html();
			html+=section;
		}
		
	}
	$("#grids").html(html);
}


 function customUnique(array) {
     return $.grep(array, function(el, index) {
        return index === $.inArray(el, array);
      });
   }
function CookieOrder(){

	order=SectionOrder();

	if(sectionCookie.getJSON("order") != "undefined" ){

		cookieOrder=sectionCookie.getJSON("order");
		order= cookieOrder.concat(order);
		order=customUnique(order);
	//	$.unique( order );
		SectionReorder(order);
	}else{
		cookieOrder=[];
	}

}

function adjustGridTitle(height,originHeight){
	
	var newHeight=height*0.8;
	var i = 0;

	$(".grid-title").each(function(){

		if($(this).height() > originHeight ){
			$(this).css("font-size",newHeight+"px");
			$(this).css("line-height",newHeight*1.4+"px");
			//console.log($(this).text());
			i++;
		}
	})
	if(i > 0){
		adjustGridTitle(newHeight,originHeight);
	}
}

var RunHideBlocks=false;
var PluginUrl="undefined";

function HideBlocksbyCookie(){
	console.log("START");
	PluginUrl=sectionCookie.getData("PluginUrl");
	
	if(RunHideBlocks == false){
		console.log("START1");
		if(PluginUrl != "undefined" ){
			console.log("START2");
			var _url=PluginUrl;
			
			console.log(_url);
			
			HideBlocks(_url);	
			
		}
	}
}

function HideBlocks(_url){

	var arr = HideBlocksUrls.map(function(elem) { return elem.toLowerCase(); });
	//var _url= oha_api.runOhaCmd("oha://getUrl");
	//var _url="http://aaww.nba.com";
	console.log("toLowerCase");
	_url=_url.toLowerCase();

	console.log("Result");
	var Result = arr.indexOf(_url);


	if(PluginUrl != "undefined" ){
		console.log("HAVE COOKIE ALREADY");
		var old_url= PluginUrl
		if(old_url !== _url){
			sectionCookie.set("PluginUrl",_url);
			location.reload();
		}
		
	}else{
		console.log("WRIGHT");
		sectionCookie.set("PluginUrl",_url);	
	}

	if(Result != -1 ){
		console.log("HaveResult");
		datas=[];
		grid_datas=[];
		$(".normal-grid").remove();
		$("#section-grid").remove();
	}
	RunHideBlocks=true;
}

