//import React from 'react';
//import 'oha.files/help.css';
window.helpManager=new function() {
	var self = this;
	var _container="div.oha_ctrl";
//	var PageNo=-1;
	var isLandscape=false;
	var uiWidth=-1;
	var uiHeight=-1;
	var help01PropP={
		curtime:{
			"en": "Current Time", 
			"zh": "目前時間", 
			"zh-CN": "目前时间", 
		},
		timer:{
			"en": "Timer+/-", 
			"zh": "加減時間設定", 
			"zh-CN": "加减时间设定", 
		},
		sound:{
			"en": "Notification", 
			"zh": "聲音提醒", 
			"zh-CN": "声音提醒", 
		},
		screen:{
			"en": "Power Saving", 
			"zh": "省電模式", 
			"zh-CN": "省电模式", 
		},
		menu:{
			id: "menu", 
			"en": "Settings", 
			"zh": "設定", 
			"zh-CN": "设定", 
		},
		uiopt:{
			"en": "UI Options", 
			"zh": "人機介面選擇", 
			"zh-CN": "人机介面选择", 
		},
		www:{
			"en": "Mini\nApp", 
			"zh": "小程序\n網址", 
			"zh-CN": "小程序\n网址", 
		},
		barView:{
			"en": "Bar\nView", 
			default: "Bar\nView"
		}
	};
	var help0Prop={};
	$.extend(help0Prop, help01PropP, {
		power:{
			"en": "Device Unconnected", 
			"zh": "裝置不存在", 
			"zh-CN": "装置不存在", 
		}
										});
	var help1Prop={};
	$.extend(help1Prop, help01PropP, {
		power:{
			"en": "ON/OFF\nClick to change", 
			"zh": "開關狀態\n觸動可改變", 
			"zh-CN": "开关状态\n触动可改变", 
		}

	});
	
	var x = document.createElement("link");
	x.rel="styleSheet";
	x.type="text/css";
	x.href="oha.files/help.css";
	document.head.appendChild(x);
	var _helpDiv=document.createElement("div");
	_helpDiv.id="helpDiv";
	_helpDiv.style.display="none";
////	_helpDiv.onclick=function() {
////		self.showHelp(false);
////	}
//	var _factor=0.6;
////	var _h=$(window).height();
//	var _h=window.innerHeight;
////    var _w=$(window).width();
//	var _w=window.innerWidth;
//	var _width=_w;
//	var _height=_h;
//	if(_h*_factor>_w) {
//		_height=_width/_factor;
//	}
//	else {
//		_width=_height*_factor;
//	}
//	var _left=(_w-_width)/2;
//	var _top=(_h-_height)/2
//	_helpDiv.style.position="absolute";
//	_helpDiv.style.display="none";
////	_helpDiv.style.width="100%";
////	_helpDiv.style.height="100%";
////	_helpDiv.style.left="0";
////	_helpDiv.style.top="0";
//	_helpDiv.style.width=_width+"px";
//	_helpDiv.style.height=_height+"px";
//	_helpDiv.style.left=_left+"px";
//	_helpDiv.style.top=_top+"px";
////	_helpDiv.style.pointerEvents="none";
//	_helpDiv.style.zIndex=9999;
//	_helpDiv.style="display:none;width:"+_width+";height:"+_height+";left="+_left+";top:"+_top+";";
//	_helpDiv.style="display:none;width:"+_width+";height:"+_height+";left="+_left+";top:"+_top+";";
	document.body.appendChild(_helpDiv);
//	this.setContainer=function(_selector) {
//		document.querySelectorAll(_selector).forEach(function(_node){
//			_node.appendChild(_helpDiv);
//		});
//	}

	class Help extends React.Component {
		constructor(props) {
			super(props)
			this.quitHelp=this.quitHelp.bind(this);
			this.state={isShow:true};
		}
		
		componentDidMount() {
			console.log("componentDidMount");
			self.resize();
		}
		
		quitHelp() {
			console.log("quitHelp run");
			this.setState({isShow:false});
//			document.getElementById("helpDiv").style.display="none";
//			document.getElementById("helpIcon").classList.remove("isShow");
//			ReactDOM.render(
//				<div></div>, document.getElementById("helpDiv")
//			);
		}

		render() {
			var _helpList=[];
//			if(!this.state.isShow) {
//				return <div className="helpContainer disabled"></div>;
//			}
			var children=this.props.children;
			for(x in children) {
				console.log("Help.render, x="+x+", this.props.children.x="+children[x]["en"]);
				var _msgOrigin=oha_api.getMessage(children[x]);
				var _msg=_msgOrigin.split("\n");
				var _msgObj=[];
				for(var i=0;i<_msg.length;i++) {
					if(i!=0) {
						_msgObj.push(<br/>);
					}
					_msgObj.push(
						<span>{_msg[i]}</span>
					);
				}
				var _class="NA";
				for(var key in children[x]) {
					if(children[x][key]==_msgOrigin) {
						_class=key;
					}
				}
				_helpList.push(
					<div id={"help_"+x} className={_class+" helpItem"}>
						<div className={"_helpTxt"}>{_msgObj}</div>
					</div>
				);
			}
				_helpList.push(
					<div id={"help_vir"} className={"helpVirItem"} onClick={rmHelp}>
					</div>
				);
//				_helpList.push(
//					<div id={"help_vir"} className={"helpVirItem"} onClick={this.quitHelp}>
//					</div>
//				);
			return <div className="helpContainer">{_helpList}</div>;
		}
	}

	function addHelp(_pageNo) {
//		console.log("addHelp("+_pageNo+")")
		var _helpObj=document.getElementById("helpDiv");
		_helpObj.style.display="block";
		if(typeof(_pageNo)=="undefined") {
			_pageNo=0;
		}
//		PageNo=_pageNo;
		switch(_pageNo) {
			case 0:
				console.log("helpManager.addHelp, _pageNo=0, power message="+help0Prop.power.en)
				ReactDOM.render(
					<Help>
					{help0Prop}
					</Help>,
				  document.getElementById("helpDiv")
				);
				break;
			case 1:
				console.log("helpManager.addHelp, _pageNo=1, power message="+help1Prop.power.en)
				ReactDOM.render(
					<Help>
					{help1Prop}
					</Help>,
				  document.getElementById("helpDiv")
				);
				break;
		}
	}
		
	function rmHelp() {
//		console.log("rmHelp");
		var _helpObj=document.getElementById("helpDiv");
		_helpObj.innerHTML="";
//		ReactDOM.render(
//			null,
//		  document.getElementById("helpDiv")
//		);
		_helpObj.style.display="none";
	}
		
	this.resize=function(_width, _height) {
		if(typeof _width =="undefined") {
			_width=uiWidth;
		}
		else {
			uiWidth=_width;
		}
		if(typeof _height =="undefined") {
			_height=uiHeight;
		}
		else {
			uiHeight=_height;
		}
		console.log("help.js resize, _width="+_width+", _height="+_height)
		if(document.getElementById("helpDiv").style.display=="none") {
			return;
		}
		var _helpDiv=document.getElementById("helpDiv");
//		var _h=$(window).height();
		var _h=window.innerHeight;
		var _w=window.innerWidth;
////		var _w=$(window).width();
//		if(isLandscape) {
//			var _factor=(1200/800);
//		}
//		else {
//			var _factor=(480/800);
//		}
////		var sizeObj=
//		var _width=_w*0.8;
//		var _height=_h*0.8;
//		if(_h*_factor>_w) {
//			_height=_width/_factor;
//		}
//		else {
//			_width=_height*_factor;
//		}
		var _left=(_w-_width)/2;
		var _top=(_h-_height)/2
		isLandscape=(_width>_height);
		setOrientation(isLandscape);
		if(isLandscape) {
			console.log("isLandscape=true, _width="+_width+", height="+_height);
			_helpDiv.style.position="absolute";
			_helpDiv.style.width=_width+"px";
			_helpDiv.style.height=_height+"px";
			_helpDiv.style.left=_left+"px";
			_helpDiv.style.top=_top+"px";
//			_helpDiv.style.display="none";
			if(document.querySelector(".helpContainer")!=null) {
				if(_helpDiv.classList.contains("oHeating")) {		// oHeating
					document.querySelector(".helpContainer #help_curtime").style.fontSize=0.06*_height+"px";
					document.querySelector(".helpContainer #help_menu").style.fontSize=0.05*_height+"px";
					document.querySelector(".helpContainer #help_barView").style.fontSize=0.04*_height+"px";
					document.querySelector(".helpContainer #help_www").style.fontSize=0.04*_height+"px";
					document.querySelector(".helpContainer #help_timer").style.fontSize=0.08*_height+"px";
					document.querySelector(".helpContainer #help_power").style.fontSize=0.04*_height+"px";
					document.querySelector(".helpContainer #help_sound").style.fontSize=0.04*_height+"px";
					document.querySelector(".helpContainer #help_screen").style.fontSize=0.04*_height+"px";
					document.querySelector(".helpContainer #help_expTemp").style.fontSize=0.05*_width+"px";
					document.querySelector(".helpContainer #help_tempUnit").style.fontSize=0.025*_width+"px";
					document.querySelector(".helpContainer #help_tempInc").style.fontSize=0.025*_width+"px";
					document.querySelector(".helpContainer #help_tempDec").style.fontSize=0.025*_width+"px";
				}
				else {
					document.querySelector(".helpContainer #help_curtime").style.fontSize=0.08*_height+"px";
					document.querySelector(".helpContainer #help_menu").style.fontSize=0.06*_height+"px";
					document.querySelector(".helpContainer #help_barView").style.fontSize=0.06*_height+"px";
					document.querySelector(".helpContainer #help_www").style.fontSize=0.06*_height+"px";
					var _zhWWW=document.querySelectorAll(".helpContainer #help_www.zh-CN, .helpContainer #help_www.zh");
					for(var i=0;i<_zhWWW.length;i++) {
						_zhWWW[i].style.fontSize=0.05*_height+"px";
					}
					document.querySelector(".helpContainer #help_timer").style.fontSize=0.07*_height+"px";
					document.querySelector(".helpContainer #help_power").style.fontSize=0.06*_height+"px";
					document.querySelector(".helpContainer #help_sound").style.fontSize=0.06*_height+"px";
					document.querySelector(".helpContainer #help_screen").style.fontSize=0.06*_height+"px";
				}
			}
		}
		else {
//			if(_h*_factor>_w) {
//				_height=_width/_factor;
//			}
//			else {
//				_width=_height*_factor;
//			}
			var _left=(_w-uiWidth)/2;
			var _top=(_h-_height)/2
			_helpDiv.style.position="absolute";
			_helpDiv.style.width=_width+"px";
			_helpDiv.style.height=_height+"px";
			_helpDiv.style.left=_left+"px";
			_helpDiv.style.top=_top+"px";
//			_helpDiv.style.display="none";
			if(document.querySelector(".helpContainer")!=null) {
				if(_helpDiv.classList.contains("oHeating")) {		// oHeating
					document.querySelector(".helpContainer #help_curtime").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_menu").style.fontSize=0.05*_width+"px";
					document.querySelector(".helpContainer #help_barView").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_www").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_timer").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_power").style.fontSize=0.08*_width+"px";
					document.querySelector(".helpContainer #help_sound").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_screen").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_expTemp").style.fontSize=0.08*_width+"px";
					document.querySelector(".helpContainer #help_tempUnit").style.fontSize=0.05*_width+"px";
					document.querySelector(".helpContainer #help_tempInc").style.fontSize=0.05*_width+"px";
					document.querySelector(".helpContainer #help_tempDec").style.fontSize=0.05*_width+"px";
				}
				else {
					document.querySelector(".helpContainer #help_curtime").style.fontSize=0.1*_width+"px";
					document.querySelector(".helpContainer #help_menu").style.fontSize=0.05*_width+"px";
					document.querySelector(".helpContainer #help_barView").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_www").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_timer").style.fontSize=0.08*_width+"px";
					document.querySelector(".helpContainer #help_power").style.fontSize=0.08*_width+"px";
					document.querySelector(".helpContainer #help_sound").style.fontSize=0.06*_width+"px";
					document.querySelector(".helpContainer #help_screen").style.fontSize=0.06*_width+"px";
				}
			}
		}
		
	}
	
	this.showHelp=function(_isShow, _pageNo) {
		console.log("help.showHelp, _isShow="+_isShow+", _pageNo="+_pageNo);
		if(typeof _isShow=="undefined") {
			_isShow=true;
		}
//		var _helpObj=document.getElementById("helpDiv")
		if(_isShow) {
//			_helpObj.style.display="block";
//			$("#helpDiv").show();
			addHelp(_pageNo);
		}
		else {
//			$("#helpDiv").hide();
//			_helpObj.style.display="none";
			rmHelp();
		}
//		this.resize();
	}
	
	this.normal=function() {
		document.getElementById("helpDiv").classList.remove("oHeating");
		document.getElementById("helpDiv").classList.remove("PWM");
		document.getElementById("helpDiv").classList.add("Normal");
		delete help0Prop.expTemp;
		delete help0Prop.tempUnit;
		delete help0Prop.tempInc;
		delete help0Prop.tempDec;
		delete help0Prop.curtime;
		delete help0Prop.strength;
		delete help1Prop.expTemp;
		delete help1Prop.tempUnit;
		delete help1Prop.tempInc;
		delete help1Prop.tempDec;
		delete help1Prop.curtime;
		delete help1Prop.strength;
		help0Prop.curtime=help01PropP.curtime;
		help1Prop.curtime=help01PropP.curtime;
	}
	
	this.oHeating=function() {
		document.getElementById("helpDiv").classList.remove("Normal");
		document.getElementById("helpDiv").classList.remove("PWM");
		document.getElementById("helpDiv").classList.add("oHeating");
		delete help0Prop.strength;
		delete help1Prop.strength;
		help1Prop.expTemp={
			"en": "Target Temp. degree", 
			"zh": "目標溫度", 
			"zh-CN": "目标温度", 
		};
		help1Prop.tempUnit={
			"en": "Temperature\n& unit", 
			"zh": "目前溫度\n&單位", 
			"zh-CN": "目前温度\n&单位", 
		};
		help1Prop.tempInc={
			"en": "Increase Temp.", 
			"zh": "增溫", 
			"zh-CN": "增温", 
		};
		help1Prop.tempDec={
			"en": "Decrease Temp.", 
			"zh": "降溫", 
			"zh-CN": "降温", 
		};
		help1Prop.curtime={
			"en": "Countdown Time", 
			"zh": "倒數時間", 
			"zh-CN": "倒数时间", 
		};

		help0Prop.expTemp=help1Prop.expTemp;
		help0Prop.tempUnit=help1Prop.tempUnit;
		help0Prop.tempInc=help1Prop.tempInc;
		help0Prop.tempDec=help1Prop.tempDec;
		console.log("help0Prop.tempInc="+help0Prop.tempInc);
	}
	
	this.PWM=function() {
		document.getElementById("helpDiv").classList.remove("oHeating");
		document.getElementById("helpDiv").classList.remove("Normal");
		document.getElementById("helpDiv").classList.add("PWM");
		delete help0Prop.expTemp;
		delete help0Prop.tempUnit;
		delete help0Prop.tempInc;
		delete help0Prop.tempDec;
		delete help1Prop.expTemp;
		delete help1Prop.tempUnit;
		delete help1Prop.tempInc;
		delete help1Prop.tempDec;
		help1Prop.strength={
			"en": "Strength", 
			"zh": "強度顯示", 
			"zh-CN": "强度显示", 
		};
//		help0Prop.strength=help1Prop.strength;
	}
	
	function setOrientation(_isLandscape) {
		console.log("setOrientation, isLandscape="+_isLandscape)
		if(_isLandscape) {
			document.getElementById("helpDiv").classList.add("landscape");
		}
		else {
			document.getElementById("helpDiv").classList.remove("landscape");
		}
		isLandscape=_isLandscape;
	}

//	window.onresize=resize;
}
