var tempCtrl=(new function(){
	var status="stop";
	var heatingStus="NA";
	var measureTxtOn=false;
	var isBlueTooth=false;
	var conf={
		maxDegree:42,
		minDegree:20
	}
	var expectTC=-1;
	var cookieConfig={
		tDegree: {
			key: "tDegree", 
			default: 25
		}, 
		tUnit: {
			key: "tUnit", 
			valueC: "C", 
			valueF: "F", 
			default: "C"
		}
	}
	//$("div.oha_ctrl").append('<div id="tempCtrl"></div>');

	//var tempCtrlSvg='\
	//<svg version="1.1" id="tempCtrlSvg" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"\
	//	 width="100%" height="100%"  viewBox="0 0 414 581"\
	//	 enable-background="new 75.446 85.377 268.011 144.871" xml:space="preserve">\
	//<g id="tempCtrl">\
	//	<g id="addTemp">\
	//		<g>\
	//			<path fill="#FFFFFF" d="M321.02,205.859h11.434v1.785H321.02v12.547h-2.063v-12.547h-11.434v-1.785h11.434v-12.488h2.063V205.859\
	//				z"/>\
	//			<circle fill="none" stroke="#FFFFFF" stroke-width="2" stroke-miterlimit="10" cx="319.99" cy="206.781" r="22.467"/>\
	//		</g>\
	//	</g>\
	//	<g id="reduceTemp">\
	//		<g>\
	//			<path fill="#FFFFFF" d="M99.944,205.859h11.432v1.785H99.944h-2.063H86.449v-1.785h11.432H99.944z"/>\
	//			<circle fill="none" stroke="#FFFFFF" stroke-width="2" stroke-miterlimit="10" cx="98.913" cy="206.781" r="22.467"/>\
	//		</g>\
	//	</g>\
	//	<text transform="matrix(1 0 0 1 153.8367 173.2256)" fill="#FFFFFF" font-family="\'Arial\'" font-size="100">30</text>\
	//	<g>\
	//		<g id="unitBtn" onclick="addtime()">\
	//			<g>\
	//				<circle fill="none" stroke="#FFFFFF" stroke-width="2" stroke-miterlimit="10" cx="209.451" cy="206.781" r="22.467"/>\
	//			</g>\
	//			<text id="txtC" transform="matrix(1 0 0 1 204.0623 220.3037)" fill="#FFFFFF" font-family="\'Arial\'" font-size="28">C</text>\
	//			\
	//				<text id="txtF" transform="matrix(1 0 0 1 205.6208 220.3037)" display="none" fill="#FFFFFF" enable-background="new    " font-family="\'Arial\'" font-size="28">F</text>\
	//			<circle fill="none" stroke="#FFFFFF" stroke-width="2" stroke-miterlimit="10" cx="200.357" cy="198.054" r="3.563"/>\
	//		</g>\
	//	</g>\
	//</g>\
	//</svg>'
	//;
	//	<rect x="0" fill=rgba(0,0,0,0) width="414.001" height="581"/>\
	//$("#tempCtrl").append(tempCtrlSvg);
		var _js = document.createElement('script');
		_js.src = 'oha_api/ouart-min.js';
		document.head.appendChild(_js);

	function init() {
		var _degree=parseFloat(oha_api.cookieRead(cookieConfig.tDegree.key, cookieConfig.tDegree.default)).toFixed(0);
		if(_degree>conf.maxDegree) {
			_degree=conf.maxDegree;
		}
		if(_degree<conf.minDegree) {
			_degree=conf.minDegree;
		}
		$("#tsave").text(_degree);
		var _unit=oha_api.cookieRead(cookieConfig.tUnit.key, cookieConfig.tUnit.default);
		if(_unit==cookieConfig.tUnit.valueC) {
			$("#tempTxt").text(_degree);
			$("#unitBtn").find("#txtF").hide()
			$("#unitBtn").find("#txtC").show()
		}
		else {
			$("#tempTxt").text((parseFloat(_degree)*1.8+32).toFixed(0));
			$("#unitBtn").find("#txtF").show()
			$("#unitBtn").find("#txtC").hide()
		}
	
	}
	
	this.setBT=function(_isBT) {
		isBlueTooth=_isBT;
	}
	
	this.oHeatingUI=function(_isOn, _isLandscape) {
	//	$("#ctrlIconList").attr({"transform":"translate(43, -20), scale(0.8, 0.8)"});
		if(_isOn) {
			$("#tempCtrl").show();
			if(_isLandscape) {
				$("#ctrlIconList").attr({transform:"matrix(1.2 0 0 1.2 -58 100)"});
				$("#timer>text").attr({transform:"matrix(1.1 0 0 1.1 300 260)"});
				$("#powerBtn").attr({transform:"matrix(1.0 0 0 1.0 0 5)"});
				$("#tempCtrl").attr({transform:"matrix(1.2 0 0 1.2 -65 138)"});
				$("#tempCtrl #addTemp").attr({transform:"matrix(1 0 0 1 54 0)"});
				$("#tempCtrl #subTemp").attr({transform:"matrix(1 0 0 1 -46 0)"});
				$("#uiOptions").attr({transform:"matrix(1.0 0 0 1.0 0 -330)"});
				$("#measureTxt").attr({transform:"matrix(1.0 0 0 1.0 308.0129 190.8408)"});
				$("#tempTxt").attr({transform:"matrix(0.6 0 0 0.6 270.4507 260.781)"});
				$("#unitBtn").attr({transform:"matrix(1.0 0 0 1.0 40 0)"});
				
			}
			else {
				$("#ctrlIconList").attr({"transform":"matrix(1.0 0 0 1.0 0 80)"});
//				$("#timer").attr({transform:"matrix(0.5 0 0 0.5 150 240)"});
				$("#timer>text").attr({transform:"matrix(1.0 0 0 1.0 300 240)"});
				$("#powerBtn").attr({transform:"matrix(1.0 0 0 1.0 0 0)"});
				$("#tempCtrl").attr({transform:"matrix(1 0 0 1 0 110)"});
				$("#tempCtrl #addTemp").removeAttr("transform");
				$("#tempCtrl #subTemp").removeAttr("transform");
				$("#uiOptions").attr({transform:"matrix(1.0 0 0 1.0 0 0)"});
//				$("#tempTxt").attr({transform:"matrix(1.0 0 0 1.0 305.0129 180.8408)"});
				$("#tempTxt").attr({transform:"matrix(0.5 0 0 0.5 270 260)"});
				$("#measureTxt").attr({transform:"matrix(0.7 0 0 0.7 300 200)"});
				$("#unitBtn").attr({transform:"matrix(1.0 0 0 1.0 30 0)"});
			}
			$("#ui_desc_div").hide();
			$("#uiOptions").hide();
		}
		else {
			$("#tempCtrl").hide();
			$("#ctrlIconList,#powerBtn,#tempCtrl,#uiOptions, #timer>text").removeAttr("transform");
			$("#tempTxt").attr({transform:"matrix(1 0 0 1 305.0129 180.8408)"});
			$("#ui_desc_div").show();
			$("#uiOptions").show();
		}
//		$("#ctrlIconList").attr({"transform":"translate(0, 110)"});
//		$("#timer").attr({"transform":"translate(150, 260), scale(0.5, 0.5)"});
//		$("#powerBtn").attr({"transform":"translate(60, 150), scale(0.8, 0.8)"});
	//	$(".oha_ctrl").append(tempCtrlSvg);
	//	$("#tempCtrlBlk").attr({"transform":"translate(100, 100)"});
	}
	
	this.start=function() {
		status="start";
		pwrOnSensor();
//		$("#tempTxt").attr("transform", "matrix(0.3 0 0 0.3 40 100)");
//		$("#measureTxt").show();
//		$("#measureTxt").attr("transform", "matrix(0.5 0 0 0.5 209.4507 173.2256)");
//		if($("#tsave").text()=="") {
//			if($("#unitBtn").find("#txtC").css("display")=="none") {
//				_curTC=Math.round((_curT-32)/1.8).toFixed(1);
//				$("#tsave").text(_curTC);
//			}
//			else {
//				$("#tsave").text(_curT);
//			}
//		}
	}
	
	this.stop=function(){
		status="stop";
		pwrOffSensor();
		pwrOffHeater();
		measureTxtOn=false;
//		$("#tempTxt").attr("transform", "matrix(1 0 0 1 209.4507 173.2256)");
//		$("#unitBtn").attr("transform", "matrix(1 0 0 1 0 0)");
		$("#measureTxt").text("NA");
	}

	$(window).ready(function() {
		$("#addTemp").click(function(){
			console.log("addTemp Click")
			var _curT=parseInt($("#tempTxt").text());
			var _curTC=_curT;
			if($("#unitBtn").find("#txtC").css("display")=="none") {
				_curTC=Math.round((_curT-32)/1.8);
			}
			if(_curTC<conf.maxDegree) {
				_curT++;
//				$("#tempTxt").text(_curT.toFixed(1))
				$("#tempTxt").text(_curT.toFixed(0))
				if($("#unitBtn").find("#txtC").css("display")=="none") {
					_curTC=Math.round((_curT-32)/1.8);
				}
				else {
					_curTC=_curT;
				}
			}
	//		console.log("curTC="+_curTC)
			$("#tsave").text(_curTC);
			oha_api.cookieWrite(cookieConfig.tDegree.key, _curTC+'');
		});

		$("#subTemp").click(function(){
	//		console.log("subTemp Click")
			var _curT=parseInt($("#tempTxt").text());
			var _curTC=_curT;
			if($("#unitBtn").find("#txtC").css("display")=="none") {
				_curTC=Math.round((_curT-32)/1.8);
			}
			if(_curTC>conf.minDegree) {
				_curT--;
//				$("#tempTxt").text(_curT.toFixed(1))
				$("#tempTxt").text(_curT.toFixed(0))
				if($("#unitBtn").find("#txtC").css("display")=="none") {
					_curTC=Math.round((_curT-32)/1.8);
				}
				else {
					_curTC=_curT;
				}
			}
	//		console.log("curT="+_curT)
			$("#tsave").text(_curTC);
			oha_api.cookieWrite(cookieConfig.tDegree.key, _curTC+'');
		});

		$("#unitBtn").click(function(){
			console.log("unitBtn is clicked")
			var _curT=parseInt($("#tempTxt").text());
			var _curMT=parseFloat($("#tmsave").text());
			if($(this).find("#txtC").css("display")=="none") {
				$(this).find("#txtC").show();
				$(this).find("#txtF").hide();
				oha_api.cookieWrite(cookieConfig.tUnit.key, cookieConfig.tUnit.valueC);
				if($("#tsave").text()=="") {
					$("#tempTxt").text(((_curT-32)/1.8).toFixed(0));
				}
				else {
					$("#tempTxt").text($("#tsave").text());
				}
				if($("#measureTxt").text()!="NA") {
					$("#measureTxt").text(_curMT.toFixed(2));
				}
			}
			else {
				$(this).find("#txtF").show();
				$(this).find("#txtC").hide();
				oha_api.cookieWrite(cookieConfig.tUnit.key, cookieConfig.tUnit.valueF);
				$("#tempTxt").text((_curT*1.8+32).toFixed(0));
				if($("#measureTxt").text()!="NA") {
					$("#measureTxt").text((_curMT*1.8+32).toFixed(2))
				}
			}
		});
	});
	oha_api.oSensorShow=function(_name, _val, _unit, _desc, _raw) {
//		$("#measureTxt").text(_val);
		$("#tmsave").text(_val);
		if(!measureTxtOn && (status=="start")) {
			$("#measureTxt").show();
//			$("#measureTxt").attr("transform", "matrix(0.8 0 0 0.8 177.4507 220.781)");
//			$("#unitBtn").attr("transform", "matrix(1 0 0 1 32 0)");
		}
//		console.log("oSensorShow, status="+status+", expectTC="+expectTC+", measureT="+parseInt(_val));
		if(status=="start") {
			console.log("oSensorShow ("+_name+","+_val+","+_unit+","+_desc+")");
			var _measureT=parseFloat($("#tmsave").text());
			var _curT=parseFloat($("#tempTxt").text());
			if($("#unitBtn").find("#txtF").css("display")=="none") {
				$("#measureTxt").text(_measureT.toFixed(2));
			}
			else {
				$("#measureTxt").text((_measureT*1.8+32).toFixed(2));
			}
			if(expectTC<0 || ($("#tsave").text()=="")) {
				if($("#unitBtn").find("#txtC").css("display")=="none") {
					_curTC=Math.round((_curT-32)/1.8).toFixed(5);
					$("#tsave").text(_curTC);
				}
				else {
					$("#tsave").text(_curT);
				}
			}
//			expectTC=parseFloat($("#tsave").text());
			expectTC=parseFloat($("#tempTxt").text());
			_measureT=parseFloat($("#measureTxt").text());
//			console.log("expectTC="+expectTC+", _measureT="+_measureT);
			if(expectTC>_measureT) {
				pwrOnHeater();
			}
			else if(expectTC<_measureT) {
				pwrOffHeater();
			}
		}
		else {
			pwrOffHeater();
		}
	}
	
	function pwrOnSensor() {
//		console.log("pwrOnSensor");
		oha_api.ApiCmdWr("04:00:00:02:08:00:00:00");
		if(isBlueTooth) {
		}
		else {
			oha_api.ApiCmdWr("02:00:00:01:00:00:AA:AA");
			oha_api.ApiCmdWr("02:01:00:01:00:00:AA")
		}
	}
	
	function pwrOffSensor() {
//		console.log("pwrOffSensor");
		if(isBlueTooth) {
			
		}
		else {
			oha_api.ApiCmdWr("02:00:00:01:00:00:AA:AA");
			oha_api.ApiCmdWr("02:01:00:01:00:00:55")
		}
	}
	
	function pwrOnHeater() {
//		console.log("pwrOnHeater");
		if(heatingStus!=="on") {
			$("#measureTxt").attr("fill", "rgb(255, 0, 0)");
			if(isBlueTooth) {
				oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
				oha_api.ApiCmdWr("02:01:00:05:00:00:AA")
			}
			else {
				oha_api.ApiCmdWr("02:00:00:04:00:00:AA:AA");
				oha_api.ApiCmdWr("02:01:00:04:00:00:AA")
			}
			heatingStus="on";
		}
	}
	
	function pwrOffHeater() {
//		console.log("pwrOffHeater");
		if(heatingStus!=="off") {
			$("#measureTxt").attr("fill", "rgb(255, 0, 0)");
			if(isBlueTooth) {
				oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
				oha_api.ApiCmdWr("02:01:00:05:00:00:55")
			}
			else {
				oha_api.ApiCmdWr("02:00:00:04:00:00:AA:AA");
				oha_api.ApiCmdWr("02:01:00:04:00:00:55")
			}
			heatingStus="off";
		}
	}
	
	init();

}());