var curData="";
_isFound=false;
oha_api.OHA_INTR=function(_recvData) {
//    console.log("OHA_INTR, data="+_recvData);
    var recvList=_recvData.split(':');
    for(var i=0;i<recvList.length;i++) {
        var _charCode=parseInt(recvList[i], 16);
        if((_charCode==0) || (_charCode==10)) {
            if(!_isFound){
//                console.log("OHA_INTR find illegal string, data="+curData);
                curData="";
                continue;
            }
            oha_api.showOsensor(curData);
            curData="";
            _isFound=false;
//            return;
        }
        curData+=String.fromCharCode(_charCode);
//        console.log("curData=("+curData+")");
        if(_isFound) {
            if(curData.length>512) {
                curData="";
                _isFound=false;
            }
        }
        else {
            var _l0=curData.indexOf("oha_sensor ");
            var _l1=curData.indexOf("oha_http ");
            var _l2=curData.indexOf("oha_sensor_js ");
            var _l3=curData.indexOf("oha_sensor_fn ");
            if((_l0>=0) || (_l1>=0) || (_l2>=0) || (_l3>0)) {
                _isFound=true;
//                console.log("OHA_INTR find key word, data="+curData);
                if(_l0 >=0) {
                    curData=curData.substr(_l0);
                }
                else if(_l1>=0) {
                    curData=curData.substr(_l1);
                }
                else if(_l2>=0){
                    curData=curData.substr(_l2);
                }
                else {
                    curData=curData.substr(_l3);
                }
            }
            else {
                if(curData.length>512) {
                    curData="";
                }
            }
        }
    }    
}

oha_api.showOsensor=function(_str) {
//    console.log("showOsensor start:"+_str.length+"("+_str+")");
    var _p=/^(?:oha_sensor)[ \t]+([^=]+)=[ \t]*([^ \t]+)[ \t]+([^ \t]+)[ \t]*[(]([^()]*)[)],(.*)[.]([0-9a-fA-F]{1,4})$/;
    if(_p.test(_str)) {
        var _name=RegExp.$1;
        var _val=RegExp.$2;
        var _unit=RegExp.$3;
        var _raw=RegExp.$4;
        var _desc=RegExp.$5;
        var _checkSum=RegExp.$6;
        if(!oha_api.oSensorCheckSum(_str)){
            return;
        }
        oha_api.oSensorShow(_name, _val, _unit, _desc, _raw);
    }
}

//oha_api.oSensorShow=function(_name, _val, _unit, _desc, _raw) {
//    console.log("oSensorShow ("+_name+","+_val+","+_unit+","+_desc+")");
//}

oha_api.oSensorCheckSum=function (_str){
    var _cs=0;
    var _p=/^(.+[.])([0-9A-Fa-f]{1,4})$/;
    if(!_p.test(_str)) {
        return false;
    }
    var _strRaw=RegExp.$1;
    for(i=0;i<_strRaw.length;i++){
        _cs+=_strRaw.charCodeAt(i);
    }
    _cs&=0xffff;
//    _cs^=0xffff;
    var _expect=parseInt(RegExp.$2,16);
    if(_cs==_expect) {
        return true;
    }
    else {
       console.log("checksum fail, _str="+_str+", expect="+RegExp.$2+", checksum="+_cs.toString(16));
        if(oha_config.ignoreCheckSum) {
            return true;
        }
        return false;
    }
}

oha_api.oSensorInit=function() {
	oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA")
	oha_api.ApiCmdWr("02:01:00:05:00:00:AA:00")
	oha_api.ApiCmdWr("04:00:00:02:08:00:00:00")

}

oha_api.oSensorClose=function() {
    oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
    oha_api.ApiCmdWr("02:01:00:05:00:00:55")
}