// JavaScript Document
var oha_config={
	debug_mode:false,			// Debug mode, must be set as "false" before release
	sw_ver:2.750, 
	model:"&oPower",				// Model Name, must be the same as Config.html
	page_name:"Page0",				// Page Name, different page must be different page name
    default_language:oha_api.langCode.English, 
	url:"", 	// URL for the UI page
	ui_title: {ofs:0, name:"OHA Controller"}, 		// Title name and offset for the UI control panel
	tag_icon: "oha.files/oha_icon.png", 	// size:100x100, background transparent
	on_icon:"oha.files/oha_button_on.png",  // size:200x200, background transparent
	off_icon:"oha.files/oha_button_off.png", // size:200x200, background transparent
    isReadOnly:false, 
    isCheckModelName: false,        
            // If thie UI page checking for Model name, 
            // "true": oha_api.DevPlugIn() will be launched if the plugged device model name 
            //      is matched with oha_config.model
            // "false": oha_api.DevPlugIn() will be launched if any OHA device is plugged
    timer:{					// Timer Setting
		time_option:[60,120,300,600,1200,1800,2400,3000],
		default_value:60
	},
}

// ================== Definition for UI page by language setting =====================
oha_config.html_config=new Object();
oha_config.html_config[oha_api.langCode.English]="default_tw.html";
oha_config.html_config[oha_api.langCode.TraditionChinese]="default_tw.html";
oha_config.html_config[oha_api.langCode.SimpleChinese]="default_tw.html";
oha_config.html_config[oha_api.langCode.Korean]="default_tw.html";
// ================== Definition for Title/Subtitle=====================
oha_config.title=new Object();
oha_config.subtitle=new Object();
//English
oha_config.title[oha_api.langCode.English]="OHA Controller(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.English]="API from network";
// TraditionalChinese
oha_config.title[oha_api.langCode.TraditionChinese]="OHA控制器(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.TraditionChinese]="API網路版本";
// SimleChinese
oha_config.title[oha_api.langCode.SimpleChinese]="OHA控制器(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.SimpleChinese]="API网路版本";
// Korea
oha_config.title[oha_api.langCode.Korean]="OHA Controller(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.Korean]="API from network";
// =========================================================================

oha_api.init(oha_config);           // Initial the oha_api with customized config object
