//import React from 'react';
//import 'oha.files/help.css';
window.helpManager=new function() {
	var self = this;
	var PageNo=-1;
	var help01PropP={
		curtime:{
			"en": "Current Time", 
			"zh": "目前時間", 
			"zh-CN": "目前时间", 
		},
		timer:{
			"en": "Timer+/-", 
			"zh": "加減時間設定", 
			"zh-CN": "加减时间设定", 
		},
		sound:{
			"en": "Notification", 
			"zh": "聲音提醒", 
			"zh-CN": "声音提醒", 
		},
		screen:{
			"en": "Power Saving", 
			"zh": "省電模式", 
			"zh-CN": "省电模式", 
		},
		menu:{
			id: "menu", 
			"en": "Settings", 
			"zh": "設定", 
			"zh-CN": "设定", 
		},
		www:{
			"en": "Mini\nApp", 
			"zh": "小程序\n網址", 
			"zh-CN": "小程序\n网址", 
		},
		barView:{
			"en": "Bar\nView", 
			default: "Bar\nView"
		}
	};
	var help0Prop={};
	$.extend(help0Prop, help01PropP, {
		power:{
			"en": "Device Unconnected", 
			"zh": "裝置不存在", 
			"zh-CN": "装置不存在", 
		}
										});
	var help1Prop={};
	$.extend(help1Prop, help01PropP, {
		power:{
			"en": "ON/OFF\nClick to change", 
			"zh": "開關狀態\n觸動可改變", 
			"zh-CN": "开关状态\n触动可改变", 
		}

	});
	
	var x = document.createElement("link");
	x.rel="styleSheet";
	x.type="text/css";
	x.href="files/help.css";
	document.head.appendChild(x);
	var _helpDiv=document.createElement("div");
	_helpDiv.id="helpDiv";
//	_helpDiv.onclick=function() {
//		self.showHelp(false);
//	}
	var _factor=0.71;
//	var _h=$(window).height();
	var _h=window.innerHeight;
//    var _w=$(window).width();
	var _w=window.innerWidth;
	var _width=_w;
	var _height=_h;
	if(_h*_factor>_w) {
		_height=_width/_factor;
	}
	else {
		_width=_height*_factor;
	}
	var _left=(_w-_width)/2;
	var _top=(_h-_height)/2
	_helpDiv.style.position="absolute";
	_helpDiv.style.display="none";
	_helpDiv.style.width=_width+"px";
	_helpDiv.style.height=_height+"px";
	_helpDiv.style.left=_left+"px";
	_helpDiv.style.top=_top+"px";
	_helpDiv.style.pointerEvents="none";
//	_helpDiv.style["pointer-events"]="none";
//	_helpDiv.style.zIndex=9999;
//	_helpDiv.style="display:none;width:"+_width+";height:"+_height+";left="+_left+";top:"+_top+";";
//	_helpDiv.style="display:none;width:"+_width+";height:"+_height+";left="+_left+";top:"+_top+";";
	document.body.appendChild(_helpDiv);
	class Help extends React.Component {
		constructor(props) {
			super(props)
		}
		
//		componentDidMount() {
//			document.querySelectorAll(".helpContainer")[0].addEventListener("click", function(e){
//				e.preventDefault();
//				console.log("helpContainer onclick");
//				}, false);
//		}

		render() {
			var _helpList=[];
			var children=this.props.children;
			for(x in children) {
//				console.log("Help.render, x="+x+", this.props.children.x="+children[x]["en"]);
				var _msg=oha_api.getMessage(children[x]).split("\n");
				var _msgObj=[];
				for(var i=0;i<_msg.length;i++) {
					if(i!=0) {
						_msgObj.push(<br/>);
					}
					_msgObj.push(
						<span>{_msg[i]}</span>
					);
				}
				var _class="NA";
				for(var key in children[x]) {
					if(children[x][key]==_msg) {
						_class=key;
					}
				}
				_helpList.push(
					<div id={"help_"+x} className={_class+" helpItem"}>
						<div className={"_helpTxt"}>{_msgObj}</div>
					</div>);
			}
			return <div className="helpContainer">{_helpList}</div>;
		}
	}

	function addHelp(_pageNo) {
		if(typeof(_pageNo)=="undefined") {
			_pageNo=0;
		}
		if(_pageNo!=PageNo) {
			PageNo=_pageNo;
			switch(_pageNo) {
				case 0:
					console.log("helpManager.addHelp, _pageNo=0, power message="+help0Prop.power.en)
					ReactDOM.render(
						<Help>
						{help0Prop}
						</Help>,
					  document.getElementById("helpDiv")
					);
					break;
				case 1:
					console.log("helpManager.addHelp, _pageNo=1, power message="+help1Prop.power.en)
					ReactDOM.render(
						<Help>
						{help1Prop}
						</Help>,
					  document.getElementById("helpDiv")
					);
					break;
			}
		}
	}
					
	function resize() {
		var _helpDiv=document.getElementById("helpDiv");
		var _factor=0.71;
//		var _h=$(window).height();
		var _h=window.innerHeight;
		var _w=window.innerWidth;
//		var _w=$(window).width();
		var _width=_w;
		var _height=_h;
		if(_h*_factor>_w) {
			_height=_width/_factor;
		}
		else {
			_width=_height*_factor;
		}
		var _left=(_w-_width)/2;
		var _top=(_h-_height)/2
		_helpDiv.style.position="absolute";
		_helpDiv.style.width=_width+"px";
		_helpDiv.style.height=_height+"px";
		_helpDiv.style.left=_left+"px";
		_helpDiv.style.top=_top+"px";
	}
	
	this.showHelp=function(_isShow, _pageNo) {
		console.log("help.showHelp, _isShow="+_isShow+", _pageNo="+_pageNo);
		if(typeof _isShow=="undefined") {
			_isShow=true;
		}
		var _helpObj=document.getElementById("helpDiv")
		if(_isShow) {
			_helpObj.style.display="block";
//			$("#helpDiv").show();
			addHelp(_pageNo);
		}
		else {
//			$("#helpDiv").hide();
			_helpObj.style.display="none";
		}
	}


	window.onresize=resize;
}
