// JavaScript Document
var isRelease=false;
var uiConfig=new function(){
	this.isHelpOn=false;
}
var intr_ww=null;
var isHBR=false;
var isFast=false;
	var ohaVer=0;
	var isDevReady=false;
    var modeHex=1;
    var modeAscii=2;
    var hasActiveMode=false;
var opMode="passive";
    var _inputMode=modeHex;
    var curData="";
    var _isFound=false;     // if the starting string "oha_sensor" is found
var DeviceId=-1;
var baudRate='19200';
var oUartEnable=true;
var UART_mode="hex";
var intrDataNo=0;
var _testStartTime=0;
var prev_time, max_time, min_time;
var _byteCount=0;
var cur_data=0;
var isInterruptEnable=false;
var pollIntv;
var isFirstIntr=true;
var checkData=-1;
var isTestFail=false;
var passCount=0;
var curSensorName=null;
var isCurPanelNo0=true;
var curPanelNo=0;
var sensorName=[];
var blackBgClickH=null;
var isoSensorSim=false;
var _curColor1="#ff0000";
var _curColor2="#ff0000";
var bgUrl="";
var osensor_fn=null;
var oha_timer;
	var panelShiftH;
//	var isKeepPanel=false;
var oSensorJsLoaded=false;         // Calibration JS file is set or not.
//	var isPass=false;
//	var panelTouchH=null;
var oWaveUpdateTime=1000;
var oSensorCalibrateCtl=[];
var hyoOptions={
	middleMin: 10
}
var oUartModeOptions={
    oSensor:0, 
    Terminal:1, 
    LoopBack0:2, 
    LoopBack1:3, 
    LoopBack2:4, 
    LoopBack3:5, 
    oVapor:6, 
    oSensorWave:7, 
    oSensorList:8, 
	oSensorCalibrate:9
           };
var oUartMode=oUartModeOptions.oSensor;
var oUartStusOptions={
    UnCounnected: -1, 
    PowerOff: 0, 
    PowerOn: 1, 
    oVaporOn: 2, 
}
var oUartStus=oUartStusOptions.UnCounnected;
var strMapTable=[22,24,26,28,30];
var oUartTerm={};
// Tom 20170504
var oSensorWave=[];
var oSensorList=[];
const VollDataAvgCount=10;		// Voll(EAV) Data process Average count(Process data as the average of the count number of data)

var oSensorConfig={
	isFixedShow: false, 
	isKeepPanel:false
}
    var config_setting={
      MaxLine:20,
    };
const cookieOptions={
    debugMode: {
        key: 'mode',
        default: 'normal', 
        options: {normal:'normal',
                  debug:'debug',
                 }, 
    },
	chartViewOpt: {
		yType: {
			key: 'chartYType', 
			options: {
				fix: 'fix', 
				low: 'low',
				high: 'high'
			},
			default: 'low'
		}, 
		yMin: {
			key: 'chartYMin', 
			default: -1
		}, 
		yMax: {
			key: 'chartYMax', 
			default: -1
		}, 
		xPageSize: {
			key: 'chartXSize', 
			default: -1
		}
	}, 
    readOnly: {
        key: 'readOnly',
        default: '0', 
        options: {writable:'0',
                  readonly:'1',
                 }, 
    },
    uiType: {
        key: 'display', 
        default: 'normal', 
        options: {
            normal:'normal', 
            bottom: 'barView'
        }
    }, 
    loopBack: {
        key: 'loopback', 
        default: 'no',
        options: {
            no: 'no', 
            mode0: 'm0', 
            mode1: 'm1', 
            mode2: 'm2', 
            mode3: 'm3', 
        }
    }, 
    uiMode: {
        key: 'uiMode', 
        default: 0, 
        options: {
            oSensor: 0, 
            Terminal:1, 
            LoopBack0:2, 
            LoopBack1:3, 
            LoopBack2:4, 
            LoopBack3:5, 
            oVapor:6, 
            oSensorWave:7, 
            oSensorList:8, 
        }
    }, 
    oVaporMode: {
        key: 'modeOvapor', 
        default: "vapor", 
        options: {
            Vaporizer: "vapor", 
            UltraSonic:"ultraSonic", 
        }
    }, 
    oVaporStr: {
        key: 'strOvapor', 
        default: 1, 
        options: [1, 2, 3, 4, 5], 
    }, 
    modelUiMode: {          // UI Mode selected by model name
        key: 'uiModeModel', 
        default: 'General', 
        options: {
            General:0, 
            Sensor:1,
            Vapor:2, 
            LoopBack:3, 
        } 
    }
}

var chartViewData= {
	yType: cookieOptions.chartViewOpt.yType.default, 
	yMin: cookieOptions.chartViewOpt.yMin.default, 
	yMax: cookieOptions.chartViewOpt.yMax.default, 
	xPageSize: cookieOptions.chartViewOpt.xPageSize.default
}

function Calibrate_Callback(callback_obj)
{
	console.log(callback_obj);
}


function Mylog(_msg) {
    if(!isRelease) {
        console.log(_msg);
    }
}

function cookieInit() {
//    Mylog("cookieInit");
    var _uiMode=parseInt(oha_api.cookieRead(cookieOptions.uiMode.key, cookieOptions.uiMode.default));
//    Mylog("cookieInit, _uiMode="+_uiMode);
    switch(_uiMode) {
        case cookieOptions.uiMode.options.oSensor:
            oSensorView();
            break;
        case cookieOptions.uiMode.options.oSensorWave:
            oSensorViewWave();
            break;
        case cookieOptions.uiMode.options.oSensorList:
            oSensorViewList();
            break;
        case cookieOptions.uiMode.options.LoopBack0:
            setLoopTest0();
            debugView();
            break;
        case cookieOptions.uiMode.options.LoopBack1:
            setLoopTest1();
            debugView();
            break;
        case cookieOptions.uiMode.options.LoopBack2:
            setLoopTest2();
            debugView();
            break;
        case cookieOptions.uiMode.options.LoopBack3:
            setLoopTest3();
            debugView();
            break;
        case cookieOptions.uiMode.options.oVapor:
            oVaporView();
            break;
        default:
            oSensorView();
            break;
                  }
    var _uiType=oha_api.cookieRead(cookieOptions.uiType.key, cookieOptions.uiType.default);
    if(_uiType==cookieOptions.uiType.options.normal) {
        Mylog("cookieInit.oSensorView.OHA_UI")
        OHA_UI();
    }
    else {
        Mylog("cookieInit.oSensorView.show_tag")
        show_tag();
    }
	var isReadOnly=(oha_api.cookieRead(cookieOptions.readOnly.key, cookieOptions.readOnly.default)==cookieOptions.readOnly.options.readonly);
	if(isReadOnly) {
		$("#oha_update").addClass("itemHide");
	}
    var _oVaporMode=oha_api.cookieRead(cookieOptions.oVaporMode.key, cookieOptions.oVaporMode.default);
    switch(_oVaporMode) {
        case cookieOptions.oVaporMode.options.Vaporizer:
            $("#modeOvapor .modeVaporizer").removeClass("itemHide");
            $("#modeOvapor .modeUltraSonic").addClass("itemHide");
            break;
        case cookieOptions.oVaporMode.options.UltraSonic:
            $("#modeOvapor .modeVaporizer").addClass("itemHide");
            $("#modeOvapor .modeUltraSonic").removeClass("itemHide");
            break;
        default:
            break;
                  }
    var _oVaporStr=oha_api.cookieRead(cookieOptions.oVaporStr.key, cookieOptions.oVaporStr.default);
    var _str=parseInt(_oVaporStr);
    $("#oVaporStrCtrl .levelMarker").attr("value", _str);
    $("#oVaporStrCtrl .levelMarker .lvlMark").each(function(i){
        if(i<_str) {
            $(this).addClass("lvlOn");
        }
    })
    switch(_oVaporStr) {
        case cookieOptions.oVaporMode.options[0]:
            $("#modeOvapor .modeVaporizer").removeClass("itemHide");
            $("#modeOvapor .modeUltraSonic").addClass("itemHide");
            break;
        case cookieOptions.oVaporMode.options.UltraSonic:
            $("#modeOvapor .modeVaporizer").addClass("itemHide");
            $("#modeOvapor .modeUltraSonic").removeClass("itemHide");
            break;
        default:
            break;
                     }
    var _modelUiMode=oha_api.cookieRead(cookieOptions.modelUiMode.key, cookieOptions.modelUiMode.default);
    switch(_modelUiMode) {
        case cookieOptions.modelUiMode.options.Sensor:
            oSensorMode();
            break;
        case cookieOptions.modelUiMode.options.Vapor:
            oVaporMode();
            break;
        case cookieOptions.modelUiMode.options.LoopBack:
            loopBackMode();
            break;
                       }
	var chartViewOpt=cookieOptions.chartViewOpt;
	chartViewData.yType=oha_api.cookieRead(chartViewOpt.yType.key, chartViewOpt.yType.default);
	chartViewData.yMin=parseInt(oha_api.cookieRead(chartViewOpt.yMin.key, chartViewOpt.yMin.default));
	chartViewData.yMax=parseInt(oha_api.cookieRead(chartViewOpt.yMax.key, chartViewOpt.yMax.default));
	chartViewData.xPageSize=parseInt(oha_api.cookieRead(chartViewOpt.xPageSize.key, chartViewOpt.xPageSize.default));
	
}

//================================ EAV Options =========================================
const eavStOptions = {
	idle:0,
	rising:1, 
	middle:2,
	falling:3, 
	calibration:4, 
	caliok:5 
}

const eavVarIdxOpt ={
	Vmax:0, 
	Idx_max:1, 
	Vmin:2, 
	Idx_min:3, 
	Vr:4, 
	Idx_vr:5, 
	Vlast:6, 
	Idx_last:7, 
	Vpre:8
}
const eavAvgStep=10;
var eavIdleVoltage=10;
var eavCaliLevel=94;
const ryoShortI=150;
const eavMiddlePrd=500;
const RyoFactor=2;
const AdcMax=370;
const CalibrationPriod=300;
//=========================================================================================


function addPanel() {
//    if($("#panel_area").hasClass("official")) {
//    }
    var _no=$("#panel_area>.panel_block.official").size();
    var _oddStr="odd";
    if(_no%2==1) {
        _oddStr="even";
    }
    var _no1=_no+1;
    var _panelHtml='\
        <div '+'id="panelBlock'+_no1+'" class="'+_oddStr+' panel_block official">\
            <div class="general_view container" style="display:none">\
                <div class="nameSection">\
                    XXXX Sensor\
                </div>\
                <div class="oha_value_section">\
                    <div class="preValueSect"></div>\
                    <div class="valueSection">\
                        <div class="numberSection">64</div>\
                        <div class="unitSection">mg/m3</div>\
						<div class="rawSection">(<span class="rawValue"></span>)</div>\
                    </div>\
                </div>\
                <div class="detailSection">\
                    The XXXX sensor is made by OHA group\
                </div>\
            </div>\
            <div class="chart_view container" style="display:none">\
            </div>\
            <div class="list_view container" style="display:none">\
            </div>\
        </div>\
    ';
	if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
		_panelHtml='\
			<div '+'id="panelBlock'+_no1+'" class="'+_oddStr+' panel_block official">\
				<div class="general_view container" style="display:none">\
					<div class="eav eavSection1">\
						<div class="nameSection">\
							EAV<span class="smallTitle">, Electro-Acupuncture According to Voll</span>\
						</div>\
						<div class="oha_value_section">\
							<div class="valueSection">\
								<span class="numberSection">64</span><span class="unitSection">&nbsp;Voll( IR/ID )</span>\
							</div>\
						</div>\
						<div class="detailSection">\
							<span>0</span> uA at 1.25V, 100K ohm\
						</div>\
					</div>\
					<div class="eav eavSection2">\
						<div class="nameSection">\
							Ryodoraku\
						</div>\
						<div class="oha_value_section">\
							<div class="valueSection">\
								<span class="numberSection">64</span><span class="unitSection">&nbsp;uA(Max)</span>\
							</div>\
						</div>\
						<div class="detailSection">\
							Min <span>0</span> ohm at 12V, 60K ohm.\
						</div>\
					</div>\
					<div class="eav eavSection3">\
						<div class="nameSection">\
							Resistance\
						</div>\
						<div class="oha_value_section">\
							<div class="valueSection">\
								<span class="numberSection">64</span><span class="unitSection">&nbsp;ohm</span>\
							</div>\
						</div>\
						<div class="detailSection">\
							ADC <span>200</span> at 1.25V, 100Kohm\
						</div>\
					</div>\
				</div>\
				<div class="chart_view container" style="display:none">\
				</div>\
				<div class="list_view container" style="display:none">\
				</div>\
				<div class="calibrate_config container" style="display:none">\
				</div>\
			</div>\
		';
	}
    $("#panel_area").append(_panelHtml);
    if(_no>0){
        $("#panel_area>.panel_block").addClass("heightDiv2");
    }
	if(SimpleProtocol.isEnable()) {
		var _waveviewConfig={
			XPageSizeSelections: [50, 100, 200, 500, 1000, 2000], 
			MaxYSelections: [1000, 256, 100, 50, 25], 
			callback: function(_config){
				console.log("waveview callback")
				chartViewOpt=cookieOptions.chartViewOpt;
				oha_api.cookieWrite(chartViewOpt.yType.key, _config.YType);
				chartViewData.yType=_config.YType;
				oha_api.cookieWrite(chartViewOpt.yMax.key, _config.YRange[0]);
				chartViewData.yMax=_config.YRange[0];
				oha_api.cookieWrite(chartViewOpt.yMin.key, _config.YRange[1]);
				chartViewData.yMin=_config.YRange[1];
				oha_api.cookieWrite(chartViewOpt.xPageSize.key, _config.XPageSize);
				chartViewData.xPageSize=_config.XPageSize;
			}
		}
		if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
			_waveviewConfig.MaxYSelections=[200, 150, 100, 50, 25];
			_waveviewConfig.YRange=[100, 0];
			_waveviewConfig.XPageSize=1000;
		}
		oSensorWave[_no]=$("#panelBlock"+_no1+" .chart_view").oha_waveview(_waveviewConfig);
		if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
			var Calibrate_Config={
				profile_id: 2,
				aw: 1.0,		// parameter a in f(x)=ax+b 
				ba: 0.0,		// parameter b in f(x)=ax+b 
				server_url:"http://54.183.18.76/tmp/chartjs/",
				callback: Calibrate_Callback
			}

			console.log("oSensorCalibrateCtl conductor, _no="+_no);
			oSensorCalibrateCtl[_no]= $("#panelBlock"+_no1+" .calibrate_config").oha_calibrate_config(Calibrate_Config);
			oSensorWave[_no].avgQ=[];
			oSensorWave[_no].eavVar=[-1, -1, 0, -1, 0, -1, -1, -1, -1];		// [Vmax, Idx_max, Vmin, Idx_min, Vr, Idx_vr, Vlast, Idx_last, Vpre]
			oSensorWave[_no].stEAV=eavStOptions.idle;
			oSensorWave[_no].CaliQ=[];
			oSensorWave[_no].CalLevel=eavCaliLevel;
			oSensorWave[_no].CaliFactor=1;
			oSensorWave[_no].eavStus={
				preData: -1,
				preOfs:-1,
				curOfs:-1, 
				middleCntr:0
			};
//			oSensorWave[_no].pushData=parseRyo;
			oSensorWave[_no].pushData=parseRyoNew;
		}
		else if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeRYO) {
			oSensorWave[_no].stEAV=eavStOptions.idle;
			oSensorWave[_no].CaliFactor=60000;
			oSensorWave[_no].CaliQ=[];
			oSensorWave[_no].CaliStartT=-1;
			oSensorWave[_no].pushData=function(_pNo, _idx, _d){
				waveSelf=oSensorWave[_pNo];
				switch(oSensorWave[_no].stEAV) {
					case eavStOptions.idle:
						console.log("eavSt=idle, _d="+_d+", CaliFactor="+waveSelf.CaliFactor);
						if(_d>=ryoShortI) {
							waveSelf.CaliStartT=new Date().getTime();
							waveSelf.stEAV=eavStOptions.calibration;
//							ADC=(1250-12*_Vollmin)/3.3
//							(1250-3.3*ADC)/12;
						}
						else {
							waveSelf.stEAV=eavStOptions.idle;
						}
						break;
					case eavStOptions.calibration:
						console.log("eavSt=calibration, _d="+_d+", CaliQ.length="+waveSelf.CaliQ.length);
						if(_d<ryoShortI) {
							waveSelf.stEAV=eavStOptions.idle;
						}
						else {
							var _period=new Date().getTime()-waveSelf.CaliStartT;
							if(_period>=3000) {
								var _sum=0;
								for(i in waveSelf.CaliQ) {
									_sum+=waveSelf.CaliQ[i];
								}
//								var _avg=(_sum/);
								var _avg=waveSelf.CaliQ[waveSelf.CaliQ.length-1];
								waveSelf.CaliFactor=12000000/_avg;
								$(".panel_block .general_view").css({"color":"lightblue"});
								waveSelf.stEAV=eavStOptions.caliok;
								console.log("Calibration success, factor="+waveSelf.CaliFactor)
							}
							else {
								waveSelf.CaliQ.push(_d);
								waveSelf.stEAV=eavStOptions.calibration;
							}
						}
						break;
					case eavStOptions.caliok:
						if(_d<ryoShortI) {
							waveSelf.stEAV=eavStOptions.idle;
							$(".panel_block .general_view").css({"color":""});
						}
						else {
							var _dCali=625/6;
							waveSelf.stEAV=eavStOptions.caliok;
						}
						break;
					default:
						console.log("eavSt=default, eavSt="+waveSelf.stEAV)
						waveSelf.stEAV=eavStOptions.idle;
				}
			}
		}
		for(var i=0;i<oSensorWave.length;i++) {
			if(chartViewData.yType!==cookieOptions.chartViewOpt.yType.default) {
//				oha_api.showToast("i="+i+", SetYType="+chartViewData.yType);
				oSensorWave[i].SetYType(chartViewData.yType);
			}
			if((chartViewData.yMin!==cookieOptions.chartViewOpt.yMin.default) || 
			   (chartViewData.yMax!==cookieOptions.chartViewOpt.yMax.default)) {
				oSensorWave[i].SetYRange(chartViewData.yMax, chartViewData.yMin);
			}
			if(chartViewData.xPageSize!==cookieOptions.chartViewOpt.xPageSize.default) {
				oSensorWave[i].SetXPageSize(chartViewData.xPageSize);
			}
		}
	}
	else {
		oSensorWave[_no]=$("#panelBlock"+_no1+" .chart_view").oha_waveview({});
	}
	oSensorWave[_no].appendIdx=0;
	oSensorWave[_no].appendRedrawNo=1;
	oSensorList[_no]=$("#panelBlock"+_no1+" .list_view").oha_listview({});
    switch(oUartMode) {
        case oUartModeOptions.oSensor:
            $("#panelBlock"+_no1+" .general_view").show();
            break;
        case oUartModeOptions.oSensorWave:
            $("#panelBlock"+_no1+" .chart_view").show();
            break;
        case oUartModeOptions.oSensorList:
            $("#panelBlock"+_no1+" .list_view").show();
            break;
		case oUartModeOptions.oSensorCalibrate:
			$("#panelBlock"+_no1+" .calibrate_config").show();
			//oSensorCalibrateCtl[_no].SwitchTo();
			break;
        default:
    }
//	$("#panel_area .panel_block:eq("+_no+")").on("touchstart", function(){
//		console.log("#panel_area .panel_block touchstart")
//		$("#panel_area .panel_block").removeClass("panel_active");
//		console.log("i="+_no);
//		$(this).addClass("panel_active");
//	});
//	$("#panel_area .panel_block:eq("+_no+")").on("touchend touchcancel", function(){
//		console.log("#panel_area .panel_block touchcanel")
//		$("#panel_area .panel_block").removeClass("panel_active");
//	});

}
	
function parseRyo (_pNo, _idx, _d){
	var waveSelf=oSensorWave[_pNo];
	console.log("pushData("+_pNo+", "+_idx+", "+_d+"), st="+waveSelf.stEAV)
	var _dCali=_d*waveSelf.CaliFactor;
	var _transValue=_dCali;
//				waveSelf.eavStus.curOfs=(_dCali-waveSelf.eavStus.preData);
	switch(waveSelf.stEAV) {
		case eavStOptions.idle:
//						console.log("eavSt=idle, _d="+_d+", CaliFactor="+waveSelf.CaliFactor);
			if(_dCali<=eavIdleVoltage) {
				waveSelf.stEAV=eavStOptions.idle;
//							ADC=(1250-12*_Vollmin)/3.3
//							(1250-3.3*ADC)/12;
			}
			else {
				if(_dCali>=waveSelf.CalLevel) {
					waveSelf.CaliQ=[];
					waveSelf.stEAV=eavStOptions.calibration;
//								oSensorWave[_no].eavVar=[-1, -1, -1, -1, 0, -1, -1, -1, -1];
				}
				else {
					waveSelf.stEAV=eavStOptions.rising;
					waveSelf.eavVar=[-1, -1, 0, -1, -1, -1, -1, -1, -1];
					waveSelf.avgQ=[];
				}
			}
			waveSelf.eavStus.preOfs=0;
			break;
		case eavStOptions.rising:
//						console.log("eavSt=rising, _d="+_d)
			if(_dCali<=eavIdleVoltage) {
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(_d>=waveSelf.CalLevel) {
					waveSelf.CaliQ=[];
					waveSelf.stEAV=eavStOptions.calibration;
//								oSensorWave[_no].eavVar=[-1, -1, -1, -1, 0, -1, -1, -1, -1];
				}
				else {
					waveSelf.avgQ.push(_dCali);
					if(waveSelf.avgQ.length==eavAvgStep) {
						var _max=0;
						var _idxLocal=0;
						for(x in waveSelf.avgQ) {
							if(waveSelf.avgQ[x]>_max) {
								_max=waveSelf.avgQ[x];
								_idxLocal=parseInt(x);
							}
						}
						waveSelf.eavVar[eavVarIdxOpt.Vr]=_transValue=mapping(_max);;		// Vmax
						waveSelf.eavVar[eavVarIdxOpt.Idx_vr]=_idx-eavAvgStep+_idxLocal;		// Idx_max
						waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_vr], "Ir="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
						console.log("SetInfo(Vr), idx="+waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+", Vr="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
						waveSelf.eavVar[eavVarIdxOpt.Vmax]=-1;		// Vmax
						waveSelf.eavVar[eavVarIdxOpt.Vmin]=999;		// Vmin
						waveSelf.avgQ=[];
						waveSelf.dataQueue=[];		// Clear the data Queue for analysis
						waveSelf.stEAV=eavStOptions.middle;
					}
					else {
						waveSelf.stEAV=eavStOptions.rising;
					}
				}
			}
		break;
		case eavStOptions.middle:
//						console.log("eavSt=middle, _d="+_d)
			if(_dCali<=eavIdleVoltage) {
				var _max=0;
				var _idxLocal=0;
				for(x in waveSelf.avgQ) {
					if(waveSelf.avgQ[x]>_max) {
						_max=waveSelf.avgQ[x];
						_idxLocal=parseInt(x);
					}
			}
				waveSelf.eavVar[eavVarIdxOpt.Vlast]=_transValue=mapping(_max);
				waveSelf.eavVar[eavVarIdxOpt.Idx_last]=_idx-waveSelf.avgQ.length+_idxLocal;
				waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_last], "In="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vlast]))
				var _idxAvg=Math.round((waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+waveSelf.eavVar[eavVarIdxOpt.Idx_last])/2);
				var _Vavg=Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]-waveSelf.eavVar[eavVarIdxOpt.Vlast]);
				waveSelf.SetInfoWithID(_idxAvg, "ID="+_Vavg);
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				waveSelf.avgQ.push(_dCali);
				if(waveSelf.avgQ.length>eavAvgStep) {
					waveSelf.avgQ.splice(0, waveSelf.avgQ.length-eavAvgStep);
			}
			}
			break;
//					case eavStOptions.falling:
//						console.log("eavSt=falling, _d="+_d+", _dCali="+_dCali)
//						if(_dCali<=eavIdleVoltage) {
//							console.log("eavSt=falling, Ir, In is ready");
//							var _Vollir=Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]);
//							var _VollLast=Math.round(waveSelf.eavVar[eavVarIdxOpt.Vlast]);
//							waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_vr], "Ir="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
//							waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_last], "In="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vlast]))
//							var _id=(_VollLast<0)?0:_Vollir-_VollLast;
//							$("#panelBlock"+(curPanelNo+1)+" .eavSection1 .numberSection").text(Math.round(_Vollir)+" / "+Math.round(_id));
////								console.log("AVG_p, idx_max="+waveSelf.eavVar[eavVarIdxOpt.Idx_max]);
////								console.log("AVG_p, Idx_min="+waveSelf.eavVar[eavVarIdxOpt.Idx_min]);
////								console.log("AVG_p, Vmax="+waveSelf.eavVar[eavVarIdxOpt.Vmax]);
////								console.log("AVG_p, Vmin="+waveSelf.eavVar[eavVarIdxOpt.Vmin]);
//								var _idxAvg=Math.round((waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+waveSelf.eavVar[eavVarIdxOpt.Idx_last])/2);
//								var _Vavg=Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]-waveSelf.eavVar[eavVarIdxOpt.Vlast]);
////								console.log("AVG, idx="+_idxAvg+", Avg="+_Vavg);
//								waveSelf.SetInfoWithID(_idxAvg, "ID="+_Vavg);
//								waveSelf.stEAV=eavStOptions.idle;
//						}
//						else if(2*waveSelf.eavStus.curOfs>waveSelf.eavStus.preOfs) {
//								waveSelf.stEAV=eavStOptions.middle;
//							}
//						break;
		case eavStOptions.calibration:
//						console.log("eavSt=calibration, _d="+_d+", CaliQ.length="+waveSelf.CaliQ.length);
			if(_d<waveSelf.CalLevel) {
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(waveSelf.CaliQ.length==CalibrationPriod) {
					var _sum=0;
					for(i in waveSelf.CaliQ) {
						_sum+=waveSelf.CaliQ[i];
					}
					var _avg=(_sum/CalibrationPriod);
					waveSelf.CaliFactor=(625/6/_avg);
					$(".eav").css({"color":"lightblue"});
					waveSelf.stEAV=eavStOptions.caliok;
					console.log("Calibration success, factor="+waveSelf.CaliFactor)
				}
				else {
					waveSelf.CaliQ.push(_d);
					waveSelf.stEAV=eavStOptions.calibration;
				}
			}
			break;
		case eavStOptions.caliok:
			if(_d<waveSelf.CalLevel) {
				waveSelf.stEAV=eavStOptions.idle;
				$(".eav").css({"color":""});
			}
			else {
				var _dCaliX=625/6;
				waveSelf.eavVar[eavVarIdxOpt.Vmin]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vmax]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vlast]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vr]=_dCaliX;
				waveSelf.stEAV=eavStOptions.caliok;
			}
			break;
		default:
			console.log("eavSt=default, eavSt="+waveSelf.stEAV)
			waveSelf.stEAV=eavStOptions.idle;
	}
	if(waveSelf.stEAV==eavStOptions.middle) {
		dataAnalysis(_dCali, _idx);
	}
//				waveSelf.eavStus.preData=_dCali;
//				waveSelf.eavStus.preOfs=waveSelf.eavStus.curOfs;				
	function mapping(_x) {
		return oSensorCalibrateCtl[curPanelNo].Calibrate(_x);
	}

	function dataAnalysis(_data, _idx) {
		console.log("dataAnalysis, _data="+_data+", _idx="+_idx);
		waveSelf.dataQueue.push(_data);
		if(waveSelf.dataQueue.length==VollDataAvgCount) {
			waveSelf.dataQueue.sort();
			var _sum=0;
			for(var i=2;i<VollDataAvgCount-2;i++) {
				_sum+=waveSelf.dataQueue[i];
			}
			var _avg=Math.round(_sum/(VollDataAvgCount-4));
			waveSelf.dataQueue=[];
			if(_avg > waveSelf.eavVar[eavVarIdxOpt.Vmax]) {
				waveSelf.eavVar[eavVarIdxOpt.Vmax]=_avg;		// Vmax
				waveSelf.eavVar[eavVarIdxOpt.Idx_max]=_idx-Math.floor(VollDataAvgCount/2);		// Idx_max
			}
			if(_avg < waveSelf.eavVar[eavVarIdxOpt.Vmin]) {
				waveSelf.eavVar[eavVarIdxOpt.Vmin]=_avg;		// Vmin
				waveSelf.eavVar[eavVarIdxOpt.Idx_min]=_idx-Math.floor(VollDataAvgCount/2);		// Idx_min
			}
		}
	}

	if((waveSelf.stEAV==eavStOptions.rising) ||
	  (waveSelf.stEAV==eavStOptions.middle)) {
		_transValue=mapping(_transValue);
	}
	return _transValue;
}

function parseRyoNew (_pNo, _idx, _d){
//				console.log("pushData("+_pNo+", "+_idx+", "+_d+")")
	var waveSelf=oSensorWave[_pNo];
	var _dCali=_d*waveSelf.CaliFactor;
	var _transValue=_dCali;
	if(typeof waveSelf.prevD=="undefined") {
		waveSelf.ofsD=_d;
	}
	else {
		waveSelf.ofsD=_d-waveSelf.prevD;
	}
//	console.log("stEAV="+waveSelf.stEAV+", ("+_d+", "+mapping(_d)+", "+_dCali+", "+waveSelf.ofsD+")");
//				waveSelf.eavStus.curOfs=(_dCali-waveSelf.eavStus.preData);
	switch(waveSelf.stEAV) {
		case eavStOptions.idle:
//						console.log("eavSt=idle, _d="+_d+", CaliFactor="+waveSelf.CaliFactor);
			if(_dCali<=eavIdleVoltage) {
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(_dCali>=waveSelf.CalLevel) {
					waveSelf.CaliQ=[];
					waveSelf.stEAV=eavStOptions.calibration;
				}
				else {
					waveSelf.stEAV=eavStOptions.rising;
					waveSelf.eavVar=[-1, -1, 0, -1, -1, -1, -1, -1, -1];
					waveSelf.avgQ=[];
					waveSelf.risingOfs=waveSelf.ofsD;
				}
			}
			break;
		case eavStOptions.rising:
//						console.log("eavSt=rising, _d="+_d)
			if(_dCali<=eavIdleVoltage) {
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(_d>=waveSelf.CalLevel) {
					waveSelf.CaliQ=[];
					waveSelf.stEAV=eavStOptions.calibration;
//								oSensorWave[_no].eavVar=[-1, -1, -1, -1, 0, -1, -1, -1, -1];
				}
				else {
					if(waveSelf.ofsD>0.8*waveSelf.risingOfs) {	// Keep rising
						waveSelf.stEAV=eavStOptions.rising;
						waveSelf.risingOfs=waveSelf.ofsD;
					}
					else {
						waveSelf.LockViewAtID (false, -1);		// Process at last input view
						waveSelf.stEAV=eavStOptions.middle;
						waveSelf.middleCntr=0;
						waveSelf.eavVar[eavVarIdxOpt.Idx_vr]=_idx;
						waveSelf.eavVar[eavVarIdxOpt.Vr]=mapping(_dCali);
						waveSelf.eavVar[eavVarIdxOpt.Vmax]=-1;		// Vmax
						waveSelf.eavVar[eavVarIdxOpt.Vmin]=999;		// Vmin
					}
//					if(waveSelf.avgQ.length==eavAvgStep) {
//						var _max=0;
//						var _idxLocal=0;
//						for(x in waveSelf.avgQ) {
//							if(waveSelf.avgQ[x]>_max) {
//								_max=waveSelf.avgQ[x];
//								_idxLocal=parseInt(x);
//							}
//						}
//						waveSelf.eavVar[eavVarIdxOpt.Vr]=_transValue=mapping(_max);;		// Vmax
//						waveSelf.eavVar[eavVarIdxOpt.Idx_vr]=_idx-eavAvgStep+_idxLocal;		// Idx_max
//						waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_vr], "Ir="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
//						console.log("SetInfo(Vr), idx="+waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+", Vr="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
//						waveSelf.eavVar[eavVarIdxOpt.Vmax]=-1;		// Vmax
//						waveSelf.eavVar[eavVarIdxOpt.Vmin]=999;		// Vmin
//						waveSelf.avgQ=[];
//						waveSelf.dataQueue=[];		// Clear the data Queue for analysis
//						waveSelf.stEAV=eavStOptions.middle;
//					}
//					else {
//						waveSelf.stEAV=eavStOptions.rising;
//					}
				}
			}
			break;
		case eavStOptions.middle:
			waveSelf.middleCntr++;
//				console.log("eavSt=middle, _d="+_d)
			if(_dCali<=eavIdleVoltage) {
				if(waveSelf.middleCntr>=hyoOptions.middleMin) {
					waveSelf.eavVar[eavVarIdxOpt.Vlast]=Math.round(mapping(waveSelf.prevD));
					waveSelf.eavVar[eavVarIdxOpt.Idx_last]=_idx;
//					console.log("Idx_vr="+waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+", Ir="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]));
					waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_vr], "Ir="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]))
//					console.log("Idx_last="+waveSelf.eavVar[eavVarIdxOpt.Idx_last]+", In="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vlast]))
					waveSelf.SetInfoWithID (waveSelf.eavVar[eavVarIdxOpt.Idx_last]-1, "In="+Math.round(waveSelf.eavVar[eavVarIdxOpt.Vlast]))
					var _idxAvg=Math.round((waveSelf.eavVar[eavVarIdxOpt.Idx_vr]+_idx)/2);
					var _Vavg=Math.round(waveSelf.eavVar[eavVarIdxOpt.Vr]-waveSelf.eavVar[eavVarIdxOpt.Vlast]);
					waveSelf.SetInfoWithID(_idxAvg, "ID="+_Vavg);
//					if(typeof waveSelf.CenterID !="undefined") {
//						waveSelf.CenterID(_idxAvg);
//					}
					if(typeof waveSelf.LockViewAtID !="undefined") {
						waveSelf.LockViewAtID (true, _idxAvg);
					}
					if(typeof waveSelf.lockH !="undefined") {
						clearTimeout(waveSelf.lockH);
						waveSelf.lockH=null;
					}
//					waveSelf.lockH=setTimeout(function() {
//						waveSelf.LockViewAtID (false, -1);		// Process at last input view
////						waveSelf.LockViewAtID (false, -2);		// Process from current locked view
//						waveSelf.lockH=null;
//					}, 10000);
				}
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(waveSelf.ofsD>0.8*waveSelf.risingOfs) {	// Keep rising
						waveSelf.stEAV=eavStOptions.rising;
						waveSelf.risingOfs=waveSelf.ofsD;
				}
				else {
					waveSelf.stEAV=eavStOptions.middle;
				}
			}
			break;
		case eavStOptions.calibration:
//						console.log("eavSt=calibration, _d="+_d+", CaliQ.length="+waveSelf.CaliQ.length);
			if(_d<waveSelf.CalLevel) {
				waveSelf.stEAV=eavStOptions.idle;
			}
			else {
				if(waveSelf.CaliQ.length==CalibrationPriod) {
					var _sum=0;
					for(i in waveSelf.CaliQ) {
						_sum+=waveSelf.CaliQ[i];
					}
					var _avg=(_sum/CalibrationPriod);
					waveSelf.CaliFactor=(625/6/_avg);
					$(".eav").css({"color":"lightblue"});
					waveSelf.stEAV=eavStOptions.caliok;
					console.log("Calibration success, factor="+waveSelf.CaliFactor)
				}
				else {
					waveSelf.CaliQ.push(_d);
					waveSelf.stEAV=eavStOptions.calibration;
				}
			}
			break;
		case eavStOptions.caliok:
			if(_d<waveSelf.CalLevel) {
				waveSelf.stEAV=eavStOptions.idle;
				$(".eav").css({"color":""});
			}
			else {
				var _dCaliX=625/6;
				waveSelf.eavVar[eavVarIdxOpt.Vmin]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vmax]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vlast]=_dCaliX;
				waveSelf.eavVar[eavVarIdxOpt.Vr]=_dCaliX;
				waveSelf.stEAV=eavStOptions.caliok;
			}
			break;
		default:
			console.log("eavSt=default, eavSt="+waveSelf.stEAV)
			waveSelf.stEAV=eavStOptions.idle;
	}
	if(waveSelf.stEAV==eavStOptions.middle) {
		dataAnalysis(_dCali, _idx);
	}
//				waveSelf.eavStus.preData=_dCali;
//				waveSelf.eavStus.preOfs=waveSelf.eavStus.curOfs;				
	function mapping(_x) {
		return oSensorCalibrateCtl[curPanelNo].Calibrate(_x);
	}

	function dataAnalysis(_data, _idx) {
		if(_data > waveSelf.eavVar[eavVarIdxOpt.Vmax]) {
			waveSelf.eavVar[eavVarIdxOpt.Vmax]=_data;		// Vmax
			waveSelf.eavVar[eavVarIdxOpt.Idx_max]=_idx;		// Idx_max
		}
		if(_data < waveSelf.eavVar[eavVarIdxOpt.Vmin]) {
			waveSelf.eavVar[eavVarIdxOpt.Vmin]=_data;		// Vmin
			waveSelf.eavVar[eavVarIdxOpt.Idx_min]=_idx;		// Idx_min
		}
//		waveSelf.dataQueue.push(_data);
//		if(waveSelf.dataQueue.length==VollDataAvgCount) {
//			waveSelf.dataQueue.sort();
//			var _sum=0;
//			for(var i=2;i<VollDataAvgCount-2;i++) {
//				_sum+=waveSelf.dataQueue[i];
//			}
//			var _avg=Math.round(_sum/(VollDataAvgCount-4));
//			waveSelf.dataQueue=[];
//			if(_avg > waveSelf.eavVar[eavVarIdxOpt.Vmax]) {
//				waveSelf.eavVar[eavVarIdxOpt.Vmax]=_avg;		// Vmax
//				waveSelf.eavVar[eavVarIdxOpt.Idx_max]=_idx-Math.floor(VollDataAvgCount/2);		// Idx_max
//			}
//			if(_avg < waveSelf.eavVar[eavVarIdxOpt.Vmin]) {
//				waveSelf.eavVar[eavVarIdxOpt.Vmin]=_avg;		// Vmin
//				waveSelf.eavVar[eavVarIdxOpt.Idx_min]=_idx-Math.floor(VollDataAvgCount/2);		// Idx_min
//			}
//		}
	}

	if((waveSelf.stEAV==eavStOptions.rising) ||
	  (waveSelf.stEAV==eavStOptions.middle)) {
		_transValue=mapping(_transValue);
	}
	waveSelf.prevD=_d;
	return _transValue;
}

function addPanelX() {
    var _n=$("#panel_area .panel_block").size()+1;
    var _class="odd";
    if(_n%2==0) {
        _class="even"
    }
    var _panelHtml=
        '<div class="panel_block '+_class+'" id="panelBlock'+_n+'">\
            <div class="nameSection">\
                XXXX Sensor\
            </div>\
            <div class="preValueSect"></div>\
            <div class="valueSection">\
                <div class="numberSection">32</div>\
                <div class="unitSection">ug/m3</div>\
            </div>\
            <div class="detailSection">\
                The PM2.5 sensor is made by OHA group\
            </div>\
        </div>';
    $("#panel_area").append(_panelHtml);
//    $(".panel_block").css({"height":"50%"});
    $(".panel_block").addClass("heightDiv2");
}

function clearPanelArea() {
    curSensorName=null;
    curPanelNo=0;
    sensorName=[];
    $("#panelBlock2,#sensorG1").addClass("itemHide");
//    $(".panel_block").css({"height":"100%"});
	oSensorWave=[];
	oSensorList=[];
    $(".panel_block.official").remove();
}

//function setControl(_baudrate, _isInterrupt, _intrDno) {
////    Mylog("setControl")
//    var n=-1;
//    var x=-1;
//    if(typeof(_baudrate)!=='number') {
//        n=parseInt(_baudrate);
//    }
//    else {
//        n=_baudrate;
//    }
//    if(typeof(_intrDno)!=='number') {
//        x=parseInt(_intrDno);
//    }
//    else {
//        x=_intrDno;
//    }
//    var _baud=1;
//    switch(n) {
//        case 9600:
//            _baud=0;
//            break;
//        case 19200:
//            _baud=1;
//            break;
//        case 38400:
//            _baud=2;
//            break;
//        case 57600:
//            _baud=3;
//            break;
//        case 115200:
//            _baud=4;
//            break;
//    }
//    if(_isInterrupt) {
//        Mylog('04:00 cp0: Active=1')
//        oha_api.ApiCmdWr("04:00:"+_baud+":01:"+x.toString(16));
//    }
//    else {
//        Mylog('04:00 cp1: Active=0')
//        oha_api.ApiCmdWr("04:00:"+_baud+":00:"+x.toString(16));
//    }
//}

$(window).resize(function() {
	setsize();
//    alert(window.onload)
});

//$(window).ready(function($, undefined) {
//    termObj=$('#debugDiv').terminal(function(command, term) {
////        termObj=term;
//        switch(command) {
//            case('send'):
//                term.echo('send command');
//                return;
//        }
//        if (command !== '') {
//            try {
//                var result = window.eval(command);
//                if (result !== undefined) {
//                    term.echo(new String(result));
//                }
//            } catch(e) {
//                term.error(new String(e));
//            }
//        } else {
//           term.echo('');
//        }
//    }, {
//        greetings: 'oUART Debug Terminal',
//        name: 'js_demo',
//        prompt: 'OHA> '
//    });
//});
function getJs(_jsUrl) {
    $.getScript(_jsUrl, function( data, textStatus, jqxhr ) {
      Mylog("data:"+data ); // Data returned
      Mylog( textStatus ); // Success
      Mylog( jqxhr.status ); // 200
      Mylog( "Load was performed." );
        if(jqxhr.status==200) {
            Mylog("getJs, success")
            var _selector="#panel_area .customize.ui_panel.container";
//            $(_selector).removeClass("itemHide");
            $("#itemCustomized").removeClass("itemHide");
            setPanelCustomized(true);
            oha_sensor_js(_selector);
        }
    });
}

var oha_sensor_js_url="";
function getJs1(_jsUrl) {
    if(_jsUrl==oha_sensor_js_url) {
        return;
    }
    oha_sensor_js_url=_jsUrl;
    $.getScript(_jsUrl)
    .done(function( script, textStatus ) {
        var _selector="#panel_area .customize.ui_panel.container";
        if(typeof oha_sensor_js!=="undefined") {
            $("#itemCustomized").removeClass("itemHide");
            setPanelCustomized(true);
            oha_sensor_js(_selector);
        }
    })
    .fail(function( jqxhr, settings, exception ) {
            Mylog("Load javascript file fail:"+_jsUrl);
    });
//    
//    var scriptTag = document.createElement('script');
//        scriptTag.type="text/javascript";
//        scriptTag.src = _jsUrl;
//        document.head.appendChild(scriptTag);
//    oSensorJsLoaded=true;
//    setTimeout(function(){sendSelector();}, 100);
}

//function sendSelector() {
//    if(typeof oha_sensor_js=="undefined") {
//        setTimeout(function(){sendSelector();}, 100);
//    }
//    else {
//        var _selector="#panel_area .customize.ui_panel.container";
//        if(typeof oha_sensor_js!=="undefined") {
//            setPanelCustomized(true);
//            oha_sensor_js(_selector);
//        }
//    }    
//}


function setPanelCustomized(_en) {
    if(_en) {
        $("#panel_area").addClass("customize");
        $("#panel_area").removeClass("official");
    }
    else {
        $("#panel_area").removeClass("customize");
        $("#panel_area").addClass("official");
    }
}

$(window).on("load", function(){
    setsize();
});

$(window).ready(function($, undefined) {
    oha_api.runOhaCmd("oha://bodySize_full");
//    getJs("http://54.183.18.76/OHA/oSensor/osensor_face1.js");
//    getJs1("http://192.168.43.209:8080/osensor_face1.js");
	if(!uiConfig.isHelpOn) {
		$("#helpIcon").hide();
	}
	setsize();
    oha_api.readJson(function(_data){
		if(_data.hasOwnProperty("OHA_UI")) {
			_jOhaUi=_data.OHA_UI;
			if(_jOhaUi.hasOwnProperty("title")) {
				$("#oha_title_2_").text(_data.OHA_UI.title)
			}
		}
	});
//    termObj=$('#debugDiv').terminal({
//        mode: function(_mode) {
//            if(_mode==undefined) {
//                this.echo("Current mode=\""+UART_mode.toUpperCase()+"\" mode");
//                return;
//            }
//            var _ascPat=/^asc(i|ii)?$/;
//            var _hexPat=/^hex(i|idec|idecimal)?$/;
//            _mode=_mode.toLowerCase();
//            if(_ascPat.test(_mode)) {
//                UART_mode="ascii";
//                this.echo("ASCII mode is selected");
//            }
//            else if(_hexPat.test(_mode)){
//                UART_mode="hex";
//                this.echo("HEX(byte) mode is selected");
//            }
//            else {
//                this.echo("Parameter is incorrect, \"ASC\"or \"HEX\" will be valid.");
//            }
//        },
//        send: function(_str) {
//            if(_str==undefined) {
//                this.echo("No parameter, example: send AABBCC")
//                return;
//            }
//        }, 
////        calc: {
////            add: function(a, b) {
////                this.echo(a+b);
////            },
////            sub: function(a, b) {
////                this.echo(a-b);
////            }
////        }
//    }, 
//    {
//        checkArity:false, 
//        greetings: 'oUART Debug Terminal',
//        name: 'js_demo',
//        prompt: 'OHA> '
//    });

//    oUartTerm.insertOutData("hello, I success");
});

var ouart_config={
    baudRate: 9600,
	uartMode:"active2",
	uartSize:8, 
    enable: true, 
    mode: "hex", 
    cookieEnable: true,
    sendHex: function(_in) {
        sendHex(_in);
    },
    sendAscii: function(_in) {
        sendAscii(_in);
    },
}
$(window).ready(function(){
//    Mylog("window load")
	var _nullconfig = {};
	
//    alert("oUartTerm initial")
    oUartTerm=$("#debugDiv").oUartTerm(ouart_config);//	alert("setCookie global(1)");
	oUartTerm.setEnableCallBack(function(_isEnable) {
        if(_isEnable) {
            $("#powerOnNormal,#xPowerOnNormal").show();
            $("#powerOffNormal,#xPowerOffNormal").hide();
        }
        else {
            $("#powerOnNormal,#xPowerOnNormal").hide();
            $("#powerOffNormal,#xPowerOffNormal").show();
        }
    });
	oUartTerm.setBaudrateCallBack(function(_baud){
		ouart_config.baudRate=_baud;
		setConfig();
	});
//	oSensorWave[0]=$("#panelBlock1 .chart_view").oha_waveview(_nullconfig);
//	Mylog("oSensorWave Obj=%o", oSensorWave);
//	oSensorList[0]=$("#panelBlock1 .list_view").oha_listview(_nullconfig);
	//oSensorList
//    if(oha_config.loopBackTest) {
//        oUartTerm.loopBackTest(true);
//    }
//   $.cookie('dfPage', '1', {expires:365, path:'/'});
    cookieInit();
	if(oha_config.debug_mode) {
		Mylog('window.load, window.width='+$(window).width());
	}
//	$(".main").css({"padding-top":($(window).height()*5)/100+"px"});
	var uAgent=navigator.userAgent;
	var _vIdx=uAgent.indexOf("oVer:");
	if(_vIdx>=0) {
		ohaVer=parseInt(uAgent.substr(_vIdx+5, 2));
//		alert("ohaVer="+ohaVer);
		if(isNaN(ohaVer)) {
			ohaVer=0;
		}
	}
	var ual=uAgent.length;
	var _lang="";
	switch(ohaVer) {
	case 0:
		_lang=uAgent.substr(ual-2,2);
//		alert("Lang(0)="+_lang);
	break;
	case 1:
		var i=uAgent.indexOf("oLang:");
		_lang=uAgent.substr(i+6,2);
//		alert("Lang(1)="+_lang);
	break;
	}
	_lang=_lang.toUpperCase();

	if(ohaVer==0) {
		$("#settings").hide();
	}

	var _url=document.documentURI;
	var _idx=_url.indexOf('?');
	_url=_url.substring(_idx+1);
	var pl=_url.split('&');
	for(var i=0;i<pl.length;i++) {
		var p=pl[i].split('=');
		if(p[0].trim()=='OHA_DevId') {
			DeviceId=parseInt(p[1]);
			if(DeviceId>=0) {
				isDevReady=true;
			}
		}
	}
	//	oha_api.DevPlugIn("oUart");
	if(oha_api.getPlateForm()==oha_api.PlateFormOpt.Apple) {
		$("#usbOtg").hide();
		$("#earPhone").show();
	}
	else {
		$("#usbOtg").show();
		$("#earPhone").hide();
	}
	oha_api.runOhaCmd("oha://orientation_false");
 });


//function init() {
//    $("#multibtn_area .upperHalfDiv .customizeBtn").each(function(i, x) {
//        $(this).css({"left":(i*25+1.5)+"%", "background-image":"url(files/oUartBtn"+(i+1)+".png)"});
//    });
//    $("#multibtn_area .lowerHalfDiv .customizeBtn").each(function(i, x) {
//        $(this).css({"left":(47/3+i*(70/3))+"%","background-image":"url(files/oUartBtn"+(i+5)+".png)"});
//    });
//}

function setCustBtn(i) {
    if(i>7) {
        Mylog("Warning, the max button number is 7")
        i=7;
    }
    else if(i<1){
        Mylog("Warning, the min button number is 1")
        i=1;
    }
    switch(i){
        case 1:
        case 2:
        case 3:
            setCustBtn1_4(i);
            break;
        case 5:
        case 7:
            setCustBtn2Line(i);
            break;
        case 4:
        case 6:
            setCustBtn4or6(i);
            break;
            }
}

function setCustPwr1Line(num){
    $("#multibtn_area").hide();
    $("#multipwr_area .customizeBtn").remove();
    if(num==1) {
        $("#powerBtnSvg").show();
        $("#multipwr_area").hide();
        return;
    }
    $("#powerBtnSvg").hide();
    $("#multipwr_area").show();
    for(var i=0;i<num;i++){
        $("#multipwr_area").append('<div class="customizeBtn"></div>');
    }
    var _h=$("#multipwr_area").height();
    var _w=$("#multipwr_area").width();
    var _w1=(0.8*_w)/num;
    var _height=0.8*_h;
    var _width=(_height>_w1*0.9)?_w1*0.9 : _height;
    var _top=0.1*_h;
    $("#multipwr_area .customizeBtn").each(function(i){
        var _left=0.1*_w+(_w1*i)+(_w1/2-_width/2);
        $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartPwr"+(i+1)+".png)"});
    });
}


function setCustBtn1_4(num){
    $("#powerBtnSvg").hide();
    $("#multipwr_area").hide();
    $("#multibtn_area").show();
    $("#multibtn_area .customizeBtn").remove();
    for(var i=0;i<num;i++){
        $("#multibtn_area").append('<div class="customizeBtn"></div>');
    }
    var _h=$("#multibtn_area").height();
    var _w=$("#multibtn_area").width();
    var _w1=(0.8*_w)/num;
    var _height=0.8*_h;
    var _width=(_height>_w1*0.9)?_w1*0.9 : _height;
    var _top=0.1*_h;
    $("#multibtn_area .customizeBtn").each(function(i){
        var _left=0.1*_w+(_w1*i)+(_w1/2-_width/2);
        $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartBtn"+(i+1)+".png)"});
    });
}


function setCustBtn4or6(num){
    $("#powerBtnSvg").hide();
    $("#multipwr_area").hide();
    $("#multibtn_area").show();
    if((num!=4) && (num!=6)) {
        Mylog("Error, num must be 4 or 6, set num as 6");
        num=6;
    }
    $("#multibtn_area .customizeBtn").remove();
    for(var i=0;i<num;i++){
        $("#multibtn_area").append('<div class="customizeBtn"></div>');
    }
    var _h=$("#multibtn_area").height();
    var _w=$("#multibtn_area").width();
    var _globalW=1.0*_w;
    var _middleW=0.5*_globalW;
    var _middleH=0.9*_h;
    var _middleL=0.25*_w;
    var _w1=_middleW/3;
    var _h1=_middleH/2;
    var _height=_h1*0.95;
    var _width=(_height>_w1)?_w1 : _height;
    $("#multibtn_area .customizeBtn").each(function(i){
        switch(i){
            case 0:
                var _top=(_h-_middleH)/2;
                var _left=(_w-_width)/2;
                $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartBtnUp.png)"});
                break;
            case 1:
                var _top=(_h-_height)/2;
                var _left=(_w-_globalW)/2+((_globalW-_middleW)/2);
                $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartBtnLeft.png)"});
                break;
            case 2:
                var _bottom=(_h-_middleH)/2;
                var _left=(_w-_width)/2;
                $(this).css({"width":_width+"px","height":_height+"px","bottom":_bottom+"px","left":_left+"px","background-image":"url(files/oUartBtnDown.png)"});
                break;
            case 3:
                var _top=(_h-_height)/2;
                var _right=(_w-_globalW)/2+((_globalW-_middleW)/2);
                $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","right":_right+"px","background-image":"url(files/oUartBtnRight.png)"});
                break;
            case 4:
                var _top=(_h-_height)/2;
                var _left=(_w-_globalW)/2+_globalW*0.05;
                $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartBtnA.png)"});
                break;
            case 5:
                var _top=(_h-_height)/2;
                var _right=(_w-_globalW)/2+_globalW*0.05;
                $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","right":_right+"px","background-image":"url(files/oUartBtnB.png)"});
                break;
                }
    });
    
}

function setCustBtn2Line(num){
    $("#powerBtnSvg").hide();
    $("#multipwr_area").hide();
    $("#multibtn_area").show();
    $("#multibtn_area .customizeBtn").remove();
    for(var i=0;i<num;i++){
        $("#multibtn_area").append('<div class="customizeBtn"></div>');
    }
    var _h=$("#multibtn_area").height();
    var _w=$("#multibtn_area").width();
    var _numh=Math.floor(num/2);
    var _numl=Math.round(num/2);
    var _globalW=0.75*_w;
    var _globalH=0.9*_h;
    var _wh=_globalW/_numh;
    var _wl=_globalW/_numl;
    var _h1=(num%2==0)? _globalH*0.5:_globalH*0.55;
    var _w1=_wl*0.95;
    var _height=_h1*0.95;
    var _width=(_height>_w1)?_w1 : _height;
    $("#multibtn_area .customizeBtn").each(function(i){
        if(i<_numh){
            var _top=(_h-_globalH)/2;
            var _left=(num%2==0)? (_w-_globalW)/2+_wh*i+(_wh-_width)/2:(_w-_globalW)/2+_wl*(i+1)-(_width)/2;
            $(this).css({"width":_width+"px","height":_height+"px","top":_top+"px","left":_left+"px","background-image":"url(files/oUartBtn"+(i+1)+".png)"});
        }
        else {
            var _bottom=(_h-_globalH)/2;
            var _left=(_w-_globalW)/2+_wl*(i-_numh)+(_wl-_width)/2;
            $(this).css({"width":_width+"px","height":_height+"px","bottom":_bottom+"px","left":_left+"px","background-image":"url(files/oUartBtn"+(i+1)+".png)"});
        }
    });
    
}

//$(function($, undefined) {
//    termObj=$('#debug_term').terminal(function(command, term) {
////        termObj=term;
//        switch(command) {
//            case('send'):
//                term.echo('send command');
//                return;
//        }
//        if (command !== '') {
//            try {
//                var result = window.eval(command);
//                if (result !== undefined) {
//                    term.echo(new String(result));
//                }
//            } catch(e) {
//                term.error(new String(e));
//            }
//        } else {
//           term.echo('');
//        }
//    }, {
//        greetings: 'Javascript Interpreter',
//        name: 'js_demo',
//        height: '80%',
//        prompt: 'js> '
//    });
//});
const AspectRatio=3/5;
function setsize() {
//    Mylog("setsize")
	var _h=$(window).height();
    var _w=$(window).width();
	var _width=_w*0.8;
	var _height=_h*0.8;
	if(_h*AspectRatio>_w) {
		_height=_width/AspectRatio;
	}
	else {
		_width=_height*AspectRatio;
	}
	var _left=(_w-_width)/2;
	var _top=(_h-_height)/2
//	sf=$(window).height()/1.5;
//	if(sf>$(window).width()) {
//		sf=$(window).width();
//	}
	$("#topDiv").css({"height":_height, "width":_width, "left":_left, "top":_top});
	$("#controlPanel").css({"font-size":_height*0.03});
	$("#titleText").css({"line-height":$("#titleText").height()+"px"});
	$("#connectBtn").css({"border-radius":_height*0.01+"px", "font-size":$("#connectDiv").width()*0.18+"px"});
	$("#outputPanel").css({"border-radius":_height*0.01+"px", "border-width":_height*0.002+"px", "font-size":_height*0.03});
	$("#inputArea").css({"line-height":$("#inputArea").height()+"px"});
	$("#inputAreaX").css({"font-size":$("#inputAreaX").height()*0.5+"px"})
    $("#bottomBar").css({'height':_w*0.2+'px'});
	$("#mask_area").css({"font-size":_width*0.04});
//    $(".nibbleTitle").css({"line-height":$(".nibbleTitle").height()+"px", "font-size":$(".nibbleTitle").height()*0.6+"px"});
//    $(".hexDigital").css({"font-size":$("div#curHex").height()*0.6+"px"})
//    $(".curHexText").css({"font-size":$("#curHexPad").height()*0.4+"px", "line-height":$("#curHexPad").height()+"px", "margin-left":$("#curHexPad").height()*0.1+"px"});
//    $(".nibbleInput").css({"font-size":$(".nibbleInput").eq(0).height()*0.6+"px"});

//	$("#powerctrl").css({"padding-top":($(window).height()*3)/100+"px"});
	$("h2").css({"font-size":_height*0.05+"px", "margin":"0"});
	$("h3").css({"font-size":_height*0.03+"px", "margin":"0"});
	$("h4").css({"font-size":_height*0.015+"px", "margin":"0"});
    $("#titleIconL").css({"width":$("#title_area").height()+"px"});
//    $("#titleIconR").css({"width":$("#title_area").height()+"px"});
	$(".subMenuTitle .optTitleText").css("font-size", _height*0.04+"px");
	$(".optBody .optItemText").css("font-size", _height*0.035+"px");
//	$(".levelMarker").css({"left":(_w*0.4-_h*0.14)+"px"});
	$("#oVaporStrCtrl").css({"left":(0.4*_w-0.25*_h)+"px"});
	$("#titleIconR").css({"width":$("#titleIconR").height()});
//	$("#oha_min").css({"width":0.06*_h, "height":0.06*_h});
}


function GetConfig() {
    var _configStr=oha_api.ApiCmdRd("04:05:05");
    if(_configStr==null) {
        Mylog("GetConfig Error!!, return null")
        return;
    }
//    Mylog('GetConfig('+_configStr+')');
    var _confA=_configStr.split(":");
    if(_confA!==null){
        Mylog('_confA[1]=='+_confA[1]);
        Mylog('Active Availble='+_confA[1]);
        var _mode=parseInt(_confA[1]);
        if((_mode==1) || (_mode==2)){
            if(_mode==1) {
                opMode="active1";
            }
            else {
                opMode="active2";
            }
            hasActiveMode=true;
            $("#ModeSel").css("opacity",1.0);
//            Mylog('Active Enable='+_confA[2]);
            if($("#ModeSel").find("text").text()=="INTR") {
                $("#rxByteNo").show();
                $("#pollIntvSet").hide();
                sendBaudrate($("#BaudSel").find("text").text(), opMode);
            }
            else {
                $("#rxByteNo").hide();
                $("#pollIntvSet").show();
                opMode="passive";
                sendBaudrate($("#BaudSel").find("text").text(), opMode);
            }
        }
        else {
            hasActiveMode=false;
            opMode="passive";
            $("#ModeSel").off("click");
            $("#ModeSel").css("opacity",0.2);
            $("#rxByteNo").hide();
            $("#pollIntvSet").show();
        }
   }
    else {
        Mylog("Config String has error!!("+_configStr);
    }
    var _ret=oha_api.ApiCmdRd("04:05:05");
    Mylog('GetConfig('+_ret+')')
    
}


oSensorShowTest=new function() {
    var self=this;
    var _h=null;
    this.run=function(){
//        oSensorViewWave();
        $("#mask_area").hide();
        self.stop();
        runTest(0);
    }
    runTest=function(i) {
        if(i<100) {
            oSensorShow("TestSensor", 300+Math.floor(Math.random()*100), "TestUnit", "oSensor Test", "raw");
            _h=setTimeout(function(){
                runTest(i+1);
            }, 300);
        }
    };
    this.stop=function(){
        if(_h!=null) {
            clearTimeout(_h);
            _h=null;
        }
    }
}

function OHA_Attached(){
	 jQuery(".loadingdot").addClass("active");
}
// function OHA_CertOK(_model){
// 	if(_model==oha_config.model) {
// 		isDevReady=1;
//        selectHex();
//        OHA_UI();
//        $(".blackbg").css({"display":"none"});
//        $("#addBtn").css({"background-image":"url(files/connect.png)"});
// 		$("#quickstitch").attr("href", '../PhoneBull/default.html?OHA_DevId='+DeviceId+'&OHA_Local=true');
//// 		$.cookie('loadOK', '1', {expires:365, path:'/'});
////        oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
////        oha_api.ApiCmdWr("02:01:00:05:00:00:AA");
//        powerOn();
//        oha_api.runOhaCmd("oha://lightness_90");
//        oha_api.runOhaCmd("oha://loudness_-2");
//        GetConfig();
// 	}
// }
 

// Device plug in call back
oha_api.DevPlugIn=function() {
//    alert("Device plugin")
	console.log("oha_api.DevPlugIn("+arguments[0]+", "+arguments[1]+")")
	if(typeof(Worker) !="undefined") {
		intr_ww=new Worker("files/oha_intr.js");
		intr_ww.onmessage = function(event) {
			var _d=event.data;
//			console.log("intr_ww.onmessage, action="+_d.action);
			switch(_d.action) {
				case "console":
					console.log(_d.message);
					break;
				case "oha_sensor":
					oSensorShow(_d.name, _d.value, _d.unit, _d.description, _d.raw);
					break;
				case "runOhaCmd":
					oha_api.runOhaCmd(_d.message);
					break;
				case "ApiCmdWr":
					oha_api.ApiCmdWr(_d.message);
					break;
				case "SimpleGetData":
//					var _t0=new Date().getTime();
					SimpleProtocol.getData(_d.message.data, _d.message.name, _d.message.unit,_d.message.description, _d.message.raw, _d.message.ryo);
//					var _period=new Date().getTime()-_t0;
//					console.log("SimpleGetData#0, _period="+_period);
					// Tom 20190626
//					if(_period>100) {
//						oSensorWave[curPanelNo].appendRedrawNo=Math.floor(oSensorWave[curPanelNo].appendRedrawNo*_period/80)+1;
////						console.log("SimpleGetData#1, appendRedrawNo="+oSensorWave[curPanelNo].appendRedrawNo);
//					}
//					else if(_period<60) {
//						oSensorWave[curPanelNo].appendRedrawNo=Math.floor(oSensorWave[curPanelNo].appendRedrawNo*_period/60)+1;
////						console.log("SimpleGetData#2, appendRedrawNo="+oSensorWave[curPanelNo].appendRedrawNo);
//					}
					break;
			}
		};
	}
	intr_ww.postMessage({
		action: "oha_config", 
		message: oha_config
	});
	intr_ww.postMessage({
		action: "SimpleProtocol", 
		message: {
			function: "config", 
			parameters: SimpleProtocol.config
		}
	});
    var _model=arguments[0];
    var _modelArray=_model.split(":");
	SimpleProtocol.DeviceType(SimpleProtocol.TypeNormal);
	for(var i=1;i<_modelArray.length;i++) {
		switch(_modelArray[i]){
			case 'Sensor':
				oSensorMode();
				break;
			case 'Vapor':
				oVaporMode();
				break;
			case 'LoopBack':
				loopBackMode();
				break;
			case 'LINK':		// oLink mode
				oLinkMode();
				break;
			case 'NB':		// New UART Board
				newBoard();
//				var _d=new Date();
//				if((_d.getFullYear()=="2018") && (_d.getMonth()==6) &&((_d.getDate()>=18) && (_d.getDate()<=22))) {
//					SimpleProtocol.isEAV=true;
//				}
				break;
			case 'EAV':		// 
				SimpleProtocol.DeviceType(SimpleProtocol.TypeEAV);
				SimpleProtocol.enable(true);
				break;
			case 'EAV1':		// 
				eavIdleVoltage=2;
				SimpleProtocol.DeviceType(SimpleProtocol.TypeEAV);
				SimpleProtocol.enable(true);
				SimpleProtocol.R200=103900;
				eavCaliLevel=95;
				break;
			case 'EAV2':		// 
				eavIdleVoltage=2;
				SimpleProtocol.DeviceType(SimpleProtocol.TypeEAV);
				isFast=true;
				SimpleProtocol.enable(true);
				SimpleProtocol.isUPP(true);
				break;
			case 'RYO':		// 良導絡
				SimpleProtocol.DeviceType(SimpleProtocol.TypeRYO);
			case 'HBR':		// 夾耳心率器
				isHBR=true;
				break;
			case 'PPG':		// 心率感測器
				isHBR=true;
				isFast=true;
				SimpleProtocol.enable(true);
				break;
			case 'FAST':		// Support fast protocol(simple protocol)
				isFast=true;
				SimpleProtocol.enable(true);
				break;
		}
	}
	if(oha_api.isReadOnly()) {
		$("#oha_update").addClass("itemHide");
		oha_api.cookieWrite(cookieOptions.readOnly.key, cookieOptions.readOnly.options.readonly);
	}
	else {
		$("#oha_update").removeClass("itemHide");
		oha_api.cookieWrite(cookieOptions.readOnly.key, cookieOptions.readOnly.options.writable);
	}
    Mylog("_model="+_model);
    isDevReady=true;
    oUartStus=oUartStusOptions.PowerOff;
    oSensorJsLoaded=false;
    DeviceId=oha_api.DeviceId;
    $("#unConnectedDiv,#xBtnPowerUnconnected").hide();
    $("#powerBtnNormal,#xBtnPowerNormal").show();
    if(ouart_config.enable) {
        $("#powerOnNormal,#xPowerOnNormal").show();
        $("#powerOffNormal,#xPowerOffNormal").hide();
		$("#oha_update").attr("disabled", "disabled");
		powerOn();
    }
    else {
        $("#powerOnNormal,#xPowerOnNormal").hide();
        $("#powerOffNormal,#xPowerOffNormal").show();
		$("#oha_update").removeAttr("disabled");
    }
	oUartTerm.devPlugIn();
	if(isFast) {
		ouart_config.uartMode="passive2";
		ouart_config.baudRate=19200;
		ouart_config.uartSize=8;
	}
	setConfig()
    $("#mask_area").show();
    bgUrl="";
    clearPanelArea();
    $("#itemCustomized").addClass("itemHide");
    oha_sensor_js_url=null;
    setPanelCustomized(false);

//    setTimeout(function(){
//        var 
//    }, 1000);
//    switch(oUartMode) {
//        case oUartModeOptions.oSensor:
//            $("#mask_area").show();
//            bgUrl="";
//            clearPanelArea();
////            $("#powerUnconnected,#xBtnPowerUnconnected").hide();
//            oSensorView();
//            break;
//        case oUartModeOptions.LoopBack0:
//        case oUartModeOptions.LoopBack1:
//        case oUartModeOptions.LoopBack2:
//        case oUartModeOptions.LoopBack3:
//        case oUartModeOptions.Terminal:
////            oUartTerm.devPlugIn();
//            break;
//        case oUartModeOptions.oVapor:
//            
//            break;
//        default:
//            break;
//                    }
    oha_api.cookieWrite('isLock', 'false');
    oha_api.cookieWrite('devId', ''+DeviceId);
    curData="";
    oha_api.runOhaCmd("oha://lightness_90");
    oha_api.runOhaCmd("oha://loudness_-2");
    oha_api.runOhaCmd("oha://polling_off");
//    oSensorShowTest.run();
}

//function plugInJob() {
////    GetConfig();
////    setConfig("57600", "active2", 8);
//    if($("#powerOnNormal").css("display")!=="none") {
//        powerOn();
//        startDev();
//    }
//}

// Device plug out call back
oha_api.DevPlugOut=function() {
    DeviceId=-1;
//    $("#powerUnconnected,#xBtnPowerUnconnected").show();
    $("#unConnectedDiv,#xBtnPowerUnconnected").show();
    $("#powerBtnNormal,#xBtnPowerNormal").hide();
    oUartTerm.devPlugOut();
	SimpleProtocol.powerOn(false);
//	SimpleProtocol.reset();
	isDevReady=false;
	isHBR=false;
    oUartStus=oUartStusOptions.UnCounnected;
    oha_timer.stop();
	intr_ww.terminate();
	intr_ww=null;
//    oSensorShowTest.stop();
}

oha_api.UiNew=function(_ver) {
    $("#titleImgR").removeClass("itemHide");
}

function oSensorMode() {
    $("#setMenuDiv #setMenuContentDiv .setMenuContent").hide();
    $("#setMenuDiv #setMenuContentDiv .setMenuContent.oSensorMode").show();
    $("#setMenuDiv #setMenuContentDiv #itemAbout").show();
    var _uiMode=oha_api.cookieRead(cookieOptions.uiMode.key, cookieOptions.uiMode.default);
    switch(_uiMode) {
        case cookieOptions.uiMode.options.oSensor:
        case cookieOptions.uiMode.options.oSensorList:
        case cookieOptions.uiMode.options.oSensorWave:
        case cookieOptions.uiMode.options.Terminal:
            break;
        default:
            oSensorView();
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oSensor);
            break;
                  }
    oha_api.cookieWrite(cookieOptions.modelUiMode.key, cookieOptions.modelUiMode.options.Sensor);
}

function oVaporMode() {
    $("#setMenuDiv #setMenuContentDiv .setMenuContent").hide();
//    $("#setMenuDiv #setMenuContentDiv .setMenuContent.oVaporMode").show();
    $("#setMenuDiv #setMenuContentDiv #itemAbout").show();
    var _uiMode=oha_api.cookieRead(cookieOptions.uiMode.key, cookieOptions.uiMode.default);
    switch(_uiMode) {
        case cookieOptions.uiMode.options.oVapor:
            break;
        default:
            oVaporView();
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oVapor);
            break;
                  }
    oha_api.cookieWrite(cookieOptions.modelUiMode.key, cookieOptions.modelUiMode.options.Vapor);
}

function loopBackMode() {
    $("#setMenuDiv #setMenuContentDiv .setMenuContent").hide();
    $("#setMenuDiv #setMenuContentDiv .setMenuContent.loopBackMode").show();
    $("#setMenuDiv #setMenuContentDiv #itemAbout").show();
    var _uiMode=oha_api.cookieRead(cookieOptions.uiMode.key, cookieOptions.uiMode.default);
    switch(_uiMode) {
        case cookieOptions.uiMode.options.LoopBack0:
        case cookieOptions.uiMode.options.LoopBack1:
        case cookieOptions.uiMode.options.LoopBack2:
        case cookieOptions.uiMode.options.LoopBack3:
        case cookieOptions.uiMode.options.Terminal:
            break;
        default:
            setLoopTest0();
            debugView();
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.LoopBack0);
            break;
                  }
    oha_api.cookieWrite(cookieOptions.modelUiMode.key, cookieOptions.modelUiMode.options.LoopBack);
}

function oLinkMode() {
	$("#oSensorDiv #panel_area #mask_area div.middleText").text("Waiting for device connecting..");
}

function newBoard() {
	var scriptTag = document.createElement('script');
	scriptTag.type="text/javascript";
	scriptTag.src = "oha_api/oha_waveview.js";
	document.head.appendChild(scriptTag);
//	SimpleProtocol.enable(true);
}

function OHA_RET(_id, _srcCmd, _recvData){
    if(_id==DeviceId) {
        var recvList=_recvData.split(':');
        var retdata="";
        for(var i=0;i<recvList.length;i++) {
            retdata+=recvList[i]+" ";
        }
        insertOutData("RX : "+retdata);
//        $("#outputPanel").append("<div>"+"RX : "+retdata+"</div>");
    }
}

var remainCount=0;
var tempData="";
oha_api.OHA_INTR=function(_recvData) {
//    Mylog("OHA_INTR, data="+_recvData);
    var recvList=_recvData.split(':');
    if(oUartTerm.isLoopTest()) {
        oUartTerm.getLoopRxData(recvList);
        return;
    }
    switch(oUartMode) {
        case oUartModeOptions.Terminal:
        case oUartModeOptions.LoopBack0:
        case oUartModeOptions.LoopBack1:
        case oUartModeOptions.LoopBack2:
        case oUartModeOptions.LoopBack3:
            oUartTerm.showRX(recvList);
            return;
            break;
        default:
            break;
      }
	intr_ww.postMessage({
		action: "intr", 
		message: _recvData
	});

//    if(oUartMode==oUartModeOptions.LoopBack0) {
////    if($("#itemDebug .debug0").eq(0).css("display")!=="none") {
//        Mylog("OHA_INTR cp1")
//        oUartTerm.showRX(recvList);
//        return;
//    }
//    for(var i=0;i<recvList.length;i++) {
//        var _charCode=parseInt(recvList[i], 16);
//		if(!_isFound) {
//			if(SimpleProtocol.pushD(_charCode)) {
//				continue;
//			}
//		}
//        if((_charCode==0) || (_charCode==10)) {
//            if(!_isFound){
//                Mylog("OHA_INTR find illegal string, data="+curData);
//                curData="";
//                continue;
//            }
//			
//            showOsensor(curData);
//            curData="";
//            _isFound=false;
////            return;
//        }
//        curData+=String.fromCharCode(_charCode);
////        Mylog("curData=("+curData+")");
//        if(_isFound) {
//            if(curData.length>512) {
//                curData="";
//                _isFound=false;
//            }
//        }
//        else {
//            var _l0=curData.indexOf("oha_sensor ");
//            var _l1=curData.indexOf("oha_http ");
//            var _l2=curData.indexOf("oha_sensor_js ");
//            var _l3=curData.indexOf("oha_sensor_fn ");
//            if((_l0>=0) || (_l1>=0) || (_l2>=0) || (_l3>0)) {
//                _isFound=true;
////                Mylog("OHA_INTR find key word, data="+curData);
//                if(_l0 >=0) {
//                    curData=curData.substr(_l0);
//                }
//                else if(_l1>=0) {
//                    curData=curData.substr(_l1);
//                }
//                else if(_l2>=0){
//                    curData=curData.substr(_l2);
//                }
//                else {
//                    curData=curData.substr(_l3);
//                }
//            }
//            else {
//                if(curData.length>512) {
//                    curData="";
//                }
//            }
//        }
//    }    
//    Mylog("OHA_INTR end, curData=("+curData+")");
}

var recvIntrStr="";
function parseIntrData(_recvStr) {
    recvIntrStr+=_recvStr;
    var _l0=recvIntrStr.indexOf("oha_sensor ");
    var _l1=recvIntrStr.indexOf("oha_http ");
    var _l2=recvIntrStr.indexOf("oha_sensor_js ");
    var _l3=recvIntrStr.indexOf("oha_sensor_fn ");
    if((_l0>=0) || (_l1>=0) || (_l2>=0) || (_l3>0)) {
        if(_l0<0) {
            _l0=99999;
        }
        if(_l1<0) {
            _curColor1=99999;
        }
        if(_l2<0) {
            _l2=99999;
        }
        if(_l3<0) {
            _l3=99999;
        }
        var _start=Math.min(_l0, l1, l2, l3);
        recvIntrStr.substring(_start);
        var _data
        var _p0=recvIntrStr.indexOf(String.fromCharCode(0));
        var _p1=recvIntrStr.indexOf(String.fromCharCode(10));
        if(_p0>0 || _p1>0) {
            if(_p0>0 && (_p0<_p1)) {
                
            }
        }
    }
}

var SimpleProtocol=new function(){
	var dataQ=[];
	var sensorQ=[];
	var isFound=false;
	var dataCount=-1;
	var dataSize=-1;
	var checkSumC=0;
	var curId=-1;
	var isEnable=false;
	var self=this;
	this.R200=100000;
//	this.isEAV=false;
	this.TypeNormal=0;
	this.TypeEAV=1;
	this.TypeRYO=2;
	this.DeviceType=self.TypeNormal;
	this.config={
	}
	this.enable=function(_isEnable) {
		self.config.enable=_isEnable;
		isEnable=_isEnable;
	}

	this.isEnable=function() {
		return isEnable;
	}
	
	this.DeviceType=function(_type) {
		if(typeof _type=="undefined") {
			if(self.config.hasOwnProperty("DeviceType")) {
				return self.config.DeviceType;
			}
			else {
				return self.TypeNormal;
			}
		}
		else {
			self.config.DeviceType=_type;
		}
	}
	
	this.isUPP=function(_isUPP) {
		self.config.isUPP=_isUPP;
	}
		
	this.powerOn=function(_isPowerOn) {
		intr_ww.postMessage({
			action: "SimpleProtocol", 
			message: {
				function: "powerOn", 
				parameters: {
					isPowerOn: _isPowerOn
				}
			}
		});
	}
	
	
	this.getEavP0=function(){
		return this.R200*3/500;
	}
	
	this.assignID=function(_name, _unit, _desc) {
		if(!isEnable) {
			return;
		}
		console.log("assignID, name="+_name+", unit="+_unit+", desc="+_desc);
		for(var i=0;i<sensorQ.length;i++) {
			if(sensorQ[i].name==_name) {
//				return "Hello, "+_name+" is old sensor";
				return;
			}
		}
		var _nameLength=_name.length;
		var _l=(4+_name.length).toString(16)+1;
		var _cmd="04:01:"+_l+":FF:33:CC:"+sensorQ.length.toString(16)+":"+_name.length.toString(16);
		for(i=0;i<_name.length;i++) {
			_cmd+=":"+_name.charCodeAt(i).toString(16);
		}
		var _ret=oha_api.ApiCmdWr(_cmd);
//		console.log("_ret="+_ret+", _cmd="+_cmd);
		if(_ret=="OK") {
			var sensorObj={
				name:_name,
				unit:_unit,
				desc:_desc
			}
			console.log("assignID OK");
			sensorQ.push(sensorObj);
//			return "Hello, "+_name+" is new sensor";
		}
	}
	
	const state={
		idle:-1,
		foundP:0,
		id:1,
		count:2,
		data:3,
		checkSum:4
	}
	var st=state.idle;
	
	this.getData=function(_dataArray, _name, _unit, _desc, _raw, _ryo) {
		console.log("SimpleProtocol.getData("+_dataArray+", "+_name+", "+_unit+", "+_desc+", "+_raw+", "+_ryo+")");
	}
	
	var _startT=-1;
	
//	this.pushD=function(_in)	{
//		console.log("pushD("+_in.toString(16)+"), isEnable="+isEnable+", state="+st)
//		if(!isEnable) {
//			return;
//		}
////		console.log("pushD("+_in.toString(16)+"), state="+st)
//		switch(st) {
//			case state.idle:
//				isFound=false;
//				if(_in==0x5A) {
//					st=state.foundP;
//					_startT=new Date().getTime();
//				}
//				break;
//			case state.foundP:
//				if((_in&0x7f)==0x25) {	//Sometimes bit 7 can't send H.
//					st=state.id;
//					isFound=true;
//				}
//				else{
//					if(_in!==0x5A) {
//						st=state.idle;
//					}
//				}
//				break;
//			case state.id:
//				dataSize=((_in>>4)&0x3)+1;
//				curId=_in&0x07;
////				console.log("get ID="+curId);
//				st=state.count;
//				break;
//			case state.count:
//				dataCount=_in;
//				console.log("get count="+dataCount);
//				st=state.data;
//				checkSumC=0;
//				break;
//			case state.data:
//				dataQ.push(_in);
//				checkSumC+=_in;
//				console.log("dataQ.length="+dataQ.length+", dataCount="+dataCount+", checkSumC="+checkSumC);
//				if(dataQ.length>=dataCount*dataSize) {
//					if(dataQ.length>dataCount*dataSize) {
//						dataQ=dataQ.slice(0, dataCount*dataSize);
//					}
//					st=state.checkSum;
//					checkSumC=(256-checkSumC&0xff)&0xff;
//					console.log("Data OK, checkSum="+checkSumC);
//				}
//				break;
//			case state.checkSum:
//				if(checkSumC==_in) {
////					console.log("CheckSum OK, curId="+curId);
////					console.log("name="+sensorQ[curId].name+", unit="+sensorQ[curId].unit+"desc="+sensorQ[curId].desc)
//					var _period=new Date().getTime()-_startT;
//					console.log("SimpleProtocol cp0 dataCount="+dataCount+", period="+_period+"ms");
//					var newDataQ=[];
//					var _raw=null;
//					var _ryo=null;
//					if(self.isUPP && self.DeviceType==self.TypeEAV) {
//						var refADC=512;		// Ideal ADC data for reference voltage=2.5V(default)
//					}
////=================================================================================================
//					for(var i=0;i<dataQ.length;i+=dataSize) {
//						if(self.DeviceType==self.TypeEAV) {
//							if(self.config.isUPP) {
//								var _d=0;
//								for(var j=0;j<dataSize;j++) {
//									_d=_d+(dataQ[i+j]<<(j*8));
////									console.log("(i,j)=("+i+","+j+", dataQ["+(i+j)+"]="+dataQ[i+j]+", _d="+_d);
//								}
////								console.log("i="+i+", dataSize="+dataSize+", _d="+_d);
//								if(i==0) {
//									refADC=_d;			// First data is ADC reference voltage(因為電壓會飄)
//									var dx30=0;
//									var dx2=0;
//								}
//								else {
//									var k=(i/dataSize);
//									switch(k%2) {
//										case 0:		// x30 data
//											dx30=_d;
////											var _voll=getVoll(refADC, dx2, dx30);
//											var _voll=getVollByR(refADC, dx2, dx30);
////											console.log("get _voll="+_voll+", dx2="+dx2+", dx30="+dx30);
//											newDataQ.push(_voll);
//											break;
//										case 1:		// x2 data
//											dx2=_d;
//											break;
//									}
//								}
//							}
//							else {
//								var _d=0;
//								for(var j=0;j<dataSize;j++) {
//									_d=_d*0x100+dataQ[i+j];
//								}
//								_raw=Math.floor(((62500-600*_d)/(6*_d)));
//								if(_raw==Infinity) {
//									_raw="N.C.";
//								}
//								else if(_raw>=1000) {
//									_raw=(_raw/1000)+"K"
//								}
//								_ryo=(1200/(3125/(3*_d)-4)).toFixed(0);		// Current, Ibody
//	//							1200/(3125/(3*measureV)-4)
//								newDataQ.push(_d);
//							}
//						}
//						else {
//							for(j=0;j<dataSize;j++) {
//								newDataQ.push(dataQ[i+j]);
//							}
//						}
//					}
////=================================================================================================
////					for(var i=0;i<dataQ.length;i+=dataSize) {
////						var _d=0;
////						for(var j=0;j<dataSize;j++) {
////							_d=_d*0x100+dataQ[i+j];
////						}
////						if(self.DeviceType==self.TypeEAV) {
////							_raw=((62500-600*_d)/(6*_d)).toFixed(0);
////							if(_raw==Infinity) {
////								_raw="N.C.";
////							}
////							else if(_raw>=1000) {
////								_raw=(_raw/1000)+"K"
////							}
////							_ryo=(1200/(3125/(3*_d)-4)).toFixed(0);		// Current, Ibody
//////							1200/(3125/(3*measureV)-4)
////						}
////						newDataQ.push(_d);
////					}
//					this.getData(newDataQ, sensorQ[curId].name, sensorQ[curId].unit, sensorQ[curId].desc, _raw, _ryo);
//					_period=new Date().getTime()-_startT;
//					console.log("SimpleProtocol cp1 dataCount="+dataCount+", period="+_period+"ms");
//				}
//				else {
//				   console.log("CheckSum Error!!Expected="+checkSumC.toString(16)+", Read="+_in.toString(16));
//				}
//				dataQ=[];
//				st=state.idle;
//				isFound=false;
//				break;
//		}
//		return isFound;
//	}
						   
//	this.reset=function(){
////		if(!isEnable) {
////			return;
////		}
//		isEnable=false;
////		console.log("reset")
//		sensorQ=[];
//		dataQ=[];
//		st=state.idle;
//		this.isFound=false;
//		curId=-1;
//	}
const ADC30MAX=750;	
	function getVollByR(adcRef, adcx2, adcx30) {
		var _voltage=0;			// Calculated voltage, unit = mA
//		console.log("getVollByR, adcRef="+adcRef+", adcx2="+adcx2+", adcx30="+adcx30);
		if(adcx30>ADC30MAX) {
			_voltage=adcx2*Vref*1000/(adcRef*2);
		}
		else {
			_voltage=adcx30*Vref*1000/(adcRef*31);
		}
		var Rbody=(125000-100*_voltage)/_voltage;
		var Ibody=1250/(104.16667+Rbody);		//uA
		console.log("getVollByR, voltage="+_voltage+"mV, Rbody="+Rbody+"Kohm, Ibody="+Ibody+"uA");
		return Ibody*100/12;
	}
	
}

SimpleProtocol.getData=function(_dataArray, _name, _unit, _desc, _raw, _ryo){
//	console.log("getData("+_dataArray+")")
	for(var i=0;i<_dataArray.length;i++) {
//		console.log("getData, i="+i+", _d="+_d);
		oSensorShow(_name, _dataArray[i], _unit, _desc, _raw, _ryo);
	}
}

var waveDataIdx=0;
		function getIdx() {
			if(waveDataIdx==1000000) {
				waveDataIdx=0;
			}
			return waveDataIdx++;
		}

function showOsensor(_str) {
    Mylog("showOsensor start:"+_str.length+"("+_str+")");
    var _p=/^(?:oha_sensor)[ \t]+([^=]+)=[ \t]*([^ \t]+)[ \t]+([^ \t]+)[ \t]*[(]([^()]*)[)],(.*)[.]([0-9a-fA-F]{1,4})$/;
    var _p1=/^(?:oha_http)[ \t]*(.*)[.]([0-9a-fA-F]{1,4})$/;
    var _p2=/^(?:oha_sensor_js)[ \t]*(.*)[.]([0-9a-fA-F]{1,4})$/;
//    var _p3=/^(?:oha_sensor_fn)[ \t]*([^=]+)[=][ \t]*([^,]*)[,]((?:[^,]+[,])*[^ \t]+)[ \t]+([^,]*)[,][ \t]*([^.]*)[.]([0-9a-fA-F]{1,4})$/;
    var _p3=/^(?:oha_sensor_fn)[ \t]*([^=]+)[=][ \t]*([^,]*)[,]((?:[0-9.+-]+[,])*[0-9.+-]+)(?:,[Ff]([0-9]))?[ \t]+([^,]*)[,][ \t]*([^.]*)[.]([0-9a-fA-F]{1,4})$/;
    if(_p.test(_str)) {
//        $("#oha_title_2_").text("oha_sensor OK")
        var _name=RegExp.$1;
        var _val=RegExp.$2;
        var _unit=RegExp.$3;
        var _raw=RegExp.$4;
        var _desc=RegExp.$5;
        var _checkSum=RegExp.$6;
//        $(".forDebug").text("p Test OK");
//        if(!checkSum(_name+_val+_unit+_raw+_desc, _checkSum)){
//            return;
//        }
        if(!checkSum(_str)){
            return;
        }
//        if(oSensorJsLoaded) {
//            var _obj=new Object();
//            _obj.value=_val;
//            _obj.raw=_raw;
//            _val=osensor_fn.eval(_obj);
//        }
		SimpleProtocol.assignID(_name, _unit, _desc);
        oSensorShow(_name, _val, _unit, _desc, _raw);
//        if(calibrationJs!=="") {
////            $.ajax({url:"http://54.183.18.76/OHA/oSensor.js", dataType:"script", success:function(){
////                oSensorJsCall(_val, _unit, _raw);
////            }})
//            if()
//            $.ajax({url:calibrationJs, dataType:"script", success:function(){
//                oSensorJsCall(_name, _val, _unit, _raw, _desc);
//            }});
//            return;
//        }
//        oSensorShow(_name, _val, _unit, _desc);
    }
    else if(_p1.test(_str)) {
        var _newUrl=RegExp.$1;
        if(!checkSum(_str)) {
            Mylog("oha_http check sum fail");
            return;
        }
        Mylog("oha_http protocol is found!!("+_newUrl+")")
        
//        if(!_newUrl.startsWith("http://") && !_newUrl.startsWith("https://")){
        if((_newUrl.indexOf("http://")==0) && (_newUrl.indexOf("https://")==0)){
            _newUrl="http://"+_newUrl;
        }
        if(bgUrl!==_newUrl) {
            bgUrl=_newUrl;
            _url=encodeURI(bgUrl)
            oha_api.runOhaCmd("oha://updateBgUrl_"+_url);
            if(oha_config.simVirtualDevice) {
                $(".urlSection").text(bgUrl);
            }
        }
//        else {
//            alert(bgUrl+" is updated before");
//        }
    }
    else if(_p2.test(_str)) {   //oha_sensor_js
        var _jsUrl=RegExp.$1;
        getJs1(_jsUrl);
//        if(checksum(_str)) {
//            getJs1(_jsUrl);
//        }
//        if(!checkSum(_str)) {
//            Mylog("oha_osensor_js checksum fail");
//            return;
//        }
//        $.ajax({url:_jsUrl, dataType:"script"});      //Load JS file
//        oSensorJsLoaded=true;
    }
    else if(_p3.test(_str)) {
        var _sname=RegExp.$1;
        var _func=RegExp.$2;
        var _param=RegExp.$3.split(",");
        var _floor=RegExp.$4;
        var _unit=RegExp.$5;
        var _desc=RegExp.$6;
//        $(".forDebug").text("p3 Test OK");
        if(!checkSum(_str)) {
            Mylog("oha_osensor_fn checksum fail");
            return;
        }
        try{
            osensor_fn=math.compile(_func);
            var _pObj=new Object();            
            for(var i=0;i<_param.length;i++) {
                _pObj[String.fromCharCode(97+i)]=parseFloat(_param[i]);
            }
//            oha_api.showToast("_pObj.a="+_pObj.a);
            var _round=0;
            if(_floor.length!==0) {
                _round=parseInt(_floor);
            }
            var _value=math.round(osensor_fn.eval(_pObj),_round);
            oSensorShow(_sname, _value, _unit, _desc);
            
        }catch(e){
            if(oha_config.debug_mode) {
                alert(e.message);
            }
            else {
                oha_api.showToast("Js function load fail!!");
            }
        }
    }
//    Mylog("showOsensor end:"+_str.length+"("+_str+")");
}

function checkSum(_str){
    var _cs=0;
    var _p=/^(.+[.])([0-9A-Fa-f]{1,4})$/;
    if(!_p.test(_str)) {
        return false;
    }
    var _strRaw=RegExp.$1;
    for(i=0;i<_strRaw.length;i++){
//        if(oha_config.ignoreCheckSum) {
//            Mylog("char["+i+"]=\""+_str.charAt(i)+"\", code="+_str.charCodeAt(i));
//        }
        _cs+=_strRaw.charCodeAt(i);
    }
    _cs&=0xffff;
//    _cs^=0xffff;
    var _expect=parseInt(RegExp.$2,16);
    if(_cs==_expect) {
        return true;
    }
    else {
       Mylog("checksum fail, _str="+_str+", expect="+RegExp.$2+", checksum="+_cs.toString(16));
        if(oha_config.ignoreCheckSum) {
            return true;
        }
        return false;
    }
}

function findSensor(_name) {
//	console.log("findSensor("+_name+")");
    for(var i=0;i<sensorName.length;i++) {
//		console.log("findSensor: i="+i+", name("+sensorName[i]+")");
        if(sensorName[i]==_name) {
            return i;
        }
    }
    return -1;
}

function addSensor(_name) {
    var i=sensorName.length;
    sensorName[i]=_name;
}

function goPanel(_panelNo) {
    var _size=$("#panel_area .panel_block").size();
    if(_panelNo>=_size) {
        _panelNo=_size-1;
    }
    if(_panelNo<0) {
        _panelNo=0;
    }
    var _h=0;
    for(var i=0;i<_panelNo;i++) {
        _h+=$("#panelBlock"+(i+1)).height();
    }
//    console.log("_panelNo="+_panelNo+", _h="+_h);
//	$(".panel_block.official").css("color","white");
//	$("#panelBlock"+(_panelNo+1)).css("color","red");
	if(!oSensorConfig.isFixedShow &&!oSensorConfig.isKeepPanel) {
		$("#panel_area").scrollTop(_h);
	}
}

var chartDataH=null;
var chartDataQ=[];
var appendConfig={
	isSimVirtualData:false, 
	curData:50
};
function runAppendChartData(_panelNo, _name, _value, _unit, caliF) {
	if(typeof(caliF)=="undefined") {
		caliF=1;
	}
//	console.log("runAppendChartData, #="+_panelNo+", name="+_name+", value="+_value+", _unit="+_unit);
//	if(oUartMode==oUartModeOptions.oSensorWave ||(chartDataH!=null)) {
//		var _data={no:_panelNo, name:_name,value:_value,unit:_unit};
////		console.log("Push Chart Data, #="+_data.no+", name="+_data.name+", value="+_data.value+", _unit="+_data.unit);
//		chartDataQ.push(_data);
//		if(chartDataH==null) {
//			chartDataH=setTimeout(function(){
//				while(chartDataQ.length>0) {
//					var _d=chartDataQ.splice(0,1)[0];
//					var _isFound=false;
//					for(var i in chartDataQ) {
//						if(chartDataQ[i].no==_d.no) {
//							_isFound=true;
//							break;
//						}
//					}
////					console.log("Update Chart Data, #="+_d.no+", name="+_d.name+", value="+_d.value+", _unit="+_d.unit+", redraw="+!_isFound);
//					var _idx=getIdx();
////					console.log("EAV appendData("+_idx+", "+parseFloat(_d.value)+")");
////					oSensorWave[_d.no].AppendChartData(_d.name, (parseFloat(_d.value)*caliF).toFixed(0), _d.unit, !_isFound, _idx)
//					var _valueX=_d.value;
//					if(_d.value<eavIdleVoltage) {
//						_valueX=0;
//					}
//					if(oSensorWave[_panelNo].hasOwnProperty("pushData")) {
//						_valueX=oSensorWave[_d.no].pushData(_d.no, _idx, _d.value);
//						console.log("pushData, _d.value="+_d.value+", ret="+_valueX);
////						if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
////							_valueX=oSensorWave[_d.no].pushData(_d.no, _idx, _d.value);
////							console.log("pushData, _d.value="+_d.value+", ret="+_valueX);
////						}
//					}
////					oSensorWave[_d.no].AppendChartData(_d.name, Math.floor(parseFloat(_d.value)*caliF), _d.unit, !_isFound, _idx);
//					oSensorWave[_d.no].AppendChartData(_d.name, _valueX, _d.unit, !_isFound, _idx);
//				}
//				chartDataH=null;
//			}, oWaveUpdateTime);
//		}
//	}
//	else {
//		var _idx=getIdx();
////		oSensorWave[_panelNo].AppendChartData(_name, (parseFloat(_value)*caliF).toFixed(0), _unit, false, _idx);
//		var _valueX=parseFloat(_value);
//		if(oSensorWave[_panelNo].hasOwnProperty("pushData")) {
//			_valueX=oSensorWave[_panelNo].pushData(_panelNo, _idx, parseFloat(_value));
////			if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
////				_valueX=oSensorWave[_panelNo].pushData(_panelNo, _idx, parseFloat(_value));
////			}
//		}
////		oSensorWave[_panelNo].AppendChartData(_name, Math.floor(parseFloat(_value)*caliF), _unit, false, _idx);
//		oSensorWave[_panelNo].AppendChartData(_name, _valueX, _unit, false, _idx);
//	}
	var _idx=getIdx();
	var _valueX=parseFloat(_value);
	if(oSensorWave[_panelNo].hasOwnProperty("pushData")) {
		_valueX=oSensorWave[_panelNo].pushData(_panelNo, _idx, _valueX);
	}
	if(oUartMode==oUartModeOptions.oSensorWave) {
//		console.log("AppendChartData@cp0, #="+_panelNo+", name="+_name+", value="+_value+", valueX="+_valueX+", _unit="+_unit+", _idx="+_idx);
		if(appendConfig.isSimVirtualData) {
			if(appendConfig.curData++>=100){
				appendConfig.curData=50;
			}
			_valueX=appendConfig.curData;
		}
		if(oSensorWave[_panelNo].appendIdx++>oSensorWave[_panelNo].appendRedrawNo) {
//			console.log("AppendChartData go!!")
			var _t0=new Date().getTime();
			oSensorWave[_panelNo].AppendChartData(_name, _valueX, _unit, true, _idx);
			var _period=(new Date().getTime()-_t0);
//			console.log("AppendChartData go!!period="+_period);
			oSensorWave[_panelNo].appendIdx=0;
			// Tom 20190626
			oSensorWave[_panelNo].appendRedrawNo = 
				Math.floor(30*_period/80)+1;
		}
		else {
			oSensorWave[_panelNo].AppendChartData(_name, _valueX, _unit, false, _idx);
//			console.log("AppendChartData write!!");
		}
//		console.log("AppendChartData _valueX="+_valueX);
//		oSensorWave[_panelNo].AppendChartData(_name, _valueX, _unit, true, _idx);
	}
	else {
//		console.log("AppendChartData@cp1, #="+_panelNo+", name="+_name+", value="+_value+", valueX="+_valueX+", _unit="+_unit+", _idx="+_idx);
		oSensorWave[_panelNo].AppendChartData(_name, _valueX, _unit, false, _idx);
	}
	return _valueX;
}

function addBottomBarData(_name, _val, _unit) {
    $("#sensorName1 text").text($("#sensorName0 text").text());
    $("#sensorValue1 text").text($("#sensorValue0 text").text());
    $("#sensorUnit1 text").text($("#sensorUnit0 text").text());    
    $("#sensorName0 text").text(_name);
    $("#sensorValue0 text").text(_val);
    $("#sensorUnit0 text").text(_unit);
}

var caliTimer=null;
function oSensorShow(_name, _val, _unit, _desc, _raw, _ryo) {
//    Mylog("oSensorShow start("+_name+","+_val+","+_unit+","+_desc+")");
	if(typeof(_raw)==undefined) {
		_raw="";
	}
	if(typeof(_val)!="number") {
		_val=parseFloat(_val);
	}
	$("#mask_area").hide();
//    _value=parseFloat(_val);
    _value=_val;
    curPanelNo=findSensor(_name);
    if(curPanelNo<0) {
		console.log("addPanel, _name="+_name);
		if(isHBR && !isFast) {
			addSensor("QRNG");
        	addPanel();
		}
        addSensor(_name);
       	addPanel();
        curPanelNo=findSensor(_name);
    }
//	$(".panel_block.official").css("font-weight","");
//	$("#panelBlock"+(curPanelNo+1)).css("font-weight","bold");

	if(!oSensorConfig.isKeepPanel) {
		goPanel(curPanelNo);
	}
	if(oSensorWave.length>curPanelNo) {
//		if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
//			runAppendChartData(curPanelNo, _name, _value, _unit, oSensorWave[curPanelNo].CaliFactor);
//		}
//		else {
//			runAppendChartData(curPanelNo, _name, _value, _unit);
//		}
		if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
//			if(!$("#itemOsensorCalibrate").hasClass("itemHide")) {
			if($(".calibrate_config.oha_calibrate_config").css("display")!="none") {	//Calibration page is displayed.
				if(oSensorCalibrateCtl[curPanelNo].GetLock()) {
					console.log("Data is locked");
					return;
				}
				else {
					if(_value<eavIdleVoltage) {
						if(caliTimer!=null) {
							clearTimeout(caliTimer);
							caliTimer=null;
							_value=0;
						}
						
						$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .oha_value_section .valueSection").css({color:"red"});
					}
					else {
						if(caliTimer==null) {
							caliTimer=setTimeout(function(){
								$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .oha_value_section .valueSection").css({color:"blue"});
								oSensorCalibrateCtl[curPanelNo].SetLock(true)
								caliTimer=null;
							}, 3000);
							$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .oha_value_section .valueSection").css({color:"white"});
						}
					}
				}
				var _v=parseInt(_value*100)/100
				oSensorCalibrateCtl[curPanelNo].SetValue(_v);
				var _caliMsg=_v+"/"+oSensorCalibrateCtl[curPanelNo].Calibrate(_v).toFixed(2);
//				var _caliMsg=_v+"/"+_vCali.toFixed(2);
				$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .numberSection").text(_caliMsg);
				return;
			}
			_value=runAppendChartData(curPanelNo, _name, _value, _unit, oSensorWave[curPanelNo].CaliFactor);
		}
		else {
			runAppendChartData(curPanelNo, _name, _value, _unit);
		}
//    	oSensorWave[curPanelNo].AppendChartData(_name, parseFloat(_value), _unit, (oUartMode==oUartModeOptions.oSensorWave));
	}
	if(oSensorList.length>curPanelNo) {
    	oSensorList[curPanelNo].insertListData(_name,_value,_unit,_desc, (oUartMode==oUartModeOptions.oSensorList));
	}
	if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeEAV) {
		if(oSensorWave[curPanelNo].stEAV==eavStOptions.caliok) {
			_value=625/6;
		}
		else {
			_value=_val*oSensorWave[curPanelNo].CaliFactor;
		}
		var _Vollir=oSensorWave[curPanelNo].eavVar[eavVarIdxOpt.Vr];
		var _VollLast=oSensorWave[curPanelNo].eavVar[eavVarIdxOpt.Vlast]
		var _id=(_VollLast<0)?0:_Vollir-_VollLast;
		$("#panelBlock"+(curPanelNo+1)+" .eavSection1 .numberSection").text(Math.round(_Vollir)+" / "+Math.round(_id));
		var _ix=(_Vollir<0)? 0:(_Vollir*0.12).toFixed(2);		// Calculate the current from Voll value
		$("#panelBlock"+(curPanelNo+1)+" .eavSection1 .detailSection span").text(_ix);
		var _Vollmin=oSensorWave[curPanelNo].eavVar[eavVarIdxOpt.Vmin];
//		var _ryo=(1200/(3125/(3*_Vollmin)-4)).toFixed(0);
//		var _Rmin=((62500-600*_value)/(6*_value));
//		var _Rmin=1250*(100-_value)/(12*_value);		// = 104.667*(100-voll)/voll, unit = kohm
		var _Rmin=1250*(100-_Vollmin)/(12*_Vollmin);		// = 104.667*(100-voll)/voll, unit = kohm
//		var _Rmin=((62500-600*_Vollmin)/(6*_Vollmin));
//		console.log("_Rmin="+_Rmin);
//		var _RminStr=(_Vollmin<0)? "N.C.":((_Rmin<1)? _Rmin*1000 : (_Rmin<1000)?Math.round(_Rmin/RyoFactor)+" K":(_Rmin*1000/RyoFactor).toFixed(2)+" M");
		var _RminStr=(_value==0)? "N.C.":((_Rmin<1)? _Rmin*1000 : (_Rmin<1000)?Math.round(_Rmin)+" K":(_Rmin/1000).toFixed(2)+" M");
		if(oSensorWave[curPanelNo].stEAV==eavStOptions.caliok) {
			_RminStr=(_Vollmin<0)? "N.C.":((_Rmin<1)? _Rmin*1000 : (_Rmin<1000)?Math.round(_Rmin)+" K":(_Rmin/1000).toFixed(2)+" M");
		}
//		var _Imin=(_Vollmin<0)?0:_Vollmin*0.12;
//		var _Imin=(_Rmin<0)?0:((12000/(60+_Rmin))*RyoFactor).toFixed(1);
//		var _Imin=(_Rmin<0)?0:((1200/(3125/(3*_Vollmin)-4))*RyoFactor).toFixed(1);
//		var _Imin=(_Rmin<0)?0:_Vollmin/100*12;		// Unit = uA
		var _Imin=(_Rmin<0)?0:12000/(60+_Rmin);		// Unit = uA
//		var _Imin=(1200*_Vollmin)/(SimpleProtocol.R200/96+(6-(SimpleProtocol.R200/10000))*_Vollmin)
		if(oSensorWave[curPanelNo].stEAV==eavStOptions.caliok) {
//			_Imin=(_Rmin<0)?0:(1200/(3125/(3*_Vollmin)-4)).toFixed(1);
			_Imin=12;
		}
		if(_Imin<0) {
			_Imin=0;
		}
//		console.log("_Imin="+_Imin+", _Rmin="+_Rmin);
		$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .numberSection").text(_Imin.toFixed(2));
		$("#panelBlock"+(curPanelNo+1)+" .eavSection2 .detailSection span").text(_RminStr);
//		$("#panelBlock"+(curPanelNo+1)+" .eavSection3 .numberSection").text(arguments[5]);
		var _adc = ((1250-12*_value)/3.3);
//		var _Rnow=(62500-SimpleProtocol.getEavP0()*_value)/(6*_value);
		var _Rnow=1250*(100-_value)/(12*_value);		// = 104.667*(100-voll)/voll, unit = kohm
		
//		var _RnowStr=(_adc>AdcMax)? "N.C.":(_Rnow<1)? Math.round(_Rnow*1000): (_Rnow<1000)? Math.round(_Rnow)+" K": (_Rnow/1000).toFixed(2)+" M";
		var _RnowStr=_value==0? "N.C.":(_Rnow<1)? Math.round(_Rnow*1000): (_Rnow<1000)? Math.round(_Rnow)+" K": (_Rnow/1000).toFixed(2)+" M";
		if(oSensorWave[curPanelNo].stEAV==eavStOptions.caliok) {
			console.log("Calibration OK, RnowStr="+_RnowStr+", _value="+_value+", _val="+_val);
		}
		$("#panelBlock"+(curPanelNo+1)+" .eavSection3 .numberSection").text(_RnowStr);
		$("#panelBlock"+(curPanelNo+1)+" .eavSection3 .detailSection span").text(_adc.toFixed(0));
//		$("#panelBlock"+(curPanelNo+1)+" .unitSection").text(_unit);
//		$("#panelBlock"+(curPanelNo+1)+" .detailSection").text(_desc);
	}
	else {
		if(isHBR && !isFast) {
			curPanelNo=findSensor("QRNG");
			$("#panelBlock"+(curPanelNo+1)+" .nameSection").text("QRNG");
			$("#panelBlock"+(curPanelNo+1)+" .rawSection").hide();
			$("#panelBlock"+(curPanelNo+1)+" .numberSection").text(_raw);
			$("#panelBlock"+(curPanelNo+1)+" .unitSection").text("TRNG");
			$("#panelBlock"+(curPanelNo+1)+" .detailSection").text("A random number by Photodiode");
			curPanelNo=findSensor(_name);
		}
		$("#panelBlock"+(curPanelNo+1)+" .nameSection").text(_name);
		if(_raw!=null) {
			$("#panelBlock"+(curPanelNo+1)+" .rawSection span").text(_raw);
		}
		else {
			$("#panelBlock"+(curPanelNo+1)+" .rawSection").hide();
		}
		if(SimpleProtocol.DeviceType()==SimpleProtocol.TypeRYO) {
			var _value1=12000000*_value/(12000000+((60000-oSensorWave[curPanelNo].CaliFactor)*_value));
			$("#panelBlock"+(curPanelNo+1)+" .numberSection").text(_value1.toFixed(0));
		}
		else {
			$("#panelBlock"+(curPanelNo+1)+" .numberSection").text(_value);
		}
		$("#panelBlock"+(curPanelNo+1)+" .unitSection").text(_unit);
		$("#panelBlock"+(curPanelNo+1)+" .detailSection").text(_desc);
	}
//        $("#panelBlock1 .valueSection .numberSection,#sensorValue0 text").text(_val);
//    $("#sensorName0 text").text(_name);
//    $("#sensorValue0 text").text(_val);
//    $("#sensorUnit0 text").text(_unit);
    addBottomBarData(_name, _val, _unit);
//    oha_sensor_value("#panelBlock"+(curPanelNo+1)+" .valueSection", _val, _unit);
	if(_value.length>6) {
		$("#panelBlock"+(curPanelNo+1)+" .numberSection").css("font-size", Math.floor(100/_value.length)+"vw");
		$("#panelBlock"+(curPanelNo+1)+" .unitSection").css("font-size", Math.floor(25/_value.length)+"vw");
//		$("#panelBlock"+(curPanelNo+1)+" .numberSection,#panelBlock"+(curPanelNo+1)+" .unitSection").css("transform", "scale(0.5,0.5)");
	}
	else {
//		$("#panelBlock"+(curPanelNo+1)+" .numberSection,#panelBlock"+(curPanelNo+1)+" .unitSection").css("transform", "");
		$("#panelBlock"+(curPanelNo+1)+" .numberSection").css("font-size", "");
		$("#panelBlock"+(curPanelNo+1)+" .unitSection").css("font-size", "");
	}
    if($("#mask_area").css("display")!=="none") {
        $("#mask_area").hide();
    }
    
    if(typeof oha_sensor_call!=="undefined") {
//        Mylog("oha_sensor_call("+_name+","+_val+","+_raw+","+_unit+","+_desc+")");
        oha_sensor_call(_name, _val, _raw, _unit, _desc);
    }    
//    Mylog("oSensorShow end("+_name+","+_val+","+_unit+","+_desc+")");
}

function oha_sensor_value(_selector, _value, _unit) {
    $(_selector+" .numberSection").text(_value);
    $(_selector+" .unitSection").text(_unit);
}

var isOsensorTest=false;
function oSensorTest(_isRun) {
	isOsensorTest=_isRun;
	oWaveUpdateTime=1000;
	if(isOsensorTest) {
		runOsensorTest(0);
		oWaveUpdateTime=5000;
	}
}

function runOsensorTest(i) {
	if(isOsensorTest) {
//		var i=Math.floor(Math.random()*8);
		var _name="oSensor Test "+i;
//		if(i<4) {
//			_name="XXXX Sensor";
//		}
		var _val=(200+(Math.random()*100)).toFixed(2);
		var _unit="cm";
		var _desc="oSensor Auto-Test("+i+")";
		var _raw="RAW";
		oSensorShow(_name, _val, _unit, _desc, _raw);
		setTimeout(function(){
			runOsensorTest((i+1==8)?0:i+1);
//			runOsensorTest(i);
		}, 1000);
	}
}

function run_Calibration(_name, _val, _unit, _desc) {
    Mylog("Hello, run_Calibration(name="+_name+", value="+_val+", unit="+_unit+", desc="+_desc+")");
    oSensorShow(_name, _val, _unit, _desc);
}

    function startDev() {
        Mylog("startDev()");
        switch(oUartMode) {
            case oUartModeOptions.oSensor:
            case oUartModeOptions.oSensorWave:
            case oUartModeOptions.oSensorList:
                _isFound=false;
                curSensorName=null;
                isCurPanelNo0=true;
                _curColor1="#ff0000";
                _curColor2="#ff0000";
                if(oha_config.simVirtualDevice) {
                    oha_api.ApiCmdWr("04:01:07:55:AA:08:64:78:14:0A");    // Send oha_http string
                    setTimeout(function() {oha_api.ApiCmdWr("04:01:08:00:55:AA:08:64:78:12:0A")}, 500);
                }
                else {
        //            oha_api.ApiCmdWr("04:01:07:55:AA:08:64:78:12:0A");      // Send oha_sensor string
                }
                break;
            case oUartModeOptions.oVapor:
                powerOn();
                if(isUltraSonicMode()){      // UltraSonic
                    var _strIdx=parseInt($(".levelMarker").attr("value"));
                    var _str=strMapTable[_strIdx-1].toString(16);
                    Mylog("ultrasonic with str="+_str)
    //                oha_api.ApiCmdWr("04:01:01:00");
                    oha_api.ApiCmdWr("04:01:08:00:55:AA:01:"+_str+":00:00:0A");
                } else {        // Vaporizer
    //                oha_api.ApiCmdWr("04:01:01:00");
                    Mylog("vaporize")
                    oha_api.ApiCmdWr("04:01:08:00:55:AA:02:01:00:00:0A");
                }
                break;
            default:
                break;
                        }
    }
    
    
    function stopDev(){
        oha_api.ApiCmdWr("04:01:00");
        passCount=0;
    }

function hexAddPadding(h, padding) {
    var hex=h;
    if(hex.length<padding) {
        hex="0"+hex;
    }
    return hex;
}

function OHA_RunErr(_id, _errMsg) {
	if(_id==DeviceId) {
		alert("USB連線中斷, 請檢查您的USB接頭是否接觸不良");
		OHA_DevOff(_id);
	}
}

function OHA_UI() {
    oha_api.runOhaCmd("oha://bodySize_full");
	$("#main").show();
    $("#bottomView").hide();
    oha_api.cookieWrite(cookieOptions.uiType.key, cookieOptions.uiType.options.normal);
}

function show_tag() {
    $("#main").hide();
    $("#bottomView").show();
    var _w=$(window).width();
    var _h=$(window).height();
    if(_h>_w) {
        var _r=Math.ceil((_w*20)/_h);
        oha_api.runOhaCmd("oha://bodySize_bottomBar_"+_r);
    }
    oha_api.cookieWrite(cookieOptions.uiType.key, cookieOptions.uiType.options.bottom);
}


function powerOn() {
//    powerOff();
    oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
    oha_api.ApiCmdWr("02:01:00:01:00:00:AA")
    setTimeout(function(){
        oha_api.ApiCmdWr("02:01:00:05:00:00:AA")
		if(isFast) {
			oha_api.ApiCmdWr("04:06:AA")
		}
    }, 100);
	SimpleProtocol.powerOn(true);
//    if(oUartMode==oUartModeOptions.oVapor){
//        Mylog("poweron on oVaport/UltraSonic mode")
//        if(isUltraSonicMode()){      // UltraSonic
//            var _lvl=parseInt($("#oVaporStrCtrl .levelMarker").attr("value"));
//            var _str=strMapTable[_lvl-1].toString(16);
////            Mylog("oVapor, str="+_str);
//            oha_api.ApiCmdWr("04:01:08:00:55:AA:01:"+_str+":00:00:0A");
//        } else {        // Vaporizer
//            oha_api.ApiCmdWr("04:01:08:00:55:AA:02:01:00:00:0A");
//        }
//    }
//    oha_api.runOhaCmd("oha://polling_off");
}

function powerOff() {
	console.log("poweroff");
//    oha_api.ApiCmdWr("04:01:00");
//    oha_api.ApiCmdWr("04:04");
    if(oUartMode==oUartModeOptions.oVapor){
        if(isUltraSonicMode()) {
            oha_api.ApiCmdWr("04:01:08:00:55:AA:01:00:00:00:0A");
        }
        else {      // oVapor
            oha_api.ApiCmdWr("04:01:08:00:55:AA:02:00:00:00:0A");
        }
    }
    oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
    oha_api.ApiCmdWr("02:01:00:05:00:00:55")
	if(isFast) {
		oha_api.ApiCmdWr("04:06:55")
	}
	SimpleProtocol.powerOn(false);
//	SimpleProtocol.reset();
}

var c0xd=String.fromCharCode(0x0d);

function errorInput(msg){
   alert(msg)
}

function autospace(obj){
    Mylog("autospace");
//	$("body").append("<div>"+words+"</div>");
    if(_inputMode!=modeHex) {
        return;
    }
	inp="#"+$(obj).attr("id");

	words=$(obj).val();	
	allword=words.split(" ");
    lastword=allword[allword.length-1];
}

function isNumberKey(evt){
//    Mylog("isNumberKey");
    if(_inputMode!=modeHex) {
        return true;
    }
    var charCode = (evt.which) ? evt.which : event.keyCode
    var contect=String.fromCharCode(charCode)    
    //Mylog(charCode)
   
//     var patt=new RegExp("["+c0xd+"0-9a-fA-F]")
     var patt=new /[ 0-9a-fA-F]/;
  

    if(patt.test(contect) || charCode==32){
    //	 Mylog(contect)
        return  true;
    }else{
        errorInput("Error! input Hex number separate with space!");
        return false;
	}
}

var _inList;
function sendHex(_inList) {
    if(_inList.length==0) {
        return;
    }

//    $("#outputPanel").append("<div>"+"TX : "+inStr+"</div>");
    if(oha_config.isTestMode) {
        var _throughPut=setInterval(function() {
//            Mylog('send('+_inList[0]+')');
            sendTxCmdHex(_inList);
            var _temp=parseInt(_inList[0], 16);
            _temp=(_temp+1==256)?0:_temp+1;
            _inList[0]=_temp.toString(16);
        }, 200);
        var _start = new Date().getTime(); 
        var _count1s=setInterval(function() {
            var _curTime=new Date().getTime();
            Mylog("_count1s");
           if((_curTime-_start) >=1000) {
                alert('_byteCount='+_byteCount);
                clearInterval(_throughPut);
                clearInterval(_count1s);
            }
        }, 100);
    }
    else {
        sendTxCmdHex(_inList);
    }
}

function selectAscii(){
//  if(_inputMode!=modeAscii) {
//      $("#inputAreaX").val("");
//  }
  $(this).find("rect").attr("stroke", "#ffffff");
  $(this).find("text").attr("fill", "#ffffff");
  $("#asciiSel").show();
  $("#hexSel").hide();
//  $("#hexText").find("rect").attr("stroke", "#808080");
//  $("#hexText").find("text").attr("fill", "#808080");
//      $("#inputAreaX").prop("readonly", false);
  _inputMode=modeAscii;
}

function selectHex() {
//     if(_inputMode!=modeHex) {
//          $("#inputAreaX").val("");
//      }
      $(this).find("rect").attr("stroke", "#ffffff");
      $(this).find("text").attr("fill", "#ffffff");
      $("#hexSel").show();
      $("#asciiSel").hide();
//      $("#asciiText").find("rect").attr("stroke", "#808080");
//      $("#asciiText").find("text").attr("fill", "#808080");
//      $("#inputAreaX").prop("readonly", true);
      _inputMode=modeHex;
}

function sendTxCmdHex(inList) {
    var _out="04:01:"+inList.length.toString(16);
//    var _out="04:01";
    for(var i=0;i<inList.length;i++) {
        _out+=":"+inList[i];
    }
    if(oha_config.debug_mode){
        Mylog("send cmd:("+_out+")")
    }
//    else {
//        Mylog("send cmd:("+_out+")")
//    }
//    oha_api.runOhaCmd(_out);
    oha_api.ApiCmdWr(_out);
//    window.location.href=_out;
}

function sendRxCmd() {
    var _stusStr=oha_api.ApiCmdRd("04:03:02");
    if(typeof _stusStr == "undefined") {
        return
    }
    var uartStus=_stusStr.split(":");
    var rxCount=parseInt(uartStus[1], 16);
    if(rxCount>0) {
        var _ret=oha_api.ApiCmdRd("04:02:"+rxCount.toString(16));
        var recvList=_ret.split(':');
        var retdata="";
        for(var i=0;i<recvList.length;i++) {
            retdata+=recvList[i]+" ";
        }
        insertOutData("RX : "+retdata);
    }
}

function sendAscii(_in) {
    if(oha_config.debug_mode){
        Mylog("sendAscii");
    }
    var inStr=_in;
//    inStr=inStr.replace(/\s/g, "&nbsp");
    if(inStr.length==0) {
        return;
    }
    _cmdIdx=0;
    var _data="";
    for(var i=0;i<inStr.length;i++) {
        _data+=":"+inStr.charCodeAt(i).toString(16);
        _cmdIdx++;
        if((i%8==7)||(i==inStr.length-1)) {
            oha_api.ApiCmdWr("04:01:0"+_cmdIdx+_data);
            _cmdIdx=0;
            _data="";
        }
    }
}

function sendBaudrate(_br, _mode) {
    var n=parseInt(_br);
    var _baud=1;
//    Mylog('sendBaudrate('+_br+':'+_mode+')')
    switch(n) {
        case 9600:
            _baud=0;
            break;
        case 19200:
            _baud=1;
            break;
        case 38400:
            _baud=2;
            break;
        case 57600:
            _baud=3;
            break;
        case 115200:
            _baud=4;
            break;
    }
    if(_mode==null) {
        oha_api.ApiCmdWr("04:00:"+_baud);
    }
    else {
        switch(_mode) {
            case "passive":
                oha_api.ApiCmdWr("04:00:"+_baud+":00");
                break;
            case "active1":
                oha_api.ApiCmdWr("04:00:"+_baud+":01:"+intrDataNo.toString(16));
                break;
            case "active2":
                oha_api.ApiCmdWr("04:00:"+_baud+":02:"+intrDataNo.toString(16));
                break;
        }
    }
}


	function setConfig() {
		var n=ouart_config.baudRate;
		var _dSize=ouart_config.uartSize;
		var _baud=0;
        switch(n) {
            case 9600:
                _baud=0;
                break;
            case 19200:
                _baud=1;
                break;
            case 38400:
                _baud=2;
                break;
            case 57600:
                _baud=3;
                break;
            case 115200:
                _baud=4;
                break;
        }
		switch(ouart_config.uartMode) {
			case "passive":
				oha_api.ApiCmdWr("04:00:"+_baud+":00");
				break;
			case "active1":
				oha_api.ApiCmdWr("04:00:"+_baud+":01:"+_dSize.toString(16));
				break;
			case "active2":
				oha_api.ApiCmdWr("04:00:"+_baud+":02:"+_dSize.toString(16));
				break;
			case "passive2":
				oha_api.ApiCmdWr("04:00:"+_baud+":03:"+_dSize.toString(16));
				break;
		}
	}
//    function setConfig(_br, _mode, _dSize) {
//        var n=parseInt(_br);
//        var _baud=1;
//    //    Mylog('sendBaudrate('+_br+':'+_mode+')')
//        switch(n) {
//            case 9600:
//                _baud=0;
//                break;
//            case 19200:
//                _baud=1;
//                break;
//            case 38400:
//                _baud=2;
//                break;
//            case 57600:
//                _baud=3;
//                break;
//            case 115200:
//                _baud=4;
//                break;
//        }
//        if(_mode==null) {
//            oha_api.ApiCmdWr("04:00:"+_baud);
//        }
//        else {
//            switch(_mode) {
//                case "passive":
//                    oha_api.ApiCmdWr("04:00:"+_baud+":00");
//                    break;
//                case "active1":
//                    oha_api.ApiCmdWr("04:00:"+_baud+":01:"+_dSize.toString(16));
//                    break;
//                case "active2":
//                    oha_api.ApiCmdWr("04:00:"+_baud+":02:"+_dSize.toString(16));
//                    break;
//                case "passive2":
//                    oha_api.ApiCmdWr("04:00:"+_baud+":03:08");
//                    break;
//            }
//        }
//    }

    
function modeSelClickHandler(_selector) {
//    $(".blackbg").show();
//    Mylog('modeSelClickHandler');
    var _mode=$(_selector).find("text").text();
    if(_mode=="POLL") {
        $(_selector).find("text").text("INTR");
        $("#ModeSel").trigger('modeChange', [true, opMode]);
        clearInterval(pollIntv);
    }
    else {
        $(_selector).find("text").text("POLL");
        $("#ModeSel").trigger('modeChange', [false, opMode]);
        pollIntv=setInterval(function(){sendRxCmd()}, parseInt($("#intvTxt text").text()));
    }
    oha_api.cookieWrite("uartMode", $(_selector).find("text").text());
    Mylog("write uartMode="+$(_selector).find("text").text());
    GetConfig();
}

function loadJSON() {
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
//      document.getElementById("demo").innerHTML =
//      this.responseText;
        var _config=JSON.parse(this.responseText);
        JSON.stringify(_config);
        Mylog("loadJSON="+JSON.stringify(_config));
    }
  };
  xhttp.open("GET", "oha_controller_options.txt", true);
  xhttp.send();
}

function setLoopValue() {
    var _intv=parseInt($("#loopIntvValue").val());
    var _count=parseInt($("#loopCountValue").val());
    var _dataMode=$("#loopDataModeNo").val();
    var _data=parseInt($("#dataValue").val(), 16);
    if((_count<256)){
        alert("Count value out of range(<1000)");
        $("#loopCountValue").focus();
    }
    else {
        $(".loopSettings").hide();
        $("#loopBackMode").css({"z-index":"999"});
//        $(".loopBackMode").addClass("itemHide");
        $(".setMenuClass").addClass("itemHide");
        $(".subMenu").addClass("itemHide");
        // Set the value
//        $("#itemLoopBack .loopBackEn .loopSetValue").text(" "+_intv+"ms/"+_count+"times");
        oUartTerm.setLoopParam(_intv, _count, _dataMode, _data);
//        if(!$("#itemLoopBack .normal").hasClass("itemHide")) {
//            oUartTerm.LoopTest(false);
//        }else if(!$("#itemLoopBack .mode0").hasClass("itemHide")){
//            oUartTerm.LoopTest(true, 0);
//        }else if(!$("#itemLoopBack .mode1").hasClass("itemHide")){
//            oUartTerm.LoopTest(true, 1);
//        }else if(!$("#itemLoopBack .mode2").hasClass("itemHide")){
//            oUartTerm.LoopTest(true, 2);
//        }else {
//            oUartTerm.LoopTest(true, 3);
//        }
    }
}

function debugView() {
//    if(oUartStus!==oUartStusOptions.UnCounnected) {
//        oUartTerm.devPlugIn();
//    }
//    if(oUartStus!==oUartStusOptions.UnCounnected) {
//        powerOff();
//    }
    $("#debugDiv").show();
//    $("#titleIconR").removeClass("itemHide");
	$("#oSensorDiv").hide();
//	$("#unConnectedDiv .mask_area").hide();
    $("#oha_min").addClass("itemHide");
    $("#oha_update").addClass("itemHide");
    $("#topDiv").addClass("fullSize");
//	$("#topDiv.fullSize").css("left");
    $("#title_area").css({"height":"6%"});
    oUartTerm.redraw();
    oha_api.setUiAlpha(1.0);
    switch(oUartMode){
        case oUartModeOptions.Terminal:
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.Terminal);
            break;
        case oUartModeOptions.LoopBack0:
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.LoopBack0);
            break;
        case oUartModeOptions.LoopBack1:
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.LoopBack1);
            break;
        case oUartModeOptions.LoopBack2:
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.LoopBack2);
            break;
        case oUartModeOptions.LoopBack3:
            oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.LoopBack3);
            break;
        default:
            break;
                    }
}

function oSensorView() {
    if(oUartStus!==oUartStusOptions.UnCounnected) {
        switch(oUartMode) {
            case oUartModeOptions.oSensor:
            case oUartModeOptions.oSensorWave:
            case oUartModeOptions.oSensorList:
                break;
            default:
                powerOff();
        //        setConfig("57600", "active2", 8);
				setConfig();
//				if(isFast) {
//					setConfig("19200", "passive2");
//				}
//				else {
//	                setConfig("9600", "active2", 8);
//
//				}
                if($("#powerOnNormal").css("display")!=="none") {
                    powerOn();
                    startDev();
                }
                break;
                        }
    }
    setPanelCustomized(false);
    oUartMode=oUartModeOptions.oSensor;
    oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oSensor)
    $("#debugDiv").hide();
//    $("#titleIconR").addClass("itemHide");
    $("#topDiv").removeClass("fullSize");
    $("#oVaporDiv").hide();
    $("#oSensorDiv").show();
	$("#panel_area").show();
    $(".general_view").show();
	$(".panel_block").children().hide();
	$(".panel_block .general_view").show();
//	$(".panel_block .chart_view").hide();
//	$(".panel_block .list_view").hide();
	
    $("#oha_min").removeClass("itemHide");
	if(isDevReady) {
		$("#oha_update").removeClass("itemHide");
	}
    oha_api.setUiAlpha(0.8);
//    $("#itemLoopBack").hide();
    $("#title_area").css({"height":"8%"});
//    $("#title_content").show();
//    $("#title_contentx").hide();
    $("#title_content").text("OHA Controller")
}

function oSensorViewWave() {
    if(oUartStus!==oUartStusOptions.UnCounnected) {
        switch(oUartMode) {
            case oUartModeOptions.oSensor:
            case oUartModeOptions.oSensorWave:
            case oUartModeOptions.oSensorList:
                break;
            default:
                powerOff();
        //        setConfig("57600", "active2", 8);
//                setConfig("9600", "active2", 8);
				setConfig();
                if($("#powerOnNormal").css("display")!=="none") {
                    powerOn();
                    startDev();
                }
                break;
                        }
    }
    setPanelCustomized(false);
    $("#debugDiv").hide();
//    $("#titleIconR").addClass("itemHide");
    $("#topDiv").removeClass("fullSize");
    $("#oVaporDiv").hide();
    $("#oSensorDiv").show();
	$("#panel_area").show();
	$(".panel_block").children().hide();
//    $(".general_view").hide();
	$(".panel_block .chart_view").show();
//	$(".panel_block .list_view").hide();
    $(".ui_panel container .customize _jsContainer").hide();
    oSensorWave.forEach(function(_obj){
        _obj.init();
		_obj.Redraw();
    })
//	oSensorWave.init();
    $("#oha_min").removeClass("itemHide");
    $("#oha_update").removeClass("itemHide");
    oha_api.setUiAlpha(0.8);
//    $("#itemLoopBack").hide();
    $("#title_area").css({"height":"8%"});
//    $("#title_content").show();
//    $("#title_contentx").hide();
    $("#title_content").text("OHA Controller")
    oUartMode=oUartModeOptions.oSensorWave;
    oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oSensorWave)
}

function oSensorViewList() {
    if(oUartStus!==oUartStusOptions.UnCounnected) {
        switch(oUartMode) {
            case oUartModeOptions.oSensor:
            case oUartModeOptions.oSensorWave:
            case oUartModeOptions.oSensorList:
                break;
            default:
                powerOff();
        //        setConfig("57600", "active2", 8);
//                setConfig("9600", "active2", 8);
				setConfig()
                if($("#powerOnNormal").css("display")!=="none") {
                    powerOn();
                    startDev();
                }
                break;
                        }
    }
    setPanelCustomized(false);
    $("#debugDiv").hide();
//    $("#titleIconR").addClass("itemHide");
    $("#topDiv").removeClass("fullSize");
    $("#oVaporDiv").hide();
    $("#oSensorDiv").show();
	$("#panel_area").show();
	$(".panel_block").children().hide();
//    $(".general_view").hide();
//	$(".panel_block .chart_view").hide();
	$(".panel_block .list_view").show();
    oSensorList.forEach(function(_obj){
        _obj.AutoScrollDown();
    })
//	oSensorList.AutoScrollDown();
    $("#oha_min").removeClass("itemHide");
    $("#oha_update").removeClass("itemHide");
    oha_api.setUiAlpha(0.8);
//    $("#itemLoopBack").hide();
    $("#title_area").css({"height":"8%"});
//    $("#title_content").show();
//    $("#title_contentx").hide();
    $("#title_content").text("OHA Controller")
    oUartMode=oUartModeOptions.oSensorList;
    oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oSensorList)
}

function oVaporView() {
//    Mylog("oVaporView")
    if(oUartStus!==oUartStusOptions.UnCounnected) {
        powerOff();
//        setConfig("9600", "active2", 8);
		setConfig()
    }
    $("#debugDiv").hide();
    $("#topDiv").removeClass("fullSize");
    $("#oSensorDiv").hide();
    $("#oVaporDiv").show();
    $("#title_area").css({"height":"8%"});
    $("#oha_min").removeClass("itemHide");
    $("#oha_update").removeClass("itemHide");
    oha_api.setUiAlpha(0.8);
    oUartMode=oUartModeOptions.oVapor;
    if(typeof oha_timer!="undefined") {
        oha_timer.redraw();
    }
//    Mylog("oVaporView, write cookie, key="+cookieOptions.uiMode.key+", mode="+cookieOptions.uiMode.options.oVapor)
    oha_api.cookieWrite(cookieOptions.uiMode.key, cookieOptions.uiMode.options.oVapor)
}

function isUltraSonicMode() {
    return !($("#modeOvapor .modeUltraSonic").hasClass("itemHide"));
}

function oSensorSim(_stus) {
    if(typeof _stus=="undefined") {
        _stus=0;
    }
    var value1 = Math.round(Math.random()*100)/100+20;
    var value2 = Math.round(Math.random()*100)/10+80;
    if(isoSensorSim) {
        switch(_stus) {
            case 0:
                oSensorShow("oSensor0", value1, "unit0", "oSensor0 simulation");
                _stus=1;
                break;
            default:
                oSensorShow("oSensor1", value2, "unit1", "oSensor1 simulation");
                _stus=0;
                break;
                    }
        setTimeout(function(){oSensorSim(_stus)}, 500);
    }
}

    function setLoopTest0() {
        oUartMode=oUartModeOptions.LoopBack0;
        $("#loopBackMode").css({"z-index":"998"});
        $(".loopSettings").show();
//        $("#loopIntvValue").focus();
        oUartTerm.LoopTest(true, 0);
    }
    
    function setLoopTest1() {
        oUartMode=oUartModeOptions.LoopBack1;
        $("#loopBackMode").css({"z-index":"998"});
        $(".loopSettings").show();
//        $("#loopIntvValue").focus();
        oUartTerm.LoopTest(true, 1);
    }
    
    function setLoopTest2() {
        oUartMode=oUartModeOptions.LoopBack2;
        $("#loopBackMode").css({"z-index":"998"});
        $(".loopSettings").show();
//        $("#loopIntvValue").focus();
        oUartTerm.LoopTest(true, 2);
    }
    
    function setLoopTest3() {
        oUartMode=oUartModeOptions.LoopBack3;
        $("#loopBackMode").css({"z-index":"998"});
        $(".loopSettings").show();
//        $("#loopIntvValue").focus();
        oUartTerm.LoopTest(true, 3);
    }
    
function oSensorViewCalibrate() 
{
	console.log("oSensorViewCalibrate() ");
//    if(oUartStus!==oUartStusOptions.UnCounnected) {
//        switch(oUartMode) {
//            case oUartModeOptions.oSensor:
//            case oUartModeOptions.oSensorWave:
//            case oUartModeOptions.oSensorList:
//			case oUartModeOptions.oSensorCalibrate:
//                break;
//            default:
//                powerOff();
//        //        setConfig("57600", "active2", 8);
//                setConfig("9600", "active2", 8);
//                if($("#powerOnNormal").css("display")!=="none") {
//                    powerOn();
//                    startDev();
//                }
//                break;
//                        }
//    }
    setPanelCustomized(false);
    $("#debugDiv").hide();
//    $("#titleIconR").addClass("itemHide");
    $("#topDiv").removeClass("fullSize");
    $("#oVaporDiv").hide();
    $("#oSensorDiv").show();
	$("#panel_area").show();
	$(".panel_block").children().hide();
//    $(".general_view").hide();
//	$(".panel_block .chart_view").hide();
//	$(".panel_block .list_view").hide();
	$(".panel_block .calibrate_config").show();
    oSensorCalibrateCtl.forEach(function(_obj){
        _obj.SwitchTo(1);
    })
//	oSensorList.AutoScrollDown();
    $("#oha_min").removeClass("itemHide");
    $("#oha_update").removeClass("itemHide");
    oha_api.setUiAlpha(0.8);
//    $("#itemLoopBack").hide();
    $("#title_area").css({"height":"8%"});
//    $("#title_content").show();
//    $("#title_contentx").hide();
    $("#title_content").text("OHA Controller")
    oUartMode=oUartModeOptions.oSensorCalibrate;
}
    

//    var optionsMain=React.createClass(
//        {
//			handleClick: function(){
//				console.log("handleClick");
//				$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//			}, 
//            render: function() {
//				var _optBody=['div', {className:"optBody subMenuContent"}];
//				for(var i=0;i<this.props.item.length;i++) {
//					var itemId=this.props.item[i].name;
//					var message=this.props.item[i].message;
//					_optBody[i+2]=React.createElement(optionsTextItem, {itemId: itemId, isActive: this.props.item[i].isActive, message: message, click:this.props.item[i].onClick});
//				}
//                return React.createElement('div', {id: this.props.idName, className:"optMain subMenuContainer"},		
//					React.createElement('div', {className:"optTitle subMenuTitle middleContainer"}, 
//							React.createElement('div', {className:"middleText"}, 
//								React.createElement('h3', {className:"optTitleText"}, this.props.title))
//							),
//                    React.createElement.apply(React, _optBody),
//					React.createElement('div', {onClick: this.props.endItem.onClick, className:"optEnd subMenuTitle middleContainer"}, 
//							React.createElement('div', {className:"middleText"}, 
//								React.createElement('h3', {className:"optTitleText"}, this.props.endItem.title)
//						   	)
//					)
//            )}
////                return React.createElement('div', {id: this.props.idName, className:"optMain subMenuContainer"},		
////					React.createElement('div', {className:"optTitle subMenuTitle middleContainer"}, 
////							React.createElement('div', {className:"middleText"}, 
////								React.createElement('h3', {className:"optTitleText"}, this.props.title))
////							),
////                    React.createElement('div', {className:"optBody subMenuContent"}, 
////						React.createElement(optionsTextItem, {itemId: this.props.item1Name, message: "Fixed view mode"}), 
////						React.createElement(optionsTextItem, {itemId: this.props.item2Name, message: "Show update mode"}), 
////									   ),
////					React.createElement('div', {onClick: this.handleClick, className:"optEnd subMenuTitle middleContainer"}, 
////							React.createElement('div', {className:"middleText"}, 
////								React.createElement('h3', {className:"optTitleText"}, "BACK"))
////							),
////            )}
//        }
//    );
//
//    var optionsTextItem=React.createClass(
//        {
//            render: function() {
//				var _className="optItem subMenuItem middleContainer";
//				if(this.props.isActive) {
//					_className+=" itemActive";
//				}
//               return React.createElement('div', {id:this.props.itemId, onClick:this.props.click, className:_className}, 
//							React.createElement('h3', {className: "optItemText leftMidText"}, this.props.message)
//										  )
//					}
////             render: function() {
////                return React.createElement('div', {id:this.props.itemId, onClick:this.closeOptionMain, className:"optItem subMenuItem middleContainer"}, 
////							React.createElement('h3', {className: "optItemText leftMidText"}, this.props.message)
////										  )
////					}
//       }
//    );
//
////var oSensorOptElement=React.createElement(optionsMain, {idName:"oSensorShowOptions", title:"oSensor Show Options", 
////														item1Name:"oSensorOpt0", item2Name:"oSensorOpt1"});
//function createMenuOptions(_id, _opt) {
//	var oSensorOptElement=React.createElement(optionsMain, _opt);
////	ReactDOM.render(oSensorOptElement, document.getElementById('subMenuDiv'));
//	ReactDOM.render(oSensorOptElement, document.getElementById(_id));
//	
//}

//var oSensorOptElement=React.createElement(optionsMain, {idName:"oSensorShowOptions", 
//														title:"oSensor Show Options", 
//														item: [
//															{
//																name: "oSensorOpt0", 
//																isActive: oSensorConfig.isFixedShow, 
//																message: "Fixed view mode", 
//																onClick: function() {
//																	console.log("oSensorOpt0 click");
//																	$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//																	oSensorConfig.isFixedShow=true;
//																}
//															},
//															{
//																name: "oSensorOpt1",
//																isActive: !oSensorConfig.isFixedShow, 
//																message: "Show update mode", 
//																onClick: function() {
//																	console.log("oSensorOpt1 click");
//																	$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//																	oSensorConfig.isFixedShow=false;
//																}
//															},
////															{
////																name: "oSensorOpt2",
////																message: "Test mode", 
////																onClick: function() {
////																	console.log("oSensorOpt2 click");
////																}
////															}
//														], 
//														endItem:{
//															title:"BACK", 
//															onClick:function() {
//															console.log("endItem is clicked");
//																	$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//															}
//														}
//													   });



var newmode=0;	
jQuery(document).ready(function(){
    oha_timer=$("#timerDiv").oha_timer({
        mode:"countup", 
//        mode:$.fn.oha_timer.ModeOptions.countup, 
    //    maxTime:-1, 
    //    minTime:1,        
//        setTime:80,
    //    stepTime:60,
        timeup:function() {
        }, 
    });
    oha_api.getUiVersion().done(function(_ver){
        Mylog("UiVersion="+_ver);
        $(".uiVer").text(_ver);
    });
  $("#asciiText").click(function() {
      selectAscii();
  });
 

//	$("#oSensorOpt0").click(function(){
//		closeOptionMain();
//	})
//	
//	$("#oSensorOpt1").click(function(){
//		closeOptionMain();
//	})
	
	
  $("#hexText").click(function() {
      selectHex();
//      if(_inputMode!=modeHex) {
//          $("#inputAreaX").val("");
//      }
//      $(this).find("rect").attr("stroke", "#ffffff");
//      $(this).find("text").attr("fill", "#ffffff");
//      $("#hexSel").show();
//      $("#asciiSel").hide();
//      $("#asciiText").find("rect").attr("stroke", "#808080");
//      $("#asciiText").find("text").attr("fill", "#808080");
////      $("#inputAreaX").prop("readonly", true);
//      _inputMode=modeHex;
  });

    $(".blackbg").each(function(){
        this.addEventListener("touchstart", function(e){
            blackBgClickH=setTimeout(function() {
                $(".blackbg").hide();
            }, 2000);
        });
    });

    $(".blackbg").each(function(){
        addEventListener("touchend", function(e){
            clearTimeout(blackBgClickH);
        });
    });
	
$("#BaudSel").click(function(){
    $(".blackbg").show();
    $("#baudMenu").show();
});

	
	$("#helpIcon").click(function(){
		$("#titleIconR").toggleClass("isShow");
		if($("#titleIconR").hasClass("isShow")) {
			helpManager.showHelp(true);
		}
		else {
			helpManager.showHelp(false);
		}
	});
//$("#ModeSel").click(function(){
////    Mylog("$('#ModeSel').click entry0")
//    modeSelClickHandler("#ModeSel");
//})

//$("#ModeSel").on('modeChange', function(_event, _isEnable, _mode) {
////    Mylog("modeChange, _isEnable="+_isEnable);
//    isInterruptEnable=_isEnable;
//    if(_isEnable) {
//        $("#rxByteNo").show();
//        $("#pollIntvSet").hide();
//    }
//    else {
//        $("#rxByteNo").hide();
//        $("#pollIntvSet").show();
//    }
//    sendBaudrate($("#BaudSel").find("text").text(), _mode);
//});

$("#addIntv").click(function() {
    var _cur=parseInt($("#intvTxt text").text());
    if(_cur<1000) {
        _cur+=50;
        $("#intvTxt text").text(_cur)
        oha_api.cookieWrite("pollingIntv", ""+_cur);
    }
})

$("#subIntv").click(function() {
    var _cur=parseInt($("#intvTxt text").text());
    if(_cur>100) {
        _cur-=50;
        $("#intvTxt text").text(_cur)
        oha_api.cookieWrite("pollingIntv", ""+_cur);
    }
})

$(".brItem").each(function(i){
            $(this).click(function(){
                var _newBr=$(this).find("text").text();
                $("#BaudSel").find("text").text(_newBr);
//                alert($(this).find("text").html());
                $(".blackbg").hide();
                $("#baudMenu").hide();
                baudRate=_newBr;
//                $.cookie('baudRate', _newBr, {expires:365});
                oha_api.cookieWrite('baudRate', ''+_newBr);
                sendBaudrate(_newBr, opMode);
            });
    });	
    
//    $("#rxIntSelList").children().each(function(i) {
//        $(this).click(function() {
//            var _n=$(this).find("text").text();
//            $("#intDataNo").text(_n)
//            intrDataNo=parseInt(_n);
//            oha_api.cookieWrite('intrDno', ''+_n);
//            setControl($("#BaudSel").find("text").text(), true, intrDataNo);
//            $("#rxIntSelListSvg").fadeOut(500);
//            $(".blackbg").hide();
//        });
//    });


$("#oha_min").click(function(){
	show_tag();
})

$("#xBtnEnlarge").click(function(){
//    Mylog("xBtnEnlarge is clicked")
    OHA_UI();
})

$("#settingsIcon").click(function() {
    Mylog("settingsIcon click")
//    $(".uiVer").text(oha_api.uiVersion);
	$(".setMenuClass").removeClass("itemHide");
	$("#subMenuDiv").addClass("itemHide");
//	$("#setMenuTitleText").css({'font-size':sf*0.05+'px', 'line-height':$("#setMenuTitle").height()+'px'});
	$("#setMenuTitleText").css({'line-height':$("#setMenuTitle").height()+'px'});
	$("#backBtnText").css({'line-height':$("#setMenuEnd").height()+'px'});
    

});
    
    $("#titleImgR").click(function(){
//        $("#titleIconR").addClass("itemHide");
        $(this).addClass("itemHide");
		oha_api.DevPlugOut();
		oha_api.runOhaCmd("oha://updateUi");
    })

//    $("#titleIconR").click(function() {
//        $(this).toggleClass("fullSize");
//        if($(this).hasClass("fullSize")) {
//            $("#dbg_large").hide();
//            $("#dbg_small").show();
//        }
//        else {
//            $("#dbg_large").show();
//            $("#dbg_small").hide();
//        }
//        $("#topDiv").toggleClass("fullSize");
//        $("#titleIconL").css({"width":$("#title_area").height()+"px"});
//        $("#titleIconR").css({"width":$("#title_area").height()+"px"});
//    });
    
    $("#backBtn").click(function() {
        Mylog("back button is pressed")
	   $(".setMenuClass").addClass("itemHide");
//        if(!$(".loopBackEn.setItemIcon").hasClass("itemHide")) {
//            oUartTerm.startLoopTest();
//        }
    });

$("#submitBtn").click(function(){
    isFirstIntr=true;
    isTestFail=false;
    passCount=0;
    if(_inputMode==modeHex) {
        sendHex();
    }
    else if(_inputMode==modeAscii) {
        sendAscii();
    }
    else {
        Mylog("input mode="+_inputMode);
    }
});
    

var _isSoundOn=true;
$("#itemSound").click(function() {
	_isSoundOn=!_isSoundOn;
	if(_isSoundOn) {
		$(this).find(".setItemIcon").css("background-image", "url('files/sound_on.png')");
		$(this).find(".setItemMsg h3").text("Alert sound on");
        oha_api.runOhaCmd("oha://loudness_-2")
	}
	else {
		$(this).find(".setItemIcon").css("background-image", "url('files/sound_off.png')");
		$(this).find(".setItemMsg h3").text("Alert sound off");
        oha_api.runOhaCmd("oha://loudness_-1")
	}
});

var _isPowerMode=true;
$("#itemPowerMode").click(function() {
	_isPowerMode=!_isPowerMode;
	if(_isPowerMode) {
		$(this).find(".setItemIcon").css("background-image", "url('files/light_off.png')");
		$(this).find(".setItemMsg h3").text("Power saving mode on");
		var oha_power=($(".powerbtn.active").css("display")!="none");
		if(oha_power) {
			powerSaveOn();
			$(".setMenuClass").addClass("itemHide");
            oha_api.runOhaCmd("oha://lightness_-1");
		}
	}
	else {
		$(this).find(".setItemIcon").css("background-image", "url('files/light_on.png')");
		$(this).find(".setItemMsg h3").text("Power saving mode off");
		if(oha_power=="on") {
            oha_api.runOhaCmd("oha://lightness_-2");
		}
	}
});

var _isPowerRate=90;
$("#itemPowerSet").click(function() {
	if(_isPowerRate==90) {
		_isPowerRate=50;
	}
	else {
		_isPowerRate=90;
	}
	if(_isPowerRate==90) {
		$(this).find(".setItemIcon").css("background-image", "url('files/light90.png')");
		$(this).find(".setItemMsg h3").text("Power saving rate is 90%");
        oha_api.runOhaCmd("oha://lightness_90");
	}
	else {
		$(this).find(".setItemIcon").css("background-image", "url('files/light50.png')");
		$(this).find(".setItemMsg h3").text("Power saving rate is 50%");
        oha_api.runOhaCmd("oha://lightness_50");
	}
});
    

//    $("#itemDebug").click(function() {
//        if($(this).find(".debug0").eq(0).css("display")=="none") {
//            Mylog("debug mode is enable");
//            debugView();
//            oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.debug)
//        }
//        else {
//            Mylog("debug mode is disable");
//            oSensorView();
//             oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.normal)
//        }
//        $(".setMenuClass").addClass("itemHide");
//    });
    $("#itemOsensor").click(function() {
//        oUartMode=oUartModeOptions.oSensor;
        oSensorView();
//        oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.normal)
        $(".setMenuClass").addClass("itemHide");
		// Tom Test.
//		$("#mask_area").hide();
		// end of Tom
    });
    $("#itemOsensorWave").click(function() {
//        oUartMode=oUartModeOptions.oSensor;
        oSensorViewWave();
//        oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.normal)
        $(".setMenuClass").addClass("itemHide");
		// Tom Test.
//		$("#mask_area").hide();
		// end of Tom
    });
    $("#itemOsensorList").click(function() {
//        oUartMode=oUartModeOptions.oSensor;
        oSensorViewList();
//        oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.normal)
        $(".setMenuClass").addClass("itemHide");
		// Tom Test.
//		$("#mask_area").hide();
		// end of Tom
    });
	$("#itemOsensorOptions").click(function() {
		$("#subMenuDiv").removeClass("itemHide");
		$("#oSensorShowOptions").removeClass("itemHide");
//		document.getElementById('subMenuDiv').innerHTML="";
//		ReactDOM.render(oSensorOptElement, document.getElementById('subMenuDiv'));
//		createMenuOptions('subMenuDiv', 
//				  {idName:"oSensorShowOptions", 
//					title:"oSensor Show Options", 
//					item: [
//						{
//							name: "oSensorOpt0", 
//							isActive: oSensorConfig.isFixedShow, 
//							message: "Fixed view mode", 
//							onClick: function() {
//								console.log("oSensorOpt0 click");
//								$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//								oSensorConfig.isFixedShow=true;
//							}
//						},
//						{
//							name: "oSensorOpt1",
//							isActive: !oSensorConfig.isFixedShow, 
//							message: "Show update mode", 
//							onClick: function() {
//								console.log("oSensorOpt1 click");
//								$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//								oSensorConfig.isFixedShow=false;
//							}
//						},
////															{
////																name: "oSensorOpt2",
////																message: "Test mode", 
////																onClick: function() {
////																	console.log("oSensorOpt2 click");
////																}
////															}
//					], 
//					endItem:{
//						title:"BACK", 
//						onClick:function() {
//						console.log("endItem is clicked");
//								$("#subMenuDiv, .setMenuClass").addClass("itemHide");
//						}
//					}
//		  });
    });
    $("#itemOsensorCalibrate").click(function() {
        oSensorViewCalibrate();
        $(".setMenuClass").addClass("itemHide");
    });

    $("#itemCustomized").click(function() {
        setPanelCustomized(true);
        $(".setMenuClass").addClass("itemHide");
    });
    $("#itemTerminal").click(function() {
        oUartMode=oUartModeOptions.Terminal;
        Mylog("Terminal mode is enable");
        oUartTerm.LoopTest(false);
        debugView();
//        oha_api.cookieWrite(cookieOptions.debugMode.key, cookieOptions.debugMode.options.debug)
        $(".setMenuClass").addClass("itemHide");
    });
    
//    $("#itemLoopBack").click(function() {
//        $(".containerDiv.subMenu").removeClass("itemHide");
//        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
//        oUartTerm.stopLoopTest();
////        if($(this).find(".loopBackEn.setItemIcon").eq(0).hasClass("itemHide")) {
////            Mylog("Loopback mode is enable");
////            $(this).find(".loopBackEn").removeClass("itemHide");
////            $(this).find(".loopBackDis").addClass("itemHide");
//////            $("#itemLoopBackMode").removeClass("itemHide");
//////            setLoopTest0();
////            oha_api.cookieWrite(cookieOptions.loopBack.key, cookieOptions.loopBack.options.mode0);
////        }
////        else {
////            Mylog("Loopback mode is disable");
////            $(this).find(".loopBackEn").addClass("itemHide");
////            $(this).find(".loopBackDis").removeClass("itemHide");
//////            $("#itemLoopBackMode").addClass("itemHide");
////            oUartTerm.LoopTest(false);
////            oha_api.cookieWrite(cookieOptions.loopBack.key, cookieOptions.loopBack.options.no);
////        }
////        $(".setMenuClass").hide();
//    });
    
    $("#itemLoopBackSet").click(function() {
//        debugView();
        $(".containerDiv.subMenu").removeClass("itemHide");
//        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
        $(".loopSettings").show();
    });
    
    $("#itemLoopBackM0").click(function() {
        setLoopTest0();
        debugView();
        $(".setMenuClass").addClass("itemHide");
    });
    
    $("#itemLoopBackM1").click(function() {
//        $(".containerDiv.subMenu").removeClass("itemHide");
//        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
//        oUartTerm.stopLoopTest();
        setLoopTest1();
        debugView();
        $(".setMenuClass").addClass("itemHide");
    });
    
    $("#itemLoopBackM2").click(function() {
//        $(".containerDiv.subMenu").removeClass("itemHide");
//        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
//        oUartTerm.stopLoopTest();
        setLoopTest2();
        debugView();
        $(".setMenuClass").addClass("itemHide");
    });
    
    $("#itemLoopBackM3").click(function() {
//        $(".containerDiv.subMenu").removeClass("itemHide");
//        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
//        oUartTerm.stopLoopTest();
        setLoopTest3();
        debugView();
        $(".setMenuClass").addClass("itemHide");
    });
    
    $("#itemOvapor").click(function() {
        oVaporView();
        $(".setMenuClass").addClass("itemHide");
    });
    
    $("#itemLoopBackMode").click(function() {
        $(".containerDiv.subMenu").removeClass("itemHide");
        $("#loopBackMode.subMenuContainer").removeClass("itemHide");
    });
    
//    $(".loopBackItem.subMenuItem").click(function(){
//        $(".containerDiv.subMenu").addClass("itemHide");
//        $("#loopBackMode.subMenuContainer").addClass("itemHide");
//        $(".setMenuClass").hide();
//    });
    $(".oVapor.incBtn").click(function(){
//        Mylog("incBtn is clicked");
        var _value=parseInt($("#oVaporStrCtrl .levelMarker").attr("value"));
        if(_value==5) {
            return;
        }
        _value++;
        oha_api.cookieWrite(cookieOptions.oVaporStr.key, cookieOptions.oVaporStr.options[_value-1]);
        $("#oVaporStrCtrl .levelMarker").attr("value", _value);
        $("#oVaporStrCtrl .levelMarker .lvlMark").each(function(i){
            if(i<_value) {
                $(this).addClass("lvlOn");
            }
        })
        if(isUltraSonicMode() && (oUartStus==oUartStusOptions.oVaporOn)){      // UltraSonic
            var _str=strMapTable[_value-1].toString(16);
            Mylog("ultrasonic with str="+_str)
            oha_api.ApiCmdWr("04:01:08:00:55:AA:01:"+_str+":00:00:0A");
        }
    });

    $(".oVapor.decBtn").click(function(){
//        Mylog("decBtn is clicked");
        var _value=parseInt($("#oVaporStrCtrl .levelMarker").attr("value"));
        if(_value==1) {
            return;
        }
        _value--;
        oha_api.cookieWrite(cookieOptions.oVaporStr.key, cookieOptions.oVaporStr.options[_value-1]);
        $("#oVaporStrCtrl .levelMarker").attr("value", _value);
        $("#oVaporStrCtrl .levelMarker .lvlMark").each(function(i){
            if(i>=_value) {
                $(this).removeClass("lvlOn");
            }
        })
        if(isUltraSonicMode() && (oUartStus==oUartStusOptions.oVaporOn)){      // UltraSonic
            var _str=strMapTable[_value-1].toString(16);
            Mylog("ultrasonic with str="+_str)
            oha_api.ApiCmdWr("04:01:08:00:55:AA:01:"+_str+":00:00:0A");
        }         
    });
    
    $("#modeOvapor").click(function(){
        if($(this).find(".modeVaporizer").hasClass("itemHide")) {
            $(this).find(".modeVaporizer").removeClass("itemHide");
            $(this).find(".modeUltraSonic").addClass("itemHide");
            oha_api.cookieWrite(cookieOptions.oVaporMode.key, cookieOptions.oVaporMode.options.Vaporizer);
        }
        else {
            $(this).find(".modeVaporizer").addClass("itemHide");
            $(this).find(".modeUltraSonic").removeClass("itemHide");
            oha_api.cookieWrite(cookieOptions.oVaporMode.key, cookieOptions.oVaporMode.options.UltraSonic);
        }
        if(oUartStus==oUartStusOptions.oVaporOn) {
            powerOff();
            startDev();
            oha_timer.stop();
            oha_timer.play();
        }
    });
    
    $("#powerOvapor").click(function(){
        if($(this).find(".powerOff").hasClass("itemHide")) {    // power On to Off
            $(this).find(".powerOff").removeClass("itemHide");
            $(this).find(".powerOn").addClass("itemHide");
            powerOff();
            oUartStus=oUartStusOptions.PowerOff;
            oha_timer.pause();
			$("#oha_update").removeAttr("disabled");
        }
        else {                                                  // power off to on
            $(this).find(".powerOff").addClass("itemHide");
            $(this).find(".powerOn").removeClass("itemHide");
            oha_timer.stop();
            oha_timer.play();
            startDev();
            oUartStus=oUartStusOptions.oVaporOn;
			$("#oha_update").attr("disabled", "disabled");
        }
    });
	
	$("#panel_area").on("touchstart mousedown", function(e){
		console.log("#panel_area touchstart")
//		$(this).addClass("panel_active");
//		if(!isPass) {
//			e.preventDefault();
//		}
//		panelTouchH=setTimeout(function(){
//			isPass=true;
//			panelTouchH=null;
//		}, 1500);
//		e.preventDefault();
//		console.log("panel_area touchstart");
		oSensorConfig.isKeepPanel=true;
//		$("text#oha_title_2_").css("fill", "yellow");
		if(panelShiftH!=null) {
			clearTimeout(panelShiftH);
			panelShiftH=null;
		}
	});
   
//	$("#panel_area").on("touchmove", function(e){
//		console.log("panel_area touchmove")
////		if(panelTouchH!=null) {
////			clearTimeout(panelTouchH);
////			panelTouchH=null;
////		}
////		if(!isPass) {
////			e.preventDefault();
////		}
//	});
   
	$("#panel_area").on("touchend touchcancel mouseup mouseout mouseover", function(e){
//		e.preventDefault();
		console.log("#panel_area touchend/touchcanel");
//		$(this).removeClass("panel_active");
		if(panelShiftH!=null) {
			clearTimeout(panelShiftH);
			panelShiftH=null;
		}
		panelShiftH=setTimeout(function(){
			oSensorConfig.isKeepPanel=false;
//			$("text#oha_title_2_").css("fill", "white");
		}, 3000);
	});
	

   
    function setNormalMode() {
//        $("#title_content").show();
//        $("#title_contentx").hide();
//        $("#title_contentx").text("Terminal Mode");
//        $("#itemLoopBack .normal").removeClass("itemHide");
//        $("#itemLoopBack .looptest").addClass("itemHide");
        oUartTerm.LoopTest(false);
        $(".loopSettings").hide();
        $("#loopBackMode").css({"z-index":"999"});
        $(".loopBackMode").addClass("itemHide");
        $(".setMenuClass").addClass("itemHide");
        $(".subMenu").addClass("itemHide");
    }
    
    $("#loopBackMode .subMenuContent #normalMode").click(function(){
        Mylog("hello, normal mode click")
        setNormalMode();
    });
    
    $("#loopBackMode .subMenuContent #loopBackMode0").click(function(){
        Mylog("hello, loopbBackMode0 click")
        setLoopTest0();
//        oUartTerm.startLoopTest();
    });
    
    $("#loopBackMode .subMenuContent #loopBackMode1").click(function(){
        Mylog("hello, loopbBackMode1 click")
        setLoopTest1();
//        oUartTerm.startLoopTest();
    });
    
    $("#loopBackMode .subMenuContent #loopBackMode2").click(function(){
        Mylog("hello, loopbBackMode2 click")
        setLoopTest2();
//        oUartTerm.startLoopTest();
    });
    
    $("#loopBackMode .subMenuContent #loopBackMode3").click(function(){
        Mylog("hello, loopbBackMode3 click")
        setLoopTest3();
//        oUartTerm.startLoopTest();
    });
    
$("#powerOffBg").click(function() {
	$("#powerOffBg").hide();
    oha_api.runOhaCmd("oha://lightness_-2");
});

	$("#oSensorShowOptions .optBody.subMenuContent #oSensorOpt0").click(function(){
		console.log("oSensorOpt0 click");
		$("#oSensorShowOptions .optBody.subMenuContent .subMenuItem").removeClass("itemActive");
		$(this).addClass("itemActive");
		$("#oSensorShowOptions").addClass("itemHide");
		$("#subMenuDiv, .setMenuClass").addClass("itemHide");
		oSensorConfig.isFixedShow=true;
	});
	
	$("#oSensorShowOptions .optBody.subMenuContent #oSensorOpt1").click(function(){
		console.log("oSensorOpt1 click");
		$("#oSensorShowOptions .optBody.subMenuContent .subMenuItem").removeClass("itemActive");
		$(this).addClass("itemActive");
		$("#oSensorShowOptions").addClass("itemHide");
		$("#subMenuDiv, .setMenuClass").addClass("itemHide");
		oSensorConfig.isFixedShow=false;
	});
	
	$("#oSensorShowOptions .optEnd").click(function(){
		console.log("endItem is clicked");
		$("#oSensorShowOptions").addClass("itemHide");
		$("#subMenuDiv, .setMenuClass").addClass("itemHide");
	})
	
	function powerSaveOn() {
		$("#powerOffBg").show();
	}
	
	function powerSaveOff() {
		$("#powerOffBg").hide();
	}
	$("#oha_update").click(function(){
		if(oha_config.debug_mode) {
			Mylog('oha_update is click');
		}
		if($(this).attr("disabled")=="disabled") {
//			console.log("The botton is disabled");
			return;
		}
        oha_api.runOhaCmd("oha://updateUrl");
	})
    
    $("#powerOnNormal,#xPowerOnNormal").click(function(){
        $("#powerOnNormal,#xPowerOnNormal").hide();
        $("#powerOffNormal,#xPowerOffNormal").show();
        powerOff();
        oUartTerm.setEnable(false);
		$("#oha_update").removeAttr("disabled");
    });

    $("#powerOffNormal,#xPowerOffNormal").click(function(){
        $("#powerOffNormal,#xPowerOffNormal").hide();
        $("#powerOnNormal,#xPowerOnNormal").show();
        $("#mask_area").show();
        bgUrl="";
        clearPanelArea();
        powerOn();
        startDev();
        oUartTerm.setEnable(true);
		$("#oha_update").attr("disabled", "disabled");

    });
    
    $("#loopIntvValue").keypress(function(e){
//        Mylog("key In:"+e.which);
       switch(e.which) {
           case 13:       // enter
               Mylog("enter is input")
               $("#loopCountValue").focus();
                break;
           case 48:
           case 49:
           case 50:
           case 51:
           case 52:
           case 53:
           case 54:
           case 55:
           case 56:
           case 57:
               var _val=parseInt($(this).val()+String.fromCharCode(e.which));
               Mylog("value="+_val);
               if(_val>1000) {
                   alert("Out of range");
                   return false;
               }
               break;
           default:
               alert("Invalid input(0-9)");
               return false;
               break;
        } 
    });
//    $("#loopCountValue").keypress(function(e){
//        Mylog("key In:"+e.which);
//       switch(e.which) {
//           case 13:       // enter
//               setLoopValue();
//                break;
//           case 48:
//           case 49:
//           case 50:
//           case 51:
//           case 52:
//           case 53:
//           case 54:
//           case 55:
//           case 56:
//           case 57:
//               var _val=parseInt($(this).val()+String.fromCharCode(e.which));
//               Mylog("value="+_val);
//               if(_val>1000000) {
//                   alert("Out of range");
//                   return false;
//               }
//               break;
//           default:
//               alert("Invalid input(0-9)");
//               return false;
//               break;
//        } 
//    });
    $("#dataValue").keypress(function(e){
        var _char=String.fromCharCode(e.which);
       switch(e.which) {
           case 13:       // enter
               $("#loopSetBtn").focus();
                break;
           case 48:     // '0'
           case 49:     // '1'
           case 50:     // '2'
           case 51:     // '3'
           case 52:     // '4'
           case 53:     // '5'
           case 54:     // '6'
           case 55:     // '7'
           case 56:     // '8'
           case 57:     // '9'
           case 65:     // 'A'
           case 66:     // 'B'
           case 67:     // 'C'
           case 68:     // 'D'
           case 69:     // 'E'
           case 70:     // 'F'
           case 97:     // 'a'
           case 98:     // 'b'
           case 99:     // 'c'
           case 100:     // 'd'
           case 101:     // 'e'
           case 102:     // 'f'
               if($(this).val().length==2) {
                   alert("Out of range(0-0xff)");
                   return false;
               }
               break;
           default:
               alert("Invalid input(Hex value)");
               return false;
               break;
        } 
    });
    
    $("#loopSetBtn").keypress(function(e) {
        switch(e.which){
            case 13:
                setLoopValue();
                break;
            default:
            break;
        }
    })
    
    $("#loopSetBtn").click(function(){
       setLoopValue();
    });

    $("#loopDataModeNo").change(function(e) {
        Mylog("selected:"+$(this).val());
        if($(this).val()=="mode1") {
            $("#dataValueDiv").removeClass("itemHide");
            $("#dataValueDiv").addClass("inline");
        }
        else {
            $("#dataValueDiv").addClass("itemHide");
            $("#dataValueDiv").removeClass("inline");
        }
    });
    $("#rxPktSizeSel").change(function(e) {
        Mylog("selected:"+$(this).val());
        switch($(this).val()) {
            case "size0":   // 8 bytes
                oUartTerm.setRxBytesPerPkt(8);
                break;
            case "size1":   // 64 bytes
                oUartTerm.setRxBytesPerPkt(64);
                break;
            case "size2":   // 256 bytes
                oUartTerm.setRxBytesPerPkt(256);
                break;
            default:
                oUartTerm.setRxBytesPerPkt(8);
                break;
                            }
    });
    
    if(oha_config.isSimOsensor) {
        $("#oSensorDiv.uiContainer").click(function(){
            if(isDevReady) {
                return;
            }
            if(!isoSensorSim) {
                isoSensorSim=true;
                oSensorSim();
            }
            else {
                isoSensorSim=false;
            }
        });
        
        $("#unConnectedDiv").click(function() {
            $(this).hide();
        });
    }
})

function runSimEAV() {				// Run Simulation for valid EAV cycle
	const _config={
		IDLE_MAX: 5, 
		RAISING_SLOPE: 40, 	// Unit index/s
		KEEPING_SLOPE: 5, 	// Unit index/s
		IR_MIN: 12, 
		IR_MAX: 50, 
		ID_MIN: 10, 
		ID_MAX: 45, 
		FALLING_SLOPE: 40
	};
	const stateOpt={
		IDLE: 0, 
		RAISING: 1, 
		FALLING: 2, 
		TAIL: 3, 
		IDLE_END: 4
	};
	var _end=false;
	var _st=stateOpt.IDLE;
	var _stCntr=0;
	var _val=0;
	var irValue=0;
	var idValue=0;
	var _preT=-1;
	var _curT=-1;
	if(!isDevReady) {
		OHA_DevReady(0, "&oUART:NB:EAV");
	}
	setTimeout(doSim, 100);
	function doSim() {
		while(!_end) {
			if((new Date().getTime()-_preT)<100) {
				continue;
			}
			_curT=new Date().getTime();
			console.log("state="+_st+", _val="+_val);
			switch(_st) {
				case stateOpt.IDLE:
					_val=Math.random()*_config.IDLE_MAX;
					if(_stCntr>=10) {
						_st=stateOpt.RAISING;
						irValue=_config.IR_MIN+Math.round(Math.random()*(_config.IR_MAX-_config.IR_MIN));
						_stCntr=0;
					}
					break;
				case stateOpt.RAISING:
					var _valNext=_val+(_curT-_preT)*_config.RAISING_SLOPE/1000;
					if(_valNext<_config.ID_MAX) {
						_st=stateOpt.FALLING;
						_val=irValue;
						_stCntr=0;
						var _idMax=(irValue>_config.ID_MAX)? _config.ID_MAX:irValue;
						idValue=Math.round(_config.IR_MIN+Math.random()*(_idMax-_config.IR_MIN));
					}
					else {
						_val=_valNext;
					}
					break;
				case stateOpt.FALLING:
					var _valNext=_val-(_curT-_preT)*_config.KEEPING_SLOPE/1000;
					if(_valNext<=idValue) {
						if(_stCntr>40) {
							_st=stateOpt.TAIL;
							_stCntr=0;
						}
						_val=idValue;
					}
					else {
						_val=_valNext;
					}
					break;
				case stateOpt.TAIL:
					var _valNext=_val-(_curT-_preT)*_config.FALLING_SLOPE/1000;
					if(_valNext<0) {
						_valNext=0;
					}
					_val=_valNext;
					if(_valNext<=_config.IDLE_MAX) {
						_st=stateOpt.IDLE_END;
						_stCntr=0;
					}
					break;
				case stateOpt.IDLE_END:
					_val=Math.random()*_config.IDLE_MAX;
					if(_stCntr>=10) {
						_st=stateOpt.IDLE;
						_stCntr=0;
						_end=true;
					}
					break;
			}
			_preT=_curT;
			_stCntr++;
			oSensorShow("EAV", Math.round(_val), "Voll", "EAV oSensor simulation");
		}
	}
}
