(function(_jq){
    var listview_Html='\
				<div  class="listviewHeader"></div>\
                <div  class="listviewPanel"></div>\
    ';
    var _css="<style>\
.oha_listview .listviewHeader {\
  background: gray;\
  position: absolute;\
  top: 0;\
  left: 0;\
  right: 0;\
  bottom: 25px;\
  outline: 0;\
  border-width:1px;\
  border-style:solid;\
  border-color:white\
}\
.oha_listview .listviewPanel {\
  background: gray;\
  position: absolute;\
  top: 26px;\
  left: 0;\
  right: 0;\
  bottom: 0;\
  outline: 0;\
  border: 1px solid white;\
}\
.oha_listview .slick-header.ui-state-default, .oha_listview .slick-headerrow.ui-state-default {\
  width: 100%;\
  overflow: hidden;\
  border-left: 0px;\
}\
\
.oha_listview .slick-header-columns, .oha_listview.slick-headerrow-columns {\
  position: relative;\
  white-space: nowrap;\
  cursor: default;\
  overflow: hidden;\
}\
\
.oha_listview .slick-header-column.ui-state-default {\
  position: relative;\
  display: inline-block;\
  overflow: hidden;\
  -o-text-overflow: ellipsis;\
  text-overflow: ellipsis;\
  height: 16px;\
  line-height: 16px;\
  margin: 0;\
  padding: 4px;\
  border-right: 1px solid silver;\
  border-left: 0px;\
  border-top: 0px;\
  border-bottom: 0px;\
  float: left;\
}\
\
.oha_listview .slick-headerrow-column.ui-state-default {\
  padding: 4px;\
}\
\
.oha_listview .slick-header-column-sorted {\
  font-style: italic;\
}\
\
.oha_listview .slick-sort-indicator {\
  display: inline-block;\
  width: 8px;\
  height: 5px;\
  margin-left: 4px;\
  margin-top: 6px;\
  float: left;\
}\
\
.oha_listview .slick-sort-indicator-desc {\
  background: url(images/sort-desc.gif);\
}\
\
.oha_listview .slick-sort-indicator-asc {\
  background: url(images/sort-asc.gif);\
}\
\
.oha_listview .slick-resizable-handle {\
  position: absolute;\
  font-size: 0.1px;\
  display: block;\
  cursor: col-resize;\
  width: 4px;\
  right: 0px;\
  top: 0;\
  height: 100%;\
}\
\
.oha_listview .slick-sortable-placeholder {\
  background: silver;\
}\
\
.oha_listview .grid-canvas {\
  position: relative;\
  outline: 0;\
}\
\
.oha_listview .slick-row.ui-widget-content, .oha_listview.slick-row.ui-state-active {\
  position: absolute;\
  border: 0px;\
  width: 100%;\
}\
\
.oha_listview .slick-cell, .oha_listview .slick-headerrow-column {\
  position: absolute;\
  border: 1px solid transparent;\
  border-right: 1px dotted silver;\
  border-bottom-color: silver;\
  overflow: hidden;\
  -o-text-overflow: ellipsis;\
  text-overflow: ellipsis;\
  vertical-align: middle;\
  z-index: 1;\
  padding: 1px 2px 2px 1px;\
  margin: 0;\
  white-space: nowrap;\
  cursor: default;\
}\
\
.oha_listview .slick-group {\
}\
\
.oha_listview .slick-group-toggle {\
  display: inline-block;\
}\
\
.oha_listview .slick-cell.highlighted {\
  background: lightskyblue;\
  background: rgba(0, 0, 255, 0.2);\
  -webkit-transition: all 0.5s;\
  -moz-transition: all 0.5s;\
  -o-transition: all 0.5s;\
  transition: all 0.5s;\
}\
\
.oha_listview .slick-cell.flashing {\
  border: 1px solid red !important;\
}\
\
.oha_listview .slick-cell.editable {\
  z-index: 11;\
  overflow: visible;\
  background: white;\
  border-color: black;\
  border-style: solid;\
}\
\
.oha_listview .slick-cell:focus {\
  outline: none;\
}\
\
.oha_listview .slick-reorder-proxy {\
  display: inline-block;\
  background: blue;\
  opacity: 0.15;\
  filter: alpha(opacity = 15);\
  cursor: move;\
}\
\
.oha_listview .slick-reorder-guide {\
  display: inline-block;\
  height: 2px;\
  background: blue;\
  opacity: 0.7;\
  filter: alpha(opacity = 70);\
}\
\
.oha_listview .slick-selection {\
  z-index: 10;\
  position: absolute;\
  border: 2px dashed black;\
}\
    </style>";

    _jq.fn.oha_listview=function(_opt) {
        var self = this;

        $(this).addClass("oha_listview");
        $('head').append(_css);
        var _default={
            maxLine:1000000,
        };
        _jq.extend(_default, _opt);
		
        $(this).append(listview_Html);
		var grid=null;
		var data = [];
		
		this.AutoScrollDown=function() {
			var canvas = _jq(self).find(".slick-viewport")[0];
			if (canvas)
			{
				canvas.scrollTop = canvas.scrollHeight;
			}
		}
        function init() {
			var list = _jq(self).find(".listviewPanel")[0];
			if (!list) return;
			var w = list.parentNode.clientWidth;
			var h = list.parentNode.clientHeight;
			//console.log("parent size("+w+","+h+")");
			//var cell_width = w/3;
			if (w==0)return;
			
			var columns = [
				{id: "Sensor", name: "Sensor Name", field: "Sensor", width:w/4},
				{id: "Value", name: "Value", field: "Value", width:w/4},
				{id: "Desc", name: "Description", field: "Description", width:w/2}
			];
			var options = {
				enableCellNavigation: true,
				enableColumnReorder: false
			};
			grid = new Slick.Grid(list, data, columns, options);
			var canvas = _jq(self).find(".slick-viewport")[0];
			if (canvas)
			{
				canvas.scrollTop = canvas.scrollHeight;
			}
			$(".slick-header-columns").css("height","0px")
			grid.resizeCanvas();
        }

		this.insertListData = function (_name, _value, _unit, _desc, redraw) 
		{
            if(typeof redraw == "undefined") {
                redraw=false;
            }
			var d = new Date();
			var spl = d.toString().split(' ');
			data.push({Sensor:spl[4], Value:_value+" "+_unit, Description:_desc});
			if (grid==null) init();
			if (grid==null) return; // parent is still width 0;
			// check grid window size and parent.
			var list = _jq(self).find(".listviewPanel")[0];
			var header = _jq(self).find(".listviewHeader")[0];
			var canvas = _jq(self).find(".slick-viewport")[0];
			var parent_w = list.parentNode.clientWidth;
			var parent_h = list.parentNode.clientHeight;
			header.innerHTML = _name;
			/*
			var w = list.clientWidth;
			var h = list.clientHeight;
			console.log(_name+" pw, w="+parent_w+" "+w+", ph, h="+parent_h+" "+h);
			*/
			// for some reason, $(".panel_block").css({"height":"50%"}); does not trigger resize event.... work around here.
			if (parent_h < canvas.offsetHeight)
			{
				init();
			}
			//data.push({Sensor:_name, Value:_value+" "+_unit, Description:" pw, w="+parent_w+" "+w+", ph, h="+parent_h+" "+h});
			
			var isScrollBottom;
			//console.log("insertListdata:"+_name+_value+_unit+_desc);
			if ((canvas.scrollTop+canvas.offsetHeight+2)>=canvas.scrollHeight)
				isScrollBottom=true;
			else
				isScrollBottom=false;
			
			
			if (data.length>=_default.maxLine)
			{
				data.shift();
				if (redraw == true) grid.invalidateAllRows();
			}
			else 
				if (redraw == true) grid.invalidateRow(data.length -1);
			
			if (redraw == true) grid.updateRowCount();
			if (isScrollBottom)
			{
				canvas.scrollTop = canvas.scrollHeight;
			}
			if (redraw == true)
				grid.render();
		}
		$( window ).resize(function() {
			init();
			console.log("oha_listview resize() called.");
		});
        init();
        return self;
    };
    
})(jQuery);
