// JavaScript Document
var oha_config={
    debug_mode:false,			// Debug mode, must be set as "false" before release
    isCheckModelName: false,     // If the model name is checked or not
	sw_ver:1.066,
	model:"&oUART",				// Model Name, must be the same as Config.html
	page_name:"Official",				// Page Name, different page must be different page name
    isTestMode:false,
    loopBackTest:false, 
    api_path:"oha_api/",
    default_language:oha_api.langCode.TraditionChinese, 

            // oha_api.langCode.English: English
            // oha_api.langCode.TraditionChinese: Traditional Chinese
            // oha_api.langCode.SimpleChinese: Simplify Chinese
            // oha_api.langCode.Korean: Korea Language
    api_path:"oha_api/",
    isCheckModelName: true, 
            // If thie UI page checking for Model name, 
            // "true": oha_api.DevPlugIn() will be launched if the plugged device model name 
            //      is matched with oha_config.model
            // "false": oha_api.DevPlugIn() will be launched if any OHA device is plugged
    simVirtualDevice:false, 
    loopBackTest:true, 
    ignoreCheckSum:false, 
    isSimOsensor:false, 
}

// ================== Definition for UI page by language setting =====================
oha_config.html_config=new Object();
oha_config.html_config[oha_api.langCode.English]="default_tw.html";
oha_config.html_config[oha_api.langCode.TraditionChinese]="default_tw.html";
oha_config.html_config[oha_api.langCode.SimpleChinese]="default_tw.html";
oha_config.html_config[oha_api.langCode.Korean]="default_tw.html";
// ================== Definition for Title/Subtitle=====================
//English
oha_config.title=new Object();
oha_config.subtitle=new Object();
oha_config.title[oha_api.langCode.English]="oSensor(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.English]="UART terminal";
// TraditionalChinese
oha_config.title[oha_api.langCode.TraditionChinese]="oSensor(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.TraditionChinese]="OHA Sensor";
// SimleChinese
oha_config.title[oha_api.langCode.SimpleChinese]="oSensor(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.SimpleChinese]="OHA Sensor";
// Korea
oha_config.title[oha_api.langCode.Korean]="oSensor(V"+oha_config.sw_ver.toFixed(3)+")";
oha_config.subtitle[oha_api.langCode.Korean]="OHA Sensor";
// =========================================================================

oha_api.init(oha_config);           // Initial the oha_api with customized config object
